package org.ziggurat.fenix.common.modelo.clientes;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

@Entity
@Table(name = "clientes", uniqueConstraints = {@UniqueConstraint(columnNames={"nombre"})})
public class Cliente implements Serializable {

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private long id;

	public long getId() {
		return id;
	}

	private String nombre;
	private String domicilio;
	private String localidad;
	private String telefono;
	private String fax;
	private String celular;
	@Enumerated(EnumType.STRING)
	private TiposDocumentos tipo_doc;
	private String documento;
	private String email;
	@Enumerated(EnumType.STRING)
	private Responsabilidad responsabilidad;

	public Cliente() {
		
	}
	
	public Cliente(String nombre) {
		this.nombre = nombre;		
	}

	public String getCelular() {
		return celular;
	}

	public void setCelular(String celular) {
		this.celular = celular;
	}

	public String getDocumento() {
		return documento;
	}

	public void setDocumento(String documento) {
		this.documento = documento;
	}

	public String getDomicilio() {
		return domicilio;
	}

	public void setDomicilio(String domicilio) {
		this.domicilio = domicilio;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getFax() {
		return fax;
	}

	public void setFax(String fax) {
		this.fax = fax;
	}

	public String getLocalidad() {
		return localidad;
	}

	public void setLocalidad(String localidad) {
		this.localidad = localidad;
	}

	public String getNombre() {
		return nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public Responsabilidad getResponsabilidad() {
		return responsabilidad;
	}

	public void setResponsabilidad(Responsabilidad responsabilidad) {
		this.responsabilidad = responsabilidad;
	}

	public String getTelefono() {
		return telefono;
	}

	public void setTelefono(String telefono) {
		this.telefono = telefono;
	}

	public TiposDocumentos getTipo_doc() {
		return tipo_doc;
	}

	public void setTipo_doc(TiposDocumentos tipo_doc) {
		this.tipo_doc = tipo_doc;
	}

	@Override
	public String toString() {
		return String.format("Cliente: %s, %s %s", this.getNombre(), this
				.getTipo_doc(), this.getDocumento());
	}

	@Override
	/**
	 * Un cliente es igual a otro cuando su nombre
	 * es identico.
	 */
	public boolean equals(Object obj) {
		if (!(obj instanceof Cliente))
			return false;
		Cliente cliente = (Cliente) obj;
		/*if (!this.getDocumento().equals(cliente.getDocumento()))
			return false;
		if (!this.getTipo_doc().equals(cliente.getTipo_doc()))
			return false;*/
		if (!this.getNombre().equals(cliente.getNombre()))
			return false;
		return true;
	}

	@Override
	public int hashCode() {
		int result = 37;
		result = 37 * result + this.getDocumento().hashCode();
		result = 37 * result + this.getTipo_doc().hashCode();
		result = 37 * result + this.getNombre().hashCode();
		return result;
	}
}
