package org.ziggurat.fenix.common.modelo.clientes;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.ziggurat.fenix.common.modelo.transacciones.Cheque;
import org.ziggurat.fenix.common.util.MoneyHelper;

@Entity
@Table(name = "pago_de_cliente")
public class PagoDeClienteInmutable extends TransaccionConCliente implements Serializable {

	@Temporal(TemporalType.DATE)
	private Date fecha;
	@OneToOne(cascade = CascadeType.ALL)
    @JoinColumn(name="cheque_FK")
	private Cheque cheque;
	private BigDecimal monto;
	private String nroRecibo;
	private String notas;
	
	public PagoDeClienteInmutable(Date fecha, Cheque cheque,
			String nroRecibo, String notas, Cliente cliente) {
		super();
		this.fecha = fecha;
		this.cheque = cheque;
		this.monto = cheque.getMonto();
		this.nroRecibo = nroRecibo;
		this.notas = notas;
		setCliente(cliente);
	}

	public PagoDeClienteInmutable(Date fecha, BigDecimal monto, String nroRecibo,
			String notas, Cliente cliente) {
		super();
		this.fecha = fecha;
		this.monto = monto;
		this.nroRecibo = nroRecibo;
		this.notas = notas;
		setCliente(cliente);
	}

	public Date getFecha() {
		return fecha;
	}

	public Cheque getCheque() {
		return cheque;
	}

	public BigDecimal getMonto() {
		return monto;
	}

	public String getNroRecibo() {
		return nroRecibo;
	}

	public String getNotas() {
		return notas;
	}

	/*protected void asentarMovimiento() {
		this.getCliente().sumarSaldo(this.getMonto());
		this.getCliente().addTransaccion(this);
	}*/

	@Override
	protected BigDecimal resolverSaldo(BigDecimal saldo) {
		return MoneyHelper.sumar(saldo, this.getMonto());		
	}

	@Override
	public String toString() {
		return String.format("Pago de cliente: %s %s", fecha, monto);
	}
	
}
