package org.ziggurat.fenix.common.modelo.clientes;

import org.ziggurat.fenix.common.modelo.comprobantes.factura.TipoFactura;


public enum Responsabilidad {
	
	RESPONSABLE_INSCRIPTO(TipoFactura.A, "Responsable inscripto"),
	RESPONSABLE_NO_INSCRIPTO(TipoFactura.A, "Responsable NO inscripto"),
	NO_RESPONSABLE(TipoFactura.B, "No responsable"),
	EXENTO(TipoFactura.B, "Exento"),
	CONSUMIDOR_FINAL(TipoFactura.B, "Consumidor final"),
	RESPONSABLE_MONOTRIBUTO(TipoFactura.B, "Responsable monotributo"),
	VENTA_BIENES_DE_USO(TipoFactura.B, "Venta bienes de uso");
	
	private final TipoFactura tipoFactura;
	private final String descripcion;
	
	private Responsabilidad(TipoFactura tipoFactura, String descripcion) {
		this.tipoFactura = tipoFactura;
		this.descripcion = descripcion;
	}
	
	public TipoFactura getTipoFactura() {
		return tipoFactura;
	}
	
	public String toString() {
		return this.descripcion;
	}
}
