package org.ziggurat.fenix.common.modelo.impresorafiscal;

import org.apache.commons.configuration.Configuration;
import org.apache.commons.configuration.ConfigurationException;
import org.apache.commons.configuration.PropertiesConfiguration;
import org.ziggurat.fenix.common.modelo.clientes.VentaAClienteInmutable;

public class ImpresoraFiscalProxy implements ImpresoraFiscalInterface {
	
	private static Configuration config;
	
	static {
		try {
			config = new PropertiesConfiguration("fenix.properties");
		} catch (ConfigurationException e) {
			e.printStackTrace();
		}
	}
	
	ImpresoraFiscalInterface impresora;
	
	public ImpresoraFiscalProxy() {
		if (config.getBoolean("impresoraFiscal.habilitada")) {
			impresora = new ImpresoraFiscal(config.getString("impresoraFiscal.puerto"));
		} else {
			impresora = new ImpresoraFiscalFake();
		}
	}

	public String getProximoNumeroDeFacturaA() throws ImpresoraFiscalExcepcion {
		return impresora.getProximoNumeroDeFacturaA();
	}

	public String getProximoNumeroDeFacturaBC() throws ImpresoraFiscalExcepcion {
		return impresora.getProximoNumeroDeFacturaBC();
	}

	public StatusImpresora getStatus() throws ImpresoraFiscalExcepcion {
		return impresora.getStatus();
	}

	public void imprimirTransaccion(VentaAClienteInmutable venta) throws ImpresoraFiscalExcepcion {
		impresora.imprimirTransaccion(venta);
	}
}
