package org.ziggurat.fenix.common.modelo.matafuego;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@Table(name="servicio_matafuego")
public class ServicioMatafuego {
	
	@Id @GeneratedValue(strategy=GenerationType.AUTO)
	private long id;

	@ManyToOne	
	private Matafuego matafuego;
	
	@Temporal(TemporalType.DATE)
	private Date fecha;
	@Column(unique=true)
	private String numeroDps;
	private boolean pruebaHidraulica;
	private String notas;
	
	private boolean lavadoInterior;
	private boolean secado;
	
	/**
	 * Estas variables corresponden a Revision-Reparacion-Reposicion
	 * por eso se usa el prefijo rrr.
	 */
	private boolean rrrExterior;
	private boolean rrrRosca;
	private boolean rrrMangyConec;
	private boolean rrrValyValReduc;
	private boolean rrrTobera;
	private boolean rrrChasis;
	private boolean rrrRuedas;
	private boolean rrrManometro;
	private boolean rrrDiscoyTapon;
	
	private boolean pintura;
	/**
	 * Estas variables estan bajo la seccion de Cargas.
	 */
	private boolean polvoTyP;
	private double polvoCarga;
	private boolean Co2;
	private boolean agua;
	private boolean hcfc;
	private boolean n2;
	private boolean afff;
	private boolean quimicaAB;
	public long getId() {
		return id;
	}
	public void setId(long id) {
		this.id = id;
	}
	public Matafuego getMatafuego() {
		return matafuego;
	}
	public void setMatafuego(Matafuego matafuego) {
		this.matafuego = matafuego;
	}
	public Date getFecha() {
		return fecha;
	}
	public void setFecha(Date fecha) {
		this.fecha = fecha;
	}
	public String getNumeroDps() {
		return numeroDps;
	}
	public void setNumeroDps(String numeroDps) {
		this.numeroDps = numeroDps;
	}
	public boolean isPruebaHidraulica() {
		return pruebaHidraulica;
	}
	public void setPruebaHidraulica(boolean pruebaHidrahulica) {
		this.pruebaHidraulica = pruebaHidrahulica;
	}
	public String getNotas() {
		return notas;
	}
	public void setNotas(String notas) {
		this.notas = notas;
	}
	public boolean isLavadoInterior() {
		return lavadoInterior;
	}
	public void setLavadoInterior(boolean lavadoInterior) {
		this.lavadoInterior = lavadoInterior;
	}
	public boolean isSecado() {
		return secado;
	}
	public void setSecado(boolean secado) {
		this.secado = secado;
	}
	public boolean isRrrExterior() {
		return rrrExterior;
	}
	public void setRrrExterior(boolean rrrExterior) {
		this.rrrExterior = rrrExterior;
	}
	public boolean isRrrRosca() {
		return rrrRosca;
	}
	public void setRrrRosca(boolean rrrRosca) {
		this.rrrRosca = rrrRosca;
	}
	public boolean isRrrMangyConec() {
		return rrrMangyConec;
	}
	public void setRrrMangyConec(boolean rrrMangyConec) {
		this.rrrMangyConec = rrrMangyConec;
	}
	public boolean isRrrValyValReduc() {
		return rrrValyValReduc;
	}
	public void setRrrValyValReduc(boolean rrrValyValReduc) {
		this.rrrValyValReduc = rrrValyValReduc;
	}
	public boolean isRrrTobera() {
		return rrrTobera;
	}
	public void setRrrTobera(boolean rrrTobera) {
		this.rrrTobera = rrrTobera;
	}
	public boolean isRrrChasis() {
		return rrrChasis;
	}
	public void setRrrChasis(boolean rrrChasis) {
		this.rrrChasis = rrrChasis;
	}
	public boolean isRrrRuedas() {
		return rrrRuedas;
	}
	public void setRrrRuedas(boolean rrrRuedas) {
		this.rrrRuedas = rrrRuedas;
	}
	public boolean isRrrManometro() {
		return rrrManometro;
	}
	public void setRrrManometro(boolean rrrManometro) {
		this.rrrManometro = rrrManometro;
	}
	public boolean isRrrDiscoyTapon() {
		return rrrDiscoyTapon;
	}
	public void setRrrDiscoyTapon(boolean rrrDiscoyTapon) {
		this.rrrDiscoyTapon = rrrDiscoyTapon;
	}
	public boolean isPintura() {
		return pintura;
	}
	public void setPintura(boolean pintura) {
		this.pintura = pintura;
	}
	public boolean isPolvoTyP() {
		return polvoTyP;
	}
	public void setPolvoTyP(boolean polvoTyP) {
		this.polvoTyP = polvoTyP;
	}
	public double getPolvoCarga() {
		return polvoCarga;
	}
	public void setPolvoCarga(double polvoCarga) {
		this.polvoCarga = polvoCarga;
	}
	public boolean isCo2() {
		return Co2;
	}
	public void setCo2(boolean co2) {
		Co2 = co2;
	}
	public boolean isAgua() {
		return agua;
	}
	public void setAgua(boolean agua) {
		this.agua = agua;
	}
	public boolean isHcfc() {
		return hcfc;
	}
	public void setHcfc(boolean hcfc) {
		this.hcfc = hcfc;
	}
	public boolean isN2() {
		return n2;
	}
	public void setN2(boolean n2) {
		this.n2 = n2;
	}
	public boolean isAfff() {
		return afff;
	}
	public void setAfff(boolean afff) {
		this.afff = afff;
	}
	public boolean isQuimicaAB() {
		return quimicaAB;
	}
	public void setQuimicaAB(boolean quimicaAB) {
		this.quimicaAB = quimicaAB;
	}
	
}
