package org.ziggurat.fenix.common.modelo.productos;

public class Stock {
	
	private int cantidadDisponible = 0;
	private int limiteMinimo = 0;
	private boolean notificarPorEscaces = true;
	
	public void aumentarStock(int cantidad) {
		this.cantidadDisponible = this.cantidadDisponible + cantidad;
	}
	
	public void disminuirStock(int cantidad) {
		if (this.cantidadDisponible < cantidad) {
			throw new IllegalArgumentException("La cantidad a decrementar es mayor que el stock existente");
		}
		this.cantidadDisponible = this.cantidadDisponible - cantidad;
	}

	public int getCantidadDisponible() {
		return cantidadDisponible;
	}

	public void setCantidadDisponible(int cantidadDisponible) {
		this.cantidadDisponible = cantidadDisponible;
	}

	public int getLimiteMinimo() {
		return limiteMinimo;
	}

	public void setLimiteMinimo(int limiteMinimo) {
		this.limiteMinimo = limiteMinimo;
	}

	public boolean isNotificarPorEscaces() {
		return notificarPorEscaces;
	}

	public void setNotificarPorEscaces(boolean notificarPorEscaces) {
		this.notificarPorEscaces = notificarPorEscaces;
	}
	
	public boolean stockDebajoDeLimiteMinimo() {
		if (this.getCantidadDisponible() < this.getLimiteMinimo())
			return true;
		return false;
	}
	
	public boolean stockDebajoDeLimiteMinimoYNotificar() {
		if (stockDebajoDeLimiteMinimo() && isNotificarPorEscaces())
			return true;
		return false;
	}
	
}