package org.ziggurat.fenix.common.modelo.proveedores;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;

import org.apache.commons.lang.NullArgumentException;
import org.apache.commons.lang.StringUtils;

@Entity
@Table(name = "categoria_proveedor")
public class CategoriaDeProveedor implements Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -2665490580832064247L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private long id;
	
	private String nombre;
	private String descripcion;
	
	public CategoriaDeProveedor() {
		
	}
	
	public CategoriaDeProveedor(String unNombre, String unaDescripcion) {
		if (unNombre == null) throw new NullArgumentException("unNombre");
		if (unNombre == null) throw new NullArgumentException("unaDescripcion");
		this.nombre = unNombre;
		this.descripcion = unaDescripcion;
	}
	
	public String getNombre() {
		return nombre;
	}
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}
	public String getDescripcion() {
		return descripcion;
	}
	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + (int) (id ^ (id >>> 32));
		result = prime * result + ((nombre == null) ? 0 : nombre.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		CategoriaDeProveedor other = (CategoriaDeProveedor) obj;
		if (id != other.id)
			return false;
		if (nombre == null) {
			if (other.nombre != null)
				return false;
		} else if (!nombre.equals(other.nombre))
			return false;
		return true;
	}
	
	public String toString() {
		return StringUtils.defaultIfEmpty(getNombre(), StringUtils.EMPTY);
	}
	
}
