package org.ziggurat.fenix.common.modelo.proveedores;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.List;

import org.ziggurat.fenix.common.util.MoneyHelper;

public class LibroDeIvaCompras implements Serializable {

	private List<CompraAProveedorInmutable> facturas;
	private int ano;
	private int mes;
	private BigDecimal netoSinIVA = BigDecimal.ZERO;
	private BigDecimal montoIVA = BigDecimal.ZERO;
	private BigDecimal noGravadoExento = BigDecimal.ZERO;
	private BigDecimal percepciones = BigDecimal.ZERO;
	private BigDecimal total= BigDecimal.ZERO;
	
	public LibroDeIvaCompras(int ano, int mes, List<CompraAProveedorInmutable> facturas) {
		this.ano = ano;
		this.mes = mes;
		this.facturas = facturas;
		for (CompraAProveedorInmutable factura : facturas) {
			netoSinIVA = MoneyHelper.sumar(netoSinIVA, factura.getNetoSinIVA());
			montoIVA = MoneyHelper.sumar(montoIVA, factura.getMontoIVA());
			noGravadoExento = MoneyHelper.sumar(noGravadoExento, factura.getNoGravadoExento());
			percepciones = MoneyHelper.sumar(percepciones, factura.getPercepciones());
			total = MoneyHelper.sumar(total, factura.getMonto());
		}
	}

	public List<CompraAProveedorInmutable> getFacturas() {
		return facturas;
	}

	public int getAno() {
		return ano;
	}

	public int getMes() {
		return mes;
	}

	public BigDecimal getNetoSinIVA() {
		return netoSinIVA;
	}

	public BigDecimal getMontoIVA() {
		return montoIVA;
	}

	public BigDecimal getNoGravadoExento() {
		return noGravadoExento;
	}

	public BigDecimal getPercepciones() {
		return percepciones;
	}

	public BigDecimal getTotal() {
		return total;
	}

}
