package org.ziggurat.fenix.common.modelo.proveedores;

import java.io.Serializable;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Table(name = "proveedores")
public class Proveedor implements Serializable {

	@Id
	@GeneratedValue(strategy = GenerationType.TABLE)
	private long id;

	private String nombre;
	private String CUIT;
	private String notas;	
	@ManyToOne( cascade = {CascadeType.PERSIST, CascadeType.MERGE} )
	private CategoriaDeProveedor categoria;

	public Proveedor() {

	}
	
	public Proveedor(String nombre, String notas, CategoriaDeProveedor categoria, String CUIT) {
		this.setNombre(nombre);
		this.setNotas(notas);
		this.setCategoria(categoria);
		this.setCUIT(CUIT);
	}

	/*
	public List<TransaccionConProveedor> getTransacciones() {
		Collections.sort(transacciones);
		CollectionUtils.filter(transacciones, new Predicate() {
			@Override
			public boolean evaluate(Object object) {
				TransaccionConProveedor tr = (TransaccionConProveedor) object;
				return tr.isVigente();				
			}
		});
		return Collections.unmodifiableList(transacciones);
	}*/
	
	
	/*
	public List<TransaccionConProveedor> getTransaccionesEntreFechas(Date fechaInicio, Date fechaFin) {
		List<TransaccionConProveedor> listaTemp = new ArrayList<TransaccionConProveedor>();
		for (TransaccionConProveedor tr : getTransacciones()) {
			if (tr.getFecha().after(fechaInicio) || DateUtils.isSameDay(tr.getFecha(), fechaInicio)) {
				if (tr.getFecha().before(fechaFin) || DateUtils.isSameDay(tr.getFecha(), fechaFin)) {
					listaTemp.add(tr);
				} else {
					break;
				}
			}

		}
		return (List<TransaccionConProveedor>) Collections.unmodifiableList(listaTemp);
	}*/
	
	/*
	public BigDecimal getSaldoHasta(Date hasta) {
		BigDecimal saldo = BigDecimal.ZERO;
		for (TransaccionConProveedor tr : getTransacciones()) {
			if (tr.getFecha().before(hasta)	|| DateUtils.isSameDay(tr.getFecha(), hasta)) {
				saldo = tr.resolverSaldo(saldo);
			} else {
				break;
			}
		}
		return saldo;
	}*/

	/*
	public BigDecimal getSaldoDesde(Date desde) {
		BigDecimal saldo = BigDecimal.ZERO;
		for (TransaccionConProveedor tr : getTransacciones()) {
			if (tr.getFecha().after(desde)
					|| DateUtils.isSameDay(tr.getFecha(), desde)) {
				saldo = tr.resolverSaldo(saldo);
			}
		}
		return saldo;
	}
	*/
	
	/*
	public CCProveedor getCCTodosLosMovimientos() {
		CCProveedor cc = new CCProveedor(getSaldo(), BigDecimal.ZERO);
		for (TransaccionConProveedor tr : getTransacciones()) {
			cc.addTransaccion(tr);
		}
		return cc;
	}
	*/
	
	/*
	public CCProveedor getCCUltimosTresMeses() {
		Calendar cal = Calendar.getInstance();
		cal.add(Calendar.MONTH, -3);		
		BigDecimal saldoPrevio = getSaldoHasta(cal.getTime());
		CCProveedor cc = new CCProveedor(getSaldo(), saldoPrevio);
		for (TransaccionConProveedor tr : getTransaccionesEntreFechas(cal.getTime(), DateUtils.add(Calendar.getInstance().getTime(), Calendar.YEAR, 2))) {
			cc.addTransaccion(tr);
		}
		return cc;
	}*/

	/*
	public List<TransaccionConProveedor> getTrasaccionesDeMes(int mes, int ano) throws ParseException {
		String[] parse = { "dd/MM/yy" };
		Date fechaInicio = DateUtils.parseDate("1/" + mes + "/" + ano, parse);
		Date fechaFin = DateUtils.addDays(DateUtils.addMonths(fechaInicio, 1), -1);
		return Collections.unmodifiableList(getTransaccionesEntreFechas(fechaInicio, fechaFin));
	}
	*/

	/*public void asentarTransaccion(TransaccionConProveedor tr) {		
		tr.setProveedor(this);
		tr.asentarMovimiento();
	}*/

	public String getNombre() {
		return nombre;
	}

	public String getNotas() {
		return notas;
	}

	public String getCUIT() {
		return CUIT;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public void setCUIT(String cuit) {
		CUIT = cuit;
	}

	public void setNotas(String notas) {
		this.notas = notas;
	}

	/*
	public BigDecimal getSaldo() {
		// Este codigo es un desastre, como se puede mejorar??
		return getSaldoHasta(DateUtils.add(Calendar.getInstance().getTime(), Calendar.YEAR, 20));
		//return saldo;
	}
	*/

	/*protected void sumarSaldo(BigDecimal monto) {
		this.saldo = MoneyHelper.sumar(saldo, monto);
	}

	protected void restarSaldo(BigDecimal monto) {
		this.saldo = MoneyHelper.restar(saldo, monto);
	}*/

	/*protected void addTransaccion(TransaccionConProveedor tr) {
		this.transacciones.add(tr);
	}*/

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((CUIT == null) ? 0 : CUIT.hashCode());
		result = prime * result + ((nombre == null) ? 0 : nombre.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Proveedor other = (Proveedor) obj;
		if (CUIT == null) {
			if (other.CUIT != null)
				return false;
		} else if (!CUIT.equals(other.CUIT))
			return false;
		if (nombre == null) {
			if (other.nombre != null)
				return false;
		} else if (!nombre.equals(other.nombre))
			return false;
		return true;
	}
	
	public String toString() {
		return String.format("Proveedor: [%s] [%s]",
				getNombre(), getCUIT());
	}

	public void setCategoria(CategoriaDeProveedor categoria) {
		this.categoria = categoria;
	}

	public CategoriaDeProveedor getCategoria() {
		return categoria;
	}
	
}
