package org.ziggurat.fenix.common.modelo.transacciones;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.ziggurat.fenix.common.util.FenixFormat;

@Entity
@Table(name = "cheques")
public class Cheque implements Serializable {

	@Id @GeneratedValue(strategy=GenerationType.AUTO)
	private long id;
	
	private String entregadoPor;
	private String CUIT;
	private String banco;
	@Temporal(TemporalType.DATE)
	private Date fecha;
	@Temporal(TemporalType.DATE)
	private Date fechaDeCobro;
	private String aLaOrdenDe;
	@Column(nullable=false)
	private BigDecimal monto;
	@Column(nullable=false)
	private String numeroCheque;
	private String descripcion;
	@Enumerated(EnumType.STRING)
	private EstadoDeCheque estado = EstadoDeCheque.SIN_COMPLETAR;
	private boolean eliminado;
	
	public boolean isEliminado() {
		return eliminado;
	}
	public void setEliminado(boolean eliminado) {
		this.eliminado = eliminado;
	}
	public String getEntregadoPor() {
		return entregadoPor;
	}
	public void setEntregadoPor(String entregadoPor) {
		this.entregadoPor = entregadoPor;
	}
	public String getCUIT() {
		return CUIT;
	}
	public void setCUIT(String cuit) {
		CUIT = cuit;
	}
	public String getBanco() {
		return banco;
	}
	public void setBanco(String banco) {
		this.banco = banco;
	}
	public Date getFecha() {
		return fecha;
	}
	public void setFecha(Date fecha) {
		this.fecha = fecha;
	}
	public Date getFechaDeCobro() {
		return fechaDeCobro;
	}
	public void setFechaDeCobro(Date fechaDeCobro) {
		this.fechaDeCobro = fechaDeCobro;
	}
	public String getALaOrdenDe() {
		return aLaOrdenDe;
	}
	public void setALaOrdenDe(String laOrdenDe) {
		aLaOrdenDe = laOrdenDe;
	}
	public BigDecimal getMonto() {
		return monto;
	}
	public void setMonto(BigDecimal monto) {
		this.monto = monto;
	}
	public String getNumeroCheque() {
		return numeroCheque;
	}
	public void setNumeroCheque(String numeroCheque) {
		this.numeroCheque = numeroCheque;
	}
	public String getDescripcion() {
		return descripcion;
	}
	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}
	public EstadoDeCheque getEstado() {
		return estado;
	}
	public void setEstado(EstadoDeCheque estado) {
		this.estado = estado;
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((monto == null) ? 0 : monto.hashCode());
		result = prime * result + ((numeroCheque == null) ? 0 : numeroCheque.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Cheque other = (Cheque) obj;
		if (monto == null) {
			if (other.monto != null)
				return false;
		} else if (!monto.equals(other.monto))
			return false;
		if (numeroCheque == null) {
			if (other.numeroCheque != null)
				return false;
		} else if (!numeroCheque.equals(other.numeroCheque))
			return false;
		return true;
	}
	
	public String toString() {
		return String.format("Cheque nro: %s monto %s", getNumeroCheque(), FenixFormat.getMoneda(getMonto()));
	}
	
}
