package org.ziggurat.fenix.common.util;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.text.NumberFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

public class FenixFormat {

	
	public static SimpleDateFormat DATE_FORMAT = new SimpleDateFormat("dd/MM/yyyy");
	private static NumberFormat cf = NumberFormat.getCurrencyInstance();
	
	static {		
		if (cf instanceof DecimalFormat) {
			cf.setGroupingUsed(false);
			DecimalFormatSymbols dfs = ((DecimalFormat)cf).getDecimalFormatSymbols();
			dfs.setCurrencySymbol("$");
			((DecimalFormat)cf).setDecimalFormatSymbols(dfs);
		}
	}
	
	/**
	 * Retorna un String con formato monetario
	 * recibiendo un BigDecimal.
	 * Si recibe null retorna 0.
	 * @param valor
	 * @return
	 */
	static public String getMoneda(BigDecimal valor) {
		if (valor == null) {
			valor = BigDecimal.ZERO;
		}
		return cf.format(valor);
	}
	
	/**
	 * Retorna la fecha formateada con
	 * formato dd/MM/yyyy
	 * 
	 * @param fecha
	 * @param DATE_FORMAT
	 * @return
	 */
	
	static public String getFecha(Date fecha) {
		if (fecha == null) {
			return "";
		}
		return DATE_FORMAT.format(fecha);
	}
	
}
