package org.ziggurat.fenix.common.util;

import java.math.BigDecimal;
import java.math.RoundingMode;

public class MoneyHelper {

	static private int scale = 2;
	static private RoundingMode roundingMode = RoundingMode.HALF_EVEN;
	
	static public BigDecimal sumar(BigDecimal valor1, BigDecimal valor2) {
		return valor1.add(valor2).setScale(scale, roundingMode);
	}
	
	/**
	 * Realiza la resta valor1 - valor2
	 * @return El resultado de la resta
	 */
	static public BigDecimal restar(BigDecimal valor1, BigDecimal valor2) {
		return valor1.subtract(valor2).setScale(scale, roundingMode);
	}
	
	static public BigDecimal multiplicar(BigDecimal valor1, BigDecimal valor2) {
		return valor1.multiply(valor2).setScale(scale, roundingMode);
	}
	
	/**
	 * Retorna la division valor1/valor2
	 * @param valor1
	 * @param valor2
	 * @return
	 */
	static public BigDecimal dividir(BigDecimal valor1, BigDecimal valor2) {
		return valor1.divide(valor2).setScale(scale, roundingMode);
	}
	
	static public BigDecimal redondear(BigDecimal valor) {
		return valor.setScale(scale, roundingMode);
	}
	
	static public boolean equals(BigDecimal value1, BigDecimal value2) {
		if (value1.compareTo(value2) == 0) return true;
		return false;
	}
}
