package org.ziggurat.fenix.common.database.hibernate;

import junit.framework.TestCase;

import org.ziggurat.fenix.common.modelo.clientes.Cliente;
import org.ziggurat.fenix.common.util.RandomDataGenerator;

public class HibClientesRepoTest extends TestCase {

	HibClienteRepository repo = new HibClienteRepository();
	
	@Override
	protected void setUp() throws Exception {
		super.setUp();
		HibernateUtil.deleteAllMatafuegos();
		HibernateUtil.deleteAllClientes();
	}

	public void testPersistirCliente() {
		Cliente c = new Cliente();
		c.setNombre("Un nombre");
		c.setDocumento("28682597");
		
	}
	/*
	public void testListaDeClientes() {
		assertEquals(0, repo.findAll().size());
		for (int i=0;i<10;i++) {
			Cliente c = RandomDataGenerator.getRandomCliente();
			repo.makePersistent(c);
		}
		assertEquals(10, repo.findAll().size());
	}
	*/
	
	public void testCountClientes() {
		assertEquals(0, repo.countClientes());
		for (int i=0;i<10;i++) {
			Cliente c = RandomDataGenerator.getRandomCliente();
			repo.makePersistent(c);
		}
		assertEquals(10, repo.countClientes());
	}
	
}
