package org.ziggurat.fenix.common.services.matafuegos;

import junit.framework.TestCase;

import org.ziggurat.fenix.common.database.hibernate.HibClienteRepository;
import org.ziggurat.fenix.common.database.hibernate.HibernateUtil;
import org.ziggurat.fenix.common.modelo.clientes.Cliente;
import org.ziggurat.fenix.common.modelo.matafuego.Matafuego;
import org.ziggurat.fenix.common.util.RandomDataGenerator;

public class MatafuegosServiceTests extends TestCase {

	private MatafuegosService ms = new MatafuegosService();
	private HibClienteRepository cr = new HibClienteRepository();
	
	public void setUp() {
		HibernateUtil.deleteAllMatafuegos();
	}
	
	public void testCountMatafuegos() {
		for (int i = 0;i<10;i++) {
			Matafuego m = RandomDataGenerator.getRandomMatafuego();
			cr.makePersistent(m.getCliente());
			ms.save(m);
		}
		assertEquals(10, ms.countMatafuegos());
	}

	public void testGetMatafuegosDeCliente() {
		Cliente c = RandomDataGenerator.getRandomCliente();
		for (int i = 0;i<10;i++) {
			Matafuego m = RandomDataGenerator.getRandomMatafuegoDeCliente(c);
			cr.makePersistent(m.getCliente());
			ms.save(m);	
		}
		assertEquals(10, ms.getMatafuegosDeCliente(c).size());
	}

	public void testGetPruebasHidrahulicasDelMatafuego() {
		fail();
	}

	public void getServiciosDelMatafuego() {
		fail();
	}

	public void testGetUltimoServicioDelMatafuego() {
		fail();
	}

	public void testSaveServicioMatafuego() {
		fail();
	}
}
