/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.ziggurat.fenix.desktop.clientes;

import java.util.Collections;
import java.util.List;
import javax.swing.table.AbstractTableModel;
import org.ziggurat.fenix.common.facade.ClientesFacade;
import org.ziggurat.fenix.common.modelo.clientes.Cliente;

/**
 *
 * @author globant
 */
public class TableModelSimpleClientes extends AbstractTableModel {

    private List<Cliente> clientes = Collections.emptyList();
	private ClientesFacade cf = new ClientesFacade();
	
	public TableModelSimpleClientes() {
		
	}
	
	public void mostrarClientesPorNombre(String nombre) {
		clientes = cf.getClientesByNombre(nombre);
		this.fireTableDataChanged();
	}
	
	public void setListaDeClientes(List<Cliente> clientes) {
		this.clientes = clientes;
		this.fireTableDataChanged();
	}
	
	public void limpiarLista() {
		clientes = Collections.emptyList();
	}

	public void dataChanged() {
		this.fireTableDataChanged();
	}

	public Cliente getElementAt(int index) {
		return clientes.get(index);
	}

	public int getColumnCount() {
		return 1;
	}

	public int getRowCount() {		
		return clientes.size();
	}

	public Object getValueAt(int rowIndex, int columnIndex) {
		Cliente cliente = clientes.get(rowIndex);
		switch (columnIndex) {
        case 0:
            return cliente.getNombre(); 
        default:
            return "";
		}
	}

	@Override
	public String getColumnName(int column) {
		switch (column) {
        case 0:
            return "Nombre"; 
        default:
            return "";
		}
	}

	@Override
	public Class<?> getColumnClass(int columnIndex) {
		switch (columnIndex) {
        case 0:
            return String.class; 
        default:
            return String.class;
		}
	}

}
