/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.ziggurat.fenix.desktop.productos;

import java.math.BigDecimal;
import java.util.Collections;
import java.util.List;
import javax.swing.table.AbstractTableModel;
import org.ziggurat.fenix.common.modelo.productos.Producto;

/**
 *
 * @author globant
 */
public class TableModelProductos extends AbstractTableModel {

    private List<Producto> productos = Collections.emptyList();

    public TableModelProductos() {
    }
    
    public TableModelProductos(List<Producto> productos) {
        this.productos = productos;
        dataChanged();
    }

    public void limpiarLista() {
        productos = Collections.emptyList();
    }

    public void dataChanged() {
        this.fireTableDataChanged();
    }

    public Producto getElementAt(int index) {
        return productos.get(index);
    }

    public int getColumnCount() {
        return 3;
    }

    public int getRowCount() {
        return productos.size();
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
        Producto prod = productos.get(rowIndex);
        switch (columnIndex) {
            case 0:
                return prod.getMarca();
            case 1:
                return prod.getDescripcion();
            case 2:
                return prod.getPrecioVenta();
            default:
                return "";
        }
    }

    @Override
    public String getColumnName(int column) {
        switch (column) {
            case 0:
                return "Marca";
            case 1:
                return "Descripcion";
            case 2:
                return "Precio";
            default:
                return "";
        }
    }

    @Override
    public Class<?> getColumnClass(int arg0) {
        switch (arg0) {
            case 0:
                return String.class;
            case 1:
                return String.class;
            case 2:
                return BigDecimal.class;
            default:
                return String.class;
        }
    }

    public void setListaDeProductos(List<Producto> productos) {
        this.productos = productos;
        dataChanged();
    }
}
