package org.ziggurat.fenix.web;

import java.math.BigDecimal;
import java.text.DecimalFormatSymbols;
import java.text.NumberFormat;
import java.util.Locale;

import org.apache.wicket.util.convert.converters.BigDecimalConverter;

public class FenixBigDecimalConverter extends BigDecimalConverter {

	private static final long serialVersionUID = 1L;

	public BigDecimal convertToObject(String value, Locale locale)
	{
		if (value!= null) {
			value = value.replace('.', DecimalFormatSymbols.getInstance(locale).getDecimalSeparator());
			value = value.replace(',', DecimalFormatSymbols.getInstance(locale).getDecimalSeparator());
		}
		return super.convertToObject(value, locale);
	}

	@Override
	public String convertToString(Object value, Locale locale) {
		// TODO Auto-generated method stub
		return super.convertToString(value, locale);
	}

	@Override
	public NumberFormat getNumberFormat(Locale locale) {			
		NumberFormat format = super.getNumberFormat(locale);
		format.setGroupingUsed(false);
		return format;
	}		

}
