package org.ziggurat.fenix.web;

import java.util.Date;

import org.apache.wicket.extensions.markup.html.form.DateTextField;
import org.apache.wicket.extensions.yui.calendar.DatePicker;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.CompoundPropertyModel;
import org.ziggurat.fenix.common.util.FenixFormat;

abstract public class FenixPanelSelectorDeFechas extends Panel {

	private String text = "";
	
	public String getText() {
		return text;
	}

	public FenixPanelSelectorDeFechas(String id, String text) {
		super(id);
		this.text = text;
		
		add(new SelectorDeFechasForm("formFechas"));
	}
	
	abstract public void doAction(Date desde, Date hasta);
	
	private class SelectorDeFechasForm extends Form {

		private Date fechaDesde;
		private Date fechaHasta;
		
		public SelectorDeFechasForm(String id) {
			super(id);
			
			CompoundPropertyModel model = new CompoundPropertyModel(this);
			this.setModel(model);
			
			add(new Label("text", getText()));
			
			DateTextField dateTextFieldDesde = new DateTextField("fechaDesde", FenixFormat.DATE_FORMAT.toPattern());
			dateTextFieldDesde.setRequired(true);
			dateTextFieldDesde.add(new DatePicker());
			add(dateTextFieldDesde);
			
			DateTextField dateTextFieldHasta = new DateTextField("fechaHasta", FenixFormat.DATE_FORMAT.toPattern());
			dateTextFieldHasta.setRequired(true);
			dateTextFieldHasta.add(new DatePicker());
			add(dateTextFieldHasta);
			
			add(new FeedbackPanel("feedback"));
		}

		@Override
		protected void onSubmit() {
			if (fechaDesde.after(fechaHasta)) {
				error("La fecha inicial debe ser mayor que la fecha final");
			} else {
				doAction(fechaDesde, fechaHasta);
			}
		}
	}
}
