package org.ziggurat.fenix.web;

import org.apache.wicket.markup.html.image.resource.DynamicImageResource;
import org.jfree.chart.JFreeChart;

public class JFreeChartImage extends DynamicImageResource {

	private int width;
	private int height;
	private JFreeChart chart;
	private byte[] image;

	public JFreeChartImage(String id, JFreeChart chart, int width, int height) {
		try {
			this.width = width;
			this.height = height;
			this.chart = chart;			
			image = toImageData(chart.createBufferedImage(width, height));
		} catch (Exception e) {
			image = new byte[0];
		}
	}

	@Override
	protected byte[] getImageData() {
		return image;		
	}
}
