package org.ziggurat.fenix.web;

import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.link.Link;
import org.apache.wicket.markup.html.panel.Panel;
import org.ziggurat.fenix.web.login.FenixAuthenticatedWebSession;

public class LoggedAsPanel extends Panel {

	public LoggedAsPanel(String id) {
		super(id);
		add(new Label("currentUser", FenixAuthenticatedWebSession.get().getLoggedUserName()));
		add(new Link("salir") {

			@Override
			public void onClick() {
				FenixAuthenticatedWebSession.get().invalidate();
				setRedirect(true);
				setResponsePage(DefaultStartPage.class);
			}
			
		});
	}

	@Override
	public boolean isVisible() {
		return FenixAuthenticatedWebSession.get().isSignedIn();
	}
	
	
	
}
