package org.ziggurat.fenix.web;

import org.apache.wicket.Request;
import org.apache.wicket.RequestCycle;
import org.apache.wicket.Response;
import org.apache.wicket.authentication.AuthenticatedWebApplication;
import org.apache.wicket.authentication.AuthenticatedWebSession;
import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.protocol.http.WebRequest;
import org.apache.wicket.protocol.http.WebResponse;
import org.ziggurat.fenix.web.login.FenixAuthenticatedWebSession;
import org.ziggurat.fenix.web.login.LoginPage;
import org.ziggurat.fenix.web.proveedores.ListadoDeProveedores;

/**
 * Application object for your web application. If you want to run this application without deploying, run the Start class.
 * 
 * @see wicket.myproject.Start#main(String[])
 */
public class WicketApplication extends AuthenticatedWebApplication
{    
	
    /**
     * Constructor
     */
	public WicketApplication()
	{
	}
	
	@Override
	protected void init() {		
		super.init();
		getApplicationSettings().setPageExpiredErrorPage(DefaultStartPage.class);
		getApplicationSettings().setAccessDeniedPage(LoginPage.class);
		//getRequestCycleSettings().setGatherExtendedBrowserInfo(true);
	}
	
	@Override
	public RequestCycle newRequestCycle(Request request, Response response) {
		return new MyRequestCycle(this, (WebRequest)request, (WebResponse)response);
	}

	/**
	 * @see wicket.Application#getHomePage()
	 */
	public Class getHomePage()
	{
		//return HomePage.class;
		//return LoginPage.class;
		return ListadoDeProveedores.class;		
	}

	@Override
	protected Class<? extends WebPage> getSignInPageClass() {
		return LoginPage.class;
	}

	@Override
	protected Class<? extends AuthenticatedWebSession> getWebSessionClass() {
		return FenixAuthenticatedWebSession.class;
	}
	
	@Override
	public String getConfigurationType() {
		return WicketApplication.DEVELOPMENT;
		//return WicketApplication.DEPLOYMENT;
	}

}
