package org.ziggurat.fenix.web.cheques;

import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.form.TextField;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.apache.wicket.model.CompoundPropertyModel;
import org.ziggurat.fenix.common.database.hibernate.HibChequesRepository;
import org.ziggurat.fenix.common.modelo.transacciones.Cheque;
import org.ziggurat.fenix.common.modelo.transacciones.EstadoDeCheque;

public class AccionSobreChequePage extends AbstractChequesPage {

	private Cheque cheque;
	
	public AccionSobreChequePage(Cheque cheque) {
		this.cheque = cheque;
		add(new AccionSobreChequeForm("destinoDeChequeForm"));
	}
	
	private class AccionSobreChequeForm extends Form<Cheque> {
		
		/**
		 * 
		 */
		private static final long serialVersionUID = 1360230604935205415L;

		public AccionSobreChequeForm(String id) {
			super(id);

			CompoundPropertyModel<Cheque> model = new CompoundPropertyModel<Cheque>(cheque);
			this.setModel(model);

			TextField<Cheque> descripcion = new TextField<Cheque>("descripcion");
			add(descripcion);
			
			/*DropDownChoice<EstadoDeCheque> estado = new DropDownChoice("estado", Arrays.asList(EstadoDeCheque.values()));
			add(estado);*/

			add(new FeedbackPanel("feedback"));
		}

		@Override
		protected void onSubmit() {
			HibChequesRepository repo = new HibChequesRepository();
			cheque.setEstado(EstadoDeCheque.OTRO);
			repo.makePersistent(cheque);
			setResponsePage(ListadoDeCheques.class);
		}

	}
	
}
