package org.ziggurat.fenix.web.cheques;

import java.util.Iterator;

import org.apache.wicket.markup.repeater.data.IDataProvider;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;
import org.ziggurat.fenix.common.database.hibernate.HibChequesRepository;
import org.ziggurat.fenix.common.modelo.transacciones.Cheque;
import org.ziggurat.fenix.common.modelo.transacciones.EstadoDeCheque;

public class ChequesDataProvider implements IDataProvider<Cheque> {

	private HibChequesRepository repo = new HibChequesRepository();
	private EstadoDeCheque estado;
	
	public ChequesDataProvider(EstadoDeCheque estado) {
		this.estado = estado;
	}
	
	@Override
	public Iterator<? extends Cheque> iterator(int first, int count) {
		if (repo == null) {
			repo = new HibChequesRepository();
		}
		return repo.getPaginaDeChequesPorEstado(estado, first, count).iterator();
	}

	@Override
	public IModel<Cheque> model(Cheque object) {
		return new Model<Cheque>(object);
	}

	@Override
	public int size() {		
		if (repo == null) {
			repo = new HibChequesRepository();
		}
		return repo.countCheques(estado);
	}

	@Override
	public void detach() {
		repo = null;
	}

}
