package org.ziggurat.fenix.web.clientes;

import java.util.Collections;
import java.util.Iterator;

import org.apache.commons.lang.StringUtils;
import org.apache.wicket.extensions.ajax.markup.html.autocomplete.AutoCompleteTextField;
import org.apache.wicket.util.convert.IConverter;
import org.ziggurat.fenix.common.database.hibernate.HibClienteRepository;
import org.ziggurat.fenix.common.modelo.clientes.Cliente;

public class ClienteAutoCompleteTextField extends AutoCompleteTextField<Cliente> {

	public ClienteAutoCompleteTextField(String id) {
		super(id, new ClienteAutoCompleteRenderer());
	}

	@Override
	protected Iterator<Cliente> getChoices(String input) {
		if (StringUtils.isEmpty(input)) return Collections.EMPTY_LIST.iterator();
		HibClienteRepository repo = new HibClienteRepository();
		return repo.getClientesPorNombre(input).iterator();
	}

	@Override
	public IConverter getConverter(Class<?> type) {
		return new FenixIdToClienteConverter();
	}
	
	

}
