package org.ziggurat.fenix.web.clientes;

import java.util.Iterator;
import java.util.List;

import org.apache.wicket.markup.repeater.data.IDataProvider;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;
import org.ziggurat.fenix.common.database.hibernate.HibClienteRepository;
import org.ziggurat.fenix.common.modelo.clientes.Cliente;

public class ClientesDataProvider implements IDataProvider<Cliente> {

	public String filtro = null;
		
	public String getFiltro() {
		return filtro;
	}

	public void setFiltro(String filtro) {
		this.filtro = filtro;
	}

	@Override
	public Iterator<? extends Cliente> iterator(int first, int count) {
		if (filtro != null) {
			return listaFiltradaDeClientes(first, count, filtro).iterator();
		} else {
			return listaCompletaDeClientes(first, count).iterator();
		}		
	}

	@Override
	public IModel<Cliente> model(Cliente object) {
		return new Model<Cliente>(object);
	}

	@Override
	public int size() {
		if (filtro != null) {
			return countClientesFiltrados(filtro);
		} else {
			return countAllClientes();
		}
	}

	@Override
	public void detach() {
		
	}
	
	public List<Cliente> listaCompletaDeClientes(int first, int count) {
		HibClienteRepository repo = new HibClienteRepository();
		return repo.findListaDeClientesPage(first, count);
	}
	
	public List<Cliente> listaFiltradaDeClientes(int first, int count, String filtro) {
		HibClienteRepository repo = new HibClienteRepository();
		return repo.findListaDeClientesPage(first, count, filtro);
	}
	
	public int countAllClientes() {
		HibClienteRepository repo = new HibClienteRepository();
		return repo.countClientes();
	}
	
	public int countClientesFiltrados(String filtro) {
		HibClienteRepository repo = new HibClienteRepository();
		return repo.countClientesFiltrados(filtro);		
	}
	
}
