package org.ziggurat.fenix.web.clientes;

import java.util.List;
import java.util.Locale;

import org.apache.commons.lang.StringUtils;
import org.apache.wicket.util.convert.converters.AbstractConverter;
import org.ziggurat.fenix.common.database.hibernate.HibClienteRepository;
import org.ziggurat.fenix.common.modelo.clientes.Cliente;

public class FenixIdToClienteConverter extends AbstractConverter {

	@Override
	protected Class<?> getTargetType() {
		return Cliente.class;
	}

	@Override
	public Object convertToObject(String value, Locale locale) {
		if (StringUtils.isEmpty(value)) return null;
		
		String[] cliente = StringUtils.split(value);
		HibClienteRepository repo = new HibClienteRepository();
		List<Cliente> results = repo.getClientesPorNombre(cliente[0]);
		if (results.size() > 0) {
			return results.get(0);
		}
		return null;
	}

}
