package org.ziggurat.fenix.web.clientes;

import java.util.Collections;
import java.util.List;

import org.apache.commons.lang.StringUtils;
import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.markup.html.AjaxLink;
import org.apache.wicket.extensions.ajax.markup.html.IndicatingAjaxButton;
import org.apache.wicket.markup.html.WebMarkupContainer;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.form.TextField;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.markup.repeater.Item;
import org.apache.wicket.markup.repeater.data.DataView;
import org.apache.wicket.model.PropertyModel;
import org.ziggurat.fenix.common.modelo.clientes.Cliente;

public class PanelSeleccionarCliente extends Panel {

	private TextField buscarClienteTF;
	private String cliente = new String("");
	private List<Cliente> clientes = Collections.EMPTY_LIST;
	private WebMarkupContainer tablaClientes = new WebMarkupContainer("tablaClientes");	
	private ClientesDataProvider dataProvider =  new ClientesDataProvider();
	
	public PanelSeleccionarCliente(final ModalWindowSeleccionarCliente modal) {
		super(modal.getContentId());
		add(new BuscarClienteForm("formBuscarCliente"));
		DataView<Cliente> dataView = new DataView<Cliente>("view", dataProvider) {

			@Override
			protected void populateItem(final Item<Cliente> item) {
				final Cliente cliente = item.getModelObject();
				item.add(new AjaxLink("linkNombre") {

					@Override
					public void onClick(AjaxRequestTarget target) {
						modal.setCliente(cliente);						
						modal.close(target);						
					}
				}.add(new Label("nombre", cliente.getNombre())));										
			}
		};
		tablaClientes.setOutputMarkupId(true);
		tablaClientes.add(dataView);
		add(tablaClientes);
	}
	
	public void limpiarFiltro() {
		dataProvider.setFiltro(StringUtils.EMPTY);
	}
	
	private class BuscarClienteForm extends Form {

		private TextField buscarClienteTF;
		private String cliente = new String("");
		
		
		public BuscarClienteForm(String id) {
			super(id);
			buscarClienteTF = new TextField("textFieldBuscarCliente", new PropertyModel<String>(this, "cliente"));
			add(buscarClienteTF);			
			add(new IndicatingAjaxButton("submit") {

				@Override
				protected void onSubmit(AjaxRequestTarget target, Form<?> form) {
					dataProvider.setFiltro(cliente);
					target.addComponent(tablaClientes);					
				}
				
			});
		}
			
	}
}
