/*
 *  Copyright 2009 manuel.
 * 
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 * 
 *       http://www.apache.org/licenses/LICENSE-2.0
 * 
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *  under the License.
 */

package org.ziggurat.fenix.web.inicio;

import java.util.List;

import org.apache.wicket.markup.html.IHeaderContributor;
import org.apache.wicket.markup.html.IHeaderResponse;
import org.apache.wicket.markup.html.panel.EmptyPanel;
import org.apache.wicket.markup.html.panel.Panel;
import org.ziggurat.fenix.common.database.hibernate.HibProveedorRepository;
import org.ziggurat.fenix.common.modelo.proveedores.Proveedor;
import org.ziggurat.fenix.web.AbstractFenixPage;

/**
 *
 * @author manuel
 */
public class Inicio extends AbstractFenixPage implements IHeaderContributor {

    public Inicio() {
        HibProveedorRepository repoProv = new HibProveedorRepository();
        List<Proveedor> proveedores = repoProv.getProveedoresConDeudaPorMasDeXDias(35);
        if (proveedores.size() != 0) {
            add(new DeudasConProveedoresPanel("deudas", proveedores));
        } else {
            add(new SinDeudasPanel("deudas"));
        }
        //add(new BuscarProveedorPanel("buscarProveedorPanel"));
        //add(new BuscarClientesPanel("buscarClientePanel"));
    }
    

    @Override
    public Panel getSubMenuPanel() {
        return new EmptyPanel("submenu");
    }

    @Override
	public void renderHead(IHeaderResponse response) {
		response.renderOnLoadJavascript("$('inicioTab').addClassName('current')");
	}
    
}
