package org.ziggurat.fenix.web.login;

import java.util.Arrays;
import java.util.List;

import org.apache.wicket.Request;
import org.apache.wicket.Session;
import org.apache.wicket.authentication.AuthenticatedWebSession;
import org.apache.wicket.authorization.strategies.role.Roles;
import org.ziggurat.fenix.web.FenixRoles;

public class FenixAuthenticatedWebSession extends AuthenticatedWebSession {

	private String userName;
	public static List<String> USERS = Arrays.asList(new String[] {"fenix", "nadie"});
	
	public FenixAuthenticatedWebSession(Request request) {
		super(request);
	}

	@Override
	public boolean authenticate(String username, String password) {
		this.userName = username;
		if (USERS.contains(username)) {
			return username.equals(password);
		}
		return false;
	}

	@Override
	public Roles getRoles() {
		if (isSignedIn())
        {
			if (userName.equals("nadie")) {
				return new Roles(new String[] {FenixRoles.PROVEEDORES,
						FenixRoles.MATAFUEGOS,
						FenixRoles.CHEQUES,
						FenixRoles.RESUMENES,
						FenixRoles.CLIENTES
						});
			} else if (userName.equals("fenix")) {
				return new Roles(new String[] {FenixRoles.PROVEEDORES,
						FenixRoles.MATAFUEGOS,
						FenixRoles.CHEQUES,
						FenixRoles.RESUMENES,
						FenixRoles.CLIENTES
						});
			}
        }
		//Roles para cualquiera, SIN LOGEARSE !!!
        return new Roles(new String[] {FenixRoles.MATAFUEGOS});
	}
	
	public String getLoggedUserName() {
		return userName;
	}
	
	public static FenixAuthenticatedWebSession get() {
		return (FenixAuthenticatedWebSession) Session.get();
	}
}
