package org.ziggurat.fenix.web.matafuegos;

import java.util.Iterator;
import java.util.List;

import org.apache.wicket.markup.repeater.data.IDataProvider;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;
import org.ziggurat.fenix.common.modelo.clientes.Cliente;
import org.ziggurat.fenix.common.modelo.matafuego.Matafuego;
import org.ziggurat.fenix.common.services.matafuegos.MatafuegosService;

public class MatafuegosDeClienteDataProvider implements IDataProvider<Matafuego> {

	private List<Matafuego> lista;
	
	public MatafuegosDeClienteDataProvider(Cliente cliente) {
		MatafuegosService service = new MatafuegosService();
		lista = service.getMatafuegosDeCliente(cliente);
	}
	
	@Override
	public Iterator<? extends Matafuego> iterator(int first, int count) {
		return lista.iterator();
	}

	@Override
	public IModel<Matafuego> model(Matafuego object) {
		return new Model<Matafuego>(object);
	}

	@Override
	public int size() {
		return lista.size();
	}

	@Override
	public void detach() {
		
	}

}
