package org.ziggurat.fenix.web.proveedores;

import java.util.Iterator;

import org.apache.commons.lang.StringUtils;
import org.apache.wicket.markup.repeater.data.IDataProvider;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;
import org.ziggurat.fenix.common.database.hibernate.HibProveedorRepository;
import org.ziggurat.fenix.common.modelo.proveedores.Proveedor;

public class BusquedaProveedoresDataProvider implements IDataProvider<Proveedor> {

	private HibProveedorRepository repo = new HibProveedorRepository();
	private String busqueda = StringUtils.EMPTY;
	
	public BusquedaProveedoresDataProvider(String busqueda) {
		this.busqueda = busqueda;
	}
	
	@Override
	public Iterator<? extends Proveedor> iterator(int first, int count) {
		if (repo == null) {
			repo = new HibProveedorRepository();
		}
		return repo.findListaDeProveedoresPage(first, count, busqueda).iterator();
	}

	@Override
	public IModel<Proveedor> model(Proveedor object) {
		return new Model<Proveedor>(object); 
	}

	@Override
	public int size() {
		if (repo == null) {
			repo = new HibProveedorRepository();
		}
		return repo.countProveedoresFiltrados(busqueda);
	}

	@Override
	public void detach() {
		repo = null;		
	}
	
}
