package org.ziggurat.fenix.web.proveedores;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.markup.html.AjaxLink;
import org.apache.wicket.extensions.ajax.markup.html.modal.ModalWindow;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.panel.Panel;
import org.ziggurat.fenix.common.modelo.proveedores.PagoAProveedorInmutable;
import org.ziggurat.fenix.web.cheques.DetalleCheque;

public class LineaDeCCPagoChequePanel extends Panel {

	public LineaDeCCPagoChequePanel(String id, PagoAProveedorInmutable pagoConCheque) {
		super(id);
		
		final ModalWindow modal;
		add(modal = new ModalWindow("infoCheque"));
		modal.setCssClassName(ModalWindow.CSS_CLASS_GRAY);
		modal.setContent(new DetalleCheque(modal.getContentId(), pagoConCheque.getCheque()));
		modal.setTitle("Detalles del cheque");
		modal.setCookieName("cheque" + pagoConCheque.getCheque().hashCode());
		modal.setWidthUnit("em");
		modal.setHeightUnit("em");
		modal.setInitialWidth(35);
		modal.setInitialHeight(23);
		modal.setResizable(false);
		
		add(new AjaxLink("numeroLink") {
			@Override
			public void onClick(AjaxRequestTarget target) {
				modal.show(target);
			}
		}.add(new Label("numero", "cheque " + pagoConCheque.getCheque().getNumeroCheque())));
	}

	/**
	 * 
	 */
	private static final long serialVersionUID = -2058650907591337550L;

	
	
	
}
