package org.ziggurat.fenix.web.proveedores;

import org.apache.log4j.Logger;
import org.apache.wicket.AttributeModifier;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.link.Link;
import org.apache.wicket.markup.repeater.Item;
import org.apache.wicket.markup.repeater.data.DataView;
import org.apache.wicket.markup.repeater.data.ListDataProvider;
import org.apache.wicket.model.AbstractReadOnlyModel;
import org.ziggurat.fenix.common.database.hibernate.HibProveedorRepository;
import org.ziggurat.fenix.common.database.hibernate.HibTransaccionConProveedorRepository;
import org.ziggurat.fenix.common.modelo.proveedores.Proveedor;
import org.ziggurat.fenix.common.util.FenixFormat;

public class ListadoDeProveedoresDeudores extends AbstractProveedoresPage {
	
	private static Logger log = Logger.getLogger("fenix");
	
	final transient HibProveedorRepository repo = new HibProveedorRepository();
	final transient HibTransaccionConProveedorRepository repoTran = new HibTransaccionConProveedorRepository();
	
	public ListadoDeProveedoresDeudores() {
		log.info("Entrando a pagina de listado de proveedores con deudas ");		
		
		add(new Label("header", "Listado de proveedores con deudas"));
		
		final DataView<Proveedor> dataView = new DataView<Proveedor>("view", new ListDataProvider(repo.findProveedoresDeudores())) {
			private static final long serialVersionUID = 1L;			
			public void populateItem(final Item<Proveedor> item) {
				final Proveedor proveedor = item.getModelObject();
				item.add(new Link("nombreLink") {
					@Override
					public void onClick() {
						setResponsePage(new CCProveedorPage(proveedor));
					}
				}.add(new Label("nombre", proveedor.getNombre())));
				
				item.add(new Label("tipo", proveedor.getCategoria().getNombre()));
				item.add(new Label("cuit", proveedor.getCUIT()));
				item.add(new Label("saldo", FenixFormat.getMoneda(repo.getSaldoDeProveedor(proveedor))));
				item.add(new AttributeModifier("class", true,
						new AbstractReadOnlyModel() {
							public Object getObject() {
								return (item.getIndex() % 2 == 1) ? "even" : "odd";
							}
						}));
			}
		};
		add(dataView);
	}
}
