package org.ziggurat.fenix.web.proveedores;

import java.math.BigDecimal;
import java.util.Calendar;
import java.util.Date;

import org.apache.log4j.Logger;
import org.apache.wicket.extensions.markup.html.form.DateTextField;
import org.apache.wicket.extensions.yui.calendar.DatePicker;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.form.TextField;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.apache.wicket.model.CompoundPropertyModel;
import org.apache.wicket.util.convert.IConverter;
import org.ziggurat.fenix.common.database.hibernate.HibTransaccionConProveedorRepository;
import org.ziggurat.fenix.common.modelo.proveedores.PagoAProveedorInmutable;
import org.ziggurat.fenix.common.modelo.proveedores.Proveedor;
import org.ziggurat.fenix.common.util.FenixFormat;
import org.ziggurat.fenix.web.FenixBigDecimalConverter;
import org.ziggurat.fenix.web.FocusOnBehavior;

public class NuevoPagoEfectivo extends AbstractProveedoresPage {

	private Proveedor proveedor;
	private static Logger log = Logger.getLogger("fenix");
	
	public NuevoPagoEfectivo(Proveedor proveedor) {
		log.info("Entrando a pagina de Nuevo pago efectivo " + proveedor.getNombre());
		this.proveedor = proveedor;
		add(new NuevoPagoForm("nuevoPagoForm"));
		add(new Label("nombreProveedor", proveedor.getNombre()));
	}

	private class NuevoPagoForm extends Form {

		private Date fecha = Calendar.getInstance().getTime();
		private BigDecimal monto;
		private String notas;
		private String nroRecibo;

		public NuevoPagoForm(String id) {
			super(id);

			CompoundPropertyModel model = new CompoundPropertyModel(this);
			this.setModel(model);

			DateTextField dateTextField = new DateTextField("fecha", FenixFormat.DATE_FORMAT.toPattern());
			dateTextField.setRequired(true);
			dateTextField.add(new DatePicker());
			add(dateTextField);

			TextField monto = new TextField("monto") {
				@Override
				public IConverter getConverter(Class type) {
					return new FenixBigDecimalConverter();
				}

			};
			monto.add(new FocusOnBehavior());
			monto.setRequired(true);
			add(monto);

			TextField nroRecibo = new TextField("nroRecibo");
			add(nroRecibo);

			TextField notas = new TextField("notas");
			add(notas);

			add(new FeedbackPanel("feedback"));
		}

		@Override
		protected void onSubmit() {
			HibTransaccionConProveedorRepository repoTran = new HibTransaccionConProveedorRepository();
			PagoAProveedorInmutable pago = new PagoAProveedorInmutable(proveedor, fecha, notas, monto,  nroRecibo);
			repoTran.makePersistent(pago);
			setResponsePage(new CCProveedorPage(proveedor));
			//setResponsePage(ListadoDeProveedores.class);
		}

	}

}
