package org.ziggurat.fenix.web.proveedores;

import org.apache.log4j.Logger;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.form.DropDownChoice;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.form.TextField;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.apache.wicket.model.CompoundPropertyModel;
import org.apache.wicket.model.ResourceModel;
import org.ziggurat.fenix.common.database.hibernate.HibProveedorRepository;
import org.ziggurat.fenix.common.modelo.proveedores.Proveedor;
import org.ziggurat.fenix.common.services.proveedores.CategoriasDeProveedorService;
import org.ziggurat.fenix.web.FocusOnBehavior;

public class NuevoProveedor extends AbstractProveedoresPage {

	private Proveedor proveedor;
	private static Logger log = Logger.getLogger("fenix");

	public NuevoProveedor(Proveedor p) {
		log.info("Entrando a pagina de modificar proveedor " + p.getNombre());
		proveedor = p;
		add(new NuevoProveedorForm("nuevoProveedorForm"));
		add(new Label("page.header1.title", new ResourceModel("page.headerModificarProveedor")));
	}
	
	public NuevoProveedor() {
		log.info("Entrando a pagina de nuevo proveedor");
		proveedor = new Proveedor();
		add(new NuevoProveedorForm("nuevoProveedorForm"));
		add(new Label("page.header1.title", new ResourceModel("page.headerNuevoProveedor")));
	}

	private class NuevoProveedorForm extends Form {

		public NuevoProveedorForm(String id) {
			super(id);
			CategoriasDeProveedorService catService = new CategoriasDeProveedorService();
			CompoundPropertyModel<Proveedor> model = new CompoundPropertyModel<Proveedor>(
					proveedor);
			this.setModel(model);

			TextField<Proveedor> nombre = new TextField<Proveedor>("nombre");
			nombre.setRequired(true);
			nombre.add(new FocusOnBehavior());
			add(nombre);

			DropDownChoice tipoDeProveedor = new DropDownChoice("categoria", catService.getCategorias());
			tipoDeProveedor.setRequired(true);
			add(tipoDeProveedor);

			TextField<Proveedor> cuit = new TextField<Proveedor>("CUIT");
			cuit.setRequired(true);
			add(cuit);

			TextField<Proveedor> notas = new TextField<Proveedor>("notas");
			add(notas);

			add(new FeedbackPanel("feedback"));
		}

		@Override
		protected void onSubmit() {
			HibProveedorRepository repo = new HibProveedorRepository();
			repo.makePersistent(proveedor);
			setResponsePage(new CCProveedorPage(proveedor));
		}

	}

}
