package org.ziggurat.fenix.web.resumenes;

import java.util.Calendar;

import org.apache.wicket.markup.html.IHeaderContributor;
import org.apache.wicket.markup.html.IHeaderResponse;
import org.apache.wicket.markup.html.link.Link;
import org.apache.wicket.markup.html.panel.Panel;

public class SubMenuPanelResumenes extends Panel implements IHeaderContributor {

	public SubMenuPanelResumenes(String id) {
		super(id);
		add(new Link("resumenDelMes") {
			@Override
			public void onClick() {
				Calendar cal = Calendar.getInstance();
				setResponsePage(new ResumenMensualPage(cal.get(Calendar.MONTH) + 1, cal.get(Calendar.YEAR)));
			}
		});
		add(new Link("libroDeIva") {
			@Override
			public void onClick() {
				setResponsePage(new LibroDeIvaComprasPage(Calendar.getInstance().get(Calendar.MONTH) + 1, Calendar.getInstance().get(Calendar.YEAR)));
			}
		});		
		add(new Link("pagosDelMes") {
			@Override
			public void onClick() {
				setResponsePage(new ListadoDePagosPage(Calendar.getInstance().get(Calendar.MONTH) + 1, Calendar.getInstance().get(Calendar.YEAR)));
			}
		});
	}
	
	@Override
	public void renderHead(IHeaderResponse response) {
		response.renderOnLoadJavascript("$('resumenesTab').addClassName('current');");
	}

}
