package org.ziggurat.fenix.web.proveedores;

import org.apache.wicket.markup.html.link.Link;
import org.apache.wicket.util.tester.FormTester;


public class TestNuevoProveedor extends AbstractProveedoresTest {

	public void testNuevoProveedor() {
		tester.assertComponent("submenu:nuevoProveedor", Link.class);
		tester.clickLink("submenu:nuevoProveedor");
		tester.assertRenderedPage(NuevoProveedor.class);
		FormTester formTester = tester.newFormTester("nuevoProveedorForm");
		formTester.setValue("nombre", "Manuel");
		formTester.select("categoria", 3);
		formTester.setValue("CUIT", "234234234");
		formTester.setValue("notas", "Unas notas");
		formTester.submit();

		tester.assertNoErrorMessage();
		tester.assertRenderedPage(CCProveedorPage.class);
	}
	
	public void testNuevoProveedorConErrores() {
		tester.assertComponent("submenu:nuevoProveedor", Link.class);
		tester.clickLink("submenu:nuevoProveedor");
		tester.assertRenderedPage(NuevoProveedor.class);
		FormTester formTester = tester.newFormTester("nuevoProveedorForm");
		
		formTester.submit();
		tester.assertErrorMessages(
				new String[]{
							"Debe ingresar el nombre del proveedor",
							"Debe ingresar la categoria del proveedor",
							"Debe ingresar el CUIT del proveedor"
				});
		tester.assertRenderedPage(NuevoProveedor.class);
	}	
	
}
