package org.ziggurat.fenix.web.resumenes;

import java.util.Calendar;
import java.util.Locale;

import org.apache.wicket.markup.html.link.Link;
import org.apache.wicket.markup.repeater.data.DataView;

public class TestPagosDelMes extends AbstractResumenesTest {

	public void testPagosDelMes() {
		login();
		tester.clickLink("resumenes");
		tester.clickLink("submenu:pagosDelMes");
		tester.assertRenderedPage(ListadoDePagosPage.class);
		tester.assertComponent("view", DataView.class);
	}
	
	public void testNavegacionEntreMeses() {
		login();
		tester.clickLink("resumenes");
		tester.clickLink("submenu:pagosDelMes");
		tester.assertRenderedPage(ListadoDePagosPage.class);
		Calendar cal = Calendar.getInstance();
		tester.assertContains(cal.getDisplayName(Calendar.MONTH, Calendar.LONG, Locale.getDefault()));
		
		tester.assertComponent("mesSiguienteLink", Link.class);
		tester.assertComponent("mesAnteriorLink", Link.class);
		
		tester.clickLink("mesSiguienteLink");
		cal.add(Calendar.MONTH, 1);
		tester.assertContains(cal.getDisplayName(Calendar.MONTH, Calendar.LONG, Locale.getDefault()));
		
		tester.assertComponent("mesSiguienteLink", Link.class);
		tester.assertComponent("mesAnteriorLink", Link.class);
		
		tester.clickLink("mesAnteriorLink");
		cal.add(Calendar.MONTH, -1);
		tester.assertContains(cal.getDisplayName(Calendar.MONTH, Calendar.LONG, Locale.getDefault()));
		
		tester.clickLink("mesAnteriorLink");
		cal.add(Calendar.MONTH, -1);
		tester.assertContains(cal.getDisplayName(Calendar.MONTH, Calendar.LONG, Locale.getDefault()));
	}
	
}
