package org.ziggurat.fenix.web.resumenes;

import java.util.Calendar;
import java.util.Locale;

import org.apache.wicket.markup.html.form.DropDownChoice;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.link.Link;
import org.apache.wicket.util.tester.FormTester;

public class TestResumenMensual extends AbstractResumenesTest {

	public void testNavegacionEntreMeses() {
		login();
		tester.clickLink("submenu:resumenDelMes");
		tester.assertRenderedPage(ResumenMensualPage.class);
		Calendar cal = Calendar.getInstance();
		tester.assertContains(cal.getDisplayName(Calendar.MONTH, Calendar.LONG, Locale.getDefault()));
		
		tester.assertComponent("mesSiguienteLink", Link.class);
		tester.assertComponent("mesAnteriorLink", Link.class);
		
		tester.clickLink("mesSiguienteLink");
		cal.add(Calendar.MONTH, 1);
		tester.assertContains(cal.getDisplayName(Calendar.MONTH, Calendar.LONG, Locale.getDefault()));
		
		tester.assertComponent("mesSiguienteLink", Link.class);
		tester.assertComponent("mesAnteriorLink", Link.class);
		
		tester.clickLink("mesAnteriorLink");
		cal.add(Calendar.MONTH, -1);
		tester.assertContains(cal.getDisplayName(Calendar.MONTH, Calendar.LONG, Locale.getDefault()));
		
		tester.clickLink("mesAnteriorLink");
		cal.add(Calendar.MONTH, -1);
		tester.assertContains(cal.getDisplayName(Calendar.MONTH, Calendar.LONG, Locale.getDefault()));
	}
	
	public void testCambiarCategoriaEnLibroDeIva() {
		login();
		tester.clickLink("submenu:resumenDelMes");
		tester.assertComponent("view:1:tipoLink", Link.class);
		tester.clickLink("view:1:tipoLink");
		tester.assertRenderedPage(LibroDeIvaComprasPage.class);
		tester.assertComponent("libroIvaPanel", LibroDeIvaPanel.class);
		tester.assertComponent("selectCategoriaForm", Form.class);
		tester.assertComponent("selectCategoriaForm:selectCategoria", DropDownChoice.class);		
		
		FormTester form = tester.newFormTester("selectCategoriaForm");		
		form.select("selectCategoria", 2);
		
		tester.assertRenderedPage(LibroDeIvaComprasPage.class);
	}
	
	public void testCambiarDePaginaEnLibroDeIvaPorCategoria() {
		login();
		tester.clickLink("submenu:resumenDelMes");
		tester.assertComponent("view:1:tipoLink", Link.class);
		tester.clickLink("view:1:tipoLink");
		tester.assertRenderedPage(LibroDeIvaComprasPage.class);
		tester.clickLink("libroIvaPanel:mesAnteriorLink");
		tester.assertRenderedPage(LibroDeIvaComprasPage.class);
		tester.clickLink("libroIvaPanel:mesSiguienteLink");
		tester.assertRenderedPage(LibroDeIvaComprasPage.class);
	}
	
	public void testLibroIvaGeneral() {
		login();
		tester.clickLink("submenu:libroDeIva");		
		tester.assertRenderedPage(LibroDeIvaComprasPage.class);
		tester.assertComponent("libroIvaPanel", LibroDeIvaPanel.class);
	}
	
}
