CREATE TABLE cheques (
    id bigint NOT NULL,
    cuit character varying(255),
    alaordende character varying(255),
    banco character varying(255),
    descripcion character varying(255),
    eliminado boolean NOT NULL,
    entregadopor character varying(255),
    estado character varying(255),
    fecha date,
    fechadecobro date,
    monto numeric(19,2) NOT NULL,
    numerocheque character varying(255) NOT NULL
);


ALTER TABLE public.cheques OWNER TO postgres;

--
-- Name: clientes; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE clientes (
    id bigint NOT NULL,
    celular character varying(255),
    documento character varying(255),
    domicilio character varying(255),
    email character varying(255),
    fax character varying(255),
    localidad character varying(255),
    nombre character varying(255),
    responsabilidad character varying(255),
    telefono character varying(255),
    tipo_doc character varying(255)
);


ALTER TABLE public.clientes OWNER TO postgres;

--
-- Name: compras_a_proveedor; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE compras_a_proveedor (
    id bigint NOT NULL,
    eliminado boolean NOT NULL,
    fechaaltaregistro date,
    notas character varying(255),
    proveedor_id bigint,
    fecha date,
    montoiva numeric(19,2),
    netosiniva numeric(19,2),
    nogravadoexento numeric(19,2),
    numero character varying(255),
    percepciones numeric(19,2),
    total numeric(19,2) NOT NULL
);


ALTER TABLE public.compras_a_proveedor OWNER TO postgres;

--
-- Name: dps; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE dps (
    id bigint NOT NULL,
    co2 boolean NOT NULL,
    afff boolean NOT NULL,
    agua boolean NOT NULL,
    estado character varying(255),
    fecha date,
    hcfc boolean NOT NULL,
    lavadointerior boolean NOT NULL,
    n2 boolean NOT NULL,
    notas character varying(255),
    numero character varying(255),
    ph boolean NOT NULL,
    pintura boolean NOT NULL,
    polvocarga double precision NOT NULL,
    polvotyp boolean NOT NULL,
    quimicaab boolean NOT NULL,
    rrrchasis boolean NOT NULL,
    rrrdiscoytapon boolean NOT NULL,
    rrrexterior boolean NOT NULL,
    rrrmangyconec boolean NOT NULL,
    rrrmanometro boolean NOT NULL,
    rrrrosca boolean NOT NULL,
    rrrruedas boolean NOT NULL,
    rrrtobera boolean NOT NULL,
    rrrvalyvalreduc boolean NOT NULL,
    secado boolean NOT NULL,
    matafuego_id bigint
);


ALTER TABLE public.dps OWNER TO postgres;

--
-- Name: hibernate_sequences; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE hibernate_sequences (
    sequence_name character varying(255),
    sequence_next_hi_value integer
);


ALTER TABLE public.hibernate_sequences OWNER TO postgres;

--
-- Name: matafuegos; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE matafuegos (
    id bigint NOT NULL,
    anofabricacion integer NOT NULL,
    capacidad double precision NOT NULL,
    direccion character varying(255),
    idinterna character varying(255),
    marca character varying(255),
    nombre character varying(255),
    nroaparato character varying(255),
    tipomatafuego character varying(255),
    ubicacion character varying(255),
    cliente_id bigint
);


ALTER TABLE public.matafuegos OWNER TO postgres;

--
-- Name: pagos_a_proveedor; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE pagos_a_proveedor (
    id bigint NOT NULL,
    eliminado boolean NOT NULL,
    fechaaltaregistro date,
    notas character varying(255),
    proveedor_id bigint,
    fecha date,
    monto numeric(19,2) NOT NULL,
    nrorecibo character varying(255),
    cheque_fk bigint
);


ALTER TABLE public.pagos_a_proveedor OWNER TO postgres;

--
-- Name: proveedores; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE proveedores (
    id bigint NOT NULL,
    cuit character varying(255),
    nombre character varying(255),
    notas character varying(255),
    tipodeproveedor character varying(255)
);


ALTER TABLE public.proveedores OWNER TO postgres;

--
-- Name: hibernate_sequence; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE hibernate_sequence
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.hibernate_sequence OWNER TO postgres;

--
-- Name: hibernate_sequence; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('hibernate_sequence', 111626, true);


--
-- Data for Name: cheques; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO cheques VALUES (250, '30667503414', NULL, 'SANTADER  RIO', NULL, false, 'VIAL TRES', 'ENTREGADO_A_PROVEEDOR', '2008-07-15', '2008-08-15', 398.00, '42228431');
INSERT INTO cheques VALUES (75, '30545690922', 'de la penn seguridad fenix sa', 'credicoop', NULL, false, NULL, 'DEPOSITADO', '2008-07-14', '2008-07-31', 1618.84, '24068535');
INSERT INTO cheques VALUES (263, '20071522629', NULL, 'BSE(santiago del estero', NULL, false, 'Fraccionadora del sur', 'DEPOSITADO', '2008-07-04', '2008-07-05', 226.19, '06968857');
INSERT INTO cheques VALUES (280, NULL, NULL, 'patagonia', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-06-20', NULL, 107.00, '65818565');
INSERT INTO cheques VALUES (376, '30578475660', 'SEGURIDAD FENIX S.A.', 'PATAGONIA', NULL, false, 'AGRO EL CARRETERO', 'ENTREGADO_A_PROVEEDOR', '2008-07-28', '2008-07-29', 1000.25, '65255586');
INSERT INTO cheques VALUES (7, '30709171093', 'PRAXAIR', 'SANTADER  RIO', NULL, false, 'FENIX', 'ENTREGADO_A_PROVEEDOR', '2008-07-11', '2008-08-11', 7011.84, '327');
INSERT INTO cheques VALUES (394, NULL, 'PRAXAIR', 'SANTADER  RIO', NULL, false, 'Seguridad Fenix', 'ENTREGADO_A_PROVEEDOR', '2008-07-30', '0008-08-30', 7385.13, '000003285');
INSERT INTO cheques VALUES (302, '20144992165', NULL, 'patagonia', NULL, false, 'JENSEN', 'ENTREGADO_A_PROVEEDOR', '2008-07-14', '2008-07-18', 235.95, '67499752');
INSERT INTO cheques VALUES (168, '30568470318', 'SEGURIDAD FENIX SA', 'patagonia', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-06-26', '2008-07-10', 259.80, '67012717');
INSERT INTO cheques VALUES (311, '33557612829', NULL, 'GALICIA', NULL, false, 'HOTEL ALFIL', 'ENTREGADO_A_PROVEEDOR', '2008-07-01', '2008-07-07', 816.00, '76936060');
INSERT INTO cheques VALUES (235, '2010809223', NULL, 'patagonia', NULL, false, 'BARCELLANDI', 'ENTREGADO_A_PROVEEDOR', '2008-07-11', '2008-07-18', 717.80, '67418793');
INSERT INTO cheques VALUES (149, '20247853333', NULL, 'macro', NULL, false, 'AGUIRRE ZABALA', 'ENTREGADO_A_PROVEEDOR', '2008-06-10', '2008-07-17', 700.00, '47247377');
INSERT INTO cheques VALUES (78, '27034923820', NULL, 'nacion', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-07-10', '2008-07-18', 625.13, '82608857');
INSERT INTO cheques VALUES (148, '20054646373', NULL, 'nacion', NULL, false, 'AGUIRRE ZABALA', 'ENTREGADO_A_PROVEEDOR', '2008-06-05', '2008-07-25', 560.95, '83240580');
INSERT INTO cheques VALUES (260, NULL, 'DE LA PENNA SEGURIDAD FENIX S.A.', 'PROVINCIA', NULL, false, NULL, 'DEPOSITADO', '2008-07-22', '2008-07-22', 16.00, '866469649');
INSERT INTO cheques VALUES (150, '20206197618', NULL, 'FRANCES', NULL, false, 'VIAL TRES', 'ENTREGADO_A_PROVEEDOR', '2008-07-16', '2008-08-08', 235.00, '220077');
INSERT INTO cheques VALUES (404, '30709360228', NULL, 'NACION', NULL, false, 'DRYLUX S.A', 'ENTREGADO_A_PROVEEDOR', '2008-08-01', '2008-08-30', 569.91, '84341850');
INSERT INTO cheques VALUES (194, '30567668661', 'SERVICIOS Y REPUESTOS VW S.H.', 'STANDARD BANK', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-07-10', '2008-07-25', 445.00, '09037');
INSERT INTO cheques VALUES (312, '20161090728', NULL, 'nacion', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-07-05', '2008-08-05', 346.00, '84394404');
INSERT INTO cheques VALUES (195, '20082950258', NULL, 'PROVINCIA', NULL, false, 'OMAR REGUERA', 'ENTREGADO_A_PROVEEDOR', '2008-06-03', '2008-07-03', 678.70, '83525806');
INSERT INTO cheques VALUES (193, '30519355317', 'MAM S.A.', 'PROVINCIA', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-07-09', '2008-07-10', 318.65, '91209201');
INSERT INTO cheques VALUES (174, '20118464126', 'SEGURIDAD FENIX SA', 'GALICIA', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-05-03', '2008-08-18', 1306.00, '41381635');
INSERT INTO cheques VALUES (64, '30578475660', NULL, 'patagonia', NULL, false, 'agro el carretero', 'ENTREGADO_A_PROVEEDOR', '2008-07-10', '2008-07-10', 677.00, '67167704');
INSERT INTO cheques VALUES (66, '23084808009', NULL, 'macro', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-07-04', '2008-07-20', 230.00, '475785514');
INSERT INTO cheques VALUES (147, '30526111393', 'D', 'GALICIA', NULL, false, 'COOP AGRARIA', 'ENTREGADO_A_PROVEEDOR', '2008-07-15', '2008-07-15', 3449.29, '03729466');
INSERT INTO cheques VALUES (33, '33550001549', NULL, 'PROVINCIA', NULL, false, 'JOSE AIELLO', 'ENTREGADO_A_PROVEEDOR', '2008-07-08', '2008-07-10', 2969.38, '87991959');
INSERT INTO cheques VALUES (353, '30544046361', 'BOTTINO INVERSORA S.A', 'CITIBANCK', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-05-28', '2008-07-10', 897.50, '13312963');
INSERT INTO cheques VALUES (177, '30545743023', 'de la penn seguridad fenix sa', 'patagonia', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-07-16', '2008-07-17', 1925.00, '67181294');
INSERT INTO cheques VALUES (192, '30545746782', 'DE LA PENNA SEGURIDAD FENIX S.A.', 'BISEL', NULL, false, 'COOPESER', 'ENTREGADO_A_PROVEEDOR', '2008-07-13', '2008-07-14', 467.00, '14102148');
INSERT INTO cheques VALUES (170, '305382950', 'SE', 'HSBC', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-06-25', '2008-07-04', 149.00, '86332184');
INSERT INTO cheques VALUES (372, '20145914745', NULL, 'SANTANDER RIO', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-07-25', '2008-07-26', 316.27, '00000750');
INSERT INTO cheques VALUES (176, '20215897975', NULL, 'GALICIA', NULL, false, 'HURACAN', 'ENTREGADO_A_PROVEEDOR', '2008-07-07', '2008-07-08', 213.00, '40757300');
INSERT INTO cheques VALUES (67, '20136511980', NULL, 'nacion', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-07-03', '2008-07-10', 484.00, '81417454');
INSERT INTO cheques VALUES (261, '30581448402', NULL, 'patagonia', NULL, false, 'bomberos', 'ENTREGADO_A_PROVEEDOR', '2008-07-23', '2008-07-23', 231.50, '17721048');
INSERT INTO cheques VALUES (173, '20053685480', NULL, 'patagonia', NULL, false, 'MENNA', 'ENTREGADO_A_PROVEEDOR', '2008-07-16', '2008-07-17', 98.00, '66135314');
INSERT INTO cheques VALUES (321, '20137044898', NULL, 'MACRO', NULL, false, 'MIGUEL FERNANDEZ', 'ENTREGADO_A_PROVEEDOR', '2008-07-21', '2008-07-25', 205.70, '47336219');
INSERT INTO cheques VALUES (68, '30667467442', NULL, 'PROVINCIA', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-07-11', '2008-07-11', 186.00, '759821493');
INSERT INTO cheques VALUES (371, '30707787208', 'DE LA PENNA SEGURIDAD FENIX S.A.', 'SANTANDER RIO', NULL, false, 'FERTYCOM', 'ENTREGADO_A_PROVEEDOR', '2008-07-25', '2008-07-26', 152.04, '82195282');
INSERT INTO cheques VALUES (225, '20110382880', NULL, 'nacion', NULL, false, 'HUERTAS DEL SOL', 'ENTREGADO_A_PROVEEDOR', '2008-06-26', '2008-08-29', 500.00, '82864897');
INSERT INTO cheques VALUES (69, '1553582396', NULL, 'rio', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-07-11', '2008-08-25', 300.00, '155003185');
INSERT INTO cheques VALUES (403, '3070728983', NULL, 'PROVINCIA', NULL, false, 'JARDIN 901', 'ENTREGADO_A_PROVEEDOR', '2008-07-28', '2008-06-28', 186.00, '70210622');
INSERT INTO cheques VALUES (151, '30505012182', 'de la penn seguridad fenix sa', 'PROVINCIA', NULL, false, 'VIAL TRES', 'ENTREGADO_A_PROVEEDOR', '2008-07-11', '2008-07-25', 222.12, '84338941');
INSERT INTO cheques VALUES (175, '30595949102', 'SEGURIDAD FENIX SA', 'LA PAMPA', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-07-17', '2008-07-21', 217.00, '17995276');
INSERT INTO cheques VALUES (76, '30578475660', NULL, 'pa', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-07-14', NULL, 148.20, '67167792');
INSERT INTO cheques VALUES (77, '30708667710', NULL, 'PROVINCIA', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-07-14', '2008-07-15', 94.00, '86138539');
INSERT INTO cheques VALUES (223, '30667469429', NULL, 'PROVINCIA', NULL, false, 'ESCUELA nÃ‚Âª 502', 'ENTREGADO_A_PROVEEDOR', '2008-07-17', '2008-07-17', 147.00, '91674783');
INSERT INTO cheques VALUES (262, '33550001549', NULL, 'patagonia', NULL, false, 'AIELLO', 'ENTREGADO_A_PROVEEDOR', '2008-07-22', '2008-08-10', 3196.07, '66373815');
INSERT INTO cheques VALUES (210, '20076958506', 'SEGURIDAD FENIX S.A.', 'LA PAMPA', NULL, false, 'SPINACCI', 'ENTREGADO_A_PROVEEDOR', '2008-07-16', '2008-07-17', 201.20, '17961417');
INSERT INTO cheques VALUES (224, '33551274379', NULL, 'PROVINCIA', NULL, false, 'COOP. CHACRA', 'ENTREGADO_A_PROVEEDOR', '2008-07-21', '2008-07-21', 224.00, '79744149');
INSERT INTO cheques VALUES (378, '30708581662', NULL, 'DE LA PROVINCIA DE BS.AS.', NULL, false, 'MOLINOS ZALLA', 'ENTREGADO_A_PROVEEDOR', '2008-07-28', '2008-07-29', 396.00, '89747913');
INSERT INTO cheques VALUES (377, '30667455819', NULL, 'PATAGONIA', NULL, false, 'CYMA', 'ENTREGADO_A_PROVEEDOR', '2008-07-25', '2008-07-28', 1314.50, '67497600');
INSERT INTO cheques VALUES (727, '30545690922', 'SEGURIDAD FENIX S.A.', 'CREDICOOP', NULL, false, 'CELTA', 'ENTREGADO_A_PROVEEDOR', '2008-08-14', '2008-08-29', 2684.29, '25627662');
INSERT INTO cheques VALUES (729, '20053826343', NULL, 'PROVINCIA', NULL, false, 'REGUERA', 'ENTREGADO_A_PROVEEDOR', '2008-08-10', NULL, 230.00, '89896906');
INSERT INTO cheques VALUES (249, '23172550479', NULL, 'MACRO', NULL, false, 'BARCELLANDI', 'ENTREGADO_A_PROVEEDOR', '2008-07-01', NULL, 578.00, '44327215');
INSERT INTO cheques VALUES (732, '30708368853', 'NO A LA ORDEN', 'PROVINCIA', NULL, false, 'DIRECCION VIALIDAD RURAL', 'DEPOSITADO', '2008-08-12', '2008-08-12', 132.00, '83160410');
INSERT INTO cheques VALUES (529, '30605162009', NULL, 'PROVINCIA', NULL, false, NULL, 'DEPOSITADO', '2008-07-03', '2008-07-03', 283.00, '90272706');
INSERT INTO cheques VALUES (518, '30627955800', NULL, 'credicoop', NULL, false, '151,90', 'DEPOSITADO', '2008-07-03', '2008-07-04', 151.90, '25588815');
INSERT INTO cheques VALUES (527, '30709478245', NULL, 'SANTADER  RIO', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-06-03', '2008-08-15', 2600.00, '153');
INSERT INTO cheques VALUES (611, '30578475660', NULL, 'patagonia', NULL, false, 'agro el carretero', 'ENTREGADO_A_PROVEEDOR', '2008-08-13', '2008-08-14', 797.00, '67168281');
INSERT INTO cheques VALUES (522, '30708723017', NULL, 'GALICIA', NULL, false, 'PALAU', 'ENTREGADO_A_PROVEEDOR', '2008-08-11', '2008-08-12', 3569.50, '77368101');
INSERT INTO cheques VALUES (464, '3054737329178', NULL, 'credicoop', NULL, false, 'CERRI', 'ENTREGADO_A_PROVEEDOR', '2008-05-01', '2008-08-27', 1200.00, '25963971');
INSERT INTO cheques VALUES (596, '33550001549', NULL, 'NACION', NULL, false, 'JOSE AIELLO', 'ENTREGADO_A_PROVEEDOR', '2008-08-12', '2008-08-29', 1909.53, '84191514');
INSERT INTO cheques VALUES (524, '20053779884', NULL, 'PROVINCIA', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-08-08', '2008-08-08', 312.00, '83493657');
INSERT INTO cheques VALUES (585, '30708723017', 'PALAU S.A.', 'GALICIA', NULL, false, 'PALAU', 'ENTREGADO_A_PROVEEDOR', '2008-08-11', '2008-08-12', 3569.50, '77368101');
INSERT INTO cheques VALUES (745, '20172313710', 'MAPEI', 'PROV', NULL, false, 'MGI', 'DEPOSITADO', '2008-08-22', '2008-08-22', 1680.00, '91677049');
INSERT INTO cheques VALUES (650, '20115991753', NULL, 'PROVINCIA', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-08-10', '2008-08-11', 108.00, '89592740');
INSERT INTO cheques VALUES (512, '30709742848', NULL, 'PROVINCIA', NULL, false, 'biocombustible', 'DEPOSITADO', '2008-07-07', '2008-07-28', 214.00, '86510577');
INSERT INTO cheques VALUES (513, '30667465776', NULL, 'PROVINCIA', NULL, false, 'JARDIN 908', 'DEPOSITADO', '2008-08-11', '2008-08-11', 62.00, '73518866');
INSERT INTO cheques VALUES (597, '30567668661', 'MACIEL HNOS.', 'CREDICOOP', NULL, false, 'RAISER S.A.', 'DEPOSITADO', '2008-07-01', '2008-07-18', 56.36, '02923373');
INSERT INTO cheques VALUES (517, '20175286102', NULL, 'NACION', NULL, false, 'REGUERA', 'ENTREGADO_A_PROVEEDOR', '2008-07-28', '2008-08-22', 400.00, '86049804');
INSERT INTO cheques VALUES (606, '30709171093', NULL, 'SANTADER  RIO', NULL, false, 'FENIX', 'ENTREGADO_A_PROVEEDOR', '2008-08-14', '2008-09-14', 3139.92, '331');
INSERT INTO cheques VALUES (525, '20053897968', NULL, 'SANTADER  RIO', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-06-30', '2008-07-31', 220.00, '15500147');
INSERT INTO cheques VALUES (610, NULL, NULL, 'LA PAMPA', NULL, false, 'LARREA', 'ENTREGADO_A_PROVEEDOR', '2008-08-14', NULL, 563.90, '18127263');
INSERT INTO cheques VALUES (465, '20137699002', NULL, 'nacion', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-08-04', '2008-08-05', 134.80, '82897647');
INSERT INTO cheques VALUES (526, '27217652362', NULL, 'PROVINCIA', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-08-01', '2008-08-03', 254.00, '85565936');
INSERT INTO cheques VALUES (521, '30707213635', NULL, 'SANTADER  RIO', NULL, false, 'CONSTRUCCIONES TRES ARROYOS', 'ENTREGADO_A_PROVEEDOR', '2008-08-11', '2008-08-20', 568.37, '78741832');
INSERT INTO cheques VALUES (627, '3066746577', NULL, 'provincia', NULL, false, 'jardin 908', 'ENTREGADO_A_PROVEEDOR', '2008-08-11', NULL, 62.00, '73518866');
INSERT INTO cheques VALUES (595, '33550001549', NULL, 'NACION', NULL, false, 'JOSE AIELLO', 'ENTREGADO_A_PROVEEDOR', '2008-08-12', '2008-08-15', 1500.00, '84191513');
INSERT INTO cheques VALUES (651, '20053706593', NULL, 'SANTADER  RIO', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-08-06', '2008-08-07', 586.50, '99661729');
INSERT INTO cheques VALUES (746, '23164740994', NULL, 'PAT', NULL, false, NULL, 'DEPOSITADO', '2008-07-28', '2008-07-30', 87.00, '65022238');
INSERT INTO cheques VALUES (652, '30709097020', NULL, 'nacion', NULL, false, 'PROINGESDE SRL', 'ENTREGADO_A_PROVEEDOR', '2008-08-19', '2008-08-20', 583.00, '76433573');
INSERT INTO cheques VALUES (609, NULL, NULL, 'PATAGONIA', NULL, false, 'AGRO EL CARRETERO', 'ENTREGADO_A_PROVEEDOR', '2008-08-14', '2008-08-14', 1994.31, '67168280');
INSERT INTO cheques VALUES (515, '30709276006', NULL, 'LA PAMPA', NULL, false, 'A.RECARI', 'ENTREGADO_A_PROVEEDOR', '2008-07-18', '2008-08-30', 500.00, '17144774');
INSERT INTO cheques VALUES (721, NULL, NULL, 'patagonia', NULL, false, 'agro el carretero', 'ENTREGADO_A_PROVEEDOR', '2008-08-21', '2008-08-22', 874.54, '00000750');
INSERT INTO cheques VALUES (528, '30605162009', NULL, 'PROVINCIA', NULL, false, 'AEROTAN', 'ENTREGADO_A_PROVEEDOR', '2008-08-01', '2008-08-01', 231.00, '90272891');
INSERT INTO cheques VALUES (516, '20136511980', NULL, 'PROVINCIA', NULL, false, 'A.RECARI', 'ENTREGADO_A_PROVEEDOR', '2008-07-24', '2008-09-29', 965.00, '90210760');
INSERT INTO cheques VALUES (593, '23108830379', NULL, 'NACION', NULL, false, 'ELIZONDO', 'ENTREGADO_A_PROVEEDOR', '2008-07-28', '2008-08-28', 1100.00, '91690901');
INSERT INTO cheques VALUES (730, '30511381459', 'SEGURIDAD FENIX SA', 'PATAGONIA', NULL, false, 'OLSEN', 'ENTREGADO_A_PROVEEDOR', '2008-08-20', '2008-08-26', 511.00, '67664431');
INSERT INTO cheques VALUES (519, '30707213635', NULL, 'SANTADER  RIO', NULL, false, 'CONSTRUCCIONES TRES ARROYOS', 'ENTREGADO_A_PROVEEDOR', '2008-08-11', '2008-09-19', 568.37, '78741834');
INSERT INTO cheques VALUES (726, '33529629619', NULL, 'LA PAMPA', NULL, false, 'JORGE SUAREZ', 'ENTREGADO_A_PROVEEDOR', '2008-07-18', '2008-08-18', 430.40, '18011336');
INSERT INTO cheques VALUES (728, '30513505058', 'SEGURIDAD FENIX SA', 'PATAGONIA', NULL, false, 'LA AURORA', 'ENTREGADO_A_PROVEEDOR', '2008-08-21', '2008-08-22', 179.00, '67818812');
INSERT INTO cheques VALUES (594, '23108830379', 'RAFAEL Y RUBEN FABI', 'NACION', NULL, false, 'ELIZONDO', 'ENTREGADO_A_PROVEEDOR', '2008-08-09', '2008-08-22', 576.90, '82033773');
INSERT INTO cheques VALUES (739, '30707676228', NULL, 'PAT', NULL, false, 'MGI', 'ENTREGADO_A_PROVEEDOR', '2008-08-02', NULL, 968.00, '18292836');
INSERT INTO cheques VALUES (514, '30615679247', NULL, 'NAACION', NULL, false, 'A.RECARI', 'ENTREGADO_A_PROVEEDOR', '2008-08-05', '2008-08-30', 274.80, '85078499');
INSERT INTO cheques VALUES (740, '30681631638', NULL, 'CITIBANK', NULL, false, 'MGI', 'ENTREGADO_A_PROVEEDOR', '2008-08-19', '2008-08-19', 544.50, '13538650');
INSERT INTO cheques VALUES (520, '30707213635', NULL, 'SANTADER  RIO', NULL, false, 'CONSTRUCCIONES TRES ARROYOS', 'ENTREGADO_A_PROVEEDOR', '2008-08-11', '2008-09-05', 568.37, '78741833');
INSERT INTO cheques VALUES (749, '30709290041', NULL, 'SANTANDER RIO', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-08-21', '2008-08-29', 229.48, '00000012');
INSERT INTO cheques VALUES (731, '20053825630', NULL, 'PROVINCIA', NULL, false, 'WIBAUX', 'ENTREGADO_A_PROVEEDOR', '2008-08-19', '2008-08-31', 455.00, '92743270');
INSERT INTO cheques VALUES (735, '20118464126', NULL, 'GALICIA', NULL, false, 'KHULMAN', 'ENTREGADO_A_PROVEEDOR', '2008-07-25', '2008-08-29', 722.56, '7690767639');
INSERT INTO cheques VALUES (747, '33509587639', 'SERVILIMP', 'PATAGONIA', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-08-08', '2008-08-08', 165.00, '15958621');
INSERT INTO cheques VALUES (748, '33550001549', NULL, 'NACION', NULL, false, 'REGUERA', 'ENTREGADO_A_PROVEEDOR', '2008-08-10', '2008-08-12', 300.00, '84191495');
INSERT INTO cheques VALUES (951, '20166061963', NULL, 'SANTANDER RIO', NULL, false, 'FUERTES', 'ENTREGADO_A_PROVEEDOR', '2008-09-04', '2008-09-15', 321.00, '324');
INSERT INTO cheques VALUES (1075, '30667481089', NULL, 'PROVINCIA', NULL, false, 'ECHEVARRIA GUILLERMO', 'ENTREGADO_A_PROVEEDOR', '2008-09-06', '2008-09-20', 148.00, '84960312');
INSERT INTO cheques VALUES (893, '20053779884', NULL, 'PATAGONIA', NULL, false, 'REGUERA', 'ENTREGADO_A_PROVEEDOR', '2008-08-27', '2008-08-27', 200.11, '16619548');
INSERT INTO cheques VALUES (981, '30620301173', NULL, 'PROVINCIA', NULL, false, 'DONADIO', 'DEPOSITADO', '2008-09-05', '2008-09-10', 3690.50, '85560048');
INSERT INTO cheques VALUES (760, '30545746782', 'SEGURIDAD FENIX SA', 'PROVINCIA', NULL, false, 'COOPESER', 'ENTREGADO_A_PROVEEDOR', '2008-08-25', '2008-08-26', 950.00, '76629521');
INSERT INTO cheques VALUES (1002, '30667502043', 'DE LA PENNA SEGURIDAD FENIX', 'PATAGONIA', NULL, false, '18 DE SETIEMBRE', 'ENTREGADO_A_PROVEEDOR', '2008-09-02', '2008-09-03', 1786.70, '67404723');
INSERT INTO cheques VALUES (983, '30626301173', NULL, 'PROVINCIA', NULL, false, 'DONADIO', 'ENTREGADO_A_PROVEEDOR', '2008-09-05', '2008-09-30', 453.75, '85560047');
INSERT INTO cheques VALUES (859, NULL, 'pRAXAIR', 'rio', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-08-29', '2008-09-29', 7314.27, '332');
INSERT INTO cheques VALUES (796, '30999034752', 'HEREDIA JUAN DAVID', 'PROVINCIA', NULL, false, 'ZABALA', 'ENTREGADO_A_PROVEEDOR', '2008-08-21', NULL, 129.29, '83811715');
INSERT INTO cheques VALUES (798, '30572680955', NULL, 'PROVINCIA', NULL, false, 'ZABALA', 'ENTREGADO_A_PROVEEDOR', '2008-08-20', NULL, 213.50, '90954478');
INSERT INTO cheques VALUES (844, '27129405908', NULL, 'GALICIA', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-08-28', '2008-09-01', 440.00, '76907672');
INSERT INTO cheques VALUES (821, '25061390', NULL, 'CREDICOOP', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-08-25', '2008-09-29', 411.40, '25061390');
INSERT INTO cheques VALUES (819, '30708729872', NULL, 'CREDICOOP', NULL, false, 'LUC. Y EZE SODE', 'ENTREGADO_A_PROVEEDOR', '2008-08-29', '2008-09-26', 637.28, '25778838');
INSERT INTO cheques VALUES (842, '30546743023', 'DE LA PENNA SEGURIDAD FENIX S.A.', 'PROV', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-08-27', '2008-08-28', 225.90, '88984203');
INSERT INTO cheques VALUES (843, '27166036734', NULL, 'PROV', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-08-28', '2008-08-29', 242.00, '93302896');
INSERT INTO cheques VALUES (797, '23232583339', NULL, 'PROVINCIA', NULL, false, 'ZABALA', 'ENTREGADO_A_PROVEEDOR', '2008-08-22', NULL, 400.00, '91371146');
INSERT INTO cheques VALUES (820, '30667468988', NULL, 'PROVINCIA', NULL, false, 'ESCUEL 4', 'ENTREGADO_A_PROVEEDOR', '2008-08-29', '2008-08-29', 160.00, '92014077');
INSERT INTO cheques VALUES (980, '30527196422', NULL, 'GALICIA', NULL, false, 'COOP. ALFA', 'ENTREGADO_A_PROVEEDOR', '2008-09-02', '2008-09-03', 338.80, '41276513');
INSERT INTO cheques VALUES (979, '27001612021', 'SEGURIDAD FENIX SA', 'PROVINCIA', NULL, false, 'MA. NELLY CIANCAGLINI', 'ENTREGADO_A_PROVEEDOR', '2008-09-05', '2008-09-05', 520.50, '85372998');
INSERT INTO cheques VALUES (1041, '30708624736', NULL, 'nacion', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-08-26', '2008-08-30', 400.00, '85671045');
INSERT INTO cheques VALUES (759, '30512279402', 'EDIFICIO VISION', 'PATAGONIA', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-08-04', '2008-08-05', 117.30, '67342439');
INSERT INTO cheques VALUES (1067, '30701829723', 'VACCA EMMA ESTER', 'CREDICOOP', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-08-26', '2008-08-26', 400.00, '00766321');
INSERT INTO cheques VALUES (890, '30707221956', NULL, 'PROV', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-08-25', NULL, 62.00, '86288684');
INSERT INTO cheques VALUES (1068, '30578475660', NULL, 'PATAGONIA', NULL, false, 'AGRO EL CARRETERO', 'ENTREGADO_A_PROVEEDOR', '2008-09-08', '2008-09-09', 867.50, '67921788');
INSERT INTO cheques VALUES (854, NULL, 'PRAXAIR', 'RIO', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-08-29', '2008-09-29', 7314.27, '332');
INSERT INTO cheques VALUES (741, '23144991834', NULL, 'LA PAMPA', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-08-19', '2008-08-19', 316.25, '16986128');
INSERT INTO cheques VALUES (910, '30708538198', 'DE LA PENNA SEGURIDAD FENIX', 'NACION', NULL, false, 'RUTAS AL SUR', 'DEPOSITADO', '2008-08-20', '2008-08-20', 402.80, '13285815');
INSERT INTO cheques VALUES (978, '30667477618', NULL, 'PROVINCIA', NULL, false, 'DISTRIBUIDORA Z', 'DEPOSITADO', '2008-09-02', '2008-09-03', 218.00, '93241761');
INSERT INTO cheques VALUES (886, '30545690922', NULL, 'credicoop', NULL, false, 'CELTA', 'DEPOSITADO', '2008-08-14', '2008-09-29', 2684.29, '25627662');
INSERT INTO cheques VALUES (984, '27168736482', NULL, 'LA PAMPA', NULL, false, 'CAZENAVE', 'ENTREGADO_A_PROVEEDOR', '2008-09-05', '2008-10-05', 885.12, '18262009');
INSERT INTO cheques VALUES (974, '30709293350', NULL, 'PROVINCIA', NULL, false, 'METALURGICA LOS ARROYOS', 'ENTREGADO_A_PROVEEDOR', '2008-09-05', '2008-09-10', 132.00, '93298104');
INSERT INTO cheques VALUES (976, '30708624736', NULL, 'NACION', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-08-26', '2008-08-30', 400.00, '85671045');
INSERT INTO cheques VALUES (1066, '30667462491', NULL, 'PROVINCIA', NULL, false, 'SERVILIMP', 'DEPOSITADO', '2008-08-25', '2008-08-25', 72.00, '73011523');
INSERT INTO cheques VALUES (888, 'BERMEJO E YR', NULL, 'SANTADER  RIO', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-09-01', '2008-09-01', 125.50, '407');
INSERT INTO cheques VALUES (866, '30708113901', NULL, 'CREDICOOP', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-08-29', '2008-08-29', 526.35, '53175650');
INSERT INTO cheques VALUES (948, '30538289503', 'SEGURIDAD FENIX SA', 'HSBC', NULL, false, 'CASA BALDA', 'ENTREGADO_A_PROVEEDOR', '2008-08-30', '2008-09-26', 636.00, '90197545');
INSERT INTO cheques VALUES (1056, '2016169796', NULL, 'PROVINCIA', NULL, false, 'REGUERA', 'ENTREGADO_A_PROVEEDOR', '2008-08-20', '2008-09-15', 500.00, '93553027');
INSERT INTO cheques VALUES (909, '20147707240', NULL, 'NACION', NULL, false, 'ALBERDI', 'ENTREGADO_A_PROVEEDOR', '2008-08-29', '2008-09-02', 170.60, '84633660');
INSERT INTO cheques VALUES (758, '20262489710', 'SEGURIDAD FENIX SA', 'FRANCES', NULL, false, 'MELENDEZ', 'ENTREGADO_A_PROVEEDOR', '2008-08-07', '2008-08-08', 130.00, '0224228');
INSERT INTO cheques VALUES (1037, '30667496825', NULL, 'PROVINCIA', NULL, false, 'OMAR TUMINI', 'DEPOSITADO', '2008-09-13', '2008-09-14', 77.45, '90631773');
INSERT INTO cheques VALUES (756, '27129297382', NULL, 'PROVINCIA', NULL, false, 'ordoqui', 'ENTREGADO_A_PROVEEDOR', '2008-08-13', '2008-08-14', 94.15, '90169973');
INSERT INTO cheques VALUES (982, '30626301173', NULL, 'PROVINCIA', NULL, false, 'DONADIO', 'ENTREGADO_A_PROVEEDOR', '2008-09-05', '2008-10-10', 3690.50, '85560048');
INSERT INTO cheques VALUES (1069, '30708581662', NULL, 'PROVINCIA', NULL, false, 'MOLINOS ZALLA', 'ENTREGADO_A_PROVEEDOR', '2008-09-08', '2008-09-09', 586.30, '89748037');
INSERT INTO cheques VALUES (757, '20215279724', NULL, 'PROVINCIA', NULL, false, 'ORDOQUI', 'ENTREGADO_A_PROVEEDOR', '2008-08-14', '2008-08-23', 322.37, '91019029');
INSERT INTO cheques VALUES (1057, '20250763302', NULL, 'LA PAMPA', NULL, false, 'REGUERA', 'ENTREGADO_A_PROVEEDOR', '2008-09-04', '2008-09-30', 300.00, '17464602');
INSERT INTO cheques VALUES (1071, '20053840591', NULL, 'PROVINCIA', NULL, false, 'LOPEZ', 'ENTREGADO_A_PROVEEDOR', '2008-09-08', '2008-09-09', 49.00, '94617726');
INSERT INTO cheques VALUES (755, '20205813161', NULL, 'PROVINCIA', NULL, false, 'reguera', 'ENTREGADO_A_PROVEEDOR', '2008-08-19', '2008-09-03', 295.66, '92320134');
INSERT INTO cheques VALUES (892, '30708667710', NULL, 'PROVINCIA', NULL, false, 'el paisano', 'ENTREGADO_A_PROVEEDOR', '2008-09-01', '2008-09-02', 144.00, '92943948');
INSERT INTO cheques VALUES (918, '30708327820', NULL, 'PROVINCIA', NULL, false, 'NAncy-campo y mar', 'ENTREGADO_A_PROVEEDOR', '2008-08-28', '2008-09-01', 692.00, '85928612');
INSERT INTO cheques VALUES (891, '30623556871', NULL, 'credicoop', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-08-29', '2008-09-01', 1722.00, '19913417');
INSERT INTO cheques VALUES (977, '30605162009', NULL, 'PROVINCIA', NULL, false, 'AEROTAN', 'ENTREGADO_A_PROVEEDOR', '2008-09-02', '2008-09-02', 261.00, '92943292');
INSERT INTO cheques VALUES (1070, '30709742848', NULL, 'PROVINCIA', NULL, false, 'BIOCOMBUSTIBLES TS.AS.', 'ENTREGADO_A_PROVEEDOR', '2008-09-02', '2008-10-05', 391.00, '91410301');
INSERT INTO cheques VALUES (1150, '30526111393', NULL, 'credicoop', NULL, false, 'COOP AGRARIA', 'ENTREGADO_A_PROVEEDOR', '2008-09-08', '2008-09-11', 4504.45, '02954687');
INSERT INTO cheques VALUES (1101, '30667516346', NULL, 'PROVINCIA', NULL, false, 'SERVILIMP', 'DEPOSITADO', '2008-08-08', '2008-08-28', 190.00, '92096781');
INSERT INTO cheques VALUES (1103, '20082882457', NULL, 'PROVINCIA', NULL, false, 'SERVILIMP', 'DEPOSITADO', '2008-05-20', '2008-08-23', 136.53, '85723802');
INSERT INTO cheques VALUES (1138, '27037663382', NULL, 'PROVINCIA', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-09-10', '2008-09-10', 410.00, '71513920');
INSERT INTO cheques VALUES (1295, '30667452089', NULL, 'GALICIA', NULL, false, 'ETERNET', 'ENTREGADO_A_PROVEEDOR', '2008-09-11', '2008-09-11', 129.00, '03646936');
INSERT INTO cheques VALUES (1335, '27106779517', 'JAVIER GALLARDO', 'PATAGONIA', NULL, false, 'JAVIER GALLARDO', 'ENTREGADO_A_PROVEEDOR', '2008-09-05', '2008-12-01', 1927.00, '67273820');
INSERT INTO cheques VALUES (1146, '20145914745', NULL, 'PROVINCIA', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-09-09', '2008-09-10', 316.25, '92873214');
INSERT INTO cheques VALUES (1100, '20145914745', NULL, 'PROVINCIA', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-09-09', '2008-09-10', 316.25, '92873214');
INSERT INTO cheques VALUES (1302, '20086598184', NULL, 'patagonia', NULL, false, 'JORGE SUAREZ', 'ENTREGADO_A_PROVEEDOR', '2008-09-17', '2008-09-18', 321.00, '67751842');
INSERT INTO cheques VALUES (1099, '20177389561', NULL, 'NACION', NULL, false, 'GARCIA GUILLERMO', 'ENTREGADO_A_PROVEEDOR', '2008-09-10', '2008-10-10', 632.00, '87603176');
INSERT INTO cheques VALUES (1222, '30667455819', NULL, 'PATAGONIA', NULL, false, 'CYMA', 'ENTREGADO_A_PROVEEDOR', '2008-08-27', '2008-08-28', 254.00, '67989885');
INSERT INTO cheques VALUES (1102, '30540524536', NULL, 'PROVINCIA', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-09-17', '2008-09-17', 207.00, '84339117');
INSERT INTO cheques VALUES (1220, '30667605018', NULL, 'PROVINCIA', NULL, false, 'ESCUELA 43', 'ENTREGADO_A_PROVEEDOR', '2008-09-16', '2008-09-17', 46.00, '620506954');
INSERT INTO cheques VALUES (1204, '20053846972', NULL, 'PROVINCIA', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-09-15', '2008-09-16', 222.00, '88148404');
INSERT INTO cheques VALUES (1221, '30578475660', NULL, 'PATAGONIA', NULL, false, 'agro el carretero', 'ENTREGADO_A_PROVEEDOR', '2008-09-15', '2008-09-16', 83.73, '67921897');
INSERT INTO cheques VALUES (1181, '20147122048', NULL, 'NACION', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-03-10', '2008-09-25', 350.00, '80382974');
INSERT INTO cheques VALUES (1179, '20177389561', NULL, 'nacion', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-09-10', '2008-10-10', 632.00, '87603176');
INSERT INTO cheques VALUES (1180, NULL, NULL, 'PROVINCIA', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-09-17', '2008-09-17', 207.00, '84339117');
INSERT INTO cheques VALUES (1178, '20101025218', NULL, 'PROVINCIA', NULL, false, 'FORTE Y..', 'ENTREGADO_A_PROVEEDOR', '2008-09-10', '2008-09-17', 330.00, '92524717');
INSERT INTO cheques VALUES (1187, '20147122048', NULL, 'NACION', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-03-10', '2008-09-17', 350.00, '80382974');
INSERT INTO cheques VALUES (1186, '30709710296', NULL, 'LA PAMPA', NULL, false, 'JUNA GER', 'ENTREGADO_A_PROVEEDOR', '2008-09-11', '2008-09-15', 231.70, '18147399');
INSERT INTO cheques VALUES (1142, '30545946943', 'SEGURIDAD FENIX SA', 'PATAGONIA', NULL, false, 'SOCIEDAD ESPAÃƒâ€˜OLA', 'ENTREGADO_A_PROVEEDOR', '2008-09-08', '2008-09-09', 133.00, '67664016');
INSERT INTO cheques VALUES (1141, '30708723017', 'PALAU S.A.', 'GALICIA', NULL, false, 'PALAU', 'ENTREGADO_A_PROVEEDOR', '2008-09-05', '2008-09-08', 387.00, '77524666');
INSERT INTO cheques VALUES (1143, '20147170107', NULL, 'LA PAMPA', NULL, false, 'SPINACCI', 'ENTREGADO_A_PROVEEDOR', '2008-09-11', '2008-09-12', 130.00, '17930578');
INSERT INTO cheques VALUES (1193, '33509687639', NULL, 'GALICIA', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-09-04', '2008-09-04', 165.00, '03779682');
INSERT INTO cheques VALUES (1305, '20053825630', NULL, 'PROVINCIA', NULL, false, 'WIBAUX', 'ENTREGADO_A_PROVEEDOR', '2008-09-18', '2008-10-04', 1054.40, '94228870');
INSERT INTO cheques VALUES (1309, '23143943844', NULL, 'frances', NULL, false, 'lucio v. lopez 222', 'ENTREGADO_A_PROVEEDOR', '2008-09-18', '2008-10-22', 2312.00, '00227484');
INSERT INTO cheques VALUES (1251, '33550001549', NULL, 'PATAGONIA', NULL, false, 'AIELLO', 'ENTREGADO_A_PROVEEDOR', '2008-09-16', '2008-09-29', 3505.73, '67664634');
INSERT INTO cheques VALUES (1229, '30664854305', 'MIGUEL AGUIRRE', 'PROVINCIA', NULL, false, 'ORDOQUI', 'ENTREGADO_A_PROVEEDOR', '2008-09-01', '2008-09-10', 72.60, '86472793');
INSERT INTO cheques VALUES (1307, '2053825630', NULL, 'PROVINCIA', NULL, false, 'wibaux', 'ENTREGADO_A_PROVEEDOR', '2008-09-18', '2008-10-04', 1054.40, '94228870');
INSERT INTO cheques VALUES (1227, '3099903659', 'ALDO OSMAR POSE', 'PROVINCIA', NULL, false, 'ORDOQUI', 'ENTREGADO_A_PROVEEDOR', '2008-09-05', '2008-09-05', 375.03, '90212234');
INSERT INTO cheques VALUES (1232, '30667476867', NULL, 'PROVINCIA', NULL, false, 'jardin 903', 'ENTREGADO_A_PROVEEDOR', '2008-09-26', '2008-09-26', 314.00, '85025825');
INSERT INTO cheques VALUES (1238, '30708581662', NULL, 'PROVINCIA', NULL, false, 'MOLINOS ZALLA', 'ENTREGADO_A_PROVEEDOR', '2008-09-15', '2008-09-16', 797.00, '89748072');
INSERT INTO cheques VALUES (1228, '30664849492', 'EDGARDO DOGUI', 'PROVINCIA', NULL, false, 'ORDOQUI', 'ENTREGADO_A_PROVEEDOR', '2008-09-09', '2008-09-09', 55.00, '82923680');
INSERT INTO cheques VALUES (1319, '30594465497', 'DE LA PENNA SEGURIDAD FENIX', 'GALICIA', NULL, false, 'LASO S.A.', 'ENTREGADO_A_PROVEEDOR', '2008-09-16', '0008-10-14', 2907.00, '13757380');
INSERT INTO cheques VALUES (1376, '30709466042', 'SEGURIDAD FENIX SA', 'PROVINCIA', NULL, false, 'ORGANISMO DESCENTRALIZADO CLAROMECO SERVICIOS TURISTICOS', 'ENTREGADO_A_PROVEEDOR', '2008-09-16', '2008-09-16', 1289.00, '92097024');
INSERT INTO cheques VALUES (1320, '27106779517', NULL, 'PATAGONIA', NULL, false, '1927', 'ENTREGADO_A_PROVEEDOR', '2008-09-05', '2008-10-01', 1927.00, '67273820');
INSERT INTO cheques VALUES (1296, '30512314860', NULL, 'PROVINCIA', NULL, false, 'ETERNET', 'ENTREGADO_A_PROVEEDOR', '2008-09-10', '2008-09-12', 129.00, '82981894');
INSERT INTO cheques VALUES (1297, '20053809708', NULL, 'PATAGONIA', NULL, false, 'ETERNET', 'ENTREGADO_A_PROVEEDOR', '2008-09-08', '2008-09-08', 69.00, '18087061');
INSERT INTO cheques VALUES (975, '30707787208', 'DE LA PENNA SEGURIDAD FENIX', 'SANTANDER RIO', NULL, false, 'FERTYCIM', 'ENTREGADO_A_PROVEEDOR', '2008-09-04', '2008-09-05', 56.00, '82195324');
INSERT INTO cheques VALUES (1249, '30664864305', 'MIGUEL AGUINNE', 'PROVINCIA', NULL, false, 'ORDOQUI', 'ENTREGADO_A_PROVEEDOR', '2008-09-07', '2008-09-10', 72.60, '86472793');
INSERT INTO cheques VALUES (1306, '30547329178', NULL, 'credicoop', NULL, false, 'CERRI', 'ENTREGADO_A_PROVEEDOR', '2008-08-01', '2008-09-22', 2000.00, '26644752');
INSERT INTO cheques VALUES (1360, '30708968648', NULL, 'SANTANDER RIO', NULL, false, 'TOSTEX', 'ENTREGADO_A_PROVEEDOR', '2008-09-19', '2008-10-17', 1249.23, '896');
INSERT INTO cheques VALUES (1361, '30657849894', 'SEGURIDAD FENIX SA', 'FRANCES', NULL, false, 'SUPERCARNE', 'ENTREGADO_A_PROVEEDOR', '2008-08-25', '2008-09-25', 494.60, '226633');
INSERT INTO cheques VALUES (1392, '20053901892', NULL, 'PROVINCIA', NULL, false, 'LANCE', 'ENTREGADO_A_PROVEEDOR', '2008-09-25', '2008-09-28', 244.00, '88758008');
INSERT INTO cheques VALUES (1388, '30545746782', 'DE LA PENNA SEGURIDAD FENIX', 'BISEL', NULL, false, 'COOPERATIVA DE SERVICIOS DE LA GARMA', 'ENTREGADO_A_PROVEEDOR', '2008-09-23', '2008-09-24', 389.50, '14102157');
INSERT INTO cheques VALUES (1253, '33550001549', NULL, 'PATAGONIA', NULL, false, 'AIELLO', 'ENTREGADO_A_PROVEEDOR', '2008-09-16', '2008-09-29', 3505.73, '67664634');
INSERT INTO cheques VALUES (1250, '30708449691', NULL, 'CREDICOOP', NULL, false, 'MOLINO TRES ARROYOS', 'ENTREGADO_A_PROVEEDOR', '2008-09-04', '2008-10-01', 6900.00, '03228021');
INSERT INTO cheques VALUES (1256, NULL, NULL, 'SANTADER  RIO', NULL, false, 'FENIX', 'ENTREGADO_A_PROVEEDOR', '2008-09-17', '2008-09-18', 8380.63, '336');
INSERT INTO cheques VALUES (1386, '20263830408', NULL, 'BANCO RIO', NULL, false, 'ALEJANDRO RECARI', 'ENTREGADO_A_PROVEEDOR', '2008-08-20', '2008-09-20', 330.00, '15500025');
INSERT INTO cheques VALUES (1389, '27217652362', 'SEGURIDAD FENIX SA', 'PROVINCIA', NULL, false, 'CECILIA PONS', 'ENTREGADO_A_PROVEEDOR', '2008-09-25', '2008-09-27', 413.00, '85565958');
INSERT INTO cheques VALUES (1391, '30627955800', NULL, 'credicoop', NULL, false, 'LA CASCADA', 'ENTREGADO_A_PROVEEDOR', '2008-09-24', '2008-09-25', 492.00, '26672821');
INSERT INTO cheques VALUES (1387, '30619043541', 'JOSE MARIA ELIZALDE', 'PROVINCIA', NULL, false, 'ALEJANDRO RECARI', 'ENTREGADO_A_PROVEEDOR', '2008-09-12', '2008-09-12', 351.50, '88990906');
INSERT INTO cheques VALUES (1505, '20261077710', '0', 'PATAGONIA', '0', false, '0', 'ENTREGADO_A_PROVEEDOR', '2008-09-23', '2008-10-03', 240.00, '63677492');
INSERT INTO cheques VALUES (1377, '20054678658', NULL, 'CREDICOOP', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-09-23', '2008-10-15', 305.90, '25667496');
INSERT INTO cheques VALUES (1422, '30545793527', NULL, 'GALICIA', NULL, false, 'COOPERATIVA ELECTRICA SAN FCO. DE BELLOCQ', 'ENTREGADO_A_PROVEEDOR', '2008-09-25', '2008-09-26', 870.00, '77195407');
INSERT INTO cheques VALUES (1421, '30707787208', 'DE LA PENNA SEGURIDAD FENIX', 'SANTANDER RIO', NULL, false, 'FERTYCOM', 'ENTREGADO_A_PROVEEDOR', '2008-09-25', '2008-09-26', 857.50, '82195364');
INSERT INTO cheques VALUES (1499, '30667468295', NULL, 'PROVINCIA', NULL, false, 'ESCUELA 16', 'ENTREGADO_A_PROVEEDOR', '2008-09-30', '2008-09-30', 108.00, '89126949');
INSERT INTO cheques VALUES (1500, '30667466764', NULL, 'PROVINCIA', NULL, false, 'ESCUELA 48', 'ENTREGADO_A_PROVEEDOR', '2008-09-30', '2008-09-30', 31.00, '61400794');
INSERT INTO cheques VALUES (1501, '30666617513', NULL, 'PROVINCIA', NULL, false, 'SINDICATO MUNICIPALES', 'ENTREGADO_A_PROVEEDOR', '2008-09-24', NULL, 48.25, '93200189');
INSERT INTO cheques VALUES (1502, '27169267667', NULL, 'SANTADER  RIO', NULL, false, 'SOCIEDAD ITALIANA', 'ENTREGADO_A_PROVEEDOR', '2008-08-15', '2008-10-16', 576.00, '15500128');
INSERT INTO cheques VALUES (1343, '30709097020', NULL, 'SANTANDER RIO', NULL, false, 'proingesde', 'ENTREGADO_A_PROVEEDOR', '2008-09-22', '2008-09-23', 250.00, '00000272');
INSERT INTO cheques VALUES (1423, '30704459099', 'TRUCKS EXPRESS S.R.L.', 'BANCO MARIVA', NULL, false, 'me parece que Jose', 'ENTREGADO_A_PROVEEDOR', '2008-08-29', '2008-09-29', 987.36, '11824386');
INSERT INTO cheques VALUES (1420, '20164742823', NULL, 'patagonia', NULL, false, 'PIOVACARI', 'ENTREGADO_A_PROVEEDOR', '2008-09-27', '2008-09-28', 167.00, '68329759');
INSERT INTO cheques VALUES (1457, '20110974141', NULL, 'PATAGONIA', NULL, false, 'TOSTEX', 'ENTREGADO_A_PROVEEDOR', '2008-09-04', '2008-10-06', 1325.00, '63437967');
INSERT INTO cheques VALUES (1458, '30568470318', 'FENIX', 'PATAGONIA', NULL, false, 'YAYABU SA', 'ENTREGADO_A_PROVEEDOR', '0008-09-17', '0008-09-29', 119.80, '67818717');
INSERT INTO cheques VALUES (1463, '30707213635', NULL, 'SANTADER  RIO', NULL, false, 'CONSTRUCCIONES TRES ARROYOS', 'ENTREGADO_A_PROVEEDOR', '2008-09-30', '2008-10-06', 500.00, '78741903');
INSERT INTO cheques VALUES (1464, '30707213635', NULL, 'SANTADER  RIO', NULL, false, 'CONSTRUCCIONES TRES ARROYOS', 'ENTREGADO_A_PROVEEDOR', '2008-09-30', '2008-10-20', 500.00, '78741904');
INSERT INTO cheques VALUES (1465, '30707213635', NULL, 'SANTADER  RIO', NULL, false, 'CONSTRUCCIONES TRES ARROYOS', 'ENTREGADO_A_PROVEEDOR', '2008-09-30', NULL, 496.80, '78741905');
INSERT INTO cheques VALUES (1466, '20110974141', NULL, 'PAT', NULL, false, 'TOSTEX', 'ENTREGADO_A_PROVEEDOR', '2008-09-04', '2008-10-06', 1325.00, '63437967');
INSERT INTO cheques VALUES (1310, '30545690922', 'de la penna seguridad fenix NO A LA ORDEN', 'CREDICOOP', NULL, false, 'CELTA', 'ENTREGADO_A_PROVEEDOR', '2008-09-12', '2008-09-30', 1053.53, '25627784');
INSERT INTO cheques VALUES (1390, '20205813161', NULL, 'PROVINCIA', NULL, false, 'RECARI', 'ENTREGADO_A_PROVEEDOR', '2008-09-09', '2008-09-25', 203.20, '92320149');
INSERT INTO cheques VALUES (1542, '23053576419', NULL, 'nacion', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-09-12', '2008-09-30', 606.00, '88281097');
INSERT INTO cheques VALUES (1546, '30505012182', 'DE LA PENNA SEGURIDAD FENIX', 'MACRO', NULL, false, 'vial agro', 'ENTREGADO_A_PROVEEDOR', '2008-09-02', '2008-08-10', 172.00, '50095923');
INSERT INTO cheques VALUES (1541, '27217652362', 'SEGURIDAD FENIX S.A.', 'PROVINCIA', NULL, false, 'CECILIA PONS', 'ENTREGADO_A_PROVEEDOR', '2008-09-25', '2008-09-27', 413.00, '85565958');
INSERT INTO cheques VALUES (1540, '30505012182', 'DE LA PENNA SEGURIDAD FENIX', 'macro', NULL, false, 'vial agro', 'ENTREGADO_A_PROVEEDOR', '2008-09-02', '2008-10-10', 172.00, '50095923');
INSERT INTO cheques VALUES (111115, '20120993705', NULL, 'PROVINCIA', NULL, false, 'ARTAZA', 'ENTREGADO_A_PROVEEDOR', '2008-09-24', '2008-10-26', 236.33, '87326882');
INSERT INTO cheques VALUES (111121, '30545690922', NULL, 'credicoop', NULL, false, 'CELTA', 'ENTREGADO_A_PROVEEDOR', '2008-10-14', '2008-10-31', 11375.27, '25627895');
INSERT INTO cheques VALUES (111116, '20278284590', NULL, 'BISEL', NULL, false, 'Tumini carlos', 'ENTREGADO_A_PROVEEDOR', '2008-10-16', '2008-10-17', 163.00, '25250356');
INSERT INTO cheques VALUES (111117, '30538289503', NULL, 'HSBC', NULL, false, 'CASA BALDA', 'ENTREGADO_A_PROVEEDOR', '2008-10-10', '2008-11-20', 1113.00, '91089879');
INSERT INTO cheques VALUES (111122, '30547329178', NULL, 'nacion', NULL, false, 'CERRI', 'ENTREGADO_A_PROVEEDOR', '2008-10-01', '2008-11-10', 800.00, '87140842');
INSERT INTO cheques VALUES (111120, '2012592479', NULL, 'GALICIA', NULL, false, 'MAÑARICUA', 'ENTREGADO_A_PROVEEDOR', '2008-10-17', '2008-10-15', 520.00, '77209737');
INSERT INTO cheques VALUES (111123, '27037829167', NULL, 'nacion', NULL, false, 'HESS NORA ESTHER', 'ENTREGADO_A_PROVEEDOR', '2008-10-30', '2008-10-30', 241.00, '88029800');
INSERT INTO cheques VALUES (111124, '30513505058', NULL, 'GALICIA', NULL, false, 'LA AURORA', 'ENTREGADO_A_PROVEEDOR', '2008-10-09', '2008-10-10', 584.00, '78089320');
INSERT INTO cheques VALUES (111125, '30605162009', NULL, 'PROVINCIA', NULL, false, 'AEROTAN', 'ENTREGADO_A_PROVEEDOR', '2008-10-02', '2008-10-02', 280.00, '92943349');
INSERT INTO cheques VALUES (111127, '30667516346', NULL, 'PROVINCIA', NULL, false, 'ISMAEL DANIEL I', 'ENTREGADO_A_PROVEEDOR', '2008-11-10', '2008-11-10', 291.30, '94841133');
INSERT INTO cheques VALUES (1456, '30708538198', 'DE LA PENNA SEGURIDAD FENIX  NO A LA ORDEN', 'NACION', NULL, true, 'RUTAS AL SUR', 'EN_POSESION_DE_FENIX', '2008-09-22', '2008-09-22', 481.00, '13949027');
INSERT INTO cheques VALUES (1485, '30667503414', NULL, 'SANTADER  RIO', NULL, true, 'VIAL TRES', 'EN_POSESION_DE_FENIX', '2008-10-02', '2008-10-17', 273.00, '42228558');
INSERT INTO cheques VALUES (111129, '3099900230', 'CARLOS KELLER', 'PROVINCIA', 'BOLIVAR 1202 - CNEL. DORREGO', false, 'CARLOS KELLER', 'ENTREGADO_A_PROVEEDOR', '2008-10-10', '2008-10-10', 97.50, '93889486');
INSERT INTO cheques VALUES (111128, '30667484509', NULL, 'GALICIA', NULL, false, 'URDAMPILLETA', 'ENTREGADO_A_PROVEEDOR', '2008-10-18', '2008-11-10', 72.00, '78340516');
INSERT INTO cheques VALUES (111135, '27103576437', NULL, 'PROVINCIA', NULL, false, 'RECARI', 'ENTREGADO_A_PROVEEDOR', '2008-09-02', '2008-09-24', 150.00, '93299146');
INSERT INTO cheques VALUES (111118, '30709639648', NULL, 'credicoop', NULL, false, '17 de Diciembre', 'ENTREGADO_A_PROVEEDOR', '2008-10-02', '2008-11-02', 810.70, '26224646');
INSERT INTO cheques VALUES (111133, '20055098744', NULL, 'PROVINCIA', NULL, false, 'RECARI', 'ENTREGADO_A_PROVEEDOR', '2008-07-29', '2008-10-03', 500.00, '92178143');
INSERT INTO cheques VALUES (111134, '30578475660', NULL, 'patagonia', NULL, false, 'agro el carretero', 'ENTREGADO_A_PROVEEDOR', '2008-10-20', '2008-10-21', 711.21, '67922378');
INSERT INTO cheques VALUES (111137, '30709171093', 'PRAXAIR', 'SANTADER  RIO', NULL, false, 'Seguridad Fenix', 'ENTREGADO_A_PROVEEDOR', '2008-10-10', '2008-11-10', 8576.56, '00000350');
INSERT INTO cheques VALUES (111138, '30709171093', 'PRAXAIR', 'SANTADER  RIO', NULL, false, 'Seguridad Fenix', 'ENTREGADO_A_PROVEEDOR', '2008-10-21', '2008-11-21', 4425.98, '00000351');
INSERT INTO cheques VALUES (111139, '30999004527', 'SEGURIDAD FENIX S.A.', 'PROVINCIA', NULL, false, 'ELIZONDO', 'ENTREGADO_A_PROVEEDOR', '2008-10-21', '2008-10-21', 396.00, '94160719');
INSERT INTO cheques VALUES (111140, '20053901833', 'SEGURIDAD FENIX S.A.', 'nacion', NULL, false, 'MARIO CARRERA', 'ENTREGADO_A_PROVEEDOR', '2008-10-22', '2008-10-30', 170.50, '85720815');
INSERT INTO cheques VALUES (111142, '20053901833', 'SEGURIDAD FENIX S.A.', 'nacion', NULL, false, 'MARIO CARRERA', 'ENTREGADO_A_PROVEEDOR', '2008-10-22', '2008-11-10', 167.50, '88631457');
INSERT INTO cheques VALUES (111143, NULL, NULL, 'PROVINCIA', NULL, false, 'JORGE RODRIGUEZ', 'ENTREGADO_A_PROVEEDOR', '2008-10-17', '2008-10-25', 120.00, '90337981');
INSERT INTO cheques VALUES (111144, '30592234692', NULL, 'patagonia', NULL, false, 'CLUB CAZADORES', 'ENTREGADO_A_PROVEEDOR', '2008-10-07', '2008-10-20', 448.50, '67596219');
INSERT INTO cheques VALUES (111146, '33550001549', 'SEGURIDAD FENIX S.A.', 'PROVINCIA', NULL, false, 'AIELLO', 'DEPOSITADO', '2008-10-22', '2008-10-27', 3618.89, '95924654');
INSERT INTO cheques VALUES (111149, '20144992165', NULL, 'PATAGONIA', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-10-14', '2008-10-20', 235.95, '68472360');
INSERT INTO cheques VALUES (111152, '20174230388', NULL, 'GALICIA', NULL, false, 'ANDRES RETA', 'ENTREGADO_A_PROVEEDOR', '2008-10-23', '2008-10-24', 221.00, '78327801');
INSERT INTO cheques VALUES (111150, '30540524536', NULL, 'PROVINCIA', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-10-20', '2008-10-20', 207.00, '87910798');
INSERT INTO cheques VALUES (111151, '30709006203', NULL, 'NACION', NULL, false, 'MADERAS SAN JOSE DE LOS ARROYOS', 'ENTREGADO_A_PROVEEDOR', '2008-10-22', '2008-11-07', 236.00, '88507626');
INSERT INTO cheques VALUES (111154, '30708066458', NULL, 'credicoop', NULL, false, 'EVELEENZ', 'ENTREGADO_A_PROVEEDOR', '2008-10-07', '2008-10-31', 345.00, '26834254');
INSERT INTO cheques VALUES (111147, '3070720466', 'ETERNET', 'PROVINCIA', NULL, false, 'ETERNET', 'ENTREGADO_A_PROVEEDOR', '2008-10-02', '2008-10-07', 129.00, '90155754');
INSERT INTO cheques VALUES (111148, '30525418762', 'DE LA PENNA SEGURIDAD FENIX', 'NACION', NULL, false, 'COOPERATIVA AGRICOLA LTDA', 'ENTREGADO_A_PROVEEDOR', '2008-10-14', '2008-10-15', 967.50, '80479326');
INSERT INTO cheques VALUES (111155, '30526111393', NULL, 'credicoop', NULL, false, 'COOP AGRARIA', 'ENTREGADO_A_PROVEEDOR', '2008-10-23', '2008-10-27', 505.09, '03422025');
INSERT INTO cheques VALUES (111160, NULL, NULL, 'SANTADER  RIO', NULL, true, 'SERVILIMP', 'EN_POSESION_DE_FENIX', '2008-09-30', NULL, 184.13, '1444');
INSERT INTO cheques VALUES (111158, NULL, NULL, 'PROVINCIA', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-08-22', '2008-10-31', 1600.00, '91349967');
INSERT INTO cheques VALUES (111162, '20053759034', 'GENOVESI HNOS. S.R.L.', 'LA PAMPA', NULL, false, 'GENOVESI HNOS. S.R.L.', 'ENTREGADO_A_PROVEEDOR', '2008-10-22', '2008-10-29', 761.25, '18220908');
INSERT INTO cheques VALUES (111165, '23053576419', NULL, 'NACION', NULL, false, 'GONZALEZ - FERREMAQ', 'ENTREGADO_A_PROVEEDOR', '2008-10-24', '2008-11-17', 392.00, '87437644');
INSERT INTO cheques VALUES (111163, '30708933011', 'MAM', 'SANTADER  RIO', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-09-30', '2008-10-30', 184.13, '01444');
INSERT INTO cheques VALUES (111166, '30648075754', NULL, 'nacion', NULL, false, 'GONZALEZ - FERREMAQ', 'ENTREGADO_A_PROVEEDOR', '2008-10-11', '2008-11-30', 326.17, '88207633');
INSERT INTO cheques VALUES (111157, '30511381459', 'FENIX', 'patagonia', NULL, false, 'OLSEN ALFREDO', 'ENTREGADO_A_PROVEEDOR', '2008-10-27', '2008-10-28', 65.50, '68511139');
INSERT INTO cheques VALUES (111159, NULL, NULL, 'PROVINCIA', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-10-10', '2008-11-02', 229.90, '90631549');
INSERT INTO cheques VALUES (111167, '30594465497', NULL, 'GALICIA', NULL, false, 'GONZALEZ - FERREMAQ', 'ENTREGADO_A_PROVEEDOR', '2008-10-23', '2008-12-10', 2216.00, '13757762');
INSERT INTO cheques VALUES (111161, '30594465497', 'DE LA PENNA SEGURIDAD FENIX', 'GALICIA', NULL, true, 'LASO S.A.', 'EN_POSESION_DE_FENIX', '2008-10-23', '2008-12-10', 2116.00, '13757762');
INSERT INTO cheques VALUES (111172, '30709171093', 'PRAXAIR', 'SANTADER  RIO', NULL, false, 'FENIX', 'ENTREGADO_A_PROVEEDOR', '2008-10-29', NULL, 1133.00, '352');
INSERT INTO cheques VALUES (111173, '30667469119', NULL, 'PROVINCIA', NULL, false, 'ESCUELA Nº2', 'ENTREGADO_A_PROVEEDOR', '2008-10-28', NULL, 97.00, '85679252');
INSERT INTO cheques VALUES (111175, '0', NULL, 'credicoop', 'CADEL-MALTERIA', false, 'LORAY CESAR MAURICIO', 'ENTREGADO_A_PROVEEDOR', '2008-10-29', '2008-10-31', 176.00, '25608473');
INSERT INTO cheques VALUES (111183, '30667455819', NULL, 'patagonia', NULL, false, 'CYMA', 'ENTREGADO_A_PROVEEDOR', '2008-10-24', '2008-10-27', 599.50, '68469905');
INSERT INTO cheques VALUES (111182, '30513505058', 'SEGURIDAD FENIX S.A.', 'GALICIA', NULL, false, 'la aurora', 'ENTREGADO_A_PROVEEDOR', '2008-10-30', '2008-10-31', 215.20, '78089345');
INSERT INTO cheques VALUES (111181, '27053882760', NULL, 'PROVINCIA', NULL, false, 'PEREZ DALSGAARD Y CIA', 'ENTREGADO_A_PROVEEDOR', '2008-10-14', '2008-10-15', 176.00, '90206814');
INSERT INTO cheques VALUES (111179, '20053647228', NULL, 'PROVINCIA', NULL, false, 'MITRE GNC', 'ENTREGADO_A_PROVEEDOR', '2008-10-24', '2008-10-25', 200.00, '89206001');
INSERT INTO cheques VALUES (111185, '20136511980', NULL, 'PROVINCIA', NULL, false, 'GERMAN CIANCAGLINI', 'ENTREGADO_A_PROVEEDOR', '2008-10-31', '2008-11-14', 484.00, '96373888');
INSERT INTO cheques VALUES (111180, '20102278926', NULL, 'LA PAMPA', NULL, false, 'METFER SA', 'ENTREGADO_A_PROVEEDOR', '2008-10-17', '2008-10-17', 2552.77, '35839346');
INSERT INTO cheques VALUES (111174, '30710601786', NULL, 'macro', NULL, false, 'AGRO IND. SUDESTE', 'ENTREGADO_A_PROVEEDOR', '2008-10-29', '2008-10-15', 2595.30, '50714933');
INSERT INTO cheques VALUES (111191, '20053865888', NULL, 'PROVINCIA', NULL, false, 'ordoqui', 'ENTREGADO_A_PROVEEDOR', '2008-10-30', '2008-11-06', 502.40, '83579506');
INSERT INTO cheques VALUES (111192, '2316606379', NULL, 'nacion', NULL, false, 'ordoqui', 'ENTREGADO_A_PROVEEDOR', '2008-10-24', '2008-11-06', 250.00, '87561628');
INSERT INTO cheques VALUES (111188, '30667469119', NULL, 'PROVINCIA', NULL, false, 'escuela nº 2', 'ENTREGADO_A_PROVEEDOR', '2008-10-30', '2008-10-30', 181.00, '85679253');
INSERT INTO cheques VALUES (111190, '30667455436', NULL, 'PROVINCIA', NULL, false, 'ESCUELA Nº8', 'ENTREGADO_A_PROVEEDOR', '2008-11-03', NULL, 130.00, '85987977');
INSERT INTO cheques VALUES (111194, '30667477618', 'IORIO', 'PROVINCIA', NULL, false, 'IORIO', 'ENTREGADO_A_PROVEEDOR', '2008-10-28', '2008-10-29', 834.90, '93241786');
INSERT INTO cheques VALUES (111196, '30708723017', NULL, 'GALICIA', NULL, false, 'PALAU', 'DEPOSITADO', '2008-10-29', '2008-10-30', 453.75, '78017375');
INSERT INTO cheques VALUES (111197, '30578475660', NULL, 'patagonia', NULL, false, 'agro el carretero', 'DEPOSITADO', '2008-10-30', '2008-10-31', 535.05, '68722854');
INSERT INTO cheques VALUES (111195, '30667476794', NULL, 'PROVINCIA', NULL, false, 'ESCUELA Nº 15', 'DEPOSITADO', '2008-11-04', NULL, 266.00, '90931506');
INSERT INTO cheques VALUES (111200, '30505012182', 'DE LA PENNA SEGURIDAD FENIX', 'MACRO', NULL, false, 'vial agro', 'DEPOSITADO', '2008-10-21', '2008-10-30', 706.14, '51617246');
INSERT INTO cheques VALUES (111198, '33686512229', NULL, 'MACRO', NULL, false, 'RAISER S.A.', 'ENTREGADO_A_PROVEEDOR', '2008-10-24', '2009-01-13', 630.00, '52416618');
INSERT INTO cheques VALUES (111203, '20080111917', NULL, 'SANTANDER RIO', NULL, false, 'METALURGICA LOS ARROYOS', 'ENTREGADO_A_PROVEEDOR', '2008-10-27', '2008-11-04', 264.83, '00901219');
INSERT INTO cheques VALUES (111202, '30545746782', 'DE LA PENNA SEGURIDAD FENIX SA', 'NUEVO BANCO BISEL', NULL, false, 'COOP DE PROVISION DE SERVICIOS PUBLICOS DE LA GARMA', 'ENTREGADO_A_PROVEEDOR', '2008-11-03', '2008-11-04', 510.00, '14102165');
INSERT INTO cheques VALUES (111204, '20137705304', NULL, 'banco de la pampa', NULL, false, 'METALURGICA LOS ARROYOS', 'ENTREGADO_A_PROVEEDOR', '2008-10-21', '2008-11-01', 506.12, '18446974');
INSERT INTO cheques VALUES (111205, '27235854274', NULL, 'PROVINCIA', NULL, false, 'aguadas gomez', 'ENTREGADO_A_PROVEEDOR', '2008-11-01', '2008-11-30', 1350.00, '90276820');
INSERT INTO cheques VALUES (111178, '30526111393', 'METFER S. A.', 'CREDICOOP', NULL, false, 'METFER', 'ENTREGADO_A_PROVEEDOR', '2008-10-01', '2008-10-02', 367.84, '03421869');
INSERT INTO cheques VALUES (111208, NULL, NULL, 'credicoop', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-10-28', '2008-10-29', 202.54, '03650252');
INSERT INTO cheques VALUES (111211, '30707331301', NULL, 'PROVINCIA', NULL, false, 'LUCIANO Y EZEQUIEL SODE', 'ENTREGADO_A_PROVEEDOR', '2008-11-04', '2008-11-25', 303.30, '93318838');
INSERT INTO cheques VALUES (111210, '30707787208', NULL, 'SANTADER  RIO', NULL, false, 'FERTYCOM', 'ENTREGADO_A_PROVEEDOR', '2008-11-07', '2008-11-08', 203.00, '82195417');
INSERT INTO cheques VALUES (111201, '33637642249', 'MOLINOS TRES ARROYOS', 'PROVINCIA', NULL, false, 'MOLINO TRES ARROYOS', 'ENTREGADO_A_PROVEEDOR', '2008-11-05', '2008-11-21', 7500.00, '96662146');
INSERT INTO cheques VALUES (111212, '20083120127', NULL, 'PROVINCIA', NULL, false, 'LUC. Y EZE SODE', 'ENTREGADO_A_PROVEEDOR', '2008-11-06', '2008-11-07', 252.89, '91019133');
INSERT INTO cheques VALUES (111213, '20083719053', NULL, 'PROVINCIA', NULL, false, 'WEINZETTEL', 'ENTREGADO_A_PROVEEDOR', '2008-11-05', '2008-12-15', 269.00, '96508854');
INSERT INTO cheques VALUES (111217, '30509139616', NULL, 'nacion', NULL, false, 'MADERERA EMANUEL', 'ENTREGADO_A_PROVEEDOR', '2008-10-28', '2008-10-29', 115.26, '86828144');
INSERT INTO cheques VALUES (111214, '30667451236', NULL, 'credicoop', NULL, false, 'SINDICATO MUNICIPALES', 'ENTREGADO_A_PROVEEDOR', '2008-11-07', '2008-11-08', 193.00, '26573936');
INSERT INTO cheques VALUES (111222, '305000957952', 'DE LA PENNA SEGURIDAD FENIX', 'PROVINCIA', NULL, false, 'TRAFER', 'DEPOSITADO', '0008-11-04', '0008-11-07', 514.00, '94528945');
INSERT INTO cheques VALUES (111223, '30545743023', 'DE LA PENNA SEGURIDAD FENIX', 'GALICIA', NULL, false, 'COOP ELECT. CLAROMECO', 'DEPOSITADO', '0008-08-10', '0008-11-11', 1252.40, '77524417');
INSERT INTO cheques VALUES (111219, '3052754061', NULL, 'PROVINCIA', NULL, false, 'TOSTEX', 'DEPOSITADO', '2008-10-10', '2008-11-11', 1001.00, '96203877');
INSERT INTO cheques VALUES (111221, '27034923820', NULL, 'NACION', NULL, false, 'BLOMAR', 'ENTREGADO_A_PROVEEDOR', '0008-11-12', '0008-11-12', 390.00, '87437675');
INSERT INTO cheques VALUES (111225, NULL, NULL, 'NO SE', NULL, false, NULL, 'DEPOSITADO', '0008-11-11', '0008-11-11', 448.00, '11111111111');
INSERT INTO cheques VALUES (111226, NULL, NULL, 'NOSE', NULL, false, NULL, 'DEPOSITADO', '0008-11-11', '0008-11-11', 139.58, '222222222');
INSERT INTO cheques VALUES (111227, NULL, NULL, 'NOSE', NULL, false, NULL, 'DEPOSITADO', '0008-11-11', '0008-11-11', 1001.00, '33333333');
INSERT INTO cheques VALUES (111220, '30527540611', NULL, 'PROVINCIA', NULL, false, 'TOSTEX', 'ENTREGADO_A_PROVEEDOR', '2008-10-10', '2008-11-13', 1001.00, '96203878');
INSERT INTO cheques VALUES (111230, '30526111393', NULL, 'GALICIA', NULL, false, 'COOP AGRARIA', 'DEPOSITADO', '2008-11-07', '2008-11-07', 4475.44, '03893372');
INSERT INTO cheques VALUES (111228, '27034923820', NULL, 'NACION', NULL, false, 'FERROMAQ', 'ENTREGADO_A_PROVEEDOR', '2008-11-12', '2008-11-30', 784.00, '89119427');
INSERT INTO cheques VALUES (111229, '30667468813', NULL, 'PROVINCIA', NULL, false, 'ESCUELA Nº5', 'ENTREGADO_A_PROVEEDOR', '2008-11-12', '2008-11-12', 124.00, '74982018');
INSERT INTO cheques VALUES (111232, '23081144109', NULL, 'CREDICOOP', NULL, false, 'RAISER S.A.', 'ENTREGADO_A_PROVEEDOR', '2008-11-08', '2008-11-15', 210.00, '26597652');
INSERT INTO cheques VALUES (111233, '30667522001', NULL, 'LA PAMPA', NULL, false, 'AUTOSERVICIO 228', 'ENTREGADO_A_PROVEEDOR', '2008-11-11', '2008-11-29', 235.00, '18546415');
INSERT INTO cheques VALUES (111236, '30709529885', NULL, 'credicop', NULL, false, 'sis. fiadoni', 'ENTREGADO_A_PROVEEDOR', '0008-11-11', '0008-11-28', 460.00, '27616881');
INSERT INTO cheques VALUES (111216, '30605162009', 'SEGURIDAD FENIX S.A.', 'PROVINCIA', NULL, false, 'AEROTAN', 'ENTREGADO_A_PROVEEDOR', '2008-11-03', '2008-11-20', 1278.03, '96368246');
INSERT INTO cheques VALUES (111235, '20130368264', NULL, 'MACRO', NULL, false, 'LUCIANO BIANCHI', 'ENTREGADO_A_PROVEEDOR', '2008-11-07', '2008-12-04', 450.00, '53442352');
INSERT INTO cheques VALUES (111247, '30556633971', NULL, 'NACION', NULL, true, 'AGUIRRE ZABALA', 'EN_POSESION_DE_FENIX', '2008-11-03', '2008-11-30', 190.00, '96928178');
INSERT INTO cheques VALUES (111249, '305566339714', NULL, 'NACION', NULL, false, 'AGUIRRE ZABALA', 'ENTREGADO_A_PROVEEDOR', '2008-10-31', '2008-11-01', 369.00, '87917144');
INSERT INTO cheques VALUES (111248, '20054249056', NULL, 'PROVINCIA', NULL, false, 'AGUIRRE ZABALA', 'ENTREGADO_A_PROVEEDOR', '2008-11-03', '2008-11-30', 190.00, '96928178');
INSERT INTO cheques VALUES (111239, '30709360228', NULL, 'nacion', NULL, false, 'DRYLUX SA', 'ENTREGADO_A_PROVEEDOR', '2008-11-12', '2008-11-13', 384.00, '88965630');
INSERT INTO cheques VALUES (111238, '30667502043', NULL, 'patagonia', NULL, false, '18 DE SETIEMBRE', 'ENTREGADO_A_PROVEEDOR', '2008-11-11', '2008-11-12', 779.00, '68496403');
INSERT INTO cheques VALUES (111234, '30605162009', 'SEGURIDAD FENIX S.A.', 'PROVINCIA', NULL, true, 'AEROTAN', 'EN_POSESION_DE_FENIX', '2008-11-03', '2008-11-20', 1278.03, '96368246');
INSERT INTO cheques VALUES (111241, '30656784403', NULL, 'nacion', NULL, false, 'AGUIRRE ZABALA', 'ENTREGADO_A_PROVEEDOR', '2008-11-02', '2008-11-07', 600.00, '87210606');
INSERT INTO cheques VALUES (111243, '20129402866', NULL, 'BISEL', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-11-10', '2008-11-17', 100.00, '25859419');
INSERT INTO cheques VALUES (111244, '20053760601', NULL, 'patagonia', NULL, false, 'ETERNET', 'ENTREGADO_A_PROVEEDOR', '2008-11-07', NULL, 89.00, '18118276');
INSERT INTO cheques VALUES (111246, '27104058340', NULL, 'patagonia', NULL, false, 'PEDERSEN SONIA', 'ENTREGADO_A_PROVEEDOR', '2008-11-10', '2008-11-12', 121.00, '63253704');
INSERT INTO cheques VALUES (111245, '30578475660', NULL, 'patagonia', NULL, false, 'agro el carretero', 'ENTREGADO_A_PROVEEDOR', '2008-11-12', '2008-11-13', 1248.33, '68723011');
INSERT INTO cheques VALUES (111265, '33551274379', 'SERVILIMP DE TRES ARROYOS S.R.L.', 'PROVINCIA', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-11-19', '2008-11-19', 846.40, '91472152');
INSERT INTO cheques VALUES (111259, '30545690922', NULL, 'credicoop', NULL, false, 'CELTA', 'ENTREGADO_A_PROVEEDOR', '2008-11-13', '2008-11-28', 6272.74, '27473442');
INSERT INTO cheques VALUES (111254, '20118464126', 'SEGURIDAD FENIX S.A.', 'GALICIA', NULL, false, 'KULHMANN', 'ENTREGADO_A_PROVEEDOR', '2008-10-29', '2008-12-29', 765.00, '76907776');
INSERT INTO cheques VALUES (111257, '30538289503', NULL, 'HSBC', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-10-24', '2008-12-10', 780.81, '91090084');
INSERT INTO cheques VALUES (111258, '20166061963', NULL, 'SANTADER  RIO', NULL, false, 'FUERTES PABLO', 'ENTREGADO_A_PROVEEDOR', '2008-11-16', '2008-11-17', 446.00, '388');
INSERT INTO cheques VALUES (111262, '20053687483', NULL, 'MACRO', NULL, false, 'BANCUR - DUNAMAR', 'ENTREGADO_A_PROVEEDOR', '2008-11-10', '2008-11-14', 150.00, '48195802');
INSERT INTO cheques VALUES (111253, '20184546362', NULL, 'LA PAMPA', NULL, true, 'LARREA', 'EN_POSESION_DE_FENIX', '2008-11-14', '2008-11-21', 129.00, '18494242');
INSERT INTO cheques VALUES (111266, '30708723017', NULL, 'GALICIA', NULL, false, 'PALAU', 'ENTREGADO_A_PROVEEDOR', '2008-11-17', '2008-11-18', 242.00, '78429871');
INSERT INTO cheques VALUES (111261, '30667509145', NULL, 'PROVINCIA', NULL, false, 'ESCUELA Nº 25 COPETONAS', 'ENTREGADO_A_PROVEEDOR', '2008-11-17', '2008-11-18', 168.00, '46635990');
INSERT INTO cheques VALUES (111263, '30707711090', NULL, 'CREDICOOP', NULL, false, 'LOMERIDE S.A.', 'ENTREGADO_A_PROVEEDOR', '2008-11-01', '2008-11-19', 2079.00, '26427648');
INSERT INTO cheques VALUES (111264, '23256055309', NULL, 'PROVINCIA', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-11-03', '2008-11-04', 700.00, '94618068');
INSERT INTO cheques VALUES (111256, '20044381088', NULL, 'patagonia', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-11-10', '2008-11-11', 273.00, '62809898');
INSERT INTO cheques VALUES (111274, '20118464126', NULL, 'GALICIA', NULL, true, 'KUHLMAN', 'EN_POSESION_DE_FENIX', '2008-10-14', '2008-11-15', 752.18, '76907795');
INSERT INTO cheques VALUES (111271, '30526111393', NULL, 'credicoop', NULL, false, 'FRIGOR.ANSELMO', 'ENTREGADO_A_PROVEEDOR', '2008-11-11', '2008-11-12', 286.67, '03422167');
INSERT INTO cheques VALUES (111276, '20118464126', NULL, 'GALICIA', NULL, false, 'RECARI', 'ENTREGADO_A_PROVEEDOR', '2008-10-14', '2008-11-15', 752.18, '76907795');
INSERT INTO cheques VALUES (111269, '30547329178', NULL, 'credicoop', NULL, false, 'CERRI CARLOS', 'ENTREGADO_A_PROVEEDOR', '2008-10-01', '2008-12-22', 800.00, '27810391');
INSERT INTO cheques VALUES (111278, '20053840559', NULL, 'GALICIA', NULL, false, 'GARCIA ALFREDO', 'ENTREGADO_A_PROVEEDOR', '2008-11-06', '2008-12-22', 200.00, '77859597');
INSERT INTO cheques VALUES (111273, '20143229409', NULL, 'PROVINCIA', NULL, false, 'PETELA', 'ENTREGADO_A_PROVEEDOR', '2008-10-16', '2008-12-18', 573.00, '95225793');
INSERT INTO cheques VALUES (111283, '30708667710', NULL, 'PROVINCIA', NULL, false, 'NEMIHUEN SA', 'ENTREGADO_A_PROVEEDOR', '2008-11-20', '2008-11-21', 157.51, '86138649');
INSERT INTO cheques VALUES (111280, '23223254829', NULL, 'STANDARD BANK', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-10-04', '2008-10-30', 443.15, '49349785');
INSERT INTO cheques VALUES (111282, '20182799891', NULL, 'SANTADER  RIO', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-09-12', '2008-10-30', 563.00, '65');
INSERT INTO cheques VALUES (111279, '30500105328', NULL, 'nacion', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-10-28', '2008-11-03', 1205.11, '83365875');
INSERT INTO cheques VALUES (111270, '20264686203', NULL, 'PATAGONIA', NULL, false, 'SCAMPINI', 'ENTREGADO_A_PROVEEDOR', '2008-11-20', '2008-11-21', 159.00, '68875076');
INSERT INTO cheques VALUES (111286, '20053782885', NULL, 'credicoop', NULL, false, 'JENSEN ROBERTO', 'DEPOSITADO', '2008-11-25', '2008-11-26', 68.50, '26501665');
INSERT INTO cheques VALUES (111289, '20144991428', NULL, 'PROVINCIA', NULL, false, 'ANSO ROBERTO', 'DEPOSITADO', '2008-11-23', '2008-11-25', 400.00, '83061439');
INSERT INTO cheques VALUES (111288, '33550001549', NULL, 'PROVINCIA', NULL, false, 'AIELLO', 'DEPOSITADO', '2008-11-24', '2008-11-25', 4229.93, '95924685');
INSERT INTO cheques VALUES (111290, '20215896138', NULL, 'GALICIA', NULL, false, 'REGUERA', 'ENTREGADO_A_PROVEEDOR', '2008-11-25', '2008-12-16', 350.00, '78458099');
INSERT INTO cheques VALUES (111275, '33560456269', NULL, 'G', NULL, false, 'TRANS. MALVINAS', 'DEPOSITADO', '2008-11-11', '2008-11-11', 491.40, '43238549');
INSERT INTO cheques VALUES (111281, '20140885771', NULL, 'patagonia', NULL, false, 'SERVILIMP', 'DEPOSITADO', '2008-09-30', '2008-10-25', 451.35, '68006821');
INSERT INTO cheques VALUES (111287, '30708538198', NULL, 'nacion', NULL, false, 'RUTAS AL SUR', 'DEPOSITADO', '2008-11-18', '2008-11-18', 221.50, '13949581');
INSERT INTO cheques VALUES (111293, '33550001549', NULL, 'PROVINCIA', NULL, false, 'SERVILIMP', 'DEPOSITADO', '2008-11-24', '2008-11-25', 1445.07, '95924673');
INSERT INTO cheques VALUES (111294, '30526111393', NULL, 'GALICIA', NULL, false, 'COOP AGRARIA', 'DEPOSITADO', '2008-11-20', '2008-11-20', 2272.38, '03893506');
INSERT INTO cheques VALUES (111291, '20051659733', NULL, 'patagonia', NULL, false, 'SERVILIMP', 'DEPOSITADO', '2008-11-21', '2008-11-21', 305.90, '18711326');
INSERT INTO cheques VALUES (111292, '00011043947', NULL, 'SANTADER  RIO', NULL, false, 'SERVILIMP', 'DEPOSITADO', '2008-11-19', '2008-11-27', 453.75, '130');
INSERT INTO cheques VALUES (111295, '30594465497', NULL, 'GALICIA', NULL, false, 'LASO S.A.', 'ENTREGADO_A_PROVEEDOR', '2008-11-20', '2009-01-07', 1435.00, '13936709');
INSERT INTO cheques VALUES (111297, '30667455819', NULL, 'patagonia', NULL, false, 'CYMA', 'ENTREGADO_A_PROVEEDOR', '2008-11-24', '2008-11-26', 2111.83, '68941040');
INSERT INTO cheques VALUES (111296, '30708581662', NULL, 'PROVINCIA', NULL, false, 'MOLINOS ZALLA', 'ENTREGADO_A_PROVEEDOR', '2008-11-26', '2008-11-27', 797.00, '94924619');
INSERT INTO cheques VALUES (111302, '23053576419', NULL, 'nacion', NULL, false, 'ferremaq', 'ENTREGADO_A_PROVEEDOR', '2008-11-28', '2008-12-22', 587.91, '89119464');
INSERT INTO cheques VALUES (111301, '30709757101', NULL, 'PROVINCIA', NULL, false, 'LOS DRAGO SA', 'ENTREGADO_A_PROVEEDOR', '2008-11-27', '2008-11-28', 886.00, '84535942');
INSERT INTO cheques VALUES (111304, '30538289503', NULL, 'HSBC', NULL, false, 'CASA BALDA', 'ENTREGADO_A_PROVEEDOR', '2008-11-27', '2008-12-22', 1214.00, '91413825');
INSERT INTO cheques VALUES (111307, '306674897993', NULL, 'GALICIA', NULL, false, 'ANSO ROBERTO', 'ENTREGADO_A_PROVEEDOR', '2008-09-12', '2008-11-10', 222.86, '77681611');
INSERT INTO cheques VALUES (111305, '30708538198', NULL, 'NACION', NULL, false, 'RUTAS AL SUR', 'ENTREGADO_A_PROVEEDOR', '2008-11-24', '2008-11-24', 327.00, '13949650');
INSERT INTO cheques VALUES (111303, '20125913742', NULL, 'LA PAMPA', NULL, false, 'MONTE DELFO', 'ENTREGADO_A_PROVEEDOR', '2008-12-01', '2008-12-30', 395.00, '18501642');
INSERT INTO cheques VALUES (111311, '20218845917', NULL, 'nacion', NULL, false, 'BONAFEDE', 'ENTREGADO_A_PROVEEDOR', '2008-12-04', '2008-12-18', 450.00, '89388740');
INSERT INTO cheques VALUES (111323, '30605162009', NULL, 'patagonia', NULL, false, 'AEROTAN', 'ENTREGADO_A_PROVEEDOR', '2008-12-03', '2008-12-03', 1089.00, '15247724');
INSERT INTO cheques VALUES (111326, '30667467752', NULL, 'PROVINCIA', NULL, false, 'ESCUELA Nº24', 'ENTREGADO_A_PROVEEDOR', '2008-12-05', '2008-12-05', 93.00, '86781682');
INSERT INTO cheques VALUES (111333, '30709466042', 'SEGURIDAD FENIX S.A.', 'PROVINCIA', NULL, false, 'ORGANISMO DESCENTRALIZADO CLAROMECO SERVICIOS TURISTICOS', 'ENTREGADO_A_PROVEEDOR', '2008-11-03', '2008-11-03', 315.50, '92097119');
INSERT INTO cheques VALUES (111325, '20118464126', NULL, 'GALICIA', NULL, false, 'KUHLMAN', 'ENTREGADO_A_PROVEEDOR', '2008-12-04', '2008-12-30', 770.00, '78604642');
INSERT INTO cheques VALUES (111300, '30707787208', NULL, 'SANTADER  RIO', NULL, false, 'FERTYCOM', 'ENTREGADO_A_PROVEEDOR', '2008-11-28', '2008-11-29', 60.00, '82195455');
INSERT INTO cheques VALUES (111313, '30707787208', NULL, 'SANTADER  RIO', NULL, true, 'FERTYCOM', 'EN_POSESION_DE_FENIX', '2008-11-28', '2008-11-29', 60.00, '82195455');
INSERT INTO cheques VALUES (111312, '30511381459', NULL, 'patagonia', NULL, false, 'OLSEN ALFREDO', 'ENTREGADO_A_PROVEEDOR', '2008-12-01', '2008-12-05', 52.00, '68511185');
INSERT INTO cheques VALUES (111314, NULL, NULL, 'PROVINCIA', NULL, false, 'ESCUELA Nº 12', 'ENTREGADO_A_PROVEEDOR', '2008-12-02', NULL, 31.00, '88983687');
INSERT INTO cheques VALUES (111319, '30708287187', 'ETERNET', 'GALICIA', NULL, false, 'ETERNET', 'ENTREGADO_A_PROVEEDOR', '2008-11-24', '2008-11-25', 73.00, '77696235');
INSERT INTO cheques VALUES (111318, '20053813047', NULL, 'PATAGONIA', NULL, false, 'COLLAZOS', 'ENTREGADO_A_PROVEEDOR', '2008-11-22', '2008-11-25', 73.00, '68010387');
INSERT INTO cheques VALUES (111317, '20128317946', NULL, 'PROVINCIA', NULL, false, 'ARANA', 'ENTREGADO_A_PROVEEDOR', '2008-11-10', '2008-11-16', 73.00, '95648232');
INSERT INTO cheques VALUES (111322, '30667509072', NULL, 'nacion', NULL, false, 'BARRERAS ALBERTO', 'ENTREGADO_A_PROVEEDOR', '2008-12-01', '2008-12-04', 85.00, '88827844');
INSERT INTO cheques VALUES (111321, '20053931740', NULL, 'GALICIA', NULL, false, 'FEREX JUAN', 'ENTREGADO_A_PROVEEDOR', '2008-12-04', '2008-12-18', 251.00, '78443381');
INSERT INTO cheques VALUES (111316, '30546679183', 'DE LA PENNA SEGURIDAD FENIX', 'NACION', 'NO A LA ORDEN', false, 'INTA', 'DEPOSITADO', '2008-12-02', '2008-12-02', 189.00, '48530520');
INSERT INTO cheques VALUES (111327, '20140694054', NULL, 'PROVINCIA', NULL, false, 'BLACKER', 'ENTREGADO_A_PROVEEDOR', '2008-12-05', '2009-01-06', 611.00, '85438767');
INSERT INTO cheques VALUES (111335, '20262489710', 'SEGURIDAD FENIX', 'FRANCES', NULL, false, 'MELENDEZ EDUARDO', 'ENTREGADO_A_PROVEEDOR', '2008-12-04', '2008-12-05', 422.00, '00233887');
INSERT INTO cheques VALUES (111342, '20184546362', 'ETERNET S.R.L.', 'LA PAMPA', NULL, false, 'ETERNET', 'ENTREGADO_A_PROVEEDOR', '2008-12-09', '2008-12-12', 121.00, '18647303');
INSERT INTO cheques VALUES (111339, '33709976759', 'SEGURIDAD FENIX', 'FRANCES', NULL, false, 'VICTOR ANDREASEN', 'ENTREGADO_A_PROVEEDOR', '2008-12-10', '2008-12-11', 234.00, '00233279');
INSERT INTO cheques VALUES (111348, '30627955800', NULL, 'credicoop', NULL, false, 'LA CASCADA', 'ENTREGADO_A_PROVEEDOR', '2008-12-10', '2008-12-15', 162.40, '27893264');
INSERT INTO cheques VALUES (111351, '30708723017', NULL, 'patagonia', NULL, false, 'PALAU', 'ENTREGADO_A_PROVEEDOR', '2008-12-11', '2008-12-11', 242.00, '18610391');
INSERT INTO cheques VALUES (111337, '30578475660', NULL, 'PATAGONIA', NULL, false, 'agro el carretero', 'ENTREGADO_A_PROVEEDOR', '2008-12-10', '2008-12-11', 845.00, '68723332');
INSERT INTO cheques VALUES (111336, '30708581662', 'DE LA PENNA SEGURIDAD FENIX', 'PROVINCIA', NULL, false, 'MOLINOS ZALLA', 'ENTREGADO_A_PROVEEDOR', '2008-12-10', '2008-12-11', 1206.00, '94924655');
INSERT INTO cheques VALUES (111341, '30709678449', 'ETERNET S.R.L.', 'PROVINCIA', NULL, false, 'ETERNET', 'ENTREGADO_A_PROVEEDOR', '2008-12-04', '2008-12-04', 347.00, '82198137');
INSERT INTO cheques VALUES (111352, '30545743023', NULL, 'GALICIA', NULL, false, 'COOP ELECT. CLAROMECO', 'ENTREGADO_A_PROVEEDOR', '2008-12-11', '2008-12-12', 306.75, '77524436');
INSERT INTO cheques VALUES (111350, '30709742848', NULL, 'PROVINCIA', NULL, false, 'BIOCOMBUSTIBLES TS.AS.', 'ENTREGADO_A_PROVEEDOR', '2008-12-11', '2008-12-22', 179.00, '95734409');
INSERT INTO cheques VALUES (111349, '20048437576', NULL, 'FRANCES', NULL, false, 'GOÑI', 'ENTREGADO_A_PROVEEDOR', '2008-12-11', '2008-12-30', 344.40, '00233745');
INSERT INTO cheques VALUES (111356, '30545690922', 'DE LA PENNA SEGURIDAD FENIX', 'CREDICOOP', NULL, false, 'CELTA', 'ENTREGADO_A_PROVEEDOR', '2008-12-12', '2008-12-31', 2278.74, '27473524');
INSERT INTO cheques VALUES (111360, '30707213635', 'SEGURIDAD FENIX S.A.', 'SANTADER  RIO', NULL, false, 'CONSTRUCCIONES TRES ARROYOS', 'ENTREGADO_A_PROVEEDOR', '2008-12-15', '2008-12-29', 630.00, '78741998');
INSERT INTO cheques VALUES (111361, '30707213635', 'SEGURIDAD FENIX S.A.', 'SANTADER  RIO', NULL, false, 'CONSTRUCCIONES TRES ARROYOS', 'ENTREGADO_A_PROVEEDOR', '2008-12-15', '2008-12-09', 630.00, '78741999');
INSERT INTO cheques VALUES (111362, '30707213635', 'SEGURIDAD FENIX S.A.', 'SANTADER  RIO', NULL, false, 'CONSTRUCCIONES TRES ARROYOS', 'ENTREGADO_A_PROVEEDOR', '2008-12-15', '2009-01-20', 630.00, '78742000');
INSERT INTO cheques VALUES (111340, '20086143330', NULL, 'PATAGONIA', NULL, false, 'ETERNET', 'ENTREGADO_A_PROVEEDOR', '2008-11-29', '2008-12-29', 100.00, '65619096');
INSERT INTO cheques VALUES (111338, '30657849894', 'SEGURIDAD FENIX S.A.', 'FRANCES', NULL, false, 'SUPERCARNE', 'ENTREGADO_A_PROVEEDOR', '2008-12-01', '2009-01-10', 660.12, '00233621');
INSERT INTO cheques VALUES (111359, '30545746782', 'DE LA PENNA SEGURIDAD FENIX', 'PROVINCIA', NULL, false, 'COOPESER', 'ENTREGADO_A_PROVEEDOR', '2008-12-15', '2008-12-16', 510.00, '94468712');
INSERT INTO cheques VALUES (111357, '30511381459', 'DE LA PENNA SEGURIDAD FENIX', 'PATAGONIA', NULL, false, 'ALFREDO OLSEN', 'ENTREGADO_A_PROVEEDOR', '2008-12-15', '2008-12-30', 55.50, '68511209');
INSERT INTO cheques VALUES (111358, '20216990375', NULL, 'LA PAMPA', NULL, false, 'PEDRO BRUNAND', 'ENTREGADO_A_PROVEEDOR', '2008-12-10', '2008-12-11', 140.00, '18431283');
INSERT INTO cheques VALUES (111364, '30578380015', 'SEGURIDAD FENIX S.A. NO A LA ORDEN', 'SANTANDARD BANK', 'NO A LA ORDEN', false, 'GOYAIKE', 'DEPOSITADO', '2008-12-10', '2008-12-11', 2843.18, '0931-54916370');
INSERT INTO cheques VALUES (111369, '20054985887', 'CARLOS EDUARDO LLANO', 'LA PAMPA', NULL, false, 'AGUIRRE ZABALA', 'DEPOSITADO', '2008-11-15', '2008-11-30', 450.00, '17679175');
INSERT INTO cheques VALUES (111371, '20107857029', NULL, 'SANTADER  RIO', NULL, false, 'JORGE MAMANI', 'ENTREGADO_A_PROVEEDOR', '2008-12-17', '2009-01-15', 1080.00, '99217172');
INSERT INTO cheques VALUES (111368, '27168736482', NULL, 'LA PAMPA', NULL, false, 'CAZENAVE', 'ENTREGADO_A_PROVEEDOR', '2008-12-17', '2009-01-03', 714.44, '18395593');
INSERT INTO cheques VALUES (111370, '30545743023', 'SERGIO SCHOURUP', 'PROVINCIA', NULL, false, 'COOP ELECT. CLAROMECO', 'ENTREGADO_A_PROVEEDOR', '2008-12-10', '2008-12-11', 400.00, '95079316');
INSERT INTO cheques VALUES (111366, '30525418762', NULL, 'NACION', NULL, false, 'COOPERATIVA AGRICOLA LTDA CASCALLARES', 'ENTREGADO_A_PROVEEDOR', '2008-12-12', '2008-12-15', 312.00, '89069675');
INSERT INTO cheques VALUES (111367, '20053782214', NULL, 'LA PAMPA', NULL, false, 'BRACCO JUAN', 'ENTREGADO_A_PROVEEDOR', '2008-12-16', '2009-01-12', 168.00, '18340541');
INSERT INTO cheques VALUES (111376, '20928929354', NULL, 'HSBC', NULL, false, 'MOLINO TRES ARROYOS', 'ENTREGADO_A_PROVEEDOR', '2008-12-01', '2008-12-19', 2500.00, '85454909');
INSERT INTO cheques VALUES (111378, NULL, NULL, 'PROVINCIA', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2008-09-24', '2008-10-28', 3618.89, '95924654');
INSERT INTO cheques VALUES (111391, '0', NULL, 'credicoop', NULL, false, 'IORIO', 'ENTREGADO_A_PROVEEDOR', '2008-12-23', '2008-12-23', 500.00, '8844');
INSERT INTO cheques VALUES (111375, '20053679820', NULL, 'PROVINCIA', NULL, false, 'RECARI', 'ENTREGADO_A_PROVEEDOR', '2008-12-15', '2008-12-19', 160.00, '93986152');
INSERT INTO cheques VALUES (111394, '30545823906', 'SEGURIDAD FENIX S.A.', 'PROVINCIA', NULL, false, 'COOP. EL PERDIDO', 'ENTREGADO_A_PROVEEDOR', '2008-12-20', '2008-12-20', 637.80, '85030550');
INSERT INTO cheques VALUES (111401, '30710601786', NULL, 'MACRO', NULL, false, 'AGROINDUSTRIAL SUDESTE', 'ENTREGADO_A_PROVEEDOR', '2008-12-26', '2009-01-14', 2147.10, '54187192');
INSERT INTO cheques VALUES (111402, '20087005179', NULL, 'NACION', NULL, false, 'REGUERA', 'ENTREGADO_A_PROVEEDOR', '2008-12-22', '2008-12-23', 200.00, '89144209');
INSERT INTO cheques VALUES (111407, '30707787208', NULL, 'SANTADER  RIO', NULL, false, 'FERTYCOM', 'ENTREGADO_A_PROVEEDOR', '2008-12-25', '2008-12-26', 250.00, '82195489');
INSERT INTO cheques VALUES (111395, '30667502043', 'FENIX', 'patagonia', NULL, false, '18 DE SETIEMBRE', 'DEPOSITADO', '2008-12-23', '2008-12-24', 2000.00, '68970060');
INSERT INTO cheques VALUES (111400, '33550001549', 'SEGURIDAD FENIX S.A.', 'PATAGONIA', NULL, false, 'AIELLO', 'ENTREGADO_A_PROVEEDOR', '2008-12-22', '2008-12-29', 4616.26, '68368684');
INSERT INTO cheques VALUES (111412, '30528544955', NULL, 'PROVINCIA', NULL, false, 'BELLIGERI', 'ENTREGADO_A_PROVEEDOR', '2008-12-26', '2008-12-29', 123.50, '97510146');
INSERT INTO cheques VALUES (111410, '30511696468', NULL, 'GALICIA', NULL, false, 'ANNECHINI', 'ENTREGADO_A_PROVEEDOR', '2008-12-16', '2008-12-19', 170.00, '08497186');
INSERT INTO cheques VALUES (111447, '30710527241', NULL, 'PROVINCIA', NULL, false, 'REGUERA', 'ENTREGADO_A_PROVEEDOR', '2008-12-10', '2009-01-08', 145.00, '95146531');
INSERT INTO cheques VALUES (111441, '30526111393', 'DE LA PENNA SEGURIDAD FENIX', 'credicoop', NULL, false, 'COOP AGRARIA', 'ENTREGADO_A_PROVEEDOR', '2008-12-23', '2008-12-29', 2786.11, '03422490');
INSERT INTO cheques VALUES (111424, '30500032886', 'SEGURIDAD FENIX S.A.', 'credicoop', NULL, false, 'LA PERSERANCIA SEGUROS', 'ENTREGADO_A_PROVEEDOR', '2008-12-26', '2008-12-26', 999.10, '01093207');
INSERT INTO cheques VALUES (111478, '30709171093', 'PRAXAIR', 'SANTADER  RIO', NULL, false, 'Seguridad Fenix', 'ENTREGADO_A_PROVEEDOR', '2009-01-08', '2009-02-09', 11410.05, '363');
INSERT INTO cheques VALUES (111422, '30500032886', 'SEGURIDAD FENIX S.A.', 'credicoop', NULL, false, 'LA PERSERANCIA SEGUROS', 'ENTREGADO_A_PROVEEDOR', '2008-12-26', '2008-12-26', 490.53, '01093203');
INSERT INTO cheques VALUES (111409, '30512235111', NULL, 'PROVINCIA', NULL, false, 'DESTAIN', 'ENTREGADO_A_PROVEEDOR', '2008-12-26', '2008-12-29', 78.00, '98202393');
INSERT INTO cheques VALUES (111393, '20160225182', NULL, 'HSBC', NULL, false, 'SUPERMERCADO PLANETA', 'ENTREGADO_A_PROVEEDOR', '2008-12-27', '2008-12-30', 600.00, '91357880');
INSERT INTO cheques VALUES (111396, '30667502043', 'FENIX', 'patagonia', NULL, false, '18 DE SETIEMBRE', 'ENTREGADO_A_PROVEEDOR', '2008-12-24', '2008-12-16', 2703.50, '68970061');
INSERT INTO cheques VALUES (111426, '30667466527', NULL, 'PROVINCIA', NULL, false, 'ASOC. COOP. VIRGEN DE LA CARRETA', 'ENTREGADO_A_PROVEEDOR', '2008-12-23', '2008-12-23', 268.00, '92248261');
INSERT INTO cheques VALUES (111425, '30512314860', 'DE LA PENNA SEGURIDAD FENIX', 'patagonia', 'PARA ACREDITAR EN CUENTA', false, 'LA ALICIA', 'ENTREGADO_A_PROVEEDOR', '2008-12-26', '2008-12-29', 116.50, '68542361');
INSERT INTO cheques VALUES (111411, '30592234692', NULL, 'patagonia', NULL, false, 'ANNECHINI', 'ENTREGADO_A_PROVEEDOR', '2008-12-16', '2008-12-22', 82.00, '68669662');
INSERT INTO cheques VALUES (111427, '30594465497', 'DE LA PENNA SEGURIDAD FENIX', 'GALICIA', NULL, false, 'LASO S.A.', 'ENTREGADO_A_PROVEEDOR', '2008-12-17', '2009-02-06', 1138.00, '13937074');
INSERT INTO cheques VALUES (111448, '30612328648', NULL, 'FRANCES', NULL, false, 'REGUERA', 'ENTREGADO_A_PROVEEDOR', '2008-12-09', '2009-01-09', 134.32, '234185');
INSERT INTO cheques VALUES (111444, '20054750324', NULL, 'LA PAMPA', NULL, false, 'FERROMAQ', 'ENTREGADO_A_PROVEEDOR', '2008-12-16', '2009-01-03', 200.00, '18626364');
INSERT INTO cheques VALUES (111451, '27265712326', NULL, 'CREDICOOP', NULL, false, 'TRANSPORTE LD', 'ENTREGADO_A_PROVEEDOR', '2008-12-16', '2008-12-30', 260.00, '27545896');
INSERT INTO cheques VALUES (111481, '30667503414', NULL, 'patagonia', NULL, false, 'VIAL TRES', 'EN_POSESION_DE_FENIX', '2009-01-09', '2009-01-20', 290.00, '68955606');
INSERT INTO cheques VALUES (111443, '20002737362', NULL, 'PROVINCIA', NULL, false, 'FACUNDO ORENSE', 'ENTREGADO_A_PROVEEDOR', '2008-12-23', '2008-12-23', 196.00, '94687905');
INSERT INTO cheques VALUES (111450, '20136511980', NULL, 'PROVINCIA', NULL, false, 'CIANCAGLINI', 'ENTREGADO_A_PROVEEDOR', '2008-12-30', '2008-12-31', 484.00, '99762991');
INSERT INTO cheques VALUES (111459, '20125368523', 'SEGURIDAD FENIX S.A.', 'nacion', NULL, false, 'BARCELLANDI', 'ENTREGADO_A_PROVEEDOR', '2008-12-31', '2009-01-15', 1125.00, '87199596');
INSERT INTO cheques VALUES (111467, '30505012182', 'DE LA PENNA SEGURIDAD FENIX', 'macro', NULL, false, 'vial agro', 'DEPOSITADO', '2008-12-26', '2009-01-05', 82.00, '54754964');
INSERT INTO cheques VALUES (111442, '20068091420', NULL, 'credicoop', NULL, false, 'DI ROCCO', 'DEPOSITADO', '2008-12-18', '2008-12-24', 144.00, '28156835');
INSERT INTO cheques VALUES (111460, '30709742848', 'SEGURIDAD FENIX S.A.', 'PROVINCIA', NULL, false, 'BIOCOMBUSTIBLES TS.AS.', 'ENTREGADO_A_PROVEEDOR', '2008-12-31', '2009-02-18', 629.20, '97845609');
INSERT INTO cheques VALUES (111470, '30708581662', NULL, 'PROVINCIA', NULL, false, 'MOLINOS ZALLA', 'ENTREGADO_A_PROVEEDOR', '2009-01-07', '2009-01-08', 373.00, '94924721');
INSERT INTO cheques VALUES (111469, '27034923820', NULL, 'NACION', NULL, false, 'GONZALEZ', 'ENTREGADO_A_PROVEEDOR', '2009-01-08', '2009-01-23', 457.28, '89119541');
INSERT INTO cheques VALUES (111477, '30709171093', 'PRAXAIR', 'SANTADER  RIO', NULL, true, 'Seguridad Fenix', 'EN_POSESION_DE_FENIX', '2009-01-08', '2009-01-09', 11410.05, '363');
INSERT INTO cheques VALUES (111499, '30667525760', NULL, 'nacion', NULL, false, 'CIUCCI-RAMELLA', 'ENTREGADO_A_PROVEEDOR', '2009-01-09', '2009-01-25', 2147.00, '90728154');
INSERT INTO cheques VALUES (111500, '30667525760', NULL, 'nacion', NULL, false, 'CIUCCI-RAMELLA', 'ENTREGADO_A_PROVEEDOR', '2009-01-09', '2009-02-04', 2147.00, '90728153');
INSERT INTO cheques VALUES (111535, '30500105328', NULL, 'nacion', NULL, false, 'SERVILIMP', 'ENTREGADO_A_PROVEEDOR', '2008-10-29', '2009-02-16', 2785.42, '83365877');
INSERT INTO cheques VALUES (111498, '20178354753', NULL, 'PROVINCIA', NULL, false, 'VAN DER HORST', 'ENTREGADO_A_PROVEEDOR', '2009-01-09', '2009-01-16', 158.00, '98202583');
INSERT INTO cheques VALUES (111480, '23104584209', NULL, 'credicoop', NULL, false, 'PEREZ DALSGAARD Y CIA', 'DEPOSITADO', '2008-12-18', '2008-12-19', 239.94, '27616812');
INSERT INTO cheques VALUES (111501, '30667452089', NULL, 'PROVINCIA', NULL, false, 'ARENAL', 'DEPOSITADO', '2009-01-09', '2009-01-10', 98.00, '94617953');
INSERT INTO cheques VALUES (111509, '33710289579', NULL, 'PROVINCIA', NULL, false, 'De Hormaechea', 'ENTREGADO_A_PROVEEDOR', '2009-01-12', '2009-01-15', 2947.50, '94765766');
INSERT INTO cheques VALUES (111522, '23073775639', NULL, 'FRANCES', NULL, false, 'FRIGOR.ANSELMO', 'ENTREGADO_A_PROVEEDOR', '2008-12-25', '2009-01-07', 126.00, '233490');
INSERT INTO cheques VALUES (111521, '20053685480', NULL, 'patagonia', NULL, false, 'FRIGOR.ANSELMO', 'ENTREGADO_A_PROVEEDOR', '2009-01-01', '2009-01-02', 325.00, '69458701');
INSERT INTO cheques VALUES (111513, '30709994650', NULL, 'FRANCES', NULL, false, 'AGUA Y SODA TRES ARROYOS', 'ENTREGADO_A_PROVEEDOR', '2009-01-08', '2009-01-09', 39.00, '00236941');
INSERT INTO cheques VALUES (111530, '30635057609', 'SEGURIDAD FENIX S.A.', 'nacion', NULL, false, 'EDIFICIO VICTORIA', 'ENTREGADO_A_PROVEEDOR', '2009-01-15', '2009-01-16', 306.50, '91519930');
INSERT INTO cheques VALUES (111527, '20141741102', NULL, 'nacion', NULL, false, 'MITRE GNC', 'ENTREGADO_A_PROVEEDOR', '2009-01-14', '2009-01-22', 235.00, '87140858');
INSERT INTO cheques VALUES (111519, '20147122048', NULL, 'nacion', NULL, false, 'REGUERA', 'ENTREGADO_A_PROVEEDOR', '2009-01-14', '2009-02-14', 300.00, '89716098');
INSERT INTO cheques VALUES (111510, '27034923820', NULL, 'nacion', NULL, false, 'FERROMAQ', 'ENTREGADO_A_PROVEEDOR', '2009-01-12', '2009-01-30', 387.91, '89119549');
INSERT INTO cheques VALUES (111532, '33550001549', 'SEGURIDAD FENIX S.A.', 'patagonia', NULL, false, 'AIELLO', 'ENTREGADO_A_PROVEEDOR', '2009-01-13', '2009-01-16', 2996.03, '68368717');
INSERT INTO cheques VALUES (111538, '27034923820', NULL, 'nacion', NULL, false, 'FERROMAQ', 'ENTREGADO_A_PROVEEDOR', '2009-01-16', '2009-02-06', 437.91, '91284440');
INSERT INTO cheques VALUES (111541, '30615687819', NULL, 'PROVINCIA', NULL, false, 'CASCO', 'ENTREGADO_A_PROVEEDOR', '2009-01-12', '2009-01-12', 89.25, '97713657');
INSERT INTO cheques VALUES (111539, '30623556871', NULL, 'nacion', NULL, false, 'COOP SERV ORIENTE', 'DEPOSITADO', '2009-01-16', '2009-01-23', 1688.00, '90068630');
INSERT INTO cheques VALUES (111374, '30708219246', NULL, 'SANTADER  RIO', NULL, false, 'RECARI', 'DEPOSITADO', '2008-11-06', '2008-12-05', 250.00, '00000322');
INSERT INTO cheques VALUES (111529, '30545690922', 'SEGURIDAD FENIX S.A.', 'credicoop', NULL, false, 'CELTA', 'DEPOSITADO', '2009-01-15', '2009-01-30', 2863.08, '27473649');
INSERT INTO cheques VALUES (111536, '30605162009', NULL, 'nacion', NULL, false, 'SERVILIMP', 'DEPOSITADO', '2009-01-13', '2009-01-19', 3318.90, '68899805');
INSERT INTO cheques VALUES (111528, '20053901892', 'SEGURIDAD FENIX S.A. NO A LA ORDEN', 'PROVINCIA', NULL, false, 'LANCE', 'DEPOSITADO', '2009-01-15', '2009-01-19', 405.00, '98304413');
INSERT INTO cheques VALUES (111543, '20053933840', NULL, 'NACION', NULL, false, 'ROBERTO STANCOVICH', 'ENTREGADO_A_PROVEEDOR', '2009-01-21', '2009-01-31', 189.00, '88363940');
INSERT INTO cheques VALUES (111544, '30667488490', NULL, 'PROVINCIA', NULL, false, 'COLONIA DE VACACIONES CLAROMECO', 'ENTREGADO_A_PROVEEDOR', '2009-01-21', '2009-01-21', 136.50, '95571644');
INSERT INTO cheques VALUES (111587, '30538289503', NULL, 'H', NULL, true, 'CASA BALDA', 'EN_POSESION_DE_FENIX', '2009-02-03', NULL, 390.00, '92968810');
INSERT INTO cheques VALUES (111547, '30708581662', NULL, 'PROVINCIA', NULL, false, 'MOLINOS ZALLA', 'ENTREGADO_A_PROVEEDOR', '2009-01-21', '2009-01-22', 797.00, '00424539');
INSERT INTO cheques VALUES (111559, '30709171093', 'ENARGAS', 'SANTADER  RIO', NULL, false, 'Seguridad Fenix', 'ENTREGADO_A_PROVEEDOR', '2009-01-21', '2009-01-21', 1165.00, '0365');
INSERT INTO cheques VALUES (111561, '30708723017', NULL, 'GALICIA', NULL, true, 'SUR AGROPECUARIA', 'EN_POSESION_DE_FENIX', '2009-01-22', '2009-01-23', 242.00, '79217814');
INSERT INTO cheques VALUES (111555, '30708723017', NULL, 'GALICIA', NULL, false, 'PALAU', 'DEPOSITADO', '2009-01-22', '2009-01-23', 242.00, '79217814');
INSERT INTO cheques VALUES (111552, '30709123382', NULL, 'nacion', NULL, false, 'RECARI', 'DEPOSITADO', '2009-01-19', '2009-01-23', 214.74, '89026565');
INSERT INTO cheques VALUES (111557, '33562096669', NULL, 'PROVINCIA', NULL, false, 'GENOVESI', 'DEPOSITADO', '2009-01-21', '2009-01-24', 988.40, '97568748');
INSERT INTO cheques VALUES (111548, '30667502426', 'DE', 'PROVINCIA', NULL, false, 'CENTRO MPAL. DE SALUD', 'DEPOSITADO', '2009-01-20', '2009-01-20', 921.50, '96816279');
INSERT INTO cheques VALUES (111549, '30578475660', NULL, 'patagonia', NULL, false, 'agro el carretero', 'DEPOSITADO', '2009-01-21', '2009-01-22', 686.93, '69463488');
INSERT INTO cheques VALUES (111563, '30709171093', 'PRAXAIR', 'RIO', NULL, false, NULL, 'ENTREGADO_A_PROVEEDOR', '2009-01-26', '2009-02-26', 6391.76, '367');
INSERT INTO cheques VALUES (111568, '30708449691', NULL, 'GALICIA', NULL, false, 'MOLINO TRES ARROYOS', 'ENTREGADO_A_PROVEEDOR', '2009-01-23', '2009-02-25', 5000.00, '04495336');
INSERT INTO cheques VALUES (111569, '20136511980', 'DE LA PENNA SEGURIDAD FENIX', 'NACION', NULL, false, 'GERMAN CIANCAGLINI', 'ENTREGADO_A_PROVEEDOR', '2009-01-28', '2009-02-16', 1618.79, '89078051');
INSERT INTO cheques VALUES (111570, '20136511980', 'DE LA PENNA SEGURIDAD FENIX', 'NACION', NULL, false, 'GERMAN CIANCAGLINI', 'ENTREGADO_A_PROVEEDOR', '2009-01-28', '2009-03-16', 1618.79, '89078052');
INSERT INTO cheques VALUES (111553, '20298492696', NULL, 'PROVINCIA', NULL, false, 'RECARI', 'ENTREGADO_A_PROVEEDOR', '2009-01-20', '2009-02-04', 232.54, '99837980');
INSERT INTO cheques VALUES (111554, '20144993617', NULL, 'PROVINCIA', NULL, false, 'PISSANI', 'ENTREGADO_A_PROVEEDOR', '2009-01-31', '2009-01-31', 186.00, '839178');
INSERT INTO cheques VALUES (111566, '30625195116', NULL, 'PROVINCIA', NULL, false, 'DON RICARDO S.A.', 'ENTREGADO_A_PROVEEDOR', '2009-01-20', '2009-01-26', 168.00, '99302443');
INSERT INTO cheques VALUES (111572, '30708968648', NULL, 'SANTADER  RIO', NULL, true, 'TOSTEX', 'EN_POSESION_DE_FENIX', '2009-01-29', '2009-01-14', 5808.00, '1008');
INSERT INTO cheques VALUES (111575, '30533149452', NULL, 'PROVINCIA', NULL, false, 'SIND CHOFERES', 'ENTREGADO_A_PROVEEDOR', '2009-01-02', '2009-01-05', 540.00, '87670244');
INSERT INTO cheques VALUES (111574, '30708968648', NULL, 'SANTADER  RIO', NULL, false, 'TOSTEX', 'ENTREGADO_A_PROVEEDOR', '2009-01-29', '2009-02-14', 5808.00, '1008');
INSERT INTO cheques VALUES (111573, '30657849894', NULL, 'credicoop', NULL, false, 'AUSTRAL MOTORS', 'ENTREGADO_A_PROVEEDOR', '2009-01-12', '2009-02-02', 171.68, '27893057');
INSERT INTO cheques VALUES (111558, '30617426869', NULL, 'LA PAMPA', NULL, false, 'GENOVESI', 'DEPOSITADO', '2009-01-07', '2009-01-30', 930.00, '18012405');
INSERT INTO cheques VALUES (111583, '20053863508', NULL, 'NACION', NULL, false, 'AMBROSIUS', 'EN_POSESION_DE_FENIX', '2009-02-02', '2009-02-11', 177.50, '90818061');
INSERT INTO cheques VALUES (111581, '30708855770', NULL, 'PROVINCIA', NULL, false, 'AGROPRIMUS', 'DEPOSITADO', '2009-01-26', '2009-02-05', 665.50, '99083373');
INSERT INTO cheques VALUES (111579, '30513505058', NULL, 'GALICIA', NULL, false, 'LA AURORA', 'DEPOSITADO', '2009-01-29', '2009-01-30', 179.00, '79151427');
INSERT INTO cheques VALUES (111584, '33560456269', NULL, 'CIUDAD', NULL, false, 'TRANS. MALVINAS', 'DEPOSITADO', '2009-01-30', '2009-01-30', 874.90, '30500109');
INSERT INTO cheques VALUES (111588, '30538289503', NULL, 'HSBC', NULL, false, 'CASA BALDA', 'DEPOSITADO', '2009-02-03', '2009-02-05', 390.00, '92968810');
INSERT INTO cheques VALUES (111602, '30595949102', 'SEGURIDAD FENIX S.A.', 'LA PAMPA', NULL, false, 'CEREALERA TRES AROYOS', 'EN_POSESION_DE_FENIX', '2009-02-06', '2009-02-15', 406.50, '18774055');
INSERT INTO cheques VALUES (111590, '307098730305', NULL, 'PROVINCIA', NULL, false, 'ANSO ROBERTO', 'DEPOSITADO', '2009-02-02', '2009-02-03', 70.00, '98304590');
INSERT INTO cheques VALUES (111604, '30710601786', NULL, 'm', NULL, true, 'AGRO IND. SUDESTE', 'EN_POSESION_DE_FENIX', '2009-02-09', NULL, 532.00, '55667585');
INSERT INTO cheques VALUES (111585, '30509429924', NULL, 'GALICIA', NULL, false, 'MITRE GNC', 'EN_POSESION_DE_FENIX', '2009-01-04', '2009-02-15', 400.00, '79231832');
INSERT INTO cheques VALUES (111580, '30667522001', NULL, 'LA PAMPA', NULL, false, 'AUTOSERVICIO 228', 'EN_POSESION_DE_FENIX', '2009-01-29', '2009-02-17', 654.79, '18875727');
INSERT INTO cheques VALUES (111593, '30545743023', NULL, 'GALICIA', NULL, false, 'COOP ELECT. CLAROMECO', 'DEPOSITADO', '2009-02-05', '2009-02-06', 946.50, '77524459');
INSERT INTO cheques VALUES (111594, '30605162009', NULL, 'NACION', NULL, false, 'AEROTAN', 'DEPOSITADO', '2009-01-15', '2009-01-15', 140.00, '39119359');
INSERT INTO cheques VALUES (111599, '30605162009', 'SEGURIDAD FENIX S.A.', 'NACION', NULL, false, 'AEROTAN', 'DEPOSITADO', '2009-01-15', '2009-01-15', 790.19, '39119391');
INSERT INTO cheques VALUES (111608, '30708581662', NULL, 'PROVINCIA', NULL, false, 'MOLINOS ZALLA', 'EN_POSESION_DE_FENIX', '2009-02-09', '2009-02-10', 1044.50, '00424605');
INSERT INTO cheques VALUES (111615, '30545746782', NULL, 'PROVINCIA', NULL, false, 'COOP DE PROVISION DE SERVICIOS PUBLICOS DE LA GARMA', 'EN_POSESION_DE_FENIX', '2009-02-12', NULL, 510.00, '468776');
INSERT INTO cheques VALUES (111597, '30709293350', NULL, 'credicoop', NULL, false, 'METALURGICA LOS ARROYOS', 'EN_POSESION_DE_FENIX', '2009-02-05', '2009-03-20', 1165.05, '27962699');
INSERT INTO cheques VALUES (111600, '30605162009', 'SEGURIDAD FENIX S.A.', 'patagonia', NULL, false, 'AEROTAN', 'EN_POSESION_DE_FENIX', '2009-02-05', '2009-02-13', 1219.15, '59419785');
INSERT INTO cheques VALUES (111611, '30578475660', NULL, 'patagonia', NULL, true, 'agro el carretero', 'EN_POSESION_DE_FENIX', '2009-02-09', '2009-02-10', 600.93, '69463757');
INSERT INTO cheques VALUES (111595, '30710656874', NULL, 'credicoop', NULL, false, 'horticolas del sur', 'EN_POSESION_DE_FENIX', '2009-02-04', '2009-02-10', 203.00, '28221014');
INSERT INTO cheques VALUES (111605, '30710601786', NULL, 'macro', NULL, false, 'AGRO IND. SUDESTE', 'EN_POSESION_DE_FENIX', '2009-02-09', '2009-03-09', 532.00, '55667585');
INSERT INTO cheques VALUES (111612, '30578475660', NULL, 'patagonia', NULL, false, 'GRUAS IORIO', 'EN_POSESION_DE_FENIX', '2009-02-09', '2009-02-10', 600.93, '69463757');
INSERT INTO cheques VALUES (111616, '1', NULL, 'NACION', NULL, false, 'FERROMAQ', 'EN_POSESION_DE_FENIX', '2009-02-12', NULL, 628.00, '284459');
INSERT INTO cheques VALUES (111596, '20102166303', NULL, 'credicoop', NULL, false, 'MANSO (PEREZ)', 'EN_POSESION_DE_FENIX', '2009-02-09', '2009-02-09', 360.00, '53938055');
INSERT INTO cheques VALUES (111609, '20221389108', NULL, 'SANTADER  RIO', NULL, false, 'SERGIO LIZARAZU', 'EN_POSESION_DE_FENIX', '2009-02-05', '2009-03-05', 89.00, '15500359');
INSERT INTO cheques VALUES (111589, '30547329178', NULL, 'credicoop', NULL, false, 'CERRI CARLOS', 'EN_POSESION_DE_FENIX', '2009-01-01', '2009-02-28', 450.00, '28334114');
INSERT INTO cheques VALUES (111601, '30707787208', 'DE LA PENNA SEGURIDAD FENIX S.A.', 'SANTADER  RIO', NULL, false, 'FERTYCOM', 'EN_POSESION_DE_FENIX', '2009-02-05', '2009-02-06', 36.50, '82195519');
INSERT INTO cheques VALUES (111620, '20262489710', NULL, 'FRANCES', NULL, false, 'AGRO IND TS AS', 'EN_POSESION_DE_FENIX', '2009-02-06', '2009-02-10', 267.00, '235974');
INSERT INTO cheques VALUES (111618, '30594465497', NULL, 'GALICIA', NULL, false, 'LASO S.A.', 'EN_POSESION_DE_FENIX', '2009-02-10', '2009-04-01', 2166.00, '14130316');
INSERT INTO cheques VALUES (111619, '30708723017', NULL, 'GALICIA', NULL, false, 'PALAU', 'EN_POSESION_DE_FENIX', '2009-02-12', '2009-02-13', 242.00, '79522574');
INSERT INTO cheques VALUES (111606, '30578475660', NULL, 'patagonia', NULL, false, 'agro el carretero', 'EN_POSESION_DE_FENIX', '2009-02-09', '2009-02-10', 1534.48, '69463797');
INSERT INTO cheques VALUES (111621, '30667481089', NULL, 'PROVINCIA', NULL, false, 'ECHEVARRIA GUILLERMO', 'EN_POSESION_DE_FENIX', '2009-02-12', '2009-02-27', 138.00, '94924025');
INSERT INTO cheques VALUES (111625, '20205293168', NULL, 'GALICIA', NULL, false, 'FLELLERUP', 'EN_POSESION_DE_FENIX', '2009-02-16', '2009-02-17', 339.00, '79256482');
INSERT INTO cheques VALUES (111610, '30601271903', NULL, 'SANTANDARD BANK', NULL, false, 'GRUAS IORIO', 'EN_POSESION_DE_FENIX', '2009-01-30', '2009-02-17', 579.19, '547');
INSERT INTO cheques VALUES (111623, '33550001549', NULL, 'patagonia', NULL, false, 'AIELLO', 'EN_POSESION_DE_FENIX', '2009-02-10', '2009-02-11', 136.50, '68368818');
INSERT INTO cheques VALUES (111617, '30526111393', NULL, 'GALICIA', NULL, false, 'COOP AGRARIA', 'EN_POSESION_DE_FENIX', '2009-02-11', '2009-02-11', 1151.11, '04015977');
INSERT INTO cheques VALUES (111624, '30708667710', NULL, 'PROVINCIA', NULL, false, 'NEMIHUEN SA', 'EN_POSESION_DE_FENIX', '2009-02-16', '2009-02-17', 520.00, '01591494');


--
-- Data for Name: clientes; Type: TABLE DATA; Schema: public; Owner: postgres
--



--
-- Data for Name: compras_a_proveedor; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO compras_a_proveedor VALUES (43, false, '2008-10-11', NULL, 42, '2008-07-07', 0.00, 0.00, 692.00, '50', 0.00, 692.00);
INSERT INTO compras_a_proveedor VALUES (307, false, '2008-10-11', NULL, 4, '2008-07-02', 35.29, 168.06, 0.00, '447761', 0.00, 203.35);
INSERT INTO compras_a_proveedor VALUES (115, false, '2008-10-11', NULL, 4, '2008-07-07', 34.94, 166.40, 0.00, '28076', 0.00, 201.34);
INSERT INTO compras_a_proveedor VALUES (1371, false, '2008-10-11', NULL, 269, '2008-09-22', 13.05, 62.13, 24.89, '7760', 2.18, 102.25);
INSERT INTO compras_a_proveedor VALUES (37, false, '2008-10-11', NULL, 36, '2008-07-11', 8.08, 76.92, 0.00, '3038', 0.00, 85.00);
INSERT INTO compras_a_proveedor VALUES (188, false, '2008-10-11', NULL, 95, '2008-07-18', 3.28, 15.60, 0.00, '112915', 0.00, 18.88);
INSERT INTO compras_a_proveedor VALUES (1113, false, '2008-10-11', NULL, 95, '2008-09-11', 3.28, 15.60, 0.00, '115298', 0.00, 18.88);
INSERT INTO compras_a_proveedor VALUES (166, false, '2008-10-11', NULL, 55, '2008-07-01', 43.89, 418.09, 0.00, '35329', 0.00, 461.98);
INSERT INTO compras_a_proveedor VALUES (1111, false, '2008-10-11', NULL, 1110, '2008-09-09', 281.40, 1340.00, 0.00, '2120', 0.00, 1621.40);
INSERT INTO compras_a_proveedor VALUES (131, false, '2008-10-11', NULL, 55, '2008-07-04', 27.55, 262.44, 0.00, '35344', 0.00, 289.99);
INSERT INTO compras_a_proveedor VALUES (658, false, '2008-10-11', NULL, 657, '2008-08-07', 47.16, 231.63, 0.00, '3192966/6', 0.00, 278.79);
INSERT INTO compras_a_proveedor VALUES (292, false, '2008-10-11', NULL, 291, '2008-07-01', 9.45, 45.00, 0.00, '29179', 0.00, 54.45);
INSERT INTO compras_a_proveedor VALUES (62, false, '2008-10-11', NULL, 61, '2008-07-03', 368.42, 1754.40, 0.00, '71047', 43.86, 2166.68);
INSERT INTO compras_a_proveedor VALUES (238, false, '2008-10-11', NULL, 114, '2008-07-21', 170.27, 810.80, 0.00, '7683', 0.00, 981.07);
INSERT INTO compras_a_proveedor VALUES (864, false, '2008-10-11', NULL, 338, '2008-08-30', 34.36, 163.64, 0.00, '1967', 4.09, 202.09);
INSERT INTO compras_a_proveedor VALUES (304, false, '2008-10-11', NULL, 303, '2008-07-17', 14.08, 67.04, 0.00, '26836', 0.00, 81.12);
INSERT INTO compras_a_proveedor VALUES (278, false, '2008-10-11', NULL, 277, '2008-07-02', 39.96, 190.30, 0.00, '2840', 0.00, 230.26);
INSERT INTO compras_a_proveedor VALUES (53, false, '2008-10-11', NULL, 52, '2008-07-03', 0.00, 0.00, 159.30, '1020', 0.00, 159.30);
INSERT INTO compras_a_proveedor VALUES (126, false, '2008-10-11', NULL, 110, '2008-06-30', 48.30, 230.00, 0.00, '1985', 0.00, 278.30);
INSERT INTO compras_a_proveedor VALUES (1374, false, '2008-10-11', NULL, 80, '2008-09-19', 318.21, 1515.30, 0.00, '2912', 0.00, 1833.51);
INSERT INTO compras_a_proveedor VALUES (81, false, '2008-10-11', NULL, 80, '2008-07-01', 304.71, 1451.00, 0.00, '2523', 0.00, 1755.71);
INSERT INTO compras_a_proveedor VALUES (661, false, '2008-10-11', NULL, 12, '2008-08-16', 9.75, 46.44, 0.00, '35333', 0.00, 56.19);
INSERT INTO compras_a_proveedor VALUES (139, false, '2008-10-11', NULL, 134, '2008-07-10', 43.21, 205.79, 0.00, '1866', 0.00, 249.00);
INSERT INTO compras_a_proveedor VALUES (186, false, '2008-10-11', NULL, 46, '2008-07-17', 47.02, 223.92, 0.00, '42404', 0.00, 270.94);
INSERT INTO compras_a_proveedor VALUES (288, false, '2008-10-11', NULL, 287, '2008-06-30', 0.00, 500.00, 0.00, '245', 0.00, 500.00);
INSERT INTO compras_a_proveedor VALUES (1108, false, '2008-10-11', NULL, 80, '2008-09-10', 166.32, 792.00, 0.00, '2864', 0.00, 958.32);
INSERT INTO compras_a_proveedor VALUES (874, false, '2008-10-11', NULL, 46, '2008-08-29', 41.71, 198.60, 0.00, '43247', 0.00, 240.31);
INSERT INTO compras_a_proveedor VALUES (50, false, '2008-10-11', NULL, 49, '2008-06-30', 7.96, 29.52, 0.65, '539539', 0.00, 38.13);
INSERT INTO compras_a_proveedor VALUES (5, false, '2008-10-11', NULL, 4, '2008-07-11', 1192.30, 5677.60, 0.00, '2669', 141.94, 7011.84);
INSERT INTO compras_a_proveedor VALUES (106, false, '2008-10-11', NULL, 103, '2008-07-14', 239.12, 1138.66, 0.00, '3461', 0.00, 1377.78);
INSERT INTO compras_a_proveedor VALUES (10, false, '2008-10-11', NULL, 9, '2008-07-10', 9.91, 47.19, 0.00, '28544', 0.00, 57.10);
INSERT INTO compras_a_proveedor VALUES (1118, false, '2008-10-11', NULL, 4, '2008-08-04', 0.01, 0.06, 0.00, '452302', 0.00, 0.07);
INSERT INTO compras_a_proveedor VALUES (220, false, '2008-10-11', NULL, 219, '2008-06-30', 135.06, 643.13, 0.00, '2266', 0.00, 778.19);
INSERT INTO compras_a_proveedor VALUES (212, false, '2008-10-11', NULL, 211, '2008-07-17', 52.04, 247.80, 0.00, '41505', 0.00, 299.84);
INSERT INTO compras_a_proveedor VALUES (711, false, '2008-10-11', NULL, 52, '2008-08-15', 0.00, 0.00, 384.00, '1049', 0.00, 384.00);
INSERT INTO compras_a_proveedor VALUES (265, false, '2008-10-11', NULL, 264, '2008-07-02', 75.60, 360.00, 0.00, '3949', 0.00, 435.60);
INSERT INTO compras_a_proveedor VALUES (708, false, '2008-10-11', NULL, 287, '2008-07-30', 0.00, 0.00, 500.00, '263', 0.00, 500.00);
INSERT INTO compras_a_proveedor VALUES (1120, false, '2008-10-11', NULL, 4, '2008-08-28', 34.94, 166.40, 0.00, '455554', 4.99, 206.33);
INSERT INTO compras_a_proveedor VALUES (21, false, '2008-10-11', NULL, 20, '2008-07-25', 38.17, 141.39, 79.16, '181234/3', 3.53, 262.25);
INSERT INTO compras_a_proveedor VALUES (273, false, '2008-10-11', NULL, 269, '2008-07-05', 7.01, 33.36, 9.63, '8950', 0.00, 50.00);
INSERT INTO compras_a_proveedor VALUES (197, false, '2008-10-11', NULL, 196, '2008-06-30', 1242.36, 5916.00, 0.00, '4949', 0.00, 7158.36);
INSERT INTO compras_a_proveedor VALUES (122, false, '2008-10-11', NULL, 121, '2008-07-07', 106.05, 505.00, 0.00, '69499', 0.00, 611.05);
INSERT INTO compras_a_proveedor VALUES (317, false, '2008-10-11', NULL, 316, '2008-07-23', 45.15, 215.00, 0.00, '1363', 0.00, 260.15);
INSERT INTO compras_a_proveedor VALUES (705, false, '2008-10-11', NULL, 704, '2008-08-08', 0.00, 0.00, 350.00, '804', 0.00, 350.00);
INSERT INTO compras_a_proveedor VALUES (142, false, '2008-10-11', NULL, 95, '2008-07-08', 3.28, 15.60, 0.00, '112472', 0.00, 18.88);
INSERT INTO compras_a_proveedor VALUES (1368, false, '2008-10-11', NULL, 269, '2008-09-20', 13.60, 64.75, 19.65, '24999', 0.00, 98.00);
INSERT INTO compras_a_proveedor VALUES (83, false, '2008-10-11', NULL, 80, '2008-07-04', 100.80, 480.00, 0.00, '2543', 0.00, 580.80);
INSERT INTO compras_a_proveedor VALUES (85, false, '2008-10-11', NULL, 80, '2008-07-07', 99.09, 471.90, 0.00, '2551', 0.00, 570.99);
INSERT INTO compras_a_proveedor VALUES (1382, false, '2008-10-11', NULL, 15, '2008-09-24', 12.36, 58.89, 0.00, '177572', 0.00, 71.25);
INSERT INTO compras_a_proveedor VALUES (87, false, '2008-10-11', NULL, 1, '2008-07-01', 45.67, 217.50, 0.00, '11887', 0.00, 263.17);
INSERT INTO compras_a_proveedor VALUES (47, false, '2008-10-11', NULL, 46, '2008-07-14', 589.40, 2806.68, 0.00, '42300', 0.00, 3396.08);
INSERT INTO compras_a_proveedor VALUES (13, false, '2008-10-11', NULL, 12, '2008-07-12', 11.69, 55.65, 0.00, '35144', 0.00, 67.34);
INSERT INTO compras_a_proveedor VALUES (104, false, '2008-10-11', NULL, 103, '2008-07-02', 241.64, 1150.66, 0.00, '3405', 0.00, 1392.30);
INSERT INTO compras_a_proveedor VALUES (296, false, '2008-10-11', NULL, 295, '2008-07-11', 0.00, 86.00, 0.00, '237', 0.00, 86.00);
INSERT INTO compras_a_proveedor VALUES (190, false, '2008-10-11', NULL, 121, '2008-07-15', 262.50, 1250.00, 0.00, '69698', 0.00, 1512.50);
INSERT INTO compras_a_proveedor VALUES (867, false, '2008-10-11', NULL, 20, '2008-08-25', 35.39, 205.33, 0.00, '225788/4', 3.28, 244.00);
INSERT INTO compras_a_proveedor VALUES (284, false, '2008-10-11', NULL, 283, '2008-07-10', 0.00, 50.00, 0.00, '785', 0.00, 50.00);
INSERT INTO compras_a_proveedor VALUES (216, false, '2008-10-11', NULL, 12, '2008-07-19', 8.64, 41.12, 0.00, '35191', 0.00, 49.76);
INSERT INTO compras_a_proveedor VALUES (319, false, '2008-10-11', NULL, 316, '2008-07-23', 125.16, 596.00, 0.00, '1364', 0.00, 721.16);
INSERT INTO compras_a_proveedor VALUES (714, false, '2008-10-11', NULL, 713, '2008-08-13', 0.00, 0.00, 90.00, '1472', 0.00, 90.00);
INSERT INTO compras_a_proveedor VALUES (101, false, '2008-10-11', NULL, 4, '2008-06-27', 47.78, 227.54, 0.00, '445888', 5.69, 281.01);
INSERT INTO compras_a_proveedor VALUES (309, false, '2008-10-11', NULL, 114, '2008-07-02', 196.64, 936.40, 0.00, '7608', 0.00, 1133.04);
INSERT INTO compras_a_proveedor VALUES (299, false, '2008-10-11', NULL, 295, '2008-07-12', 0.00, 86.00, 0.00, '200', 0.00, 86.00);
INSERT INTO compras_a_proveedor VALUES (327, false, '2008-10-11', NULL, 326, '2008-07-24', 5.86, 27.95, 0.00, '105896', 0.00, 33.81);
INSERT INTO compras_a_proveedor VALUES (699, false, '2008-10-11', NULL, 385, '2008-08-19', 397.32, 1892.00, 0.00, '7945', 0.00, 2289.32);
INSERT INTO compras_a_proveedor VALUES (2, false, '2008-10-11', NULL, 1, '2008-07-11', 111.93, 533.00, 0.00, '119713', 0.00, 644.93);
INSERT INTO compras_a_proveedor VALUES (717, false, '2008-10-11', NULL, 578, '2008-08-20', 9.53, 54.38, 0.00, '1201', 0.00, 63.91);
INSERT INTO compras_a_proveedor VALUES (509, false, '2008-10-11', NULL, 12, '2008-08-09', 14.60, 79.05, 0.00, '35430', 0.00, 93.65);
INSERT INTO compras_a_proveedor VALUES (898, false, '2008-10-11', NULL, 1, '2008-08-14', 86.10, 410.00, 0.00, '12261', 0.00, 496.10);
INSERT INTO compras_a_proveedor VALUES (333, false, '2008-10-11', NULL, 332, '2008-07-24', 0.00, 186.00, 0.00, '2860', 0.00, 186.00);
INSERT INTO compras_a_proveedor VALUES (1116, false, '2008-10-11', NULL, 4, '2008-09-02', 30.88, 147.07, 0.00, '456709', 5.88, 183.83);
INSERT INTO compras_a_proveedor VALUES (547, false, '2008-10-11', NULL, 546, '2008-08-11', 1.84, 8.76, 0.00, '28458', 0.00, 10.60);
INSERT INTO compras_a_proveedor VALUES (468, false, '2008-10-11', NULL, 20, '2008-07-23', 32.74, 121.27, 69.21, '248/1', 3.03, 226.25);
INSERT INTO compras_a_proveedor VALUES (926, false, '2008-10-11', NULL, 114, '2008-09-01', 145.32, 692.00, 0.00, '7938', 0.00, 837.32);
INSERT INTO compras_a_proveedor VALUES (880, false, '2008-10-11', NULL, 49, '2008-09-27', 23.46, 111.70, 0.00, '5667', 3.35, 138.51);
INSERT INTO compras_a_proveedor VALUES (455, false, '2008-10-11', NULL, 98, '2008-07-16', 0.00, 0.00, 185.00, '249', 0.00, 185.00);
INSERT INTO compras_a_proveedor VALUES (363, false, '2008-10-11', NULL, 196, '2008-07-10', 243.60, 1160.00, 0.00, '4969', 0.00, 1403.60);
INSERT INTO compras_a_proveedor VALUES (496, false, '2008-10-11', NULL, 495, '2008-08-06', 0.00, 0.00, 100.00, '1947', 0.00, 100.00);
INSERT INTO compras_a_proveedor VALUES (579, false, '2008-10-11', NULL, 578, '2008-08-11', 60.13, 286.34, 63.00, '1183', 0.00, 409.47);
INSERT INTO compras_a_proveedor VALUES (244, false, '2008-10-11', NULL, 46, '2008-07-22', 95.77, 456.03, 0.00, '42491', 0.00, 551.80);
INSERT INTO compras_a_proveedor VALUES (457, false, '2008-10-11', NULL, 46, '2008-08-01', 273.92, 1304.40, 0.00, '42751', 0.00, 1578.32);
INSERT INTO compras_a_proveedor VALUES (1378, false, '2008-10-11', NULL, 61, '2008-09-22', 323.69, 1541.40, 0.00, '73058', 61.66, 1926.75);
INSERT INTO compras_a_proveedor VALUES (537, false, '2008-10-11', NULL, 536, '2008-08-12', 0.00, 0.00, 2.20, '23116', 0.00, 2.20);
INSERT INTO compras_a_proveedor VALUES (540, false, '2008-10-11', NULL, 536, '2008-08-12', 0.00, 0.00, 2.20, '23130', 0.00, 2.20);
INSERT INTO compras_a_proveedor VALUES (388, false, '2008-10-11', NULL, 111, '2008-07-28', 25.06, 119.32, 0.00, '174271', 2.98, 147.36);
INSERT INTO compras_a_proveedor VALUES (482, false, '2008-10-11', NULL, 49, '2008-06-29', 144.20, 623.11, 21.99, '11104', 15.58, 804.88);
INSERT INTO compras_a_proveedor VALUES (929, false, '2008-10-11', NULL, 928, '2008-07-30', 32.85, 156.44, 0.00, '30553', 0.00, 189.29);
INSERT INTO compras_a_proveedor VALUES (415, false, '2008-10-11', NULL, 111, '2008-07-31', 147.00, 700.00, 0.00, '174570', 17.50, 864.50);
INSERT INTO compras_a_proveedor VALUES (933, false, '2008-10-11', NULL, 928, '2008-08-13', 8.89, 42.35, 0.00, '30767', 0.00, 51.24);
INSERT INTO compras_a_proveedor VALUES (471, false, '2008-10-11', NULL, 291, '2008-08-01', 9.45, 45.00, 0.00, '29787', 0.00, 54.45);
INSERT INTO compras_a_proveedor VALUES (1128, false, '2008-10-11', NULL, 617, '2008-09-11', 5.13, 29.87, 0.00, '31419', 0.00, 35.00);
INSERT INTO compras_a_proveedor VALUES (903, false, '2008-10-11', NULL, 219, '2008-08-28', 227.20, 1081.91, 0.00, '2533', 0.00, 1309.11);
INSERT INTO compras_a_proveedor VALUES (400, false, '2008-10-11', NULL, 399, '2008-08-01', 0.00, 200.00, 0.00, '33146', 0.00, 200.00);
INSERT INTO compras_a_proveedor VALUES (441, false, '2008-10-11', NULL, 440, '2008-08-05', 0.00, 30.00, 0.00, '1076', 0.00, 30.00);
INSERT INTO compras_a_proveedor VALUES (29, false, '2008-10-11', NULL, 28, '2008-07-04', 453.29, 2158.50, 0.00, '5119', 53.97, 2665.76);
INSERT INTO compras_a_proveedor VALUES (461, false, '2008-10-11', NULL, 111, '2008-08-05', 162.20, 772.40, 0.00, '174850', 23.17, 957.77);
INSERT INTO compras_a_proveedor VALUES (412, false, '2008-10-11', NULL, 407, '2008-08-01', 96.47, 459.36, 0.00, '22326', 0.00, 555.83);
INSERT INTO compras_a_proveedor VALUES (672, false, '2008-10-11', NULL, 111, '2008-08-15', 130.08, 619.42, 0.00, '175596', 18.58, 768.08);
INSERT INTO compras_a_proveedor VALUES (503, false, '2008-10-11', NULL, 211, '2008-08-07', 15.29, 72.80, 0.00, '41799', 0.00, 88.09);
INSERT INTO compras_a_proveedor VALUES (31, false, '2008-10-11', NULL, 28, '2008-07-04', 604.38, 2878.00, 0.00, '5118', 71.94, 3554.32);
INSERT INTO compras_a_proveedor VALUES (184, false, '2008-10-11', NULL, 80, '2008-07-17', 266.49, 1269.00, 0.00, '2603', 0.00, 1535.49);
INSERT INTO compras_a_proveedor VALUES (492, false, '2008-10-11', NULL, 491, '2008-08-06', 0.00, 0.00, 58.00, '2972', 0.00, 58.00);
INSERT INTO compras_a_proveedor VALUES (429, false, '2008-10-11', NULL, 15, '2008-08-05', 3.91, 18.63, 0.00, '175286', 0.00, 22.54);
INSERT INTO compras_a_proveedor VALUES (1202, false, '2008-10-11', NULL, 15, '2008-09-13', 14.66, 69.77, 0.00, '177083', 0.00, 84.43);
INSERT INTO compras_a_proveedor VALUES (339, false, '2008-10-11', NULL, 338, '2008-07-25', 73.59, 350.41, 0.00, '1849', 8.76, 432.76);
INSERT INTO compras_a_proveedor VALUES (341, false, '2008-10-11', NULL, 256, '2008-04-01', 0.00, 10.32, 0.06, '120735', 0.31, 10.69);
INSERT INTO compras_a_proveedor VALUES (575, false, '2008-10-11', NULL, 574, '2008-08-08', 14.47, 68.92, 11.61, '35153', 0.00, 95.00);
INSERT INTO compras_a_proveedor VALUES (343, false, '2008-10-11', NULL, 256, '2008-04-30', 16.20, 77.14, 0.46, '783505', 2.31, 96.11);
INSERT INTO compras_a_proveedor VALUES (1126, false, '2008-10-11', NULL, 111, '2008-09-09', 65.68, 312.75, 0.00, '176995', 12.51, 390.94);
INSERT INTO compras_a_proveedor VALUES (894, false, '2008-10-11', NULL, 812, '2008-09-02', 49.48, 235.63, 0.00, '48281', 0.00, 285.11);
INSERT INTO compras_a_proveedor VALUES (488, false, '2008-10-11', NULL, 42, '2008-08-04', 0.00, 0.00, 692.00, '51', 0.00, 692.00);
INSERT INTO compras_a_proveedor VALUES (361, false, '2008-10-11', NULL, 360, '2008-07-12', 0.00, 78.00, 0.00, '1768', 0.00, 78.00);
INSERT INTO compras_a_proveedor VALUES (451, false, '2008-10-11', NULL, 95, '2008-07-02', 5.29, 25.20, 0.00, '112244', 0.00, 30.49);
INSERT INTO compras_a_proveedor VALUES (675, false, '2008-10-11', NULL, 674, '2008-08-20', 0.00, 0.00, 18.20, '5230', 0.00, 18.20);
INSERT INTO compras_a_proveedor VALUES (437, false, '2008-10-11', NULL, 95, '2008-08-06', 3.28, 15.60, 0.00, '1132714', 0.00, 18.88);
INSERT INTO compras_a_proveedor VALUES (669, false, '2008-10-11', NULL, 668, '2008-08-13', 0.00, 0.00, 150.00, '166', 0.00, 150.00);
INSERT INTO compras_a_proveedor VALUES (479, false, '2008-10-11', NULL, 478, '2008-07-18', 0.00, 600.00, 0.00, '565', 0.00, 600.00);
INSERT INTO compras_a_proveedor VALUES (369, false, '2008-10-11', NULL, 55, '2008-07-29', 46.46, 442.52, 0.00, '35616', 0.00, 488.98);
INSERT INTO compras_a_proveedor VALUES (565, false, '2008-10-11', NULL, 564, '2008-07-03', 12.43, 59.21, 0.00, '3919', 0.00, 71.64);
INSERT INTO compras_a_proveedor VALUES (876, false, '2008-10-11', NULL, 121, '2008-08-21', 155.40, 740.00, 0.00, '71230', 0.00, 895.40);
INSERT INTO compras_a_proveedor VALUES (380, false, '2008-10-11', NULL, 4, '2008-07-07', 34.94, 166.40, 0.00, '448935', 0.00, 201.34);
INSERT INTO compras_a_proveedor VALUES (446, false, '2008-10-11', NULL, 283, '2008-08-07', 0.00, 0.00, 50.00, '0791', 0.00, 50.00);
INSERT INTO compras_a_proveedor VALUES (18, false, '2008-10-11', NULL, 15, '2008-07-10', 4.24, 20.17, 0.00, '174071', 0.00, 24.41);
INSERT INTO compras_a_proveedor VALUES (386, false, '2008-10-11', NULL, 385, '2008-07-28', 218.40, 1040.00, 0.00, '7731', 0.00, 1258.40);
INSERT INTO compras_a_proveedor VALUES (397, false, '2008-10-11', NULL, 385, '2008-07-30', 412.27, 1963.20, 0.00, '7760', 0.00, 2375.47);
INSERT INTO compras_a_proveedor VALUES (347, false, '2008-10-11', NULL, 12, '2008-07-26', 3.93, 18.70, 0.00, '34250', 0.00, 22.63);
INSERT INTO compras_a_proveedor VALUES (931, false, '2008-10-11', NULL, 928, '2008-07-29', 4.60, 21.89, 0.00, '30515', 0.00, 26.49);
INSERT INTO compras_a_proveedor VALUES (581, false, '2008-10-11', NULL, 385, '2008-08-07', 219.41, 1044.80, 0.00, '7861', 0.00, 1264.21);
INSERT INTO compras_a_proveedor VALUES (405, false, '2008-10-11', NULL, 1, '2008-08-01', 204.54, 974.00, 0.00, '12131', 0.00, 1178.54);
INSERT INTO compras_a_proveedor VALUES (583, false, '2008-10-11', NULL, 385, '2008-08-08', 486.36, 2316.00, 0.00, '7874', 0.00, 2802.36);
INSERT INTO compras_a_proveedor VALUES (417, false, '2008-10-11', NULL, 219, '2008-07-27', 117.19, 558.04, 0.00, '2362', 0.00, 675.23);
INSERT INTO compras_a_proveedor VALUES (900, false, '2008-10-11', NULL, 291, '2008-09-01', 11.98, 57.03, 0.00, '30255', 0.00, 69.01);
INSERT INTO compras_a_proveedor VALUES (119, false, '2008-10-11', NULL, 15, '2008-07-11', 5.07, 24.12, 0.00, '174129', 0.00, 29.19);
INSERT INTO compras_a_proveedor VALUES (425, false, '2008-10-11', NULL, 15, '2008-08-01', 30.42, 144.87, 0.00, '175114', 0.00, 175.29);
INSERT INTO compras_a_proveedor VALUES (427, false, '2008-10-11', NULL, 15, '2008-08-02', 58.64, 279.28, 0.00, '175172', 0.00, 337.92);
INSERT INTO compras_a_proveedor VALUES (701, false, '2008-10-11', NULL, 114, '2008-08-01', 68.67, 327.00, 0.00, '7756', 0.00, 395.67);
INSERT INTO compras_a_proveedor VALUES (507, false, '2008-10-11', NULL, 1, '2008-08-08', 17.09, 81.40, 0.00, '12217', 0.00, 98.49);
INSERT INTO compras_a_proveedor VALUES (505, false, '2008-10-11', NULL, 1, '2008-08-08', 267.33, 1273.00, 0.00, '12216', 0.00, 1540.33);
INSERT INTO compras_a_proveedor VALUES (878, false, '2008-10-11', NULL, 49, '2008-08-27', 19.03, 90.63, 0.00, '5663', 2.72, 112.38);
INSERT INTO compras_a_proveedor VALUES (392, false, '2008-10-11', NULL, 4, '2008-07-30', 1139.12, 5424.40, 0.00, '0120-00002686', 135.61, 6699.13);
INSERT INTO compras_a_proveedor VALUES (1122, false, '2008-10-11', NULL, 4, '2008-08-28', 32.03, 152.50, 0.00, '455555', 4.58, 189.11);
INSERT INTO compras_a_proveedor VALUES (680, false, '2008-10-11', NULL, 80, '2008-08-19', 106.43, 506.80, 0.00, '2757', 0.00, 613.23);
INSERT INTO compras_a_proveedor VALUES (1152, false, '2008-10-11', NULL, 80, '2008-09-11', 109.01, 519.10, 0.00, '2871', 0.00, 628.11);
INSERT INTO compras_a_proveedor VALUES (1404, false, '2008-10-11', NULL, 1403, '2008-09-26', 40.43, 192.50, 0.00, '14378', 0.00, 232.93);
INSERT INTO compras_a_proveedor VALUES (1409, false, '2008-10-11', NULL, 955, '2008-09-24', 27.76, 132.20, 0.00, '570', 0.00, 159.96);
INSERT INTO compras_a_proveedor VALUES (485, false, '2008-10-11', NULL, 49, '2008-08-07', 16.69, 61.81, 90.75, '80713', 1.54, 170.79);
INSERT INTO compras_a_proveedor VALUES (550, false, '2008-10-11', NULL, 49, '2008-08-19', 155.68, 578.43, 23.76, '1454040', 14.46, 772.33);
INSERT INTO compras_a_proveedor VALUES (233, false, '2008-10-11', NULL, 61, '2008-07-18', 536.11, 2552.90, 0.00, '71426', 63.82, 3152.83);
INSERT INTO compras_a_proveedor VALUES (1399, false, '2008-10-11', NULL, 111, '2008-09-23', 55.85, 265.95, 0.00, '177866', 10.64, 332.44);
INSERT INTO compras_a_proveedor VALUES (112, false, '2008-10-11', NULL, 111, '2008-07-04', 145.75, 694.06, 0.00, '172813', 17.35, 857.16);
INSERT INTO compras_a_proveedor VALUES (208, false, '2008-10-11', NULL, 111, '2008-07-17', 74.81, 356.22, 0.00, '173610', 8.91, 439.94);
INSERT INTO compras_a_proveedor VALUES (695, false, '2008-10-11', NULL, 111, '2008-08-19', 15.58, 69.43, 0.00, '146804', 2.08, 87.09);
INSERT INTO compras_a_proveedor VALUES (619, false, '2008-10-11', NULL, 617, '2008-08-13', 1.89, 8.61, 1.50, '31121', 0.00, 12.00);
INSERT INTO compras_a_proveedor VALUES (1395, false, '2008-10-11', NULL, 111, '2008-09-23', 42.12, 200.55, 0.00, '177880', 8.02, 250.69);
INSERT INTO compras_a_proveedor VALUES (16, false, '2008-10-11', NULL, 15, '2008-07-12', 2.84, 13.51, 0.00, '174189', 0.00, 16.35);
INSERT INTO compras_a_proveedor VALUES (1418, false, '2008-10-11', NULL, 20, '2008-09-23', 44.53, 253.86, 0.00, '247.969/3', 4.11, 302.50);
INSERT INTO compras_a_proveedor VALUES (1158, false, '2008-10-11', NULL, 1, '2008-09-11', 248.85, 1185.00, 0.00, '12487', 0.00, 1433.85);
INSERT INTO compras_a_proveedor VALUES (1393, false, '2008-10-11', NULL, 196, '2008-09-24', 1945.52, 9264.40, 0.00, '5064', 0.00, 11209.92);
INSERT INTO compras_a_proveedor VALUES (829, false, '2008-10-11', NULL, 52, '2008-08-27', 0.00, 70.00, 0.00, '1059', 0.00, 70.00);
INSERT INTO compras_a_proveedor VALUES (246, false, '2008-10-11', NULL, 55, '2008-07-23', 41.33, 393.66, 0.00, '35529', 0.00, 434.99);
INSERT INTO compras_a_proveedor VALUES (1162, false, '2008-10-11', NULL, 287, '2008-08-30', 0.00, 0.00, 500.00, '282', 0.00, 500.00);
INSERT INTO compras_a_proveedor VALUES (631, false, '2008-10-11', NULL, 630, '2008-08-08', 100.17, 477.00, 0.00, '30669', 0.00, 577.17);
INSERT INTO compras_a_proveedor VALUES (636, false, '2008-10-11', NULL, 635, '2008-08-14', 0.00, 0.00, 300.00, '200', 0.00, 300.00);
INSERT INTO compras_a_proveedor VALUES (640, false, '2008-10-11', NULL, 639, '2008-08-15', 9.57, 45.59, 0.00, '12374', 0.00, 55.16);
INSERT INTO compras_a_proveedor VALUES (761, false, '2008-10-11', NULL, 61, '2008-08-21', 420.01, 2000.05, 0.00, '72236', 60.00, 2480.06);
INSERT INTO compras_a_proveedor VALUES (936, false, '2008-10-11', NULL, 935, '2008-09-01', 22.21, 105.79, 0.00, '2872', 0.00, 128.00);
INSERT INTO compras_a_proveedor VALUES (1172, false, '2008-10-11', NULL, 121, '2008-09-10', 262.50, 1250.00, 0.00, '72188', 0.00, 1512.50);
INSERT INTO compras_a_proveedor VALUES (809, false, '2008-10-11', NULL, 808, '2008-08-29', 9.66, 46.00, 0.00, '5511', 0.00, 55.66);
INSERT INTO compras_a_proveedor VALUES (682, false, '2008-10-11', NULL, 4, '2008-08-11', 29.40, 140.00, 0.00, '453019', 0.00, 169.40);
INSERT INTO compras_a_proveedor VALUES (89, false, '2008-10-11', NULL, 15, '2008-07-01', 26.72, 127.25, 0.00, '173702', 0.00, 153.97);
INSERT INTO compras_a_proveedor VALUES (1136, false, '2008-10-11', NULL, 98, '2008-09-11', 0.00, 445.00, 0.00, '267', 0.00, 445.00);
INSERT INTO compras_a_proveedor VALUES (1407, false, '2008-10-11', NULL, 121, '2008-09-18', 262.50, 1250.00, 0.00, '72494', 0.00, 1512.50);
INSERT INTO compras_a_proveedor VALUES (688, false, '2008-10-11', NULL, 687, '2008-08-09', 3.09, 29.41, 0.00, '8394', 0.00, 32.50);
INSERT INTO compras_a_proveedor VALUES (91, false, '2008-10-11', NULL, 15, '2008-07-05', 27.02, 128.66, 0.00, '173932', 0.00, 155.68);
INSERT INTO compras_a_proveedor VALUES (444, false, '2008-10-11', NULL, 80, '2008-08-05', 78.75, 375.00, 0.00, '2709', 0.00, 453.75);
INSERT INTO compras_a_proveedor VALUES (678, false, '2008-10-11', NULL, 80, '2008-08-15', 92.41, 440.06, 0.00, '2754', 0.00, 532.47);
INSERT INTO compras_a_proveedor VALUES (40, false, '2008-10-11', NULL, 15, '2008-07-15', 6.02, 28.65, 0.00, '174282', 0.00, 34.67);
INSERT INTO compras_a_proveedor VALUES (624, false, '2008-10-11', NULL, 55, '2008-08-15', 42.76, 407.23, 0.00, '35748', 0.00, 449.99);
INSERT INTO compras_a_proveedor VALUES (724, false, '2008-10-11', NULL, 49, '2008-08-29', 3.28, 12.17, 0.00, '78993', 0.00, 15.45);
INSERT INTO compras_a_proveedor VALUES (621, false, '2008-10-11', NULL, 256, '2008-08-04', 0.00, 0.00, 10.32, '120812', 0.38, 10.70);
INSERT INTO compras_a_proveedor VALUES (1133, false, '2008-10-11', NULL, 256, '2008-09-11', 16.20, 77.60, 0.00, '193635', 1.93, 95.73);
INSERT INTO compras_a_proveedor VALUES (816, false, '2008-10-11', NULL, 812, '2008-08-20', 11.40, 54.30, 0.00, '48086', 0.00, 65.70);
INSERT INTO compras_a_proveedor VALUES (822, false, '2008-10-11', NULL, 536, '2008-08-19', 0.00, 2.20, 0.00, '936820', 0.00, 2.20);
INSERT INTO compras_a_proveedor VALUES (790, false, '2008-10-11', NULL, 478, '2008-08-20', 0.00, 400.00, 0.00, '574', 0.00, 400.00);
INSERT INTO compras_a_proveedor VALUES (793, false, '2008-10-11', NULL, 24, '2008-08-12', 0.00, 720.00, 0.00, '185240', 0.00, 720.00);
INSERT INTO compras_a_proveedor VALUES (1166, false, '2008-10-11', NULL, 1165, '2008-09-12', 27.11, 129.09, 0.00, '12069', 0.00, 156.20);
INSERT INTO compras_a_proveedor VALUES (93, false, '2008-10-11', NULL, 15, '2008-07-16', 7.55, 35.97, 0.00, '174337', 0.00, 43.52);
INSERT INTO compras_a_proveedor VALUES (1013, false, '2008-10-11', NULL, 269, '2008-08-24', 6.62, 31.50, 11.91, '14029', 0.00, 50.03);
INSERT INTO compras_a_proveedor VALUES (911, false, '2008-10-11', NULL, 269, '2008-08-25', 12.50, 59.50, 28.00, '14138', 2.19, 102.19);
INSERT INTO compras_a_proveedor VALUES (182, false, '2008-10-11', NULL, 15, '2008-07-18', 33.78, 160.85, 0.00, '174450', 0.00, 194.63);
INSERT INTO compras_a_proveedor VALUES (773, false, '2008-10-11', NULL, 295, '2008-08-27', 0.00, 86.00, 0.00, '145469334', 0.00, 86.00);
INSERT INTO compras_a_proveedor VALUES (777, false, '2008-10-11', NULL, 776, '2008-08-28', 9.20, 87.80, 0.00, '3555555339', 0.00, 97.00);
INSERT INTO compras_a_proveedor VALUES (684, false, '2008-10-11', NULL, 95, '2008-08-20', 3.28, 15.60, 0.00, '114239', 0.00, 18.88);
INSERT INTO compras_a_proveedor VALUES (781, false, '2008-10-11', NULL, 780, '2008-08-27', 0.00, 6.25, 0.00, '272', 0.00, 6.25);
INSERT INTO compras_a_proveedor VALUES (799, false, '2008-10-11', NULL, 780, '2008-08-27', 0.00, 6.25, 0.00, '4414', 0.00, 6.25);
INSERT INTO compras_a_proveedor VALUES (784, false, '2008-10-11', NULL, 780, '2008-08-28', 0.00, 6.50, 0.00, '5308', 0.00, 6.50);
INSERT INTO compras_a_proveedor VALUES (1397, false, '2008-10-11', NULL, 111, '2008-09-23', 60.53, 288.24, 0.00, '177915', 11.53, 360.30);
INSERT INTO compras_a_proveedor VALUES (598, false, '2008-10-11', NULL, 4, '2008-08-14', 1262.06, 6009.80, 180.29, '13158', 0.00, 7452.15);
INSERT INTO compras_a_proveedor VALUES (839, false, '2008-10-11', NULL, 55, '2008-08-25', 42.76, 407.23, 0.00, '35831', 0.00, 449.99);
INSERT INTO compras_a_proveedor VALUES (1169, false, '2008-10-11', NULL, 9, '2008-09-12', 15.06, 71.74, 0.00, '29012', 0.00, 86.80);
INSERT INTO compras_a_proveedor VALUES (826, false, '2008-10-11', NULL, 825, '2008-08-25', 0.00, 6.70, 0.00, '95175', 0.00, 6.70);
INSERT INTO compras_a_proveedor VALUES (813, false, '2008-10-11', NULL, 812, '2008-08-28', 24.36, 115.98, 0.00, '48197', 0.00, 140.34);
INSERT INTO compras_a_proveedor VALUES (787, false, '2008-10-11', NULL, 780, '2008-08-28', 0.00, 0.90, 0.00, '575363', 0.00, 0.90);
INSERT INTO compras_a_proveedor VALUES (646, false, '2008-10-11', NULL, 645, '2008-08-11', 210.62, 1002.96, 0.00, '437302', 30.09, 1243.67);
INSERT INTO compras_a_proveedor VALUES (805, false, '2008-10-11', NULL, 804, '2008-08-28', 0.00, 15.00, 0.00, '4779', 0.00, 15.00);
INSERT INTO compras_a_proveedor VALUES (117, false, '2008-10-11', NULL, 15, '2008-07-08', 44.57, 212.25, 0.00, '174022', 0.00, 256.82);
INSERT INTO compras_a_proveedor VALUES (1156, false, '2008-10-11', NULL, 61, '2008-09-10', 54.05, 257.40, 0.00, '72779', 10.30, 321.75);
INSERT INTO compras_a_proveedor VALUES (214, false, '2008-10-11', NULL, 15, '2008-07-19', 4.53, 21.56, 0.00, '174520', 0.00, 26.09);
INSERT INTO compras_a_proveedor VALUES (231, false, '2008-10-11', NULL, 15, '2008-07-22', 36.25, 172.63, 0.00, '174593', 0.00, 208.88);
INSERT INTO compras_a_proveedor VALUES (837, false, '2008-10-11', NULL, 385, '2008-08-25', 669.10, 3186.20, 0.00, '8006', 0.00, 3855.30);
INSERT INTO compras_a_proveedor VALUES (242, false, '2008-10-11', NULL, 15, '2008-07-23', 12.58, 59.90, 0.00, '174662', 0.00, 72.48);
INSERT INTO compras_a_proveedor VALUES (330, false, '2008-10-11', NULL, 15, '2008-07-25', 2.21, 10.51, 0.00, '174776', 0.00, 12.72);
INSERT INTO compras_a_proveedor VALUES (996, false, '2008-10-11', NULL, 995, '2008-09-03', 852.47, 4059.40, 0.00, '577', 0.00, 4911.87);
INSERT INTO compras_a_proveedor VALUES (855, false, '2008-10-11', NULL, 4, '2008-08-29', 1144.71, 5451.00, 0.00, '2722', 163.53, 6759.24);
INSERT INTO compras_a_proveedor VALUES (869, false, '2008-10-11', NULL, 12, '2008-08-30', 20.17, 96.06, 0.00, '35512', 0.00, 116.23);
INSERT INTO compras_a_proveedor VALUES (985, false, '2008-10-11', NULL, 196, '2008-09-05', 297.23, 1415.40, 0.00, '5043', 0.00, 1712.63);
INSERT INTO compras_a_proveedor VALUES (1025, false, '2008-10-11', NULL, 269, '2008-06-22', 11.62, 55.32, 28.08, '7966', 2.09, 97.11);
INSERT INTO compras_a_proveedor VALUES (1198, false, '2008-10-11', NULL, 111, '2008-09-13', 103.63, 493.47, 0.00, '177193', 19.74, 616.84);
INSERT INTO compras_a_proveedor VALUES (1028, false, '2008-10-11', NULL, 269, '2008-07-06', 12.02, 57.24, 28.75, '9075', 2.15, 100.16);
INSERT INTO compras_a_proveedor VALUES (1045, false, '2008-10-11', NULL, 1044, '2008-09-02', 11.79, 56.12, 0.00, '12308', 0.00, 67.91);
INSERT INTO compras_a_proveedor VALUES (354, false, '2008-10-11', NULL, 269, '2008-07-09', 8.75, 41.69, 11.56, '9298', 1.33, 63.33);
INSERT INTO compras_a_proveedor VALUES (571, false, '2008-10-11', NULL, 269, '2008-07-11', 3.13, 14.89, 5.98, '9488', 0.00, 24.00);
INSERT INTO compras_a_proveedor VALUES (1195, false, '2008-10-11', NULL, 12, '2008-09-13', 12.99, 61.85, 0.00, '35295', 0.00, 74.84);
INSERT INTO compras_a_proveedor VALUES (459, false, '2008-10-11', NULL, 15, '2008-08-07', 8.56, 40.75, 0.00, '175356', 0.00, 49.31);
INSERT INTO compras_a_proveedor VALUES (952, false, '2008-10-11', NULL, 277, '2008-09-04', 54.60, 260.00, 0.00, '3060', 0.00, 314.60);
INSERT INTO compras_a_proveedor VALUES (433, false, '2008-10-11', NULL, 55, '2008-08-04', 43.89, 418.09, 0.00, '35637', 0.00, 461.98);
INSERT INTO compras_a_proveedor VALUES (530, false, '2008-10-11', NULL, 55, '2008-08-12', 45.41, 432.56, 0.00, '35725', 0.00, 477.97);
INSERT INTO compras_a_proveedor VALUES (534, false, '2008-10-11', NULL, 15, '2008-08-12', 32.68, 155.60, 0.00, '175576', 0.00, 188.28);
INSERT INTO compras_a_proveedor VALUES (643, false, '2008-10-11', NULL, 15, '2008-08-15', 5.92, 28.20, 0.00, '175707', 0.00, 34.12);
INSERT INTO compras_a_proveedor VALUES (664, false, '2008-10-11', NULL, 15, '2008-08-16', 2.72, 12.97, 0.00, '175762', 0.00, 15.69);
INSERT INTO compras_a_proveedor VALUES (666, false, '2008-10-11', NULL, 15, '2008-08-20', 5.64, 26.87, 0.00, '175854', 0.00, 32.51);
INSERT INTO compras_a_proveedor VALUES (693, false, '2008-10-11', NULL, 15, '2008-08-21', 20.88, 99.45, 0.00, '175905', 0.00, 120.33);
INSERT INTO compras_a_proveedor VALUES (835, false, '2008-10-11', NULL, 15, '2008-08-23', 21.28, 101.34, 0.00, '176053', 0.00, 122.62);
INSERT INTO compras_a_proveedor VALUES (922, false, '2008-10-11', NULL, 55, '2008-09-03', 42.76, 407.23, 0.00, '35958', 0.00, 449.99);
INSERT INTO compras_a_proveedor VALUES (1038, false, '2008-10-11', NULL, 55, '2008-09-08', 50.74, 483.23, 0.00, '35993', 0.00, 533.97);
INSERT INTO compras_a_proveedor VALUES (1034, false, '2008-10-11', NULL, 564, '2008-06-06', 11.50, 54.77, 0.00, '3863', 0.00, 66.27);
INSERT INTO compras_a_proveedor VALUES (971, false, '2008-10-11', NULL, 283, '2008-09-05', 0.00, 0.00, 50.00, '797', 0.00, 50.00);
INSERT INTO compras_a_proveedor VALUES (956, false, '2008-10-11', NULL, 955, '2008-09-02', 145.95, 695.00, 0.00, '558', 0.00, 840.95);
INSERT INTO compras_a_proveedor VALUES (959, false, '2008-10-11', NULL, 491, '2008-09-04', 0.00, 0.00, 67.00, '3035', 0.00, 67.00);
INSERT INTO compras_a_proveedor VALUES (1550, false, '2008-10-11', NULL, 546, '2008-09-30', 95.80, 456.20, 0.00, '1120344', 18.25, 570.25);
INSERT INTO compras_a_proveedor VALUES (993, false, '2008-10-11', NULL, 219, '2008-09-06', 0.00, 0.00, 3.97, 'devolucion efvo', 0.00, 3.97);
INSERT INTO compras_a_proveedor VALUES (336, false, '2008-10-11', NULL, 28, '2008-07-23', 45.33, 215.85, 0.00, '5651', 5.40, 266.58);
INSERT INTO compras_a_proveedor VALUES (697, false, '2008-10-11', NULL, 111, '2008-08-19', 60.42, 287.73, 0.00, '175715', 8.63, 356.78);
INSERT INTO compras_a_proveedor VALUES (907, false, '2008-10-11', NULL, 111, '2008-08-29', 49.44, 235.43, 0.00, '176403', 7.06, 291.93);
INSERT INTO compras_a_proveedor VALUES (940, false, '2008-10-11', NULL, 111, '2008-09-02', 37.80, 180.00, 0.00, '176537', 7.20, 225.00);
INSERT INTO compras_a_proveedor VALUES (1552, false, '2008-10-11', NULL, 617, '2008-10-06', 1.89, 10.11, 0.00, '31608', 0.00, 12.00);
INSERT INTO compras_a_proveedor VALUES (942, false, '2008-10-11', NULL, 111, '2008-09-02', 21.66, 103.16, 0.00, '176564', 4.13, 128.95);
INSERT INTO compras_a_proveedor VALUES (1054, false, '2008-10-11', NULL, 111, '2008-09-05', 240.20, 1143.80, 0.00, '176848', 45.75, 1429.75);
INSERT INTO compras_a_proveedor VALUES (1058, false, '2008-10-11', NULL, 95, '2008-09-06', 3.28, 15.60, 0.00, '115056', 0.00, 18.88);
INSERT INTO compras_a_proveedor VALUES (1556, false, '2008-10-11', NULL, 1555, '2008-10-06', 24.09, 114.72, 0.00, '4587', 0.00, 138.81);
INSERT INTO compras_a_proveedor VALUES (1004, false, '2008-10-11', NULL, 80, '2008-09-05', 42.69, 203.28, 0.00, '2841', 0.00, 245.97);
INSERT INTO compras_a_proveedor VALUES (1175, false, '2008-10-11', NULL, 1174, '2008-09-12', 4.34, 20.66, 0.00, '8115', 0.00, 25.00);
INSERT INTO compras_a_proveedor VALUES (1063, false, '2008-10-11', NULL, 1062, '2008-09-08', 37.15, 176.90, 0.00, '400', 0.00, 214.05);
INSERT INTO compras_a_proveedor VALUES (1559, false, '2008-10-11', NULL, 668, '2008-10-02', 0.00, 150.00, 0.00, '170', 0.00, 150.00);
INSERT INTO compras_a_proveedor VALUES (1031, false, '2008-10-11', NULL, 269, '2008-06-01', 11.89, 56.62, 27.53, '5652', 2.10, 98.14);
INSERT INTO compras_a_proveedor VALUES (410, false, '2008-10-11', NULL, 28, '2008-07-31', 2096.59, 9983.75, 0.00, '5875', 249.57, 12329.91);
INSERT INTO compras_a_proveedor VALUES (963, false, '2008-10-11', NULL, 962, '2008-09-03', 364.18, 1734.20, 0.00, '45', 0.00, 2098.38);
INSERT INTO compras_a_proveedor VALUES (1049, false, '2008-10-11', NULL, 1048, '2008-09-02', 36.38, 173.20, 0.00, '7915', 0.00, 209.58);
INSERT INTO compras_a_proveedor VALUES (1234, false, '2008-10-11', NULL, 1233, '2008-09-15', 261.70, 1246.20, 0.00, '34581', 49.85, 1557.75);
INSERT INTO compras_a_proveedor VALUES (1207, false, '2008-10-11', NULL, 42, '2008-09-15', 0.00, 0.00, 692.00, '53', 0.00, 692.00);
INSERT INTO compras_a_proveedor VALUES (1211, false, '2008-10-11', NULL, 1210, '2008-08-30', 47.69, 227.11, 0.00, '3930', 0.00, 274.80);
INSERT INTO compras_a_proveedor VALUES (1290, false, '2008-10-11', NULL, 80, '2008-09-17', 67.20, 320.00, 0.00, '2897', 0.00, 387.20);
INSERT INTO compras_a_proveedor VALUES (1218, false, '2008-10-11', NULL, 55, '2008-09-16', 42.75, 407.22, 0.00, '36079', 0.00, 449.97);
INSERT INTO compras_a_proveedor VALUES (124, false, '2008-10-11', NULL, 28, '2008-07-07', 125.08, 595.60, 0.00, '5174', 14.89, 735.57);
INSERT INTO compras_a_proveedor VALUES (615, false, '2008-10-11', NULL, 28, '2008-08-12', 336.11, 1600.50, 0.00, '6231', 48.04, 1984.65);
INSERT INTO compras_a_proveedor VALUES (648, false, '2008-10-11', NULL, 28, '2008-08-15', 134.82, 642.00, 0.00, '6342', 19.26, 796.08);
INSERT INTO compras_a_proveedor VALUES (1315, false, '2008-10-11', NULL, 28, '2008-09-09', 1517.57, 7226.50, 0.00, '7083', 289.06, 9033.13);
INSERT INTO compras_a_proveedor VALUES (501, false, '2008-10-11', NULL, 15, '2008-08-09', 13.45, 64.01, 0.00, '175454', 0.00, 77.46);
INSERT INTO compras_a_proveedor VALUES (833, false, '2008-10-11', NULL, 15, '2008-08-26', 31.88, 151.77, 0.00, '176097', 0.00, 183.65);
INSERT INTO compras_a_proveedor VALUES (831, false, '2008-10-11', NULL, 15, '2008-08-27', 49.77, 236.99, 0.00, '176149', 0.00, 286.76);
INSERT INTO compras_a_proveedor VALUES (872, false, '2008-10-11', NULL, 15, '2008-08-30', 2.28, 10.89, 0.00, '176354', 0.00, 13.17);
INSERT INTO compras_a_proveedor VALUES (905, false, '2008-10-11', NULL, 15, '2008-09-02', 4.00, 19.04, 0.00, '176455', 0.00, 23.04);
INSERT INTO compras_a_proveedor VALUES (938, false, '2008-10-11', NULL, 15, '2008-09-03', 7.36, 35.06, 0.00, '176523', 0.00, 42.42);
INSERT INTO compras_a_proveedor VALUES (1283, false, '2008-10-11', NULL, 52, '2008-09-17', 0.00, 318.00, 0.00, '1070', 0.00, 318.00);
INSERT INTO compras_a_proveedor VALUES (944, false, '2008-10-11', NULL, 15, '2008-09-04', 67.54, 321.60, 0.00, '176600', 0.00, 389.14);
INSERT INTO compras_a_proveedor VALUES (965, false, '2008-10-11', NULL, 15, '2008-09-05', 22.32, 106.30, 0.00, '176659', 0.00, 128.62);
INSERT INTO compras_a_proveedor VALUES (987, false, '2008-10-11', NULL, 15, '2008-09-06', 4.07, 19.41, 0.00, '176729', 0.00, 23.48);
INSERT INTO compras_a_proveedor VALUES (1052, false, '2008-10-11', NULL, 15, '2008-09-09', 6.82, 32.51, 0.00, '176815', 0.00, 39.33);
INSERT INTO compras_a_proveedor VALUES (1097, false, '2008-10-11', NULL, 15, '2008-09-10', 24.29, 115.71, 0.00, '176897', 0.00, 140.00);
INSERT INTO compras_a_proveedor VALUES (1124, false, '2008-10-11', NULL, 15, '2008-09-11', 48.51, 230.97, 0.00, '176971', 0.00, 279.48);
INSERT INTO compras_a_proveedor VALUES (1154, false, '2008-10-11', NULL, 15, '2008-09-12', 17.82, 84.90, 0.00, '177009', 0.00, 102.72);
INSERT INTO compras_a_proveedor VALUES (1242, false, '2008-10-11', NULL, 15, '2008-09-17', 23.17, 110.34, 0.00, '177209', 0.00, 133.51);
INSERT INTO compras_a_proveedor VALUES (1278, false, '2008-10-11', NULL, 15, '2008-09-18', 12.02, 57.25, 0.00, '177292', 0.00, 69.27);
INSERT INTO compras_a_proveedor VALUES (1292, false, '2008-10-11', NULL, 95, '2008-09-18', 3.28, 15.60, 0.00, '115606', 0.00, 18.88);
INSERT INTO compras_a_proveedor VALUES (1094, false, '2008-10-11', NULL, 111, '2008-09-08', 74.78, 356.10, 0.00, '176884', 14.24, 445.12);
INSERT INTO compras_a_proveedor VALUES (1090, false, '2008-10-11', NULL, 385, '2008-09-08', 225.12, 1072.00, 0.00, '8161', 0.00, 1297.12);
INSERT INTO compras_a_proveedor VALUES (1086, false, '2008-10-11', NULL, 46, '2008-09-10', 0.00, 414.00, 0.00, 'CHEQUE RECHAZADO', 0.00, 414.00);
INSERT INTO compras_a_proveedor VALUES (1276, false, '2008-10-11', NULL, 46, '2008-09-17', 94.93, 452.04, 0.00, '43638', 0.00, 546.97);
INSERT INTO compras_a_proveedor VALUES (1274, false, '2008-10-11', NULL, 114, '2008-09-15', 119.49, 569.00, 0.00, '8033', 0.00, 688.49);
INSERT INTO compras_a_proveedor VALUES (1272, false, '2008-10-11', NULL, 114, '2008-09-16', 72.58, 345.60, 0.00, '8038', 0.00, 418.18);
INSERT INTO compras_a_proveedor VALUES (1246, false, '2008-10-11', NULL, 995, '2008-09-17', 485.44, 2311.60, 0.00, '580', 0.00, 2797.04);
INSERT INTO compras_a_proveedor VALUES (1258, false, '2008-10-11', NULL, 928, '2008-09-12', 2.66, 12.65, 0.00, '31309', 0.00, 15.31);
INSERT INTO compras_a_proveedor VALUES (1260, false, '2008-10-11', NULL, 928, '2008-09-12', 17.70, 84.28, 0.00, '32057', 0.00, 101.98);
INSERT INTO compras_a_proveedor VALUES (1262, false, '2008-10-11', NULL, 928, '2008-09-13', 30.02, 142.93, 0.00, '31365', 0.00, 172.95);
INSERT INTO compras_a_proveedor VALUES (1264, false, '2008-10-11', NULL, 928, '2008-09-15', 7.31, 34.80, 0.00, '31407', 0.00, 42.11);
INSERT INTO compras_a_proveedor VALUES (136, false, '2008-10-11', NULL, 135, '2008-07-04', 17.01, 80.99, 0.00, '175669', 0.00, 98.00);
INSERT INTO compras_a_proveedor VALUES (474, false, '2008-10-11', NULL, 135, '2008-07-23', 35.02, 68.98, 0.00, '177022', 0.00, 104.00);
INSERT INTO compras_a_proveedor VALUES (1269, false, '2008-10-11', NULL, 135, '2008-09-18', 17.36, 82.64, 0.00, '181913', 0.00, 100.00);
INSERT INTO compras_a_proveedor VALUES (1280, false, '2008-10-11', NULL, 49, '2008-09-18', 250.33, 927.16, 0.00, '1593574', 96.41, 1273.90);
INSERT INTO compras_a_proveedor VALUES (1287, false, '2008-10-11', NULL, 1286, '2008-09-17', 21.00, 100.00, 0.00, '2790', 0.00, 121.00);
INSERT INTO compras_a_proveedor VALUES (882, false, '2008-10-11', NULL, 49, '2008-09-27', 23.46, 111.70, 0.00, '5665', 3.35, 138.51);
INSERT INTO compras_a_proveedor VALUES (1244, false, '2008-10-11', NULL, 103, '2008-09-17', 266.58, 1269.45, 0.00, '3887', 0.00, 1536.03);
INSERT INTO compras_a_proveedor VALUES (1445, false, '2008-10-11', NULL, 256, '2008-09-29', 0.00, 55.65, 0.00, '355680', 1.67, 57.32);
INSERT INTO compras_a_proveedor VALUES (1351, false, '2008-10-11', NULL, 1350, '2008-09-22', 29.33, 139.67, 0.00, '1074', 0.00, 169.00);
INSERT INTO compras_a_proveedor VALUES (1333, false, '2008-10-11', NULL, 111, '2008-09-18', 98.74, 470.18, 0.00, '177608', 18.81, 587.73);
INSERT INTO compras_a_proveedor VALUES (1448, false, '2008-10-11', NULL, 1447, '2008-07-01', 6.80, 32.38, 0.00, '2513', 0.00, 39.18);
INSERT INTO compras_a_proveedor VALUES (1429, false, '2008-10-11', NULL, 52, '2008-09-25', 0.00, 17.00, 0.00, '1073', 0.00, 17.00);
INSERT INTO compras_a_proveedor VALUES (1357, false, '2008-10-11', NULL, 1356, '2008-09-22', 0.00, 2480.00, 0.00, '153', 0.00, 2480.00);
INSERT INTO compras_a_proveedor VALUES (861, false, '2008-10-11', NULL, 12, '2008-08-23', 18.39, 87.56, 0.00, '35554', 0.00, 105.95);
INSERT INTO compras_a_proveedor VALUES (1326, false, '2008-10-11', NULL, 12, '2008-09-19', 11.04, 52.58, 0.00, '35299', 0.00, 63.62);
INSERT INTO compras_a_proveedor VALUES (1432, false, '2008-10-11', NULL, 12, '2008-09-27', 10.06, 47.90, 0.00, '35541', 0.00, 57.96);
INSERT INTO compras_a_proveedor VALUES (1329, false, '2008-10-11', NULL, 15, '2008-09-20', 16.29, 77.58, 0.00, '177466', 0.00, 93.87);
INSERT INTO compras_a_proveedor VALUES (1438, false, '2008-10-11', NULL, 15, '2008-09-27', 3.13, 14.93, 0.00, '177800', 0.00, 18.06);
INSERT INTO compras_a_proveedor VALUES (1324, false, '2008-10-11', NULL, 1233, '2008-09-18', 298.10, 2839.00, 0.00, '34671', 113.56, 3250.66);
INSERT INTO compras_a_proveedor VALUES (178, false, '2008-10-11', NULL, 28, '2008-07-16', 226.64, 1079.25, 0.00, '5435', 26.98, 1332.87);
INSERT INTO compras_a_proveedor VALUES (180, false, '2008-10-11', NULL, 28, '2008-07-16', 982.12, 4676.75, 0.00, '5470', 116.92, 5775.79);
INSERT INTO compras_a_proveedor VALUES (229, false, '2008-10-11', NULL, 28, '2008-07-17', 124.91, 594.80, 0.00, '5499', 14.87, 734.58);
INSERT INTO compras_a_proveedor VALUES (227, false, '2008-10-11', NULL, 28, '2008-07-18', 407.96, 1942.65, 0.00, '5529', 48.56, 2399.17);
INSERT INTO compras_a_proveedor VALUES (1436, false, '2008-10-11', NULL, 211, '2008-09-25', 113.92, 542.50, 0.00, '42394', 0.00, 656.42);
INSERT INTO compras_a_proveedor VALUES (56, false, '2008-10-11', NULL, 55, '2008-07-14', 43.89, 418.09, 0.00, '35486', 0.00, 461.98);
INSERT INTO compras_a_proveedor VALUES (1450, false, '2008-10-11', NULL, 55, '2008-09-29', 42.76, 407.23, 0.00, '36215', 0.00, 449.99);
INSERT INTO compras_a_proveedor VALUES (357, false, '2008-10-11', NULL, 269, '2008-07-27', 11.38, 54.18, 16.14, '11224', 1.76, 83.46);
INSERT INTO compras_a_proveedor VALUES (422, false, '2008-10-11', NULL, 269, '2008-08-02', 10.03, 47.78, 14.23, '11824', 1.55, 73.59);
INSERT INTO compras_a_proveedor VALUES (552, false, '2008-10-11', NULL, 269, '2008-08-07', 21.85, 104.06, 41.15, '12475', 3.63, 170.69);
INSERT INTO compras_a_proveedor VALUES (543, false, '2008-10-11', NULL, 269, '2008-08-09', 6.97, 33.20, 9.86, '12343', 0.00, 50.03);
INSERT INTO compras_a_proveedor VALUES (1016, false, '2008-10-11', NULL, 269, '2008-08-09', 3.97, 18.92, 7.15, '13562', 0.00, 30.04);
INSERT INTO compras_a_proveedor VALUES (1022, false, '2008-10-11', NULL, 269, '2008-08-10', 9.42, 44.85, 17.74, '12815', 1.56, 73.57);
INSERT INTO compras_a_proveedor VALUES (558, false, '2008-10-11', NULL, 269, '2008-06-22', 18.75, 89.27, 33.99, '7967', 3.08, 145.09);
INSERT INTO compras_a_proveedor VALUES (770, false, '2008-10-11', NULL, 28, '2008-08-20', 1178.10, 5610.00, 0.00, '6425', 168.30, 6956.40);
INSERT INTO compras_a_proveedor VALUES (946, false, '2008-10-11', NULL, 28, '2008-09-02', 2373.63, 11303.00, 0.00, '6818', 452.12, 14128.75);
INSERT INTO compras_a_proveedor VALUES (969, false, '2008-10-11', NULL, 28, '2008-09-03', 328.76, 1565.50, 0.00, '6860', 62.62, 1956.88);
INSERT INTO compras_a_proveedor VALUES (967, false, '2008-10-11', NULL, 28, '2008-09-03', 246.33, 1173.00, 0.00, '6859', 46.92, 1466.25);
INSERT INTO compras_a_proveedor VALUES (1092, false, '2008-10-11', NULL, 28, '2008-09-08', 180.64, 860.20, 0.00, '7029', 34.43, 1075.27);
INSERT INTO compras_a_proveedor VALUES (1322, false, '2008-10-11', NULL, 28, '2008-09-09', 0.00, 0.01, 0.00, '7083', 0.00, 0.01);
INSERT INTO compras_a_proveedor VALUES (1131, false, '2008-10-11', NULL, 28, '2008-09-09', 154.35, 735.00, 0.00, '7053', 29.40, 918.75);
INSERT INTO compras_a_proveedor VALUES (1414, false, '2008-10-11', NULL, 61, '2008-09-24', 254.80, 1213.35, 0.00, '73142', 48.53, 1516.68);
INSERT INTO compras_a_proveedor VALUES (1019, false, '2008-10-11', NULL, 269, '2008-08-17', 9.13, 43.46, 16.43, '13563', 1.50, 70.52);
INSERT INTO compras_a_proveedor VALUES (1200, false, '2008-10-11', NULL, 28, '2008-09-11', 388.50, 1850.00, 0.00, '7123', 74.00, 2312.50);
INSERT INTO compras_a_proveedor VALUES (1365, false, '2008-10-11', NULL, 95, '2008-09-23', 3.28, 15.60, 0.00, '115887', 0.00, 18.88);
INSERT INTO compras_a_proveedor VALUES (1230, false, '2008-10-11', NULL, 28, '2008-09-15', 88.20, 420.00, 0.00, '00007174', 16.80, 525.00);
INSERT INTO compras_a_proveedor VALUES (568, false, '2008-10-11', NULL, 269, '2008-07-06', 14.56, 69.31, 26.18, '6811', 2.39, 112.44);
INSERT INTO compras_a_proveedor VALUES (270, false, '2008-10-11', NULL, 269, '2008-07-20', 6.96, 33.16, 9.88, '10396', 0.00, 50.00);
INSERT INTO compras_a_proveedor VALUES (555, false, '2008-10-11', NULL, 269, '2008-07-20', 20.92, 99.62, 39.51, '10415', 3.48, 163.53);
INSERT INTO compras_a_proveedor VALUES (914, false, '2008-10-11', NULL, 269, '2008-08-30', 11.87, 56.53, 26.60, '14469', 2.08, 97.08);
INSERT INTO compras_a_proveedor VALUES (1010, false, '2008-10-11', NULL, 269, '2008-08-31', 23.68, 112.76, 42.63, '14530', 3.88, 182.95);
INSERT INTO compras_a_proveedor VALUES (999, false, '2008-10-11', NULL, 269, '2008-09-02', 10.37, 49.36, 14.27, '59397', 1.59, 75.59);
INSERT INTO compras_a_proveedor VALUES (1007, false, '2008-10-11', NULL, 269, '2008-09-05', 23.01, 109.58, 41.41, '15043', 3.77, 177.77);
INSERT INTO compras_a_proveedor VALUES (1347, false, '2008-10-11', NULL, 269, '2008-09-07', 20.37, 96.99, 45.65, '15279', 3.57, 166.58);
INSERT INTO compras_a_proveedor VALUES (1215, false, '2008-10-11', NULL, 269, '2008-09-16', 17.86, 85.05, 32.14, '7524', 2.93, 137.98);
INSERT INTO compras_a_proveedor VALUES (1267, false, '2008-10-11', NULL, 269, '2008-09-18', 23.21, 110.54, 44.28, '16035', 3.87, 181.90);
INSERT INTO compras_a_proveedor VALUES (1344, false, '2008-10-11', NULL, 269, '2008-09-20', 6.14, 29.23, 14.63, '16452', 0.00, 50.00);
INSERT INTO compras_a_proveedor VALUES (1453, false, '2008-10-11', NULL, 269, '2008-09-27', 6.94, 33.06, 10.03, '7962', 0.00, 50.03);
INSERT INTO compras_a_proveedor VALUES (1331, false, '2008-10-11', NULL, 28, '2008-09-18', 22.27, 106.05, 0.00, '7283', 4.24, 132.56);
INSERT INTO compras_a_proveedor VALUES (1424, false, '2008-10-11', NULL, 269, '2008-09-29', 24.13, 114.90, 46.04, '7925', 4.02, 189.09);
INSERT INTO compras_a_proveedor VALUES (1459, false, '2008-10-11', NULL, 812, '2008-09-30', 46.98, 223.73, 0.00, '48769', 0.00, 270.71);
INSERT INTO compras_a_proveedor VALUES (1472, false, '2008-10-11', NULL, 1044, '2008-09-30', 5.90, 28.10, 0.00, '12569', 0.00, 34.00);
INSERT INTO compras_a_proveedor VALUES (25, false, '2008-10-11', NULL, 24, '2008-07-04', 0.00, 0.00, 720.00, '182196', 0.00, 720.00);
INSERT INTO compras_a_proveedor VALUES (1480, false, '2008-10-11', NULL, 24, '2008-09-29', 0.00, 2730.00, 0.00, '187794', 0.00, 2730.00);
INSERT INTO compras_a_proveedor VALUES (1486, false, '2008-10-11', NULL, 291, '2008-10-01', 11.98, 57.03, 0.00, '30717', 0.00, 69.01);
INSERT INTO compras_a_proveedor VALUES (1489, false, '2008-10-11', NULL, 283, '2008-10-02', 0.00, 50.00, 0.00, '604', 0.00, 50.00);
INSERT INTO compras_a_proveedor VALUES (1493, false, '2008-10-11', NULL, 1492, '2008-10-02', 0.00, 36.00, 0.00, '2490', 0.00, 36.00);
INSERT INTO compras_a_proveedor VALUES (1503, false, '2008-10-11', NULL, 269, '2008-10-03', 13.46, 64.09, 19.45, '27485', 0.00, 97.00);
INSERT INTO compras_a_proveedor VALUES (1509, false, '2008-10-11', NULL, 277, '2008-10-03', 44.15, 210.24, 0.00, '3191', 0.00, 254.39);
INSERT INTO compras_a_proveedor VALUES (1506, false, '2008-10-11', NULL, 316, '2008-10-03', 373.80, 1780.00, 0.00, '1446', 0.00, 2153.80);
INSERT INTO compras_a_proveedor VALUES (1483, false, '2008-10-11', NULL, 219, '2008-09-30', 153.53, 731.08, 0.00, '2698', 0.00, 884.61);
INSERT INTO compras_a_proveedor VALUES (1517, false, '2008-10-11', NULL, 28, '2008-10-02', 234.61, 1117.20, 0.00, '7682', 39.10, 1390.91);
INSERT INTO compras_a_proveedor VALUES (1519, false, '2008-10-11', NULL, 12, '2008-10-04', 7.10, 33.82, 0.00, '35631', 0.00, 40.92);
INSERT INTO compras_a_proveedor VALUES (1522, false, '2008-10-11', NULL, 287, '2008-09-30', 0.00, 500.00, 0.00, '302', 0.00, 500.00);
INSERT INTO compras_a_proveedor VALUES (1525, false, '2008-10-11', NULL, 15, '2008-10-04', 5.78, 27.52, 0.00, '178132', 0.00, 33.30);
INSERT INTO compras_a_proveedor VALUES (390, false, '2008-10-11', NULL, 15, '2008-07-30', 18.24, 86.84, 0.00, '174970', 0.00, 105.08);
INSERT INTO compras_a_proveedor VALUES (1401, false, '2008-10-11', NULL, 15, '2008-09-25', 41.77, 198.95, 0.00, '177654', 0.00, 240.72);
INSERT INTO compras_a_proveedor VALUES (1412, false, '2008-10-11', NULL, 15, '2008-09-26', 7.48, 35.61, 0.00, '177712', 0.00, 43.09);
INSERT INTO compras_a_proveedor VALUES (1475, false, '2008-10-11', NULL, 15, '2008-10-01', 14.71, 70.06, 0.00, '177960', 0.00, 84.77);
INSERT INTO compras_a_proveedor VALUES (1527, false, '2008-10-11', NULL, 1, '2008-10-03', 42.21, 201.00, 0.00, '12728', 0.00, 243.21);
INSERT INTO compras_a_proveedor VALUES (1478, false, '2008-10-11', NULL, 1, '2008-10-01', 546.94, 2604.50, 0.00, '12676', 0.00, 3151.44);
INSERT INTO compras_a_proveedor VALUES (857, false, '2008-10-11', NULL, 4, '2008-08-29', 0.00, 0.00, 3200.00, 'DEVOLUCIÃƒâ€œN DE CHEQUE', 0.00, 3200.00);
INSERT INTO compras_a_proveedor VALUES (1529, false, '2008-10-11', NULL, 4, '2008-09-15', 33.64, 160.20, 0.00, '458737', 6.41, 200.25);
INSERT INTO compras_a_proveedor VALUES (1531, false, '2008-10-11', NULL, 4, '2008-09-23', 1758.54, 8374.00, 0.00, '2743', 334.96, 10467.50);
INSERT INTO compras_a_proveedor VALUES (1111122, true, '2008-10-15', NULL, -1308164096, '2008-10-15', 0.00, 0.00, 0.00, '12345', 0.10, 0.10);
INSERT INTO compras_a_proveedor VALUES (1111123, false, '2008-10-15', NULL, -1308164096, '2008-10-15', 0.00, 0.00, 0.00, '1234554321', 0.02, 0.02);
INSERT INTO compras_a_proveedor VALUES (1111134, false, '2008-10-16', NULL, 28, '2008-10-03', 51.45, 245.00, 0.00, '7741', 8.58, 305.03);
INSERT INTO compras_a_proveedor VALUES (1111135, false, '2008-10-16', NULL, 338, '2008-10-07', 7.81, 37.19, 0.00, '2169', 0.00, 45.00);
INSERT INTO compras_a_proveedor VALUES (1111137, false, '2008-10-16', NULL, 55, '2008-10-07', 42.76, 407.23, 0.00, '36245', 0.00, 449.99);
INSERT INTO compras_a_proveedor VALUES (1111139, false, '2008-10-16', NULL, -1308164095, '2008-10-07', 200.42, 954.40, 0.00, '79900', 0.00, 1154.82);
INSERT INTO compras_a_proveedor VALUES (1111141, false, '2008-10-16', NULL, 42, '2008-10-07', 0.00, 1056.00, 0.00, '565', 0.00, 1056.00);
INSERT INTO compras_a_proveedor VALUES (1111143, false, '2008-10-16', NULL, 196, '2008-10-08', 596.32, 2839.60, 0.00, '5083', 0.00, 3435.92);
INSERT INTO compras_a_proveedor VALUES (1111144, false, '2008-10-16', NULL, 1403, '2008-10-08', 109.20, 520.00, 0.00, '14463', 0.00, 629.20);
INSERT INTO compras_a_proveedor VALUES (1111146, false, '2008-10-16', NULL, 61, '2008-10-10', 108.11, 514.80, 0.00, '73559', 18.02, 640.93);
INSERT INTO compras_a_proveedor VALUES (1111149, false, '2008-10-16', NULL, 812, '2008-10-16', 23.49, 111.86, 0.00, '49070', 0.00, 135.35);
INSERT INTO compras_a_proveedor VALUES (1111262, false, '2008-10-20', NULL, 55, '2008-10-20', 45.60, 434.37, 0.00, '36337', 0.00, 479.97);
INSERT INTO compras_a_proveedor VALUES (1111266, false, '2008-10-20', NULL, 49, '2008-10-16', 475.65, 1297.16, 107.32, '38795', 0.00, 1880.13);
INSERT INTO compras_a_proveedor VALUES (1111268, false, '2008-10-20', NULL, -1308164092, '2008-10-17', 13.96, 66.47, 9.30, '27185', 10.28, 100.01);
INSERT INTO compras_a_proveedor VALUES (1111300, false, '2008-10-20', NULL, -1308164091, '2008-10-15', 23.95, 114.05, 0.00, '2114', 0.00, 138.00);
INSERT INTO compras_a_proveedor VALUES (1111302, false, '2008-10-20', NULL, 269, '2008-10-15', 26.10, 124.29, 49.64, '18709', 0.00, 200.03);
INSERT INTO compras_a_proveedor VALUES (1111304, false, '2008-10-20', NULL, -1308164089, '2008-10-18', 4.51, 21.48, 0.00, '18542', 0.00, 25.99);
INSERT INTO compras_a_proveedor VALUES (1111307, false, '2008-10-20', NULL, -1308164088, '2008-10-20', 12.55, 59.75, 0.00, '0795', 0.00, 72.30);
INSERT INTO compras_a_proveedor VALUES (1111309, false, '2008-10-20', NULL, 12, '2008-10-18', 8.64, 41.15, 0.00, '35718', 0.00, 49.79);
INSERT INTO compras_a_proveedor VALUES (1111311, false, '2008-10-20', NULL, -1308164087, '2008-10-20', 0.00, 613.47, 0.00, '12713', 0.00, 613.47);
INSERT INTO compras_a_proveedor VALUES (1111313, false, '2008-10-20', NULL, 55, '2008-10-16', 4.27, 40.72, 0.00, '36324', 0.00, 44.99);
INSERT INTO compras_a_proveedor VALUES (1111315, false, '2008-10-20', NULL, -1308164086, '2008-09-30', 53.13, 282.63, 0.00, '33507/0', 0.00, 335.76);
INSERT INTO compras_a_proveedor VALUES (1111318, false, '2008-10-21', NULL, -1308164093, '2008-10-13', 63.46, 302.18, 0.00, '120080913', 0.00, 365.64);
INSERT INTO compras_a_proveedor VALUES (1111320, false, '2008-10-21', NULL, 46, '2008-10-20', 179.91, 856.71, 0.00, '44151', 0.00, 1036.62);
INSERT INTO compras_a_proveedor VALUES (1111322, false, '2008-10-21', NULL, 114, '2008-10-17', 160.65, 765.00, 0.00, '8238', 0.00, 925.65);
INSERT INTO compras_a_proveedor VALUES (1111329, false, '2008-10-21', NULL, 15, '2008-10-21', 83.41, 397.19, 0.00, '178821', 0.00, 480.60);
INSERT INTO compras_a_proveedor VALUES (1111360, false, '2008-10-21', NULL, 385, '2008-10-17', 641.76, 3056.00, 0.00, '8561', 0.00, 3697.76);
INSERT INTO compras_a_proveedor VALUES (1111361, false, '2008-10-21', NULL, 928, '2008-10-11', 9.25, 44.03, 0.00, '31895', 0.00, 53.28);
INSERT INTO compras_a_proveedor VALUES (1111363, false, '2008-10-21', NULL, 928, '2008-09-29', 39.79, 189.47, 0.00, '31673', 0.00, 229.26);
INSERT INTO compras_a_proveedor VALUES (1111365, false, '2008-10-21', NULL, 4, '2008-10-10', 1446.65, 6888.80, 0.00, '2770', 241.11, 8576.56);
INSERT INTO compras_a_proveedor VALUES (1111367, false, '2008-10-21', NULL, 4, '2008-10-21', 746.55, 3555.00, 0.00, '2777', 124.43, 4425.98);
INSERT INTO compras_a_proveedor VALUES (1111410, false, '2008-10-22', NULL, 80, '2008-10-20', 460.57, 2193.18, 0.00, '3052', 0.00, 2653.75);
INSERT INTO compras_a_proveedor VALUES (1111411, false, '2008-10-22', NULL, 95, '2008-10-22', 5.29, 25.20, 0.00, '117474', 0.00, 30.49);
INSERT INTO compras_a_proveedor VALUES (1111413, false, '2008-10-22', NULL, 15, '2008-10-22', 18.53, 88.22, 0.00, '178883', 0.00, 106.75);
INSERT INTO compras_a_proveedor VALUES (1111414, false, '2008-10-22', NULL, 46, '2008-10-21', 58.90, 280.50, 0.00, '44164', 0.00, 339.40);
INSERT INTO compras_a_proveedor VALUES (1111451, false, '2008-10-23', NULL, 211, '2008-10-21', 100.84, 480.20, 0.00, '42695', 0.00, 581.04);
INSERT INTO compras_a_proveedor VALUES (1111452, false, '2008-10-23', NULL, 15, '2008-10-23', 49.89, 237.56, 0.00, '178949', 0.00, 287.45);
INSERT INTO compras_a_proveedor VALUES (1111453, false, '2008-10-23', NULL, 1233, '2008-10-21', 908.46, 4326.00, 0.00, '35255', 151.41, 5385.87);
INSERT INTO compras_a_proveedor VALUES (1111454, false, '2008-10-23', NULL, 28, '2008-10-21', 644.28, 3068.00, 0.00, '8171', 107.40, 3819.68);
INSERT INTO compras_a_proveedor VALUES (1311, true, '2008-10-11', NULL, 49, '2008-09-29', 3.77, 14.00, 0.00, '128391', 0.00, 17.77);
INSERT INTO compras_a_proveedor VALUES (1111532, false, '2008-10-24', NULL, 407, '2008-10-20', 535.32, 2549.16, 0.00, '23527', 0.00, 3084.48);
INSERT INTO compras_a_proveedor VALUES (1111539, false, '2008-10-24', NULL, 114, '2008-10-22', 37.80, 180.00, 0.00, '8263', 0.00, 217.80);
INSERT INTO compras_a_proveedor VALUES (1111562, false, '2008-10-24', NULL, 256, '2008-10-24', 2.79, 13.30, 0.00, '5-1-249167', 0.00, 16.09);
INSERT INTO compras_a_proveedor VALUES (1111563, false, '2008-10-24', NULL, 15, '2008-10-24', 2.79, 13.26, 0.00, '178979', 0.00, 16.05);
INSERT INTO compras_a_proveedor VALUES (1111564, false, '2008-10-24', NULL, -1308131328, '2008-09-30', 8.19, 39.00, 0.00, '1926', 0.00, 47.19);
INSERT INTO compras_a_proveedor VALUES (1111566, false, '2008-10-25', NULL, 28, '2008-10-23', 246.33, 1173.00, 0.00, '8225', 41.07, 1460.40);
INSERT INTO compras_a_proveedor VALUES (1111567, false, '2008-10-25', NULL, 15, '2008-10-25', 6.77, 32.23, 0.00, '179044', 0.00, 39.00);
INSERT INTO compras_a_proveedor VALUES (1111680, false, '2008-10-28', NULL, -1308131327, '2008-10-18', 10.89, 51.87, 21.48, '55294', 1.77, 86.01);
INSERT INTO compras_a_proveedor VALUES (1111682, false, '2008-10-28', NULL, 269, '2008-10-18', 4.04, 19.26, 7.69, '8675', 0.00, 30.99);
INSERT INTO compras_a_proveedor VALUES (1111684, false, '2008-10-28', NULL, 269, '2008-10-24', 21.53, 102.54, 40.95, '19524', 0.00, 165.02);
INSERT INTO compras_a_proveedor VALUES (1111686, false, '2008-10-28', NULL, -1308131326, '2008-10-19', 24.80, 118.12, 43.65, '119404', 3.53, 190.10);
INSERT INTO compras_a_proveedor VALUES (1111688, false, '2008-10-28', NULL, -1308131325, '2008-10-28', 0.00, 30.00, 0.00, '0', 0.00, 30.00);
INSERT INTO compras_a_proveedor VALUES (1111690, false, '2008-10-28', NULL, -1308131324, '2008-10-28', 2.78, 13.22, 0.00, '924', 0.00, 16.00);
INSERT INTO compras_a_proveedor VALUES (1111692, false, '2008-10-28', NULL, 1, '2008-10-20', 0.00, 305.00, 0.00, 'NOTA DE PEDIDO', 0.00, 305.00);
INSERT INTO compras_a_proveedor VALUES (1111693, false, '2008-10-28', NULL, 52, '2008-10-11', 0.00, 136.00, 0.00, '1095', 0.00, 136.00);
INSERT INTO compras_a_proveedor VALUES (1111694, false, '2008-10-28', NULL, 52, '2008-10-11', 0.00, 344.00, 0.00, '1096', 0.00, 344.00);
INSERT INTO compras_a_proveedor VALUES (1111695, false, '2008-10-28', NULL, 52, '2008-10-11', 0.00, 183.00, 0.00, '1097', 0.00, 183.00);
INSERT INTO compras_a_proveedor VALUES (1111696, false, '2008-10-28', NULL, 52, '2008-10-11', 0.00, 98.00, 0.00, '1098', 0.00, 98.00);
INSERT INTO compras_a_proveedor VALUES (1111698, false, '2008-10-28', NULL, 52, '2008-10-11', 0.00, 277.00, 0.00, '1100', 0.00, 277.00);
INSERT INTO compras_a_proveedor VALUES (1111699, false, '2008-10-28', NULL, 52, '2008-10-11', 0.00, 112.00, 0.00, '1102', 0.00, 112.00);
INSERT INTO compras_a_proveedor VALUES (1111700, false, '2008-10-28', NULL, 52, '2008-10-27', 0.00, 936.00, 0.00, '1113', 0.00, 936.00);
INSERT INTO compras_a_proveedor VALUES (1111701, false, '2008-10-28', NULL, 52, '2008-10-28', 0.00, 239.00, 0.00, '1114', 0.00, 239.00);
INSERT INTO compras_a_proveedor VALUES (1111321, true, '2008-10-21', NULL, 1, '2008-10-20', 382.30, 1820.50, 0.00, '12871', 0.00, 2202.80);
INSERT INTO compras_a_proveedor VALUES (1111317, true, '2008-10-21', NULL, 49, '2008-10-29', 4.67, 17.32, 0.00, '177969', 0.00, 21.99);
INSERT INTO compras_a_proveedor VALUES (1111455, true, '2008-10-23', NULL, 49, '2008-10-21', 42.70, 203.36, 0.00, '43086', 0.00, 246.06);
INSERT INTO compras_a_proveedor VALUES (1111702, false, '2008-10-28', NULL, 52, '2008-10-28', 0.00, 68.00, 0.00, '1115', 0.00, 68.00);
INSERT INTO compras_a_proveedor VALUES (1111697, true, '2008-10-28', NULL, 52, '2008-10-11', 0.00, 272.00, 0.00, '1099', 0.00, 272.00);
INSERT INTO compras_a_proveedor VALUES (1111703, false, '2008-10-28', NULL, 52, '2008-10-11', 0.00, 268.00, 0.00, '1099', 0.00, 268.00);
INSERT INTO compras_a_proveedor VALUES (1111704, false, '2008-10-28', NULL, -1308164088, '2008-10-02', 29.17, 138.90, 0.00, '493', 0.00, 168.07);
INSERT INTO compras_a_proveedor VALUES (1111705, false, '2008-10-28', NULL, 1, '2008-10-20', 382.30, 1820.50, 0.00, '12871', 0.00, 2202.80);
INSERT INTO compras_a_proveedor VALUES (1111706, false, '2008-10-28', NULL, 80, '2008-10-27', 352.85, 1680.28, 0.00, '3083', 0.00, 2033.13);
INSERT INTO compras_a_proveedor VALUES (1111707, false, '2008-10-28', NULL, 95, '2008-10-28', 3.28, 15.60, 0.00, '117781', 0.00, 18.88);
INSERT INTO compras_a_proveedor VALUES (1111709, false, '2008-10-29', NULL, -1308164093, '2008-10-06', 0.00, 96.18, 0.00, '81006', 0.00, 96.18);
INSERT INTO compras_a_proveedor VALUES (1111711, false, '2008-10-29', NULL, 49, '2008-10-11', 0.00, 17.00, 0.00, '177969', 0.00, 17.00);
INSERT INTO compras_a_proveedor VALUES (1111713, false, '2008-10-29', NULL, -1308131323, '2008-10-28', 7.36, 35.07, 0.00, '02-1567', 0.00, 42.43);
INSERT INTO compras_a_proveedor VALUES (1111715, false, '2008-10-29', NULL, 4, '2008-10-28', 191.11, 910.05, 0.00, '28347', 31.85, 1133.01);
INSERT INTO compras_a_proveedor VALUES (1111717, false, '2008-10-29', NULL, 407, '2008-10-28', 51.41, 244.80, 0.00, '23592', 0.00, 296.21);
INSERT INTO compras_a_proveedor VALUES (1111718, false, '2008-10-29', NULL, 61, '2008-10-27', 53.61, 255.30, 0.00, '73912', 8.94, 317.85);
INSERT INTO compras_a_proveedor VALUES (1111719, false, '2008-10-29', NULL, 15, '2008-10-29', 5.71, 27.21, 0.00, '179212', 0.00, 32.92);
INSERT INTO compras_a_proveedor VALUES (1111760, false, '2008-10-29', NULL, -1308131322, '2008-08-27', 0.00, 920.00, 0.00, '0', 0.00, 920.00);
INSERT INTO compras_a_proveedor VALUES (1111765, false, '2008-10-30', NULL, -1308131321, '2008-10-28', 176.40, 840.00, 0.00, '8051', 0.00, 1016.40);
INSERT INTO compras_a_proveedor VALUES (1111766, false, '2008-10-30', NULL, 15, '2008-10-30', 22.87, 108.87, 0.00, '179286', 0.00, 131.74);
INSERT INTO compras_a_proveedor VALUES (1111767, false, '2008-10-30', NULL, 28, '2008-10-28', 360.15, 1715.00, 0.00, '8331', 60.03, 2135.18);
INSERT INTO compras_a_proveedor VALUES (1111768, false, '2008-10-30', NULL, -1308131320, '2008-10-30', 0.00, 21.94, 0.00, '30000', 0.00, 21.94);
INSERT INTO compras_a_proveedor VALUES (1111770, false, '2008-10-30', NULL, 1, '2008-10-29', 40.53, 193.00, 0.00, '12967', 0.00, 233.53);
INSERT INTO compras_a_proveedor VALUES (1111771, false, '2008-10-30', NULL, -1308131319, '2008-10-29', 169.18, 805.60, 0.00, '7151', 0.00, 974.78);
INSERT INTO compras_a_proveedor VALUES (1111772, false, '2008-10-30', NULL, -1308131318, '2008-10-29', 214.20, 1020.00, 0.00, '2409', 0.00, 1234.20);
INSERT INTO compras_a_proveedor VALUES (1111775, false, '2008-10-30', NULL, -1308131317, '2008-10-29', 4.17, 19.83, 0.00, '96814', 0.00, 24.00);
INSERT INTO compras_a_proveedor VALUES (1111842, false, '2008-10-31', NULL, 121, '2008-10-27', 262.50, 1250.00, 0.00, '74079', 0.00, 1512.50);
INSERT INTO compras_a_proveedor VALUES (1111843, false, '2008-10-31', NULL, -1308131316, '2008-10-25', 8.68, 41.32, 0.00, '29225', 0.00, 50.00);
INSERT INTO compras_a_proveedor VALUES (1111844, false, '2008-10-31', NULL, -1308131315, '2008-10-30', 12.48, 59.43, 18.09, '63527', 0.00, 90.00);
INSERT INTO compras_a_proveedor VALUES (1111846, false, '2008-10-31', NULL, 15, '2008-10-31', 30.24, 144.02, 0.00, '179341', 0.00, 174.26);
INSERT INTO compras_a_proveedor VALUES (1111847, false, '2008-10-31', NULL, 385, '2008-10-29', 59.47, 283.20, 0.00, '8662', 0.00, 342.67);
INSERT INTO compras_a_proveedor VALUES (1111848, false, '2008-10-31', NULL, 385, '2008-10-29', 337.68, 1608.00, 0.00, '8660', 0.00, 1945.68);
INSERT INTO compras_a_proveedor VALUES (1111849, false, '2008-10-31', NULL, 291, '2008-11-01', 11.98, 57.02, 0.00, '31209', 0.00, 69.00);
INSERT INTO compras_a_proveedor VALUES (1111863, false, '2008-11-01', NULL, 61, '2008-11-01', 0.00, 322.37, 0.00, 'reposicion ch/.', 0.00, 322.37);
INSERT INTO compras_a_proveedor VALUES (1111866, false, '2008-11-01', NULL, 385, '2008-10-30', 225.12, 1072.00, 0.00, '8683', 0.00, 1297.12);
INSERT INTO compras_a_proveedor VALUES (1111869, false, '2008-11-01', NULL, 46, '2008-10-31', 179.91, 856.71, 0.00, '44332', 0.00, 1036.62);
INSERT INTO compras_a_proveedor VALUES (1111870, false, '2008-11-01', NULL, 15, '2008-11-01', 23.33, 111.08, 0.00, '179392', 0.00, 134.41);
INSERT INTO compras_a_proveedor VALUES (1111871, false, '2008-11-01', NULL, 55, '2008-11-01', 35.63, 339.35, 0.00, '36479', 0.00, 374.98);
INSERT INTO compras_a_proveedor VALUES (1111873, false, '2008-11-01', NULL, 12, '2008-10-31', 13.18, 62.75, 0.00, '35871', 0.00, 75.93);
INSERT INTO compras_a_proveedor VALUES (1111875, false, '2008-11-03', NULL, 111, '2008-10-03', 111.70, 531.90, 0.00, '178694', 18.62, 662.22);
INSERT INTO compras_a_proveedor VALUES (1111876, false, '2008-11-03', NULL, -1308131314, '2008-11-03', 123.90, 590.00, 0.00, '75', 0.00, 713.90);
INSERT INTO compras_a_proveedor VALUES (1111879, false, '2008-11-03', NULL, -1308131312, '2008-10-14', 37.80, 180.00, 0.00, '6329', 0.00, 217.80);
INSERT INTO compras_a_proveedor VALUES (1111891, false, '2008-11-04', NULL, 28, '2008-10-31', 128.02, 609.60, 0.00, '8442', 21.33, 758.95);
INSERT INTO compras_a_proveedor VALUES (1111892, false, '2008-11-04', NULL, 114, '2008-10-31', 133.39, 635.20, 0.00, '8336', 0.00, 768.59);
INSERT INTO compras_a_proveedor VALUES (1111893, false, '2008-11-04', NULL, 812, '2008-11-04', 11.75, 55.93, 0.00, '49407', 0.00, 67.68);
INSERT INTO compras_a_proveedor VALUES (1111895, false, '2008-11-04', NULL, 15, '2008-11-04', 10.04, 47.79, 0.00, '179491', 0.00, 57.83);
INSERT INTO compras_a_proveedor VALUES (1111896, false, '2008-11-04', NULL, 15, '2008-10-07', 5.11, 24.35, 0.00, '178202', 0.00, 29.46);
INSERT INTO compras_a_proveedor VALUES (1111897, false, '2008-11-04', NULL, 15, '2008-10-11', 6.27, 29.88, 0.00, '178448', 0.00, 36.15);
INSERT INTO compras_a_proveedor VALUES (1111898, false, '2008-11-04', NULL, 15, '2008-10-15', 9.65, 45.96, 0.00, '178552', 0.00, 55.61);
INSERT INTO compras_a_proveedor VALUES (1111935, false, '2008-11-04', NULL, 219, '2008-10-30', 136.54, 650.17, 0.00, '2879', 0.00, 786.71);
INSERT INTO compras_a_proveedor VALUES (1111841, true, '2008-10-31', NULL, 49, '2008-10-27', 50.95, 242.60, 0.00, '0003-00344608', 0.00, 293.55);
INSERT INTO compras_a_proveedor VALUES (1111990, false, '2008-11-05', NULL, 49, '2008-10-28', 235.23, 1423.03, 0.00, '1882547', 76.19, 1734.45);
INSERT INTO compras_a_proveedor VALUES (1111999, false, '2008-11-06', NULL, 46, '2008-11-05', 143.16, 681.72, 0.00, '44404', 0.00, 824.88);
INSERT INTO compras_a_proveedor VALUES (1112060, false, '2008-11-06', NULL, 80, '2008-10-29', 186.96, 890.30, 0.00, '3101', 0.00, 1077.26);
INSERT INTO compras_a_proveedor VALUES (1112061, false, '2008-11-06', NULL, -1308098560, '2008-11-06', 0.00, 210.20, 0.00, '117', 0.00, 210.20);
INSERT INTO compras_a_proveedor VALUES (1112063, false, '2008-11-06', NULL, 95, '2008-11-06', 3.28, 15.60, 0.00, '118372', 0.00, 18.88);
INSERT INTO compras_a_proveedor VALUES (1112065, false, '2008-11-06', NULL, 15, '2008-11-06', 8.14, 38.76, 0.00, '179617', 0.00, 46.90);
INSERT INTO compras_a_proveedor VALUES (1112066, false, '2008-11-06', NULL, 111, '2008-11-04', 47.99, 228.54, 0.00, '180350', 8.00, 284.53);
INSERT INTO compras_a_proveedor VALUES (1112067, false, '2008-11-06', NULL, 928, '2008-10-29', 6.87, 32.70, 0.00, '32222', 0.00, 39.57);
INSERT INTO compras_a_proveedor VALUES (1112068, false, '2008-11-06', NULL, 928, '2008-10-29', 20.60, 98.11, 0.00, '32223', 0.00, 118.71);
INSERT INTO compras_a_proveedor VALUES (1112069, false, '2008-11-06', NULL, 928, '2008-10-29', 14.70, 70.01, 0.00, '32226', 0.00, 84.71);
INSERT INTO compras_a_proveedor VALUES (1112070, false, '2008-11-06', NULL, 928, '2008-10-31', 0.58, 2.77, 0.00, '32365', 0.00, 3.35);
INSERT INTO compras_a_proveedor VALUES (1112073, false, '2008-11-06', NULL, 20, '2008-10-23', 39.66, 224.42, 0.00, '270.595/2', 3.67, 267.75);
INSERT INTO compras_a_proveedor VALUES (1112076, false, '2008-11-07', NULL, -1308131315, '2008-11-07', 12.06, 57.45, 17.48, '64543', 1.87, 88.86);
INSERT INTO compras_a_proveedor VALUES (1112078, false, '2008-11-07', NULL, 283, '2008-11-07', 0.00, 50.00, 0.00, '614', 0.00, 50.00);
INSERT INTO compras_a_proveedor VALUES (1112090, false, '2008-11-07', NULL, 28, '2008-11-05', 1461.60, 6960.00, 0.00, '8527', 243.60, 8665.20);
INSERT INTO compras_a_proveedor VALUES (1112091, false, '2008-11-07', NULL, 407, '2008-11-06', 51.41, 244.80, 0.00, '23737', 0.00, 296.21);
INSERT INTO compras_a_proveedor VALUES (1112095, false, '2008-11-07', NULL, 15, '2008-11-07', 39.95, 190.22, 0.00, '179688', 0.00, 230.17);
INSERT INTO compras_a_proveedor VALUES (1112150, false, '2008-11-07', NULL, 28, '2008-11-05', 32.00, 152.40, 0.00, '8525', 5.33, 189.73);
INSERT INTO compras_a_proveedor VALUES (1112152, false, '2008-11-08', NULL, 61, '2008-11-06', 99.65, 474.50, 0.00, '74176', 16.61, 590.76);
INSERT INTO compras_a_proveedor VALUES (1112159, false, '2008-11-08', NULL, -1308098559, '2008-11-03', 0.00, 150.00, 0.00, '2212', 0.00, 150.00);
INSERT INTO compras_a_proveedor VALUES (1112180, false, '2008-11-08', NULL, 55, '2008-11-08', 32.78, 312.21, 0.00, '36500', 0.00, 344.99);
INSERT INTO compras_a_proveedor VALUES (1112182, false, '2008-11-08', NULL, 269, '2008-11-07', 25.28, 120.39, 48.08, '20910', 0.00, 193.75);
INSERT INTO compras_a_proveedor VALUES (1112184, false, '2008-11-08', NULL, 15, '2008-11-08', 5.64, 26.86, 0.00, '179726', 0.00, 32.50);
INSERT INTO compras_a_proveedor VALUES (1111878, true, '2008-11-03', NULL, -1308131313, '2008-10-29', 3.80, 36.20, 0.00, '96369', 0.00, 40.00);
INSERT INTO compras_a_proveedor VALUES (1112185, false, '2008-11-08', NULL, -1308131313, '2008-10-29', 11.40, 108.60, 0.00, '96369', 0.00, 120.00);
INSERT INTO compras_a_proveedor VALUES (1112310, false, '2008-11-12', NULL, 114, '2008-11-12', 195.21, 929.56, 0.00, '8386', 0.00, 1124.77);
INSERT INTO compras_a_proveedor VALUES (1112314, false, '2008-11-12', NULL, 15, '2008-11-12', 8.30, 39.50, 0.00, '179856', 0.00, 47.80);
INSERT INTO compras_a_proveedor VALUES (1112315, false, '2008-11-12', NULL, 52, '2008-11-07', 0.00, 39.00, 0.00, '1126', 0.00, 39.00);
INSERT INTO compras_a_proveedor VALUES (1112316, false, '2008-11-12', NULL, 657, '2008-11-12', 47.90, 235.29, 0.00, '3292154/4', 7.98, 291.17);
INSERT INTO compras_a_proveedor VALUES (1112376, false, '2008-11-12', NULL, 256, '2008-10-15', 0.01, 1.85, 0.00, '5-1-250772', 0.07, 1.93);
INSERT INTO compras_a_proveedor VALUES (1112403, false, '2008-11-13', NULL, -1308065792, '2008-10-19', 72.89, 347.14, 0.00, '411', 0.00, 420.03);
INSERT INTO compras_a_proveedor VALUES (1112405, false, '2008-11-13', NULL, 42, '2008-11-10', 0.00, 1056.00, 0.00, '58', 0.00, 1056.00);
INSERT INTO compras_a_proveedor VALUES (1112407, false, '2008-11-13', NULL, 287, '2008-10-31', 0.00, 500.00, 0.00, '324', 0.00, 500.00);
INSERT INTO compras_a_proveedor VALUES (1112408, false, '2008-11-13', NULL, -1308065791, '2008-11-08', 0.00, 48.20, 0.00, '174', 0.00, 48.20);
INSERT INTO compras_a_proveedor VALUES (1112421, false, '2008-11-13', NULL, 995, '2008-11-13', 31.29, 149.00, 0.00, '593', 0.00, 180.29);
INSERT INTO compras_a_proveedor VALUES (1112420, true, '2008-11-13', NULL, 277, '2008-10-03', 44.15, 210.24, 0.00, '3191', 0.00, 254.39);
INSERT INTO compras_a_proveedor VALUES (1112427, false, '2008-11-13', NULL, 4, '2008-11-13', 197.92, 942.48, 0.00, '2804', 32.99, 1173.39);
INSERT INTO compras_a_proveedor VALUES (1112428, false, '2008-11-13', NULL, 4, '2008-11-13', 1781.29, 8482.32, 0.00, '2805', 296.88, 10560.49);
INSERT INTO compras_a_proveedor VALUES (1112508, false, '2008-11-14', NULL, 269, '2008-11-10', 24.27, 115.59, 46.17, '9571', 0.00, 186.03);
INSERT INTO compras_a_proveedor VALUES (1112510, false, '2008-11-14', NULL, 28, '2008-11-11', 480.06, 2286.00, 0.00, '8661', 80.03, 2846.09);
INSERT INTO compras_a_proveedor VALUES (1112511, false, '2008-11-14', NULL, 28, '2008-11-11', 170.48, 811.80, 0.00, '8700', 28.44, 1010.72);
INSERT INTO compras_a_proveedor VALUES (1112512, false, '2008-11-14', NULL, 28, '2008-11-11', 393.12, 1872.00, 0.00, '8655', 65.52, 2330.64);
INSERT INTO compras_a_proveedor VALUES (1112513, false, '2008-11-14', NULL, 103, '2008-11-13', 134.48, 640.40, 0.00, '4210', 0.00, 774.88);
INSERT INTO compras_a_proveedor VALUES (1112514, false, '2008-11-14', NULL, 1, '2008-11-12', 97.65, 465.00, 0.00, '13117', 0.00, 562.65);
INSERT INTO compras_a_proveedor VALUES (1112515, false, '2008-11-14', NULL, 15, '2008-11-14', 35.26, 167.94, 0.00, '179980', 0.00, 203.20);
INSERT INTO compras_a_proveedor VALUES (1112516, false, '2008-11-14', NULL, 407, '2008-11-13', 102.82, 489.60, 0.00, '23791', 0.00, 592.42);
INSERT INTO compras_a_proveedor VALUES (1112518, true, '2008-11-14', NULL, -1308065790, '2008-11-12', 0.00, 170.00, 0.00, '0', 0.00, 170.00);
INSERT INTO compras_a_proveedor VALUES (1112520, false, '2008-11-14', NULL, -1308065790, '2008-11-14', 0.00, 181.00, 0.00, '0', 0.00, 181.00);
INSERT INTO compras_a_proveedor VALUES (1112550, false, '2008-11-15', NULL, -1308033024, '2008-11-14', 0.00, 100.00, 0.00, '3654', 0.00, 100.00);
INSERT INTO compras_a_proveedor VALUES (1112552, false, '2008-11-15', NULL, 15, '2008-11-15', 2.94, 14.00, 0.00, '180032', 0.00, 16.94);
INSERT INTO compras_a_proveedor VALUES (1112553, false, '2008-11-15', NULL, 46, '2008-11-14', 119.94, 571.14, 0.00, '44612', 0.00, 691.08);
INSERT INTO compras_a_proveedor VALUES (1112554, false, '2008-11-17', NULL, -1308033023, '2008-11-17', 147.00, 700.00, 0.00, '933', 0.00, 847.00);
INSERT INTO compras_a_proveedor VALUES (1112603, false, '2008-11-18', NULL, 1, '2008-11-17', 119.38, 568.50, 0.00, '13152', 0.00, 687.88);
INSERT INTO compras_a_proveedor VALUES (1112604, false, '2008-11-18', NULL, 15, '2008-11-18', 3.11, 14.82, 0.00, '180129', 0.00, 17.93);
INSERT INTO compras_a_proveedor VALUES (1112673, false, '2008-11-20', NULL, -1308000256, '2008-11-20', 0.00, 3855.55, 0.00, '1', 0.00, 3855.55);
INSERT INTO compras_a_proveedor VALUES (1112678, false, '2008-11-20', NULL, 4, '2008-11-04', 43.23, 205.87, 0.00, '465631', 7.21, 256.31);
INSERT INTO compras_a_proveedor VALUES (1112679, false, '2008-11-20', NULL, 4, '2008-10-23', 52.00, 247.60, 0.00, '464059', 8.67, 308.27);
INSERT INTO compras_a_proveedor VALUES (1112680, false, '2008-11-20', NULL, 46, '2008-11-18', 77.82, 370.56, 0.00, '44657', 0.00, 448.38);
INSERT INTO compras_a_proveedor VALUES (1112681, false, '2008-11-20', NULL, 269, '2008-11-19', 22.90, 109.04, 44.40, '21978', 0.00, 176.34);
INSERT INTO compras_a_proveedor VALUES (1112683, false, '2008-11-20', NULL, 15, '2008-11-19', 2.64, 12.59, 0.00, '180170', 0.00, 15.23);
INSERT INTO compras_a_proveedor VALUES (1112684, false, '2008-11-20', NULL, 49, '2008-11-11', 2.93, 10.83, 0.00, '228341', 0.00, 13.76);
INSERT INTO compras_a_proveedor VALUES (1112685, false, '2008-11-20', NULL, 55, '2008-11-17', 30.64, 291.85, 0.00, '36627', 0.00, 322.49);
INSERT INTO compras_a_proveedor VALUES (1112689, false, '2008-11-21', NULL, 80, '2008-11-20', 152.88, 728.00, 0.00, '3211', 0.00, 880.88);
INSERT INTO compras_a_proveedor VALUES (1112720, false, '2008-11-21', NULL, 574, '2008-11-21', 19.60, 93.34, 11.17, '39293', 0.00, 124.11);
INSERT INTO compras_a_proveedor VALUES (1112722, false, '2008-11-21', NULL, 61, '2008-11-19', 54.05, 257.40, 0.00, '74460', 9.01, 320.46);
INSERT INTO compras_a_proveedor VALUES (1112723, false, '2008-11-21', NULL, 15, '2008-11-21', 6.37, 30.34, 0.00, '180291', 0.00, 36.71);
INSERT INTO compras_a_proveedor VALUES (1112724, false, '2008-11-21', NULL, 46, '2008-11-20', 46.17, 219.84, 0.00, '44691', 0.00, 266.01);
INSERT INTO compras_a_proveedor VALUES (1112725, false, '2008-11-22', NULL, -1308000255, '2008-11-21', 0.00, 40.00, 0.00, '193', 0.00, 40.00);
INSERT INTO compras_a_proveedor VALUES (1112842, false, '2008-11-24', NULL, 995, '2008-11-24', 102.06, 486.00, 0.00, '0598', 0.00, 588.06);
INSERT INTO compras_a_proveedor VALUES (1112843, false, '2008-11-24', NULL, 55, '2008-11-24', 32.06, 305.42, 0.00, '36648', 0.00, 337.48);
INSERT INTO compras_a_proveedor VALUES (1112850, false, '2008-11-25', NULL, 15, '2008-11-25', 4.86, 23.12, 0.00, '180457', 0.00, 27.98);
INSERT INTO compras_a_proveedor VALUES (1112851, false, '2008-11-25', NULL, 385, '2008-11-21', 127.01, 604.80, 0.00, '8929', 0.00, 731.81);
INSERT INTO compras_a_proveedor VALUES (1112852, false, '2008-11-27', NULL, 80, '2008-11-26', 323.40, 1540.00, 0.00, '3236', 0.00, 1863.40);
INSERT INTO compras_a_proveedor VALUES (1112853, false, '2008-11-27', NULL, -1307967488, '2008-11-25', 12.53, 59.67, 0.00, '15389', 11.30, 83.50);
INSERT INTO compras_a_proveedor VALUES (1112855, false, '2008-11-27', NULL, 668, '2008-11-27', 0.00, 150.00, 0.00, '185', 0.00, 150.00);
INSERT INTO compras_a_proveedor VALUES (1112857, false, '2008-11-27', NULL, -1307967487, '2008-11-25', 7.89, 37.58, 0.00, '24077', 0.01, 45.48);
INSERT INTO compras_a_proveedor VALUES (1112858, false, '2008-11-27', NULL, -1307967487, '2008-11-26', 1.30, 6.18, 0.00, '24084', 0.00, 7.48);
INSERT INTO compras_a_proveedor VALUES (1112859, false, '2008-11-27', NULL, -1307967487, '2008-11-26', 2.44, 11.61, 0.00, '24083', 0.00, 14.05);
INSERT INTO compras_a_proveedor VALUES (1112981, false, '2008-11-27', NULL, 15, '2008-11-27', 2.72, 12.93, 0.00, '180570', 0.00, 15.65);
INSERT INTO compras_a_proveedor VALUES (1112982, false, '2008-11-27', NULL, 103, '2008-11-27', 87.81, 418.15, 0.00, '4276', 0.00, 505.96);
INSERT INTO compras_a_proveedor VALUES (1112983, false, '2008-11-28', NULL, 114, '2008-11-26', 327.76, 1560.76, 0.00, '8485', 0.00, 1888.52);
INSERT INTO compras_a_proveedor VALUES (1112989, false, '2008-11-28', NULL, 385, '2008-11-26', 287.11, 1367.20, 0.00, '8986', 0.00, 1654.31);
INSERT INTO compras_a_proveedor VALUES (1112990, false, '2008-11-28', NULL, 15, '2008-11-28', 31.90, 151.89, 0.00, '180634', 0.00, 183.79);
INSERT INTO compras_a_proveedor VALUES (1112991, true, '2008-11-28', NULL, -1307967486, '2008-11-28', 0.00, 87.00, 0.00, '64034', 0.00, 87.00);
INSERT INTO compras_a_proveedor VALUES (1113063, false, '2008-12-02', NULL, 55, '2008-12-01', 32.06, 305.42, 0.00, '36721', 0.00, 337.48);
INSERT INTO compras_a_proveedor VALUES (1113065, false, '2008-12-02', NULL, 291, '2008-12-01', 11.98, 57.02, 0.00, '31700', 0.00, 69.00);
INSERT INTO compras_a_proveedor VALUES (1113066, false, '2008-12-02', NULL, 46, '2008-11-28', 119.94, 571.14, 0.00, '44800', 0.00, 691.08);
INSERT INTO compras_a_proveedor VALUES (1113067, false, '2008-12-02', NULL, 15, '2008-11-29', 2.94, 14.00, 0.00, '180703', 0.00, 16.94);
INSERT INTO compras_a_proveedor VALUES (1113068, true, '2008-12-02', NULL, 295, '2008-11-04', 0.00, 91.00, 0.00, '145473267', 0.00, 91.00);
INSERT INTO compras_a_proveedor VALUES (1113080, false, '2008-12-02', NULL, 295, '2008-11-04', 0.00, 91.00, 0.00, '473267', 0.00, 91.00);
INSERT INTO compras_a_proveedor VALUES (1113081, true, '2008-12-02', NULL, 295, '2008-11-04', 0.00, 91.00, 0.00, '473267', 0.00, 91.00);
INSERT INTO compras_a_proveedor VALUES (1113082, false, '2008-12-02', NULL, -1307967486, '2008-11-26', 0.00, 87.00, 0.00, '64034', 0.00, 87.00);
INSERT INTO compras_a_proveedor VALUES (1113084, false, '2008-12-02', NULL, 776, '2008-11-26', 9.69, 92.31, 0.00, '561406', 0.00, 102.00);
INSERT INTO compras_a_proveedor VALUES (1113086, false, '2008-12-02', NULL, 295, '2008-11-07', 0.00, 91.00, 0.00, '273436', 0.00, 91.00);
INSERT INTO compras_a_proveedor VALUES (1113088, false, '2008-12-02', NULL, -1307934720, '2008-11-28', 0.00, 10.00, 0.00, '805', 0.00, 10.00);
INSERT INTO compras_a_proveedor VALUES (1113090, false, '2008-12-02', NULL, 20, '2008-11-25', 41.77, 235.88, 0.00, '292.729/5', 3.85, 281.50);
INSERT INTO compras_a_proveedor VALUES (1113091, false, '2008-12-02', NULL, -1308131312, '2008-11-08', 10.50, 50.00, 0.00, '6378', 0.00, 60.50);
INSERT INTO compras_a_proveedor VALUES (1113094, false, '2008-12-02', NULL, 269, '2008-12-01', 13.16, 62.65, 19.41, '23272', 0.00, 95.22);
INSERT INTO compras_a_proveedor VALUES (1113096, false, '2008-12-02', NULL, 295, '2008-11-04', 0.00, 91.00, 0.00, '473268', 0.00, 91.00);
INSERT INTO compras_a_proveedor VALUES (1113098, false, '2008-12-03', NULL, 407, '2008-12-02', 97.34, 463.50, 0.00, '23970', 0.00, 560.84);
INSERT INTO compras_a_proveedor VALUES (1113102, false, '2008-12-03', NULL, 1, '2008-12-02', 19.99, 95.20, 0.00, '13307', 0.00, 115.19);
INSERT INTO compras_a_proveedor VALUES (1113103, false, '2008-12-03', NULL, 15, '2008-12-03', 16.61, 79.09, 0.00, '180873', 0.00, 95.70);
INSERT INTO compras_a_proveedor VALUES (1113104, false, '2008-12-04', NULL, -1307934719, '2008-12-02', 1155.21, 5501.02, 0.00, '34190', 192.54, 6848.77);
INSERT INTO compras_a_proveedor VALUES (1113105, false, '2008-12-04', NULL, 283, '2008-12-04', 0.00, 50.00, 0.00, '618', 0.00, 50.00);
INSERT INTO compras_a_proveedor VALUES (1113107, false, '2008-12-04', NULL, 15, '2008-12-04', 28.82, 137.24, 0.00, '180943', 0.00, 166.06);
INSERT INTO compras_a_proveedor VALUES (1113201, false, '2008-12-05', NULL, 219, '2008-11-28', 126.83, 603.94, 0.00, '3093', 0.00, 730.77);
INSERT INTO compras_a_proveedor VALUES (1113280, false, '2008-12-09', NULL, 269, '2008-12-09', 26.71, 127.18, 0.00, '24198', 0.00, 153.89);
INSERT INTO compras_a_proveedor VALUES (1113282, false, '2008-12-09', NULL, 269, '2008-12-04', 24.15, 114.99, 46.82, '23768', 0.00, 185.96);
INSERT INTO compras_a_proveedor VALUES (1113284, false, '2008-12-09', NULL, 269, '2008-11-29', 24.99, 119.02, 48.47, '23022', 0.00, 192.48);
INSERT INTO compras_a_proveedor VALUES (1113286, false, '2008-12-09', NULL, -1307901952, '2008-12-01', 20.43, 97.29, 42.31, '1281', 0.00, 160.03);
INSERT INTO compras_a_proveedor VALUES (1113288, false, '2008-12-09', NULL, -1307901951, '2008-12-03', 8.99, 42.79, 18.22, '410', 0.00, 70.00);
INSERT INTO compras_a_proveedor VALUES (1113290, false, '2008-12-09', NULL, -1307901950, '2008-11-29', 18.62, 88.69, 37.70, '45994', 0.00, 145.01);
INSERT INTO compras_a_proveedor VALUES (1113292, false, '2008-12-09', NULL, -1307901950, '2008-12-03', 19.92, 94.84, 40.31, '28318', 0.00, 155.07);
INSERT INTO compras_a_proveedor VALUES (1113294, false, '2008-12-09', NULL, 574, '2008-12-09', 8.79, 41.87, 6.36, '39949', 0.00, 57.02);
INSERT INTO compras_a_proveedor VALUES (1113296, false, '2008-12-09', NULL, 15, '2008-12-06', 22.54, 107.37, 0.00, '181034', 0.00, 129.91);
INSERT INTO compras_a_proveedor VALUES (1113297, false, '2008-12-09', NULL, 1, '2008-12-05', 59.85, 285.00, 0.00, '13344', 0.00, 344.85);
INSERT INTO compras_a_proveedor VALUES (1113298, false, '2008-12-09', NULL, 111, '2008-12-04', 77.89, 370.92, 0.00, '181997', 12.98, 461.79);
INSERT INTO compras_a_proveedor VALUES (1113299, false, '2008-12-09', NULL, 103, '2008-12-04', 246.71, 1174.80, 0.00, '4305', 0.00, 1421.51);
INSERT INTO compras_a_proveedor VALUES (1113300, false, '2008-12-09', NULL, 55, '2008-12-09', 30.64, 291.85, 0.00, '36742', 0.00, 322.49);
INSERT INTO compras_a_proveedor VALUES (1113303, false, '2008-12-09', NULL, 98, '2008-12-05', 0.00, 135.00, 0.00, '299', 0.00, 135.00);
INSERT INTO compras_a_proveedor VALUES (1113305, false, '2008-12-09', NULL, 80, '2008-12-04', 109.54, 521.63, 0.00, '3275', 0.00, 631.17);
INSERT INTO compras_a_proveedor VALUES (1113306, false, '2008-12-09', NULL, 42, '2008-12-04', 0.00, 1056.00, 0.00, '61', 0.00, 1056.00);
INSERT INTO compras_a_proveedor VALUES (1113308, false, '2008-12-09', NULL, 269, '2008-09-07', 16.87, 80.33, 37.81, '15282', 2.95, 137.96);
INSERT INTO compras_a_proveedor VALUES (1113310, false, '2008-12-09', NULL, 269, '2008-09-21', 16.21, 77.17, 38.64, '16575', 2.90, 134.92);
INSERT INTO compras_a_proveedor VALUES (1113312, false, '2008-12-09', NULL, 269, '2008-10-02', 17.19, 81.84, 40.97, '8086', 3.07, 143.07);
INSERT INTO compras_a_proveedor VALUES (1113314, false, '2008-12-09', NULL, 269, '2008-10-05', 18.11, 86.26, 43.19, '17750', 3.24, 150.80);
INSERT INTO compras_a_proveedor VALUES (1113316, false, '2008-12-09', NULL, 928, '2008-11-27', 1.94, 9.25, 0.00, '32843', 0.00, 11.19);
INSERT INTO compras_a_proveedor VALUES (1113317, false, '2008-12-09', NULL, 928, '2008-11-27', 4.83, 22.98, 0.00, '33422', 0.00, 27.81);
INSERT INTO compras_a_proveedor VALUES (1113318, false, '2008-12-09', NULL, -1308164093, '2008-11-13', 17.15, 148.85, 0.00, '81113', 0.00, 166.00);
INSERT INTO compras_a_proveedor VALUES (1113319, false, '2008-12-09', NULL, -1307901949, '2008-10-09', 71.16, 338.84, 0.00, '18477', 0.00, 410.00);
INSERT INTO compras_a_proveedor VALUES (1113321, false, '2008-12-09', NULL, -1307901948, '2008-12-07', 4.95, 23.55, 0.00, '12545', 0.00, 28.50);
INSERT INTO compras_a_proveedor VALUES (1113323, false, '2008-12-10', NULL, 4, '2008-12-10', 1368.74, 6517.80, 0.00, '2840', 228.12, 8114.66);
INSERT INTO compras_a_proveedor VALUES (1113340, false, '2008-12-11', NULL, 111, '2008-12-09', 124.49, 592.80, 0.00, '182107', 20.75, 738.04);
INSERT INTO compras_a_proveedor VALUES (1113341, false, '2008-12-11', NULL, 385, '2008-12-09', 443.52, 2112.00, 0.00, '9098', 0.00, 2555.52);
INSERT INTO compras_a_proveedor VALUES (1113342, false, '2008-12-11', NULL, 15, '2008-12-11', 44.11, 210.05, 0.00, '181165', 0.00, 254.16);
INSERT INTO compras_a_proveedor VALUES (1113343, false, '2008-12-11', NULL, 399, '2008-12-10', 0.00, 204.50, 0.00, '35079', 0.00, 204.50);
INSERT INTO compras_a_proveedor VALUES (1113345, false, '2008-12-11', NULL, 1, '2008-12-02', 257.25, 1225.00, 0.00, '13297', 0.00, 1482.25);
INSERT INTO compras_a_proveedor VALUES (1113346, false, '2008-12-11', NULL, -1308098559, '2008-12-01', 0.00, 150.00, 0.00, '2237', 0.00, 150.00);
INSERT INTO compras_a_proveedor VALUES (1113348, false, '2008-12-11', NULL, -1307967487, '2008-12-10', 16.34, 77.84, 0.00, '24205', 0.00, 94.18);
INSERT INTO compras_a_proveedor VALUES (1113430, false, '2008-12-11', NULL, 269, '2008-10-07', 6.14, 29.23, 14.64, '17886', 0.00, 50.01);
INSERT INTO compras_a_proveedor VALUES (1113432, false, '2008-12-11', NULL, 269, '2008-10-13', 6.08, 28.96, 14.98, '18501', 0.00, 50.02);
INSERT INTO compras_a_proveedor VALUES (1113434, false, '2008-12-11', NULL, 269, '2008-10-13', 9.03, 42.98, 0.00, '18537', 0.00, 52.01);
INSERT INTO compras_a_proveedor VALUES (1113436, false, '2008-12-11', NULL, 269, '2008-10-18', 6.16, 29.35, 14.55, '18984', 0.00, 50.06);
INSERT INTO compras_a_proveedor VALUES (1113438, false, '2008-12-11', NULL, 269, '2008-10-27', 6.16, 29.31, 14.53, '19728', 0.00, 50.00);
INSERT INTO compras_a_proveedor VALUES (1113440, false, '2008-12-11', NULL, 269, '2008-10-24', 18.16, 86.46, 42.88, '8910', 0.00, 147.50);
INSERT INTO compras_a_proveedor VALUES (1113442, false, '2008-12-11', NULL, 269, '2008-10-30', 6.16, 29.33, 14.54, '20048', 0.00, 50.03);
INSERT INTO compras_a_proveedor VALUES (1113444, false, '2008-12-11', NULL, 269, '2008-11-02', 17.95, 85.48, 41.57, '20390', 0.00, 145.00);
INSERT INTO compras_a_proveedor VALUES (1113446, false, '2008-12-11', NULL, 269, '2008-11-02', 11.08, 52.78, 26.17, '20391', 0.00, 90.03);
INSERT INTO compras_a_proveedor VALUES (1113448, false, '2008-12-11', NULL, 269, '2008-11-16', 19.70, 93.81, 47.49, '21747', 0.00, 161.00);
INSERT INTO compras_a_proveedor VALUES (1113450, false, '2008-12-11', NULL, 269, '2008-11-16', 17.62, 83.91, 42.47, '21713', 0.00, 144.00);
INSERT INTO compras_a_proveedor VALUES (1113452, false, '2008-12-11', NULL, 269, '2008-11-23', 14.93, 71.09, 35.98, '22388', 0.00, 122.00);
INSERT INTO compras_a_proveedor VALUES (1113454, false, '2008-12-11', NULL, 269, '2008-12-07', 17.75, 84.50, 42.77, '24082', 0.00, 145.02);
INSERT INTO compras_a_proveedor VALUES (1113456, false, '2008-12-11', NULL, 269, '2008-12-07', 19.58, 93.24, 47.20, '24081', 0.00, 160.02);
INSERT INTO compras_a_proveedor VALUES (1113458, false, '2008-12-11', NULL, 630, '2008-12-02', 106.47, 507.00, 0.00, '31742', 0.00, 613.47);
INSERT INTO compras_a_proveedor VALUES (1113462, false, '2008-12-11', NULL, 287, '2008-11-30', 0.00, 500.00, 0.00, '347', 0.00, 500.00);
INSERT INTO compras_a_proveedor VALUES (1113470, false, '2008-12-12', NULL, 52, '2008-12-09', 0.00, 217.50, 0.00, '1146', 0.00, 217.50);
INSERT INTO compras_a_proveedor VALUES (1113471, false, '2008-12-12', NULL, 385, '2008-12-11', 384.30, 1830.00, 0.00, '9128', 0.00, 2214.30);
INSERT INTO compras_a_proveedor VALUES (1113472, false, '2008-12-12', NULL, 28, '2008-12-10', 1395.45, 6645.00, 0.00, '9164', 232.59, 8273.04);
INSERT INTO compras_a_proveedor VALUES (1113473, false, '2008-12-12', NULL, 15, '2008-12-12', 68.90, 328.08, 0.00, '181257', 0.00, 396.98);
INSERT INTO compras_a_proveedor VALUES (1113474, false, '2008-12-12', NULL, 1, '2008-12-11', 485.10, 2310.00, 0.00, '13364', 0.00, 2795.10);
INSERT INTO compras_a_proveedor VALUES (1113530, false, '2008-12-15', NULL, -1307869184, '2008-12-12', 14.09, 67.11, 28.82, '13425', 0.19, 110.21);
INSERT INTO compras_a_proveedor VALUES (1113532, false, '2008-12-15', NULL, -1307869183, '2008-12-11', 17.45, 83.08, 34.48, '11918', 0.00, 135.01);
INSERT INTO compras_a_proveedor VALUES (1113535, false, '2008-12-15', NULL, 269, '2008-12-10', 22.08, 105.12, 42.80, '24380', 0.00, 170.00);
INSERT INTO compras_a_proveedor VALUES (1113537, false, '2008-12-15', NULL, -1307869182, '2008-12-12', 11.06, 52.66, 19.81, '46658', 1.52, 85.05);
INSERT INTO compras_a_proveedor VALUES (1113539, false, '2008-12-15', NULL, 536, '2008-12-11', 0.00, 2.10, 0.00, '451851', 0.00, 2.10);
INSERT INTO compras_a_proveedor VALUES (1113551, false, '2008-12-15', NULL, -1307869181, '2008-12-15', 61.34, 292.08, 0.00, '1991', 0.00, 353.42);
INSERT INTO compras_a_proveedor VALUES (1113552, false, '2008-12-15', NULL, -1307869180, '2008-12-02', 0.00, 275.60, 0.00, '127184', 0.00, 275.60);
INSERT INTO compras_a_proveedor VALUES (1113637, false, '2008-12-16', NULL, -1307836416, '2008-12-16', 6.33, 30.17, 0.00, '4647', 0.00, 36.50);
INSERT INTO compras_a_proveedor VALUES (1113639, false, '2008-12-16', NULL, 4, '2008-11-30', 52.00, 247.60, 0.00, '469678', 8.67, 308.27);
INSERT INTO compras_a_proveedor VALUES (1113650, false, '2008-12-16', NULL, 55, '2008-12-16', 32.06, 305.42, 0.00, '36862', 0.00, 337.48);
INSERT INTO compras_a_proveedor VALUES (1113654, false, '2008-12-17', NULL, 277, '2008-12-17', 22.68, 108.00, 0.00, '3475', 0.00, 130.68);
INSERT INTO compras_a_proveedor VALUES (1113723, false, '2008-12-19', NULL, 269, '2008-12-06', 9.68, 46.09, 14.28, '23981', 0.00, 70.05);
INSERT INTO compras_a_proveedor VALUES (1113725, false, '2008-12-19', NULL, 80, '2008-12-16', 47.92, 228.17, 0.00, '3303', 0.00, 276.09);
INSERT INTO compras_a_proveedor VALUES (1113726, false, '2008-12-19', NULL, -1307836415, '2008-12-18', 14.44, 68.77, 0.00, '7973', 0.00, 83.21);
INSERT INTO compras_a_proveedor VALUES (1113728, false, '2008-12-19', NULL, 15, '2008-12-18', 9.36, 44.59, 0.00, '181523', 0.00, 53.95);
INSERT INTO compras_a_proveedor VALUES (1113729, false, '2008-12-19', NULL, 28, '2008-12-16', 246.33, 1173.00, 0.00, '9273', 41.07, 1460.40);
INSERT INTO compras_a_proveedor VALUES (1113730, false, '2008-12-19', NULL, 269, '2008-12-18', 13.11, 62.43, 19.48, '25313', 0.00, 95.02);
INSERT INTO compras_a_proveedor VALUES (1113732, false, '2008-12-19', NULL, 15, '2008-12-19', 28.68, 136.57, 0.00, '181591', 0.00, 165.25);
INSERT INTO compras_a_proveedor VALUES (1113733, false, '2008-12-19', NULL, 385, '2008-12-19', 435.62, 2074.40, 0.00, '9202', 0.00, 2510.02);
INSERT INTO compras_a_proveedor VALUES (1113735, false, '2008-12-20', NULL, 28, '2008-12-20', 556.77, 2651.25, 0.00, '9296', 92.80, 3300.82);
INSERT INTO compras_a_proveedor VALUES (1113736, false, '2008-12-20', NULL, 28, '2008-12-20', 557.58, 2655.12, 0.00, '9326', 92.90, 3305.60);
INSERT INTO compras_a_proveedor VALUES (1113737, false, '2008-12-20', NULL, 28, '2008-12-18', 375.35, 1787.40, 0.00, '9327', 62.56, 2225.31);
INSERT INTO compras_a_proveedor VALUES (1113738, false, '2008-12-20', NULL, 15, '2008-12-20', 33.63, 160.16, 0.00, '181649', 0.00, 193.79);
INSERT INTO compras_a_proveedor VALUES (1113771, true, '2008-12-22', NULL, 1233, '2008-02-11', 130.20, 4845.00, 443.63, '30682', 121.13, 5539.96);
INSERT INTO compras_a_proveedor VALUES (1113774, false, '2008-12-23', NULL, -1307836414, '2008-12-22', 0.00, 100.00, 0.00, '618', 0.00, 100.00);
INSERT INTO compras_a_proveedor VALUES (1113776, false, '2008-12-23', NULL, -1307836413, '2008-12-22', 33.33, 158.70, 0.00, '2423', 0.00, 192.03);
INSERT INTO compras_a_proveedor VALUES (1113778, false, '2008-12-23', NULL, 269, '2008-12-23', 24.94, 118.78, 49.29, '25323', 4.20, 197.21);
INSERT INTO compras_a_proveedor VALUES (1113790, false, '2008-12-23', NULL, 55, '2008-12-23', 30.64, 291.85, 0.00, '36890', 0.00, 322.49);
INSERT INTO compras_a_proveedor VALUES (1113792, false, '2008-12-23', NULL, 80, '2008-12-22', 95.61, 455.28, 0.00, '3333', 0.00, 550.89);
INSERT INTO compras_a_proveedor VALUES (1113793, false, '2008-12-23', NULL, 4, '2008-12-04', 43.23, 205.87, 0.00, '469784', 7.21, 256.31);
INSERT INTO compras_a_proveedor VALUES (1113794, false, '2008-12-23', NULL, 1, '2008-03-03', 100.25, 477.39, 0.00, '10930', 0.00, 577.64);
INSERT INTO compras_a_proveedor VALUES (1113796, false, '2008-12-23', NULL, 1, '2008-03-19', 109.88, 523.25, 0.00, '11061', 0.00, 633.13);
INSERT INTO compras_a_proveedor VALUES (1113798, false, '2008-12-23', NULL, 1, '2008-03-27', 241.29, 1149.00, 0.00, '11102', 0.00, 1390.29);
INSERT INTO compras_a_proveedor VALUES (1113800, false, '2008-12-23', NULL, 211, '2008-03-04', 42.34, 201.60, 0.00, '39849', 0.00, 243.94);
INSERT INTO compras_a_proveedor VALUES (1113802, false, '2008-12-23', NULL, 211, '2008-03-28', 36.96, 176.02, 0.00, '40122', 0.00, 212.98);
INSERT INTO compras_a_proveedor VALUES (1113804, false, '2008-12-23', NULL, 28, '2008-03-03', 330.56, 1574.10, 0.00, '1931', 39.35, 1944.01);
INSERT INTO compras_a_proveedor VALUES (1113806, false, '2008-12-23', NULL, 28, '2008-03-19', 724.45, 3449.75, 0.00, '2273', 86.26, 4260.46);
INSERT INTO compras_a_proveedor VALUES (1113810, false, '2008-12-23', NULL, -1308164094, '2008-03-03', 40.23, 191.60, 0.00, '239', 0.00, 231.83);
INSERT INTO compras_a_proveedor VALUES (1113812, false, '2008-12-23', NULL, -1308164094, '2008-03-03', 44.69, 212.80, 0.00, '14832', 0.00, 257.49);
INSERT INTO compras_a_proveedor VALUES (1113813, true, '2008-12-23', NULL, -1308164094, '2008-03-03', 44.69, 212.80, 0.00, '14832', 0.00, 257.49);
INSERT INTO compras_a_proveedor VALUES (1113815, false, '2008-12-23', NULL, 46, '2008-03-17', 152.30, 725.23, 0.00, '39744', 0.00, 877.53);
INSERT INTO compras_a_proveedor VALUES (1113817, false, '2008-12-23', NULL, 114, '2008-03-12', 140.87, 670.80, 0.00, '6928', 0.00, 811.67);
INSERT INTO compras_a_proveedor VALUES (1113819, false, '2008-12-23', NULL, 995, '2008-03-04', 322.89, 1537.60, 0.00, '509', 0.00, 1860.49);
INSERT INTO compras_a_proveedor VALUES (1113821, false, '2008-12-23', NULL, 995, '2008-03-13', 112.66, 536.50, 0.00, '512', 0.00, 649.16);
INSERT INTO compras_a_proveedor VALUES (1113823, false, '2008-12-23', NULL, 114, '2008-03-26', 27.30, 130.00, 0.00, '6998', 0.00, 157.30);
INSERT INTO compras_a_proveedor VALUES (1113825, false, '2008-12-23', NULL, 385, '2008-03-06', 117.94, 561.60, 0.00, '6343', 0.00, 679.54);
INSERT INTO compras_a_proveedor VALUES (1113827, false, '2008-12-23', NULL, 385, '2008-03-07', 150.53, 716.80, 0.00, '6351', 0.00, 867.33);
INSERT INTO compras_a_proveedor VALUES (1113829, false, '2008-12-23', NULL, 61, '2008-03-11', 255.74, 1217.80, 0.00, '67849', 30.45, 1503.99);
INSERT INTO compras_a_proveedor VALUES (1113831, false, '2008-12-23', NULL, 61, '2008-03-13', 99.70, 474.75, 0.00, '67970', 11.87, 586.32);
INSERT INTO compras_a_proveedor VALUES (1113833, false, '2008-12-23', NULL, 55, '2008-03-08', 39.44, 375.56, 0.00, '34233', 0.00, 415.00);
INSERT INTO compras_a_proveedor VALUES (1113835, false, '2008-12-23', NULL, 55, '2008-03-25', 39.44, 375.56, 0.00, '34293', 0.00, 415.00);
INSERT INTO compras_a_proveedor VALUES (1113837, false, '2008-12-23', NULL, 4, '2008-03-07', 1624.58, 7736.10, 0.00, '2533', 193.40, 9554.08);
INSERT INTO compras_a_proveedor VALUES (1113839, false, '2008-12-23', NULL, 4, '2008-03-19', 21.64, 103.04, 0.00, '431551', 2.58, 127.26);
INSERT INTO compras_a_proveedor VALUES (1113841, false, '2008-12-23', NULL, 4, '2008-03-04', 29.11, 138.60, 0.00, '431656', 3.47, 171.18);
INSERT INTO compras_a_proveedor VALUES (1113843, false, '2008-12-23', NULL, 4, '2008-03-26', 1680.36, 8001.70, 0.00, '433702', 200.04, 9882.10);
INSERT INTO compras_a_proveedor VALUES (1113845, false, '2008-12-23', NULL, 4, '2008-03-27', 1284.72, 6117.70, 0.00, '2551', 152.94, 7555.36);
INSERT INTO compras_a_proveedor VALUES (1113847, false, '2008-12-23', NULL, 111, '2008-03-07', 22.43, 106.82, 0.00, '164854', 2.67, 131.92);
INSERT INTO compras_a_proveedor VALUES (1113849, false, '2008-12-23', NULL, 111, '2008-03-13', 244.36, 1163.60, 0.00, '165212', 29.09, 1437.05);
INSERT INTO compras_a_proveedor VALUES (1113851, false, '2008-12-23', NULL, 111, '2008-03-13', 22.43, 106.82, 0.00, '165175', 2.67, 131.92);
INSERT INTO compras_a_proveedor VALUES (1113853, false, '2008-12-23', NULL, 111, '2008-03-28', 55.36, 263.60, 0.00, '165982', 6.59, 325.55);
INSERT INTO compras_a_proveedor VALUES (1113855, false, '2008-12-23', NULL, 407, '2008-03-04', 65.10, 310.00, 0.00, '19954', 0.00, 375.10);
INSERT INTO compras_a_proveedor VALUES (1113857, false, '2008-12-23', NULL, 269, '2008-03-16', 18.73, 89.20, 40.10, '2051', 3.23, 151.26);
INSERT INTO compras_a_proveedor VALUES (1113859, false, '2008-12-23', NULL, 269, '2008-03-30', 8.58, 40.86, 23.56, '2770', 1.61, 74.61);
INSERT INTO compras_a_proveedor VALUES (1113861, false, '2008-12-23', NULL, 269, '2008-03-02', 17.51, 83.36, 39.12, '1303', 3.06, 143.05);
INSERT INTO compras_a_proveedor VALUES (1113863, false, '2008-12-23', NULL, 269, '2008-03-18', 6.93, 32.98, 10.22, '2152', 0.00, 50.13);
INSERT INTO compras_a_proveedor VALUES (1113865, false, '2008-12-23', NULL, 269, '2008-03-12', 6.91, 32.90, 10.20, '1804', 0.00, 50.01);
INSERT INTO compras_a_proveedor VALUES (1113867, false, '2008-12-23', NULL, -1308131315, '2008-03-13', 6.91, 32.90, 10.20, '42624', 0.00, 50.01);
INSERT INTO compras_a_proveedor VALUES (1113869, false, '2008-12-23', NULL, 269, '2008-03-07', 6.80, 32.40, 10.80, '1613', 0.00, 50.00);
INSERT INTO compras_a_proveedor VALUES (1113871, false, '2008-12-23', NULL, 269, '2008-03-14', 5.60, 26.65, 7.75, '1950', 0.00, 40.00);
INSERT INTO compras_a_proveedor VALUES (1113873, false, '2008-12-23', NULL, 269, '2008-03-16', 15.19, 72.31, 32.50, '2056', 2.62, 122.62);
INSERT INTO compras_a_proveedor VALUES (1113875, false, '2008-12-23', NULL, -1308131315, '2008-03-27', 9.42, 44.87, 13.91, '6091', 1.47, 69.67);
INSERT INTO compras_a_proveedor VALUES (1113877, false, '2008-12-23', NULL, 15, '2008-03-04', 7.37, 35.08, 0.00, '168447', 0.00, 42.45);
INSERT INTO compras_a_proveedor VALUES (1113879, false, '2008-12-23', NULL, 15, '2008-03-06', 4.91, 23.39, 0.00, '168543', 0.00, 28.30);
INSERT INTO compras_a_proveedor VALUES (1113881, false, '2008-12-23', NULL, 15, '2008-03-08', 2.78, 13.26, 0.00, '168647', 0.00, 16.04);
INSERT INTO compras_a_proveedor VALUES (1113883, false, '2008-12-23', NULL, 15, '2008-03-11', 11.03, 52.49, 0.00, '168730', 0.00, 63.52);
INSERT INTO compras_a_proveedor VALUES (1113885, false, '2008-12-23', NULL, 15, '2008-03-13', 9.58, 45.59, 0.00, '168858', 0.00, 55.17);
INSERT INTO compras_a_proveedor VALUES (1113890, false, '2008-12-24', NULL, 15, '2008-03-15', 20.18, 96.08, 0.00, '168982', 0.00, 116.26);
INSERT INTO compras_a_proveedor VALUES (1113892, false, '2008-12-24', NULL, 15, '2008-03-19', 18.42, 87.70, 0.00, '169152', 0.00, 106.12);
INSERT INTO compras_a_proveedor VALUES (1113894, false, '2008-12-24', NULL, 15, '2008-03-18', 14.88, 70.87, 0.00, '169094', 0.00, 85.75);
INSERT INTO compras_a_proveedor VALUES (1113896, false, '2008-12-24', NULL, 15, '2008-03-20', 5.02, 23.93, 0.00, '169205', 0.00, 28.95);
INSERT INTO compras_a_proveedor VALUES (1113900, false, '2008-12-24', NULL, 15, '2008-03-27', 16.78, 79.92, 0.00, '169430', 0.00, 96.70);
INSERT INTO compras_a_proveedor VALUES (1113898, true, '2008-12-24', NULL, 15, '2008-03-27', 16.78, 79.92, 0.00, '169430', 0.00, 96.70);
INSERT INTO compras_a_proveedor VALUES (1113902, false, '2008-12-24', NULL, 15, '2008-03-28', 13.52, 64.40, 0.00, '169453', 0.00, 77.92);
INSERT INTO compras_a_proveedor VALUES (1113904, false, '2008-12-24', NULL, -1307803648, '2008-03-04', 4.47, 21.30, 0.00, '57566', 0.00, 25.77);
INSERT INTO compras_a_proveedor VALUES (1113906, false, '2008-12-24', NULL, 95, '2008-03-06', 2.52, 12.00, 0.00, '104970', 0.00, 14.52);
INSERT INTO compras_a_proveedor VALUES (1113908, false, '2008-12-24', NULL, 61, '2008-12-22', 148.01, 704.80, 0.00, '75040', 24.67, 877.48);
INSERT INTO compras_a_proveedor VALUES (1113923, false, '2008-12-24', NULL, 49, '2008-12-11', 0.00, 14.25, 0.00, '9478', 0.00, 14.25);
INSERT INTO compras_a_proveedor VALUES (1113924, false, '2008-12-24', NULL, 15, '2008-12-24', 12.24, 58.29, 0.00, '181815', 0.00, 70.53);
INSERT INTO compras_a_proveedor VALUES (1113925, false, '2008-12-24', NULL, 28, '2008-12-22', 115.31, 549.10, 0.00, '9361', 19.21, 683.62);
INSERT INTO compras_a_proveedor VALUES (1113926, false, '2008-12-24', NULL, -1307803646, '2008-03-28', 0.00, 50.00, 0.00, '11', 0.00, 50.00);
INSERT INTO compras_a_proveedor VALUES (1113928, false, '2008-12-24', NULL, -1307803645, '2008-03-09', 31.24, 148.76, 0.00, '3360', 0.00, 180.00);
INSERT INTO compras_a_proveedor VALUES (1113970, false, '2008-12-26', NULL, -1307770880, '2008-03-13', 51.89, 247.11, 0.00, '609', 0.00, 299.00);
INSERT INTO compras_a_proveedor VALUES (1113972, false, '2008-12-26', NULL, 536, '2008-03-04', 0.00, 2.20, 0.00, '710679', 0.00, 2.20);
INSERT INTO compras_a_proveedor VALUES (1113974, false, '2008-12-26', NULL, 536, '2008-03-04', 0.00, 2.20, 0.00, '842869', 0.00, 2.20);
INSERT INTO compras_a_proveedor VALUES (1113976, false, '2008-12-26', NULL, 630, '2008-03-20', 119.07, 567.00, 0.00, '29421', 0.00, 686.07);
INSERT INTO compras_a_proveedor VALUES (1113978, false, '2008-12-26', NULL, 1048, '2008-03-28', 4.47, 21.33, 0.00, '7302', 0.00, 25.80);
INSERT INTO compras_a_proveedor VALUES (1113980, false, '2008-12-26', NULL, -1308164091, '2008-03-19', 7.98, 38.02, 0.00, '1973', 0.00, 46.00);
INSERT INTO compras_a_proveedor VALUES (1113982, true, '2008-12-26', NULL, 928, '2008-03-20', 0.00, 62.80, 0.00, '35205', 0.00, 62.80);
INSERT INTO compras_a_proveedor VALUES (1113986, false, '2008-12-26', NULL, 12, '2008-03-15', 7.78, 37.05, 0.00, '34443', 0.00, 44.83);
INSERT INTO compras_a_proveedor VALUES (1113988, false, '2008-12-26', NULL, 12, '2008-03-26', 7.89, 37.57, 0.00, '34385', 0.00, 45.46);
INSERT INTO compras_a_proveedor VALUES (1113990, false, '2008-12-26', NULL, 12, '2008-03-29', 22.22, 105.80, 0.00, '34966', 0.00, 128.02);
INSERT INTO compras_a_proveedor VALUES (1113992, false, '2008-12-26', NULL, 24, '2008-03-07', 0.00, 960.00, 0.00, '177750', 0.00, 960.00);
INSERT INTO compras_a_proveedor VALUES (1114030, false, '2008-12-26', NULL, 49, '2008-02-28', 149.71, 667.72, 22.80, '749501', 16.69, 856.92);
INSERT INTO compras_a_proveedor VALUES (1114032, false, '2008-12-26', NULL, -1308164093, '2008-02-13', 0.00, 218.79, 0.00, '80213', 0.00, 218.79);
INSERT INTO compras_a_proveedor VALUES (1114034, false, '2008-12-26', NULL, 291, '2008-03-01', 9.45, 45.00, 0.00, '26051', 0.00, 54.45);
INSERT INTO compras_a_proveedor VALUES (1114036, false, '2008-12-26', NULL, 287, '2008-02-29', 0.00, 500.00, 0.00, '167', 0.00, 500.00);
INSERT INTO compras_a_proveedor VALUES (1114038, false, '2008-12-26', NULL, -1308098559, '2008-03-03', 0.00, 150.00, 0.00, '2028', 0.00, 150.00);
INSERT INTO compras_a_proveedor VALUES (1114040, false, '2008-12-26', NULL, -1307738112, '2008-03-06', 0.00, 40.00, 0.00, '379', 0.00, 40.00);
INSERT INTO compras_a_proveedor VALUES (1114042, false, '2008-12-26', NULL, 52, '2008-02-29', 0.00, 780.00, 0.00, '927', 0.00, 780.00);
INSERT INTO compras_a_proveedor VALUES (1114044, false, '2008-12-26', NULL, 639, '2008-03-10', 3.21, 15.29, 0.00, '11806', 0.00, 18.50);
INSERT INTO compras_a_proveedor VALUES (1114046, false, '2008-12-26', NULL, -1307738110, '2008-03-25', 0.00, 500.00, 0.00, '14645', 0.00, 500.00);
INSERT INTO compras_a_proveedor VALUES (1114048, false, '2008-12-26', NULL, 1233, '2008-02-11', 573.83, 4845.00, 0.00, '30682', 121.13, 5539.96);
INSERT INTO compras_a_proveedor VALUES (1114050, false, '2008-12-26', NULL, 4, '2008-03-04', 29.11, 138.60, 0.00, '431656', 3.47, 171.18);
INSERT INTO compras_a_proveedor VALUES (1114052, false, '2008-12-26', NULL, 80, '2008-03-05', 229.53, 1093.00, 0.00, '2079', 0.00, 1322.53);
INSERT INTO compras_a_proveedor VALUES (1114054, false, '2008-12-26', NULL, 121, '2008-03-19', 105.00, 500.00, 0.00, '65045', 0.00, 605.00);
INSERT INTO compras_a_proveedor VALUES (1114056, false, '2008-12-26', NULL, 4, '2008-03-26', 1680.36, 8001.70, 0.00, '433702', 200.04, 9882.10);
INSERT INTO compras_a_proveedor VALUES (1114058, false, '2008-12-26', NULL, 219, '2008-03-28', 110.36, 525.50, 0.00, '1758', 0.00, 635.86);
INSERT INTO compras_a_proveedor VALUES (1114060, false, '2008-12-26', NULL, 269, '2008-03-30', 6.91, 32.91, 10.20, '2859', 0.00, 50.02);
INSERT INTO compras_a_proveedor VALUES (1114062, false, '2008-12-26', NULL, 928, '2008-03-31', 9.01, 42.92, 0.00, '28475', 0.00, 51.93);
INSERT INTO compras_a_proveedor VALUES (1114064, false, '2008-12-26', NULL, -1308131321, '2008-03-31', 45.89, 218.50, 0.00, '7513', 0.00, 264.39);
INSERT INTO compras_a_proveedor VALUES (1114068, false, '2008-12-26', NULL, 52, '2008-12-26', 0.00, 240.45, 0.00, '1155', 0.00, 240.45);
INSERT INTO compras_a_proveedor VALUES (1114082, false, '2008-12-27', NULL, -1307738109, '2008-12-01', 0.00, 150.00, 0.00, '12801', 0.00, 150.00);
INSERT INTO compras_a_proveedor VALUES (1114084, false, '2008-12-27', NULL, 20, '2008-12-23', 45.21, 257.61, 0.00, '16644.02/1', 4.18, 307.00);
INSERT INTO compras_a_proveedor VALUES (1114085, false, '2008-12-27', NULL, 385, '2008-04-01', 102.06, 486.00, 0.00, '6529', 0.00, 588.06);
INSERT INTO compras_a_proveedor VALUES (1114087, false, '2008-12-27', NULL, -1307934719, '2008-04-01', 423.99, 2018.98, 0.00, '32121', 50.47, 2493.44);
INSERT INTO compras_a_proveedor VALUES (1114089, false, '2008-12-27', NULL, 15, '2008-04-01', 22.23, 105.84, 0.00, '169647', 0.00, 128.07);
INSERT INTO compras_a_proveedor VALUES (1114131, true, '2008-12-27', NULL, 20, '2008-03-27', 9.39, 49.69, 0.00, '70017-19141707/4', 0.00, 59.08);
INSERT INTO compras_a_proveedor VALUES (1114136, true, '2008-12-27', NULL, -1308164086, '2008-03-27', 0.00, 59.08, 0.00, '19141707/4', 0.00, 59.08);
INSERT INTO compras_a_proveedor VALUES (1114138, false, '2008-12-27', NULL, -1308164086, '2008-03-27', 9.39, 49.69, 0.00, '19141707/4', 0.00, 59.08);
INSERT INTO compras_a_proveedor VALUES (1114139, false, '2008-12-27', NULL, 291, '2008-04-01', 9.45, 45.00, 0.00, '26651', 0.00, 54.45);
INSERT INTO compras_a_proveedor VALUES (1114141, false, '2008-12-27', NULL, -1308033024, '2008-04-01', 9.30, 44.30, 21.41, '39776', 0.00, 75.01);
INSERT INTO compras_a_proveedor VALUES (1114143, false, '2008-12-27', NULL, 80, '2008-04-03', 116.76, 556.00, 0.00, '2163', 0.00, 672.76);
INSERT INTO compras_a_proveedor VALUES (1114145, false, '2008-12-27', NULL, 4, '2008-04-03', 20.23, 96.32, 0.00, '435814', 2.89, 119.44);
INSERT INTO compras_a_proveedor VALUES (1114147, false, '2008-12-27', NULL, 15, '2008-04-03', 6.40, 30.47, 0.00, '169714', 0.00, 36.87);
INSERT INTO compras_a_proveedor VALUES (1114149, false, '2008-12-27', NULL, -1307738108, '2008-04-03', 0.00, 40.00, 0.00, '1477', 0.00, 40.00);
INSERT INTO compras_a_proveedor VALUES (1114151, false, '2008-12-27', NULL, 283, '2008-04-03', 0.00, 50.00, 0.00, '753', 0.00, 50.00);
INSERT INTO compras_a_proveedor VALUES (1114153, false, '2008-12-27', NULL, 49, '2008-04-03', 7.57, 28.07, 0.00, '395302', 0.00, 35.64);
INSERT INTO compras_a_proveedor VALUES (1114155, false, '2008-12-27', NULL, 61, '2008-04-04', 139.94, 666.40, 0.00, '68422', 16.66, 823.00);
INSERT INTO compras_a_proveedor VALUES (1114157, false, '2008-12-27', NULL, 28, '2008-04-04', 769.73, 3665.38, 0.00, '2574', 91.66, 4526.77);
INSERT INTO compras_a_proveedor VALUES (1114159, false, '2008-12-27', NULL, 114, '2008-04-04', 101.81, 484.80, 0.00, '7050', 0.00, 586.61);
INSERT INTO compras_a_proveedor VALUES (1114161, false, '2008-12-27', NULL, 385, '2008-04-04', 208.32, 992.00, 0.00, '6554', 0.00, 1200.32);
INSERT INTO compras_a_proveedor VALUES (1114163, false, '2008-12-27', NULL, 15, '2008-04-04', 12.73, 60.62, 0.00, '169769', 0.00, 73.35);
INSERT INTO compras_a_proveedor VALUES (1114165, false, '2008-12-27', NULL, 98, '2008-04-04', 0.00, 180.00, 0.00, '222', 0.00, 180.00);
INSERT INTO compras_a_proveedor VALUES (1114167, false, '2008-12-27', NULL, -1308164093, '2008-04-04', 0.00, 159.77, 0.00, '80313', 0.00, 159.77);
INSERT INTO compras_a_proveedor VALUES (1114169, false, '2008-12-27', NULL, 20, '2008-04-04', 41.07, 232.13, 0.00, '114544/1', 3.80, 277.00);
INSERT INTO compras_a_proveedor VALUES (1114171, false, '2008-12-27', NULL, 12, '2008-04-05', 8.23, 39.21, 0.00, '34461', 0.00, 47.44);
INSERT INTO compras_a_proveedor VALUES (1114173, false, '2008-12-27', NULL, 28, '2008-04-07', 71.30, 339.50, 0.00, '2605', 8.49, 419.29);
INSERT INTO compras_a_proveedor VALUES (1114175, false, '2008-12-27', NULL, 95, '2008-04-07', 2.65, 12.60, 0.00, '108210', 0.00, 15.25);
INSERT INTO compras_a_proveedor VALUES (1114177, false, '2008-12-27', NULL, 15, '2008-04-08', 15.72, 74.86, 0.00, '169897', 0.00, 90.58);
INSERT INTO compras_a_proveedor VALUES (1114179, false, '2008-12-27', NULL, 55, '2008-04-07', 43.89, 418.11, 0.00, '34439', 0.00, 462.00);
INSERT INTO compras_a_proveedor VALUES (1114181, false, '2008-12-27', NULL, -1307738112, '2008-04-07', 0.00, 40.00, 0.00, '400', 0.00, 40.00);
INSERT INTO compras_a_proveedor VALUES (1114183, false, '2008-12-27', NULL, 24, '2008-04-07', 0.00, 480.00, 0.00, '178660', 0.00, 480.00);
INSERT INTO compras_a_proveedor VALUES (1114185, false, '2008-12-27', NULL, 385, '2008-04-08', 104.83, 499.20, 0.00, '6588', 0.00, 604.03);
INSERT INTO compras_a_proveedor VALUES (1114187, false, '2008-12-27', NULL, 42, '2008-04-08', 0.00, 692.00, 0.00, '43', 0.00, 692.00);
INSERT INTO compras_a_proveedor VALUES (1114189, false, '2008-12-27', NULL, -1307738107, '2008-04-09', 0.00, 165.00, 0.00, '3289', 0.00, 165.00);
INSERT INTO compras_a_proveedor VALUES (1114195, false, '2008-12-29', NULL, 536, '2008-12-06', 0.00, 2.20, 0.00, '837813', 0.00, 2.20);
INSERT INTO compras_a_proveedor VALUES (1114197, false, '2008-12-29', NULL, -1307738106, '2008-12-25', 13.46, 64.10, 22.45, '90296', 0.00, 100.01);
INSERT INTO compras_a_proveedor VALUES (1114199, false, '2008-12-29', NULL, -1307738105, '2008-12-29', 3.07, 14.63, 0.00, '29870', 0.00, 17.70);
INSERT INTO compras_a_proveedor VALUES (1114201, false, '2008-12-29', NULL, 15, '2008-12-27', 4.41, 21.02, 0.00, '181873', 0.00, 25.43);
INSERT INTO compras_a_proveedor VALUES (1114202, false, '2008-12-29', NULL, 1, '2008-12-26', 49.98, 238.00, 0.00, '13469', 0.00, 287.98);
INSERT INTO compras_a_proveedor VALUES (1114203, false, '2008-12-29', NULL, 211, '2008-04-09', 105.25, 501.20, 0.00, '40246', 0.00, 606.45);
INSERT INTO compras_a_proveedor VALUES (1114205, false, '2008-12-29', NULL, 1110, '2008-04-09', 66.74, 317.80, 0.00, '2007', 0.00, 384.54);
INSERT INTO compras_a_proveedor VALUES (1114207, false, '2008-12-29', NULL, 776, '2008-04-09', 2.08, 9.92, 0.00, '13405', 0.00, 12.00);
INSERT INTO compras_a_proveedor VALUES (1114209, false, '2008-12-29', NULL, 15, '2008-04-09', 27.57, 131.30, 0.00, '169960', 0.00, 158.87);
INSERT INTO compras_a_proveedor VALUES (1114211, false, '2008-12-29', NULL, 995, '2008-04-10', 151.60, 721.90, 0.00, '516', 0.00, 873.50);
INSERT INTO compras_a_proveedor VALUES (1114213, false, '2008-12-29', NULL, 995, '2008-04-10', 95.08, 452.80, 0.00, '517', 0.00, 547.88);
INSERT INTO compras_a_proveedor VALUES (1114215, false, '2008-12-29', NULL, 1, '2008-04-10', 44.41, 211.50, 0.00, '11240', 0.00, 255.91);
INSERT INTO compras_a_proveedor VALUES (1114217, false, '2008-12-29', NULL, 713, '2008-12-10', 0.00, 100.00, 0.00, '1593', 0.00, 100.00);
INSERT INTO compras_a_proveedor VALUES (1114219, false, '2008-12-29', NULL, -1307738104, '2008-12-29', 135.45, 645.00, 0.00, '5499', 0.00, 780.45);
INSERT INTO compras_a_proveedor VALUES (1114232, true, '2008-12-29', NULL, 1286, '2008-04-10', 0.00, 123.00, 0.00, '233', 0.00, 123.00);
INSERT INTO compras_a_proveedor VALUES (1114280, false, '2008-12-30', NULL, -1308098559, '2008-04-10', 0.00, 150.00, 0.00, '2060', 0.00, 150.00);
INSERT INTO compras_a_proveedor VALUES (1114282, false, '2008-12-30', NULL, -1307738105, '2008-04-10', 4.51, 21.49, 0.00, '27882', 0.00, 26.00);
INSERT INTO compras_a_proveedor VALUES (1114284, false, '2008-12-30', NULL, 114, '2008-04-11', 183.60, 874.30, 0.00, '7105', 0.00, 1057.90);
INSERT INTO compras_a_proveedor VALUES (1114286, false, '2008-12-30', NULL, -1308164095, '2008-04-11', 171.52, 816.75, 0.00, '70498', 0.00, 988.27);
INSERT INTO compras_a_proveedor VALUES (1114288, false, '2008-12-30', NULL, 574, '2008-04-11', 12.43, 59.21, 11.42, '29818', 0.00, 83.06);
INSERT INTO compras_a_proveedor VALUES (1114290, false, '2008-12-30', NULL, 269, '2008-04-11', 6.66, 31.73, 9.32, '3477', 0.00, 47.71);
INSERT INTO compras_a_proveedor VALUES (1114292, false, '2008-12-30', NULL, 15, '2008-04-10', 4.04, 19.23, 0.00, '170016', 0.00, 23.27);
INSERT INTO compras_a_proveedor VALUES (1114294, false, '2008-12-30', NULL, 15, '2008-04-11', 5.91, 28.16, 0.00, '170067', 0.00, 34.07);
INSERT INTO compras_a_proveedor VALUES (1114296, false, '2008-12-30', NULL, 15, '2008-04-12', 21.36, 101.67, 0.00, '170142', 0.00, 123.03);
INSERT INTO compras_a_proveedor VALUES (1114298, false, '2008-12-30', NULL, 617, '2008-04-12', 1.53, 8.47, 0.00, '29894', 0.00, 10.00);
INSERT INTO compras_a_proveedor VALUES (1114300, false, '2008-12-30', NULL, 12, '2008-04-12', 11.69, 55.68, 0.00, '34606', 0.00, 67.37);
INSERT INTO compras_a_proveedor VALUES (1114302, false, '2008-12-30', NULL, 80, '2008-04-14', 53.97, 257.00, 0.00, '2197', 0.00, 310.97);
INSERT INTO compras_a_proveedor VALUES (1114305, false, '2008-12-30', NULL, 1, '2008-04-14', 38.85, 185.00, 0.00, '11269', 0.00, 223.85);
INSERT INTO compras_a_proveedor VALUES (1114307, false, '2008-12-30', NULL, 46, '2008-04-14', 59.04, 281.16, 0.00, '40320', 0.00, 340.20);
INSERT INTO compras_a_proveedor VALUES (1114309, false, '2008-12-30', NULL, 28, '2008-12-23', 257.25, 1225.00, 0.00, '9431', 42.89, 1525.14);
INSERT INTO compras_a_proveedor VALUES (1114310, false, '2008-12-30', NULL, -1308164093, '2008-12-15', 0.00, 57.07, 0.00, '81213', 0.00, 57.07);
INSERT INTO compras_a_proveedor VALUES (1114311, false, '2008-12-30', NULL, 15, '2008-12-30', 36.63, 174.43, 0.00, '181925', 0.00, 211.06);
INSERT INTO compras_a_proveedor VALUES (1114312, false, '2008-12-30', NULL, 28, '2008-04-14', 431.87, 2056.50, 0.00, '2762', 51.42, 2539.79);
INSERT INTO compras_a_proveedor VALUES (1114314, false, '2008-12-30', NULL, 928, '2008-04-14', 5.89, 28.07, 0.00, '28689', 0.00, 33.96);
INSERT INTO compras_a_proveedor VALUES (1114316, false, '2008-12-30', NULL, 111, '2008-04-15', 242.26, 1153.61, 0.00, '167235', 28.84, 1424.71);
INSERT INTO compras_a_proveedor VALUES (1114318, false, '2008-12-30', NULL, 15, '2008-04-15', 3.89, 18.54, 0.00, '170249', 0.00, 22.43);
INSERT INTO compras_a_proveedor VALUES (1114320, false, '2008-12-30', NULL, 55, '2008-04-16', 41.33, 393.66, 0.00, '34477', 0.00, 434.99);
INSERT INTO compras_a_proveedor VALUES (1114322, false, '2008-12-30', NULL, -1307705344, '2008-04-16', 48.30, 230.10, 0.00, '3713', 0.00, 278.40);
INSERT INTO compras_a_proveedor VALUES (1114324, false, '2008-12-30', NULL, 15, '2008-04-16', 10.15, 48.31, 0.00, '170296', 0.00, 58.46);
INSERT INTO compras_a_proveedor VALUES (1114326, false, '2008-12-30', NULL, 15, '2008-04-17', 6.18, 29.47, 0.00, '170353', 0.00, 35.65);
INSERT INTO compras_a_proveedor VALUES (1114328, false, '2008-12-30', NULL, 211, '2008-04-17', 130.10, 619.50, 0.00, '40341', 0.00, 749.60);
INSERT INTO compras_a_proveedor VALUES (1114330, false, '2008-12-30', NULL, -1307705343, '2008-04-17', 10.57, 50.31, 9.12, '2818', 0.00, 70.00);
INSERT INTO compras_a_proveedor VALUES (1114332, false, '2008-12-30', NULL, 15, '2008-04-17', 2.52, 12.00, 0.00, '170410', 0.00, 14.52);
INSERT INTO compras_a_proveedor VALUES (1114334, false, '2008-12-30', NULL, 15, '2008-04-19', 14.95, 71.19, 0.00, '170497', 0.00, 86.14);
INSERT INTO compras_a_proveedor VALUES (1114336, false, '2008-12-30', NULL, 12, '2008-04-19', 7.23, 34.44, 0.00, '34477', 0.00, 41.67);
INSERT INTO compras_a_proveedor VALUES (1114338, false, '2008-12-30', NULL, 264, '2008-04-18', 24.15, 115.00, 0.00, '3852', 0.00, 139.15);
INSERT INTO compras_a_proveedor VALUES (1114347, false, '2008-12-30', NULL, 61, '2008-12-24', 404.46, 1926.00, 0.00, '75096', 67.41, 2397.87);
INSERT INTO compras_a_proveedor VALUES (1114348, false, '2008-12-30', NULL, 61, '2008-12-23', 314.41, 1497.20, 0.00, '75062', 52.40, 1864.01);
INSERT INTO compras_a_proveedor VALUES (1114349, false, '2008-12-30', NULL, 1, '2008-04-23', 315.52, 1502.50, 0.00, '11339', 0.00, 1818.02);
INSERT INTO compras_a_proveedor VALUES (1114351, false, '2008-12-30', NULL, 1, '2008-04-24', 6.36, 30.30, 0.00, '40435', 0.00, 36.66);
INSERT INTO compras_a_proveedor VALUES (1114353, false, '2008-12-30', NULL, 385, '2008-04-24', 707.62, 3369.60, 0.00, '6759', 0.00, 4077.22);
INSERT INTO compras_a_proveedor VALUES (1114355, false, '2008-12-30', NULL, 385, '2008-04-24', 1.97, 9.40, 0.00, '6767', 0.00, 11.37);
INSERT INTO compras_a_proveedor VALUES (1114357, false, '2008-12-30', NULL, 15, '2008-04-24', 10.86, 51.73, 0.00, '170755', 0.00, 62.59);
INSERT INTO compras_a_proveedor VALUES (1114359, false, '2008-12-30', NULL, -1307705342, '2008-04-24', 0.00, 100.00, 0.00, '23428', 0.00, 100.00);
INSERT INTO compras_a_proveedor VALUES (1114361, false, '2008-12-30', NULL, 49, '2008-04-18', 130.23, 504.01, 0.00, '89326', 12.10, 646.34);
INSERT INTO compras_a_proveedor VALUES (1114363, false, '2008-12-30', NULL, 121, '2008-04-24', 105.00, 500.00, 0.00, '66263', 0.00, 605.00);
INSERT INTO compras_a_proveedor VALUES (1114364, false, '2008-12-30', NULL, 24, '2008-04-25', 0.00, 945.00, 0.00, '179532', 0.00, 945.00);
INSERT INTO compras_a_proveedor VALUES (1114366, false, '2008-12-30', NULL, -1307738110, '2008-04-25', 4.24, 20.20, 0.00, '15224', 0.00, 24.44);
INSERT INTO compras_a_proveedor VALUES (1114368, false, '2008-12-30', NULL, 269, '2008-04-25', 11.45, 54.54, 16.01, '4246', 1.76, 83.76);
INSERT INTO compras_a_proveedor VALUES (1114370, false, '2008-12-30', NULL, 995, '2008-04-25', 359.60, 1712.40, 0.00, '524', 0.00, 2072.00);
INSERT INTO compras_a_proveedor VALUES (1114372, false, '2008-12-30', NULL, -1307934719, '2008-04-25', 611.00, 2909.50, 0.00, '32300', 72.74, 3593.24);
INSERT INTO compras_a_proveedor VALUES (1114374, false, '2008-12-30', NULL, 385, '2008-04-25', 521.47, 2483.20, 0.00, '6780', 0.00, 3004.67);
INSERT INTO compras_a_proveedor VALUES (1114376, false, '2008-12-30', NULL, 28, '2008-03-25', 568.26, 2706.00, 0.00, '2322', 67.68, 3341.94);
INSERT INTO compras_a_proveedor VALUES (1113808, true, '2008-12-23', NULL, 28, '2008-03-25', 568.26, 2706.00, 0.00, '2322', 67.68, 3341.94);
INSERT INTO compras_a_proveedor VALUES (1114378, false, '2008-12-30', NULL, 111, '2008-04-25', 129.81, 618.12, 0.00, '168091', 15.45, 763.38);
INSERT INTO compras_a_proveedor VALUES (1114380, false, '2008-12-30', NULL, 61, '2008-04-25', 288.62, 1374.40, 0.00, '69105', 34.36, 1697.38);
INSERT INTO compras_a_proveedor VALUES (1114390, false, '2008-12-31', NULL, 15, '2008-04-26', 51.10, 243.33, 0.00, '170889', 0.00, 294.43);
INSERT INTO compras_a_proveedor VALUES (1114382, true, '2008-12-30', NULL, 15, '2008-04-26', 51.10, 243.33, 0.00, '170889', 0.00, 294.43);
INSERT INTO compras_a_proveedor VALUES (1114392, false, '2008-12-31', NULL, 12, '2008-04-26', 10.15, 48.35, 0.00, '34489', 0.00, 58.50);
INSERT INTO compras_a_proveedor VALUES (1114394, false, '2008-12-31', NULL, 269, '2008-04-27', 8.38, 39.91, 11.72, '4388', 1.29, 61.30);
INSERT INTO compras_a_proveedor VALUES (1114396, false, '2008-12-31', NULL, 61, '2008-03-27', 109.78, 522.75, 0.00, '68189', 13.07, 645.60);
INSERT INTO compras_a_proveedor VALUES (1114398, false, '2008-12-31', NULL, 55, '2008-04-28', 41.33, 393.66, 0.00, '34639', 0.00, 434.99);
INSERT INTO compras_a_proveedor VALUES (1114400, false, '2008-12-31', NULL, 287, '2008-03-28', 0.00, 500.00, 0.00, '187', 0.00, 500.00);
INSERT INTO compras_a_proveedor VALUES (1114402, false, '2008-12-31', NULL, 121, '2008-12-31', 262.50, 1250.00, 0.00, '76279', 0.00, 1512.50);
INSERT INTO compras_a_proveedor VALUES (1114403, false, '2008-12-31', NULL, 15, '2008-12-31', 5.00, 23.80, 0.00, '181996', 0.00, 28.80);
INSERT INTO compras_a_proveedor VALUES (1114404, false, '2008-12-31', NULL, 111, '2008-12-29', 66.44, 316.40, 0.00, '182828', 11.07, 393.91);
INSERT INTO compras_a_proveedor VALUES (1114405, false, '2008-12-31', NULL, 385, '2008-04-29', 80.22, 382.00, 0.00, '6818', 0.00, 462.22);
INSERT INTO compras_a_proveedor VALUES (1114407, false, '2008-12-31', NULL, 15, '2008-04-29', 26.77, 127.50, 0.00, '170974', 0.00, 154.27);
INSERT INTO compras_a_proveedor VALUES (1114409, false, '2008-12-31', NULL, -1308131320, '2008-04-29', 2.87, 13.63, 0.00, '22939', 0.00, 16.50);
INSERT INTO compras_a_proveedor VALUES (1114451, false, '2008-12-31', NULL, 28, '2008-04-29', 603.12, 2872.00, 0.00, '3061', 71.80, 3546.92);
INSERT INTO compras_a_proveedor VALUES (1114453, false, '2008-12-31', NULL, 28, '2008-04-29', 75.55, 359.75, 0.00, '3058', 8.99, 444.29);
INSERT INTO compras_a_proveedor VALUES (1114455, false, '2008-12-31', NULL, 219, '2008-04-29', 265.06, 1262.21, 0.00, '19.03', 0.00, 1527.27);
INSERT INTO compras_a_proveedor VALUES (1114457, false, '2008-12-31', NULL, 812, '2008-04-29', 8.41, 40.03, 0.00, '46241', 0.00, 48.44);
INSERT INTO compras_a_proveedor VALUES (1114459, false, '2008-12-31', NULL, 15, '2008-04-30', 34.45, 164.03, 0.00, '170058', 0.00, 198.48);
INSERT INTO compras_a_proveedor VALUES (1114461, false, '2008-12-31', NULL, 49, '2008-04-30', 4.83, 62.17, 0.00, '448778', 0.00, 67.00);
INSERT INTO compras_a_proveedor VALUES (1114463, false, '2008-12-31', NULL, 1174, '2008-04-30', 22.04, 104.96, 0.00, '7681', 0.00, 127.00);
INSERT INTO compras_a_proveedor VALUES (1114465, false, '2008-12-31', NULL, 546, '2008-04-25', 86.95, 414.05, 0.00, '75843', 10.35, 511.35);
INSERT INTO compras_a_proveedor VALUES (1114467, false, '2008-12-31', NULL, 4, '2008-04-23', 1697.37, 8082.70, 0.00, '2585', 202.07, 9982.14);
INSERT INTO compras_a_proveedor VALUES (1114490, false, '2009-01-02', NULL, 55, '2009-01-02', 32.06, 305.42, 0.00, '37013', 0.00, 337.48);
INSERT INTO compras_a_proveedor VALUES (1114494, false, '2009-01-03', NULL, 1110, '2008-12-29', 166.57, 793.20, 0.00, '2168', 0.00, 959.77);
INSERT INTO compras_a_proveedor VALUES (1114495, false, '2009-01-03', NULL, -1308131312, '2008-12-19', 14.70, 70.00, 0.00, '6450', 0.00, 84.70);
INSERT INTO compras_a_proveedor VALUES (1114522, false, '2009-01-05', NULL, 617, '2009-01-02', 2.43, 12.57, 0.00, '32556', 0.00, 15.00);
INSERT INTO compras_a_proveedor VALUES (1114524, false, '2009-01-05', NULL, 269, '2009-01-05', 17.71, 84.35, 35.00, '25907', 0.00, 137.06);
INSERT INTO compras_a_proveedor VALUES (1114526, false, '2009-01-05', NULL, 269, '2009-01-05', 24.30, 115.70, 48.01, '11194', 0.00, 188.01);
INSERT INTO compras_a_proveedor VALUES (1114528, false, '2009-01-05', NULL, 20, '2008-05-22', 36.01, 204.16, 0.00, '158.824/8', 3.33, 243.50);
INSERT INTO compras_a_proveedor VALUES (1114530, false, '2009-01-05', NULL, -1308164086, '2008-05-26', 16.53, 84.34, 0.00, '2299/7', 3.54, 104.41);
INSERT INTO compras_a_proveedor VALUES (1114532, false, '2009-01-05', NULL, 15, '2008-05-30', 4.33, 20.61, 0.00, '172508', 0.00, 24.94);
INSERT INTO compras_a_proveedor VALUES (1114534, false, '2009-01-05', NULL, 269, '2008-05-29', 7.00, 33.35, 9.69, '5494', 0.00, 50.04);
INSERT INTO compras_a_proveedor VALUES (1114536, false, '2009-01-05', NULL, 15, '2008-05-29', 6.13, 29.18, 0.00, '172448', 0.00, 35.31);
INSERT INTO compras_a_proveedor VALUES (1114538, false, '2009-01-05', NULL, 15, '2008-05-28', 2.79, 13.28, 0.00, '172370', 0.00, 16.07);
INSERT INTO compras_a_proveedor VALUES (1114540, false, '2009-01-05', NULL, -1307672575, '2008-05-28', 134.33, 639.65, 0.00, '7271', 0.00, 773.98);
INSERT INTO compras_a_proveedor VALUES (1114542, false, '2009-01-05', NULL, 211, '2008-05-27', 90.54, 431.20, 0.00, '40833', 0.00, 521.74);
INSERT INTO compras_a_proveedor VALUES (1114544, false, '2009-01-05', NULL, 385, '2008-05-27', 25.20, 120.00, 0.00, '7139', 0.00, 145.20);
INSERT INTO compras_a_proveedor VALUES (1114546, false, '2009-01-05', NULL, -1307803648, '2008-05-27', 3.13, 14.90, 0.00, '59796', 0.00, 18.03);
INSERT INTO compras_a_proveedor VALUES (1114548, false, '2009-01-05', NULL, -1308164094, '2008-05-26', 12.58, 59.88, 0.00, '15256', 0.00, 72.46);
INSERT INTO compras_a_proveedor VALUES (1114550, false, '2009-01-05', NULL, 407, '2008-05-26', 49.64, 236.40, 0.00, '21441', 0.00, 286.04);
INSERT INTO compras_a_proveedor VALUES (1114552, false, '2009-01-05', NULL, 269, '2008-05-24', 4.34, 20.67, 6.01, '6344', 0.00, 31.02);
INSERT INTO compras_a_proveedor VALUES (1114554, false, '2009-01-05', NULL, 12, '2008-05-24', 10.84, 51.64, 0.00, '34869', 0.00, 62.48);
INSERT INTO compras_a_proveedor VALUES (1114556, false, '2009-01-05', NULL, 15, '2008-05-24', 2.74, 13.06, 0.00, '172233', 0.00, 15.80);
INSERT INTO compras_a_proveedor VALUES (1114558, false, '2009-01-05', NULL, 15, '2008-05-23', 2.33, 11.08, 0.00, '172175', 0.00, 13.41);
INSERT INTO compras_a_proveedor VALUES (1114560, false, '2009-01-05', NULL, 55, '2008-05-23', 43.89, 418.09, 0.00, '35020', 0.00, 461.98);
INSERT INTO compras_a_proveedor VALUES (1114562, false, '2009-01-05', NULL, 211, '2008-05-22', 85.26, 406.00, 0.00, '40777', 0.00, 491.26);
INSERT INTO compras_a_proveedor VALUES (1114564, false, '2009-01-05', NULL, 4, '2008-05-22', 799.85, 3808.80, 0.00, '2615', 95.22, 4703.87);
INSERT INTO compras_a_proveedor VALUES (1114566, false, '2009-01-05', NULL, 15, '2008-05-22', 25.54, 121.64, 0.00, '172118', 0.00, 147.18);
INSERT INTO compras_a_proveedor VALUES (1114568, false, '2009-01-05', NULL, 617, '2008-05-22', 5.50, 27.50, 0.00, '30285', 0.00, 33.00);
INSERT INTO compras_a_proveedor VALUES (1114570, false, '2009-01-05', NULL, -1307672574, '2008-05-22', 0.00, 15.00, 0.00, '596', 0.00, 15.00);
INSERT INTO compras_a_proveedor VALUES (1114572, false, '2009-01-05', NULL, 111, '2008-05-21', 62.45, 297.36, 0.00, '169738', 7.43, 367.24);
INSERT INTO compras_a_proveedor VALUES (1114574, false, '2009-01-05', NULL, 15, '2008-05-21', 8.26, 39.33, 0.00, '172047', 0.00, 47.59);
INSERT INTO compras_a_proveedor VALUES (1114578, false, '2009-01-06', NULL, -1307672573, '2009-01-06', 33.62, 160.11, 0.00, '9658', 4.33, 198.06);
INSERT INTO compras_a_proveedor VALUES (1114580, false, '2009-01-06', NULL, 219, '2009-01-06', 244.16, 1162.69, 0.00, '3318', 0.00, 1406.85);
INSERT INTO compras_a_proveedor VALUES (1114581, false, '2009-01-06', NULL, 15, '2009-01-06', 2.33, 11.06, 0.00, '182087', 0.00, 13.39);
INSERT INTO compras_a_proveedor VALUES (1114582, false, '2009-01-06', NULL, 1, '2009-01-05', 13.92, 66.30, 0.00, '13510', 0.00, 80.22);
INSERT INTO compras_a_proveedor VALUES (1114584, false, '2009-01-06', NULL, 291, '2009-01-01', 11.98, 57.02, 0.00, '32197', 0.00, 69.00);
INSERT INTO compras_a_proveedor VALUES (1114586, false, '2009-01-06', NULL, 121, '2008-05-21', 105.00, 500.00, 0.00, '67398', 0.00, 605.00);
INSERT INTO compras_a_proveedor VALUES (1114588, false, '2009-01-06', NULL, -1308164088, '2008-05-21', 10.38, 49.45, 0.00, '27298', 0.00, 59.83);
INSERT INTO compras_a_proveedor VALUES (1114612, false, '2009-01-06', NULL, -1308098559, '2009-01-02', 0.00, 150.00, 0.00, '2255', 0.00, 150.00);
INSERT INTO compras_a_proveedor VALUES (1114614, false, '2009-01-06', NULL, 1, '2008-05-21', 1106.78, 5270.40, 0.00, '11585', 0.00, 6377.18);
INSERT INTO compras_a_proveedor VALUES (1114616, false, '2009-01-06', NULL, 1110, '2008-05-20', 247.28, 1177.50, 0.00, '2032', 0.00, 1424.78);
INSERT INTO compras_a_proveedor VALUES (1114618, false, '2009-01-06', NULL, 269, '2008-05-20', 6.99, 33.28, 9.74, '5015', 0.00, 50.01);
INSERT INTO compras_a_proveedor VALUES (1114620, false, '2009-01-06', NULL, 15, '2008-05-20', 70.66, 336.49, 0.00, '171979', 0.00, 407.15);
INSERT INTO compras_a_proveedor VALUES (1114622, false, '2009-01-06', NULL, 114, '2008-05-19', 68.04, 324.00, 0.00, '7314', 0.00, 392.04);
INSERT INTO compras_a_proveedor VALUES (1114624, false, '2009-01-06', NULL, 111, '2008-05-19', 113.29, 539.47, 0.00, '169555', 13.49, 666.25);
INSERT INTO compras_a_proveedor VALUES (1114626, false, '2009-01-06', NULL, 269, '2008-05-18', 17.57, 83.69, 30.74, '5882', 2.86, 134.86);
INSERT INTO compras_a_proveedor VALUES (1114630, false, '2009-01-07', NULL, 15, '2008-05-17', 5.20, 24.76, 0.00, '171866', 0.00, 29.96);
INSERT INTO compras_a_proveedor VALUES (1114632, false, '2009-01-07', NULL, 114, '2008-05-15', 169.68, 808.00, 0.00, '7282', 0.00, 977.68);
INSERT INTO compras_a_proveedor VALUES (1114634, false, '2009-01-07', NULL, 121, '2008-05-16', 157.50, 750.00, 0.00, '67197', 0.00, 907.50);
INSERT INTO compras_a_proveedor VALUES (1114637, false, '2009-01-07', NULL, 385, '2008-05-16', 26.04, 124.00, 0.00, '7012', 0.00, 150.04);
INSERT INTO compras_a_proveedor VALUES (1114639, false, '2009-01-07', NULL, 49, '2008-05-19', 145.65, 564.01, 0.00, '29232', 13.55, 723.21);
INSERT INTO compras_a_proveedor VALUES (1114642, false, '2009-01-07', NULL, 15, '2008-05-16', 33.41, 159.09, 0.00, '171819', 0.00, 192.50);
INSERT INTO compras_a_proveedor VALUES (1114644, false, '2009-01-07', NULL, -1307672572, '2008-05-15', 142.88, 680.40, 0.00, '612', 0.00, 823.28);
INSERT INTO compras_a_proveedor VALUES (1114646, false, '2009-01-07', NULL, 111, '2008-05-15', 91.32, 434.89, 0.00, '169352', 10.87, 537.08);
INSERT INTO compras_a_proveedor VALUES (1114648, false, '2009-01-07', NULL, 15, '2008-05-15', 5.11, 24.33, 0.00, '171744', 0.00, 29.44);
INSERT INTO compras_a_proveedor VALUES (1114650, false, '2009-01-07', NULL, 1, '2008-05-14', 44.73, 213.00, 0.00, '11527', 0.00, 257.73);
INSERT INTO compras_a_proveedor VALUES (1114652, false, '2009-01-07', NULL, 55, '2008-05-14', 46.46, 442.52, 0.00, '34829', 0.00, 488.98);
INSERT INTO compras_a_proveedor VALUES (1114654, false, '2009-01-07', NULL, 578, '2008-05-14', 19.11, 91.00, 22.50, '996', 0.00, 132.61);
INSERT INTO compras_a_proveedor VALUES (1114656, false, '2009-01-07', NULL, 28, '2008-05-14', 47.99, 228.50, 0.00, '3587', 5.71, 282.20);
INSERT INTO compras_a_proveedor VALUES (1114658, false, '2009-01-07', NULL, 15, '2008-05-14', 7.94, 37.81, 0.00, '171672', 0.00, 45.75);
INSERT INTO compras_a_proveedor VALUES (1114660, false, '2009-01-07', NULL, 407, '2008-05-13', 75.52, 359.64, 0.00, '21185', 0.00, 435.16);
INSERT INTO compras_a_proveedor VALUES (1114662, false, '2009-01-07', NULL, 95, '2008-05-13', 3.28, 15.60, 0.00, '110038', 0.00, 18.88);
INSERT INTO compras_a_proveedor VALUES (1114664, false, '2009-01-07', NULL, 574, '2008-05-13', 9.09, 43.28, 7.65, '31333', 0.00, 60.02);
INSERT INTO compras_a_proveedor VALUES (1114666, false, '2009-01-07', NULL, 111, '2008-05-12', 222.12, 1057.74, 0.00, '169050', 26.44, 1306.30);
INSERT INTO compras_a_proveedor VALUES (1114668, false, '2009-01-07', NULL, 28, '2008-05-12', 812.65, 3869.75, 0.00, '3474', 96.76, 4779.16);
INSERT INTO compras_a_proveedor VALUES (1114680, false, '2009-01-07', NULL, 15, '2008-05-12', 33.57, 159.86, 0.00, '171546', 0.00, 193.43);
INSERT INTO compras_a_proveedor VALUES (1114682, false, '2009-01-07', NULL, 28, '2008-05-12', 2266.43, 10792.50, 0.00, '3461', 269.82, 13328.75);
INSERT INTO compras_a_proveedor VALUES (1114684, false, '2009-01-07', NULL, 28, '2008-05-12', 386.82, 1842.00, 0.00, '3417', 46.06, 2274.88);
INSERT INTO compras_a_proveedor VALUES (1114686, false, '2009-01-08', NULL, 12, '2008-05-12', 6.83, 32.50, 0.00, '34640', 0.00, 39.33);
INSERT INTO compras_a_proveedor VALUES (1114688, false, '2009-01-08', NULL, 12, '2008-05-12', 6.83, 32.50, 0.00, '34640', 0.00, 39.33);
INSERT INTO compras_a_proveedor VALUES (1114710, false, '2009-01-08', NULL, 111, '2008-05-12', 16.13, 76.80, 0.00, '169034', 1.92, 94.85);
INSERT INTO compras_a_proveedor VALUES (1114712, false, '2009-01-08', NULL, -1308164095, '2008-05-09', 200.82, 956.28, 0.00, '71891', 0.00, 1157.10);
INSERT INTO compras_a_proveedor VALUES (1114714, false, '2009-01-08', NULL, 15, '2008-05-09', 6.31, 30.03, 0.00, '171486', 0.00, 36.34);
INSERT INTO compras_a_proveedor VALUES (1114716, false, '2009-01-08', NULL, 80, '2008-05-09', 267.79, 1257.20, 0.00, '2285', 0.00, 1524.99);
INSERT INTO compras_a_proveedor VALUES (1114718, false, '2009-01-08', NULL, 269, '2008-05-07', 6.98, 33.25, 9.76, '4403', 0.00, 49.99);
INSERT INTO compras_a_proveedor VALUES (1114720, false, '2009-01-08', NULL, -1307738104, '2008-05-09', 44.94, 214.00, 0.00, '5063', 0.00, 258.94);
INSERT INTO compras_a_proveedor VALUES (1114722, false, '2009-01-08', NULL, 578, '2008-05-09', 3.15, 19.50, 0.00, '992', 0.00, 22.65);
INSERT INTO compras_a_proveedor VALUES (1114724, false, '2009-01-08', NULL, 4, '2008-05-08', 1150.51, 5478.60, 0.00, '2688', 136.97, 6766.08);
INSERT INTO compras_a_proveedor VALUES (1114726, false, '2009-01-08', NULL, 111, '2008-05-08', 339.64, 1617.36, 0.00, '168.863', 40.43, 1997.43);
INSERT INTO compras_a_proveedor VALUES (1114728, false, '2009-01-08', NULL, 15, '2008-05-08', 17.60, 83.82, 0.00, '171424', 0.00, 101.42);
INSERT INTO compras_a_proveedor VALUES (1114730, false, '2009-01-08', NULL, 578, '2008-05-08', 7.98, 42.50, 0.00, '988', 0.00, 50.48);
INSERT INTO compras_a_proveedor VALUES (1114732, false, '2009-01-08', NULL, 28, '2008-05-07', 492.35, 2344.50, 0.00, '3274', 58.62, 2895.47);
INSERT INTO compras_a_proveedor VALUES (1114734, false, '2009-01-08', NULL, 61, '2008-05-07', 102.82, 489.60, 0.00, '69441', 12.24, 604.66);
INSERT INTO compras_a_proveedor VALUES (1114737, false, '2009-01-08', NULL, 121, '2008-05-07', 588.00, 2800.00, 0.00, '66947', 0.00, 3388.00);
INSERT INTO compras_a_proveedor VALUES (1114739, false, '2009-01-08', NULL, 15, '2008-05-07', 6.95, 33.10, 0.00, '171376', 0.00, 40.05);
INSERT INTO compras_a_proveedor VALUES (1114741, false, '2009-01-08', NULL, 1, '2008-05-06', 82.05, 390.75, 0.00, '11443', 0.00, 472.80);
INSERT INTO compras_a_proveedor VALUES (1114743, false, '2009-01-08', NULL, 15, '2008-05-06', 2.32, 11.05, 0.00, '171314', 0.00, 13.37);
INSERT INTO compras_a_proveedor VALUES (1114745, false, '2009-01-08', NULL, 95, '2008-05-06', 5.29, 25.20, 0.00, '109672', 0.00, 30.49);
INSERT INTO compras_a_proveedor VALUES (1114747, false, '2009-01-08', NULL, 28, '2008-05-06', 333.86, 1589.80, 0.00, '3225', 39.77, 1963.43);
INSERT INTO compras_a_proveedor VALUES (1114749, false, '2009-01-08', NULL, 657, '2008-05-06', 47.22, 229.83, 0.00, '3090678/9', 0.00, 277.05);
INSERT INTO compras_a_proveedor VALUES (1114754, false, '2009-01-09', NULL, -1307934719, '2009-01-07', 57.40, 282.88, 0.00, '34374', 0.00, 340.28);
INSERT INTO compras_a_proveedor VALUES (1114755, false, '2009-01-09', NULL, 407, '2009-01-08', 45.74, 217.80, 0.00, '24277', 0.00, 263.54);
INSERT INTO compras_a_proveedor VALUES (1114757, false, '2009-01-09', NULL, 15, '2009-01-09', 5.32, 25.32, 0.00, '182226', 0.00, 30.64);
INSERT INTO compras_a_proveedor VALUES (1114758, false, '2009-01-09', NULL, 269, '2009-01-07', 24.56, 116.94, 48.52, '11594', 0.00, 190.02);
INSERT INTO compras_a_proveedor VALUES (1114760, false, '2009-01-09', NULL, 4, '2009-01-08', 1924.59, 9164.70, 0.00, '2877', 320.76, 11410.05);
INSERT INTO compras_a_proveedor VALUES (1114762, false, '2009-01-09', NULL, -1307672571, '2009-01-05', 5.85, 27.84, 0.00, '5054', 0.00, 33.69);
INSERT INTO compras_a_proveedor VALUES (1114764, false, '2009-01-09', NULL, 928, '2009-01-09', 6.25, 29.75, 0.00, '33229', 0.00, 36.00);
INSERT INTO compras_a_proveedor VALUES (1114765, false, '2009-01-09', NULL, 283, '2009-01-08', 0.00, 50.00, 0.00, '625', 0.00, 50.00);
INSERT INTO compras_a_proveedor VALUES (1114767, false, '2009-01-09', NULL, 15, '2009-01-07', 11.81, 56.23, 0.00, '182142', 0.00, 68.04);
INSERT INTO compras_a_proveedor VALUES (1114768, false, '2009-01-09', NULL, 114, '2009-01-05', 279.93, 1333.00, 0.00, '8647', 0.00, 1612.93);
INSERT INTO compras_a_proveedor VALUES (1114769, false, '2009-01-09', NULL, 812, '2009-01-03', 23.11, 110.06, 0.00, '50186', 0.00, 133.17);
INSERT INTO compras_a_proveedor VALUES (1114790, false, '2009-01-09', NULL, 42, '2009-01-05', 0.00, 1056.00, 0.00, '65', 0.00, 1056.00);
INSERT INTO compras_a_proveedor VALUES (1114792, false, '2009-01-09', NULL, 46, '2008-05-05', 61.56, 293.16, 0.00, '40775', 0.00, 354.72);
INSERT INTO compras_a_proveedor VALUES (1114794, false, '2009-01-09', NULL, -1307738105, '2008-05-05', 6.40, 30.50, 0.00, '28069', 0.00, 36.90);
INSERT INTO compras_a_proveedor VALUES (1114796, false, '2009-01-09', NULL, 114, '2008-05-05', 101.81, 484.80, 0.00, '7223', 0.00, 586.61);
INSERT INTO compras_a_proveedor VALUES (1114820, false, '2009-01-10', NULL, 80, '2008-05-05', 331.96, 1580.75, 0.00, '2268', 0.00, 1912.71);
INSERT INTO compras_a_proveedor VALUES (1114822, false, '2009-01-10', NULL, 4, '2008-05-05', 16.85, 80.25, 0.00, '439786', 2.01, 99.11);
INSERT INTO compras_a_proveedor VALUES (1114824, false, '2009-01-10', NULL, 55, '2008-05-05', 41.33, 393.66, 0.00, '34774', 0.00, 434.99);
INSERT INTO compras_a_proveedor VALUES (1114826, false, '2009-01-10', NULL, 269, '2008-05-05', 5.31, 25.27, 7.42, '4916', 0.00, 38.00);
INSERT INTO compras_a_proveedor VALUES (1114828, false, '2009-01-10', NULL, 269, '2008-05-04', 10.01, 47.65, 17.36, '4908', 1.63, 76.65);
INSERT INTO compras_a_proveedor VALUES (1114830, false, '2009-01-10', NULL, 269, '2008-05-04', 3.77, 17.95, 8.29, '4909', 0.00, 30.01);
INSERT INTO compras_a_proveedor VALUES (1114832, false, '2009-01-10', NULL, 269, '2008-05-03', 3.77, 17.95, 8.29, '4218', 0.00, 30.01);
INSERT INTO compras_a_proveedor VALUES (1114834, false, '2009-01-10', NULL, 15, '2008-05-03', 13.76, 65.52, 0.00, '171201', 0.00, 79.28);
INSERT INTO compras_a_proveedor VALUES (1114836, false, '2009-01-10', NULL, 12, '2008-05-03', 5.00, 23.80, 0.00, '34663', 0.00, 28.80);
INSERT INTO compras_a_proveedor VALUES (1114838, false, '2009-01-10', NULL, 12, '2008-05-03', 8.56, 40.78, 0.00, '34634', 0.00, 49.34);
INSERT INTO compras_a_proveedor VALUES (1114840, false, '2009-01-10', NULL, 15, '2008-05-02', 6.34, 30.21, 0.00, '171125', 0.00, 36.55);
INSERT INTO compras_a_proveedor VALUES (1114842, false, '2009-01-10', NULL, 46, '2008-05-02', 179.33, 853.93, 0.00, '40559', 0.00, 1033.26);
INSERT INTO compras_a_proveedor VALUES (1114844, false, '2009-01-10', NULL, 713, '2008-05-02', 0.00, 230.00, 0.00, '1366', 0.00, 230.00);
INSERT INTO compras_a_proveedor VALUES (1114846, false, '2009-01-10', NULL, 4, '2008-04-30', 31.33, 149.20, 0.00, '439311', 3.73, 184.26);
INSERT INTO compras_a_proveedor VALUES (1114848, false, '2009-01-10', NULL, 269, '2008-04-27', 3.77, 17.95, 8.29, '4417', 0.00, 30.01);
INSERT INTO compras_a_proveedor VALUES (1114850, false, '2009-01-10', NULL, 20, '2008-04-23', 31.26, 177.85, 0.00, '136.901/0', 2.89, 212.00);
INSERT INTO compras_a_proveedor VALUES (1114852, false, '2009-01-10', NULL, 291, '2008-05-01', 9.45, 45.00, 0.00, '27893', 0.00, 54.45);
INSERT INTO compras_a_proveedor VALUES (1114854, false, '2009-01-10', NULL, 536, '2008-05-13', 0.00, 2.20, 0.00, '682827', 0.00, 2.20);
INSERT INTO compras_a_proveedor VALUES (1114856, false, '2009-01-10', NULL, 536, '2008-05-13', 0.00, 2.20, 0.00, '55504', 0.00, 2.20);
INSERT INTO compras_a_proveedor VALUES (1114858, false, '2009-01-10', NULL, 42, '2008-05-05', 0.00, 692.00, 0.00, '045', 0.00, 692.00);
INSERT INTO compras_a_proveedor VALUES (1114860, false, '2009-01-10', NULL, -1307639808, '2008-05-26', 0.00, 96.12, 0.00, '147405', 0.00, 96.12);
INSERT INTO compras_a_proveedor VALUES (1114862, false, '2009-01-10', NULL, -1308164093, '2008-05-12', 24.80, 118.09, 0.00, '80413', 0.00, 142.89);
INSERT INTO compras_a_proveedor VALUES (1114864, false, '2009-01-10', NULL, 52, '2008-05-20', 0.00, 54.00, 0.00, '977', 0.00, 54.00);
INSERT INTO compras_a_proveedor VALUES (1114866, false, '2009-01-10', NULL, -1307738107, '2008-05-14', 0.00, 165.00, 0.00, '3394', 0.00, 165.00);
INSERT INTO compras_a_proveedor VALUES (1114868, false, '2009-01-10', NULL, 52, '2008-04-23', 0.00, 111.00, 0.00, '948', 0.00, 111.00);
INSERT INTO compras_a_proveedor VALUES (1114870, false, '2009-01-10', NULL, 52, '2008-05-08', 0.00, 283.50, 0.00, '961', 0.00, 283.50);
INSERT INTO compras_a_proveedor VALUES (1114872, false, '2009-01-10', NULL, 98, '2008-05-07', 0.00, 85.00, 0.00, '230', 0.00, 85.00);
INSERT INTO compras_a_proveedor VALUES (1114874, true, '2009-01-10', NULL, 657, '2009-01-10', 0.00, 260.88, 0.00, '3090678', 0.00, 260.88);
INSERT INTO compras_a_proveedor VALUES (1114876, false, '2009-01-10', NULL, 657, '2008-05-14', 0.00, 260.88, 0.00, '3090678', 0.00, 260.88);
INSERT INTO compras_a_proveedor VALUES (1114880, false, '2009-01-10', NULL, 287, '2008-04-30', 0.00, 500.00, 0.00, '207', 0.00, 500.00);
INSERT INTO compras_a_proveedor VALUES (1114882, false, '2009-01-10', NULL, -1308098559, '2008-05-02', 0.00, 150.00, 0.00, '2074', 0.00, 150.00);
INSERT INTO compras_a_proveedor VALUES (1114884, false, '2009-01-10', NULL, 283, '2008-05-02', 0.00, 50.00, 0.00, '761', 0.00, 50.00);
INSERT INTO compras_a_proveedor VALUES (1114886, false, '2009-01-10', NULL, -1307738112, '2008-05-05', 0.00, 50.00, 0.00, '419', 0.00, 50.00);
INSERT INTO compras_a_proveedor VALUES (1114888, false, '2009-01-10', NULL, 1, '2008-06-20', 236.25, 1125.00, 0.00, '11828', 0.00, 1361.25);
INSERT INTO compras_a_proveedor VALUES (1114890, false, '2009-01-10', NULL, 1, '2008-06-20', 236.25, 1125.00, 0.00, '11828', 0.00, 1361.25);
INSERT INTO compras_a_proveedor VALUES (1114892, false, '2009-01-10', NULL, 1, '2008-06-25', 39.27, 187.00, 0.00, '11854', 0.00, 226.27);
INSERT INTO compras_a_proveedor VALUES (1114894, false, '2009-01-10', NULL, 1, '2008-06-19', 111.30, 530.00, 0.00, '11815', 0.00, 641.30);
INSERT INTO compras_a_proveedor VALUES (1114896, false, '2009-01-10', NULL, 1, '2008-05-03', 432.81, 2061.00, 0.00, '11691', 0.00, 2493.81);
INSERT INTO compras_a_proveedor VALUES (1114898, false, '2009-01-10', NULL, 1, '2008-06-02', 70.61, 336.25, 0.00, '11676', 0.00, 406.86);
INSERT INTO compras_a_proveedor VALUES (1114900, false, '2009-01-10', NULL, 211, '2008-06-24', 25.87, 123.20, 0.00, '41187', 0.00, 149.07);
INSERT INTO compras_a_proveedor VALUES (1114902, false, '2009-01-10', NULL, 28, '2008-06-18', 75.55, 359.75, 0.00, '4668', 8.99, 444.29);
INSERT INTO compras_a_proveedor VALUES (1114904, false, '2009-01-10', NULL, 28, '2008-06-10', 86.56, 412.20, 0.00, '4469', 10.31, 509.07);
INSERT INTO compras_a_proveedor VALUES (1114906, false, '2009-01-10', NULL, 28, '2008-06-03', 377.74, 1798.75, 0.00, '4224', 44.97, 2221.46);
INSERT INTO compras_a_proveedor VALUES (1114908, false, '2009-01-10', NULL, 28, '2008-06-05', 170.86, 813.60, 0.00, '4313', 20.35, 1004.81);
INSERT INTO compras_a_proveedor VALUES (1114910, false, '2009-01-10', NULL, 46, '2008-06-02', 318.66, 1517.45, 0.00, '41446', 0.00, 1836.11);
INSERT INTO compras_a_proveedor VALUES (1114912, false, '2009-01-10', NULL, 114, '2008-06-25', 216.22, 1029.60, 0.00, '7547', 0.00, 1245.82);
INSERT INTO compras_a_proveedor VALUES (1114914, false, '2009-01-10', NULL, 114, '2008-06-03', 68.46, 326.00, 0.00, '7422', 0.00, 394.46);
INSERT INTO compras_a_proveedor VALUES (1114916, false, '2009-01-10', NULL, 385, '2008-05-06', 342.72, 1632.00, 0.00, '6853', 0.00, 1974.72);
INSERT INTO compras_a_proveedor VALUES (1114918, false, '2009-01-10', NULL, 61, '2008-06-18', 68.32, 325.32, 0.00, '70672', 8.13, 401.77);
INSERT INTO compras_a_proveedor VALUES (1114920, false, '2009-01-10', NULL, 61, '2008-06-02', 234.28, 1115.60, 0.00, '70217', 27.89, 1377.77);
INSERT INTO compras_a_proveedor VALUES (1114922, false, '2009-01-10', NULL, 103, '2008-06-13', 617.16, 2938.84, 0.00, '3302', 0.00, 3556.00);
INSERT INTO compras_a_proveedor VALUES (1114924, false, '2009-01-10', NULL, 962, '2008-06-13', 171.36, 816.00, 0.00, '18', 0.00, 987.36);
INSERT INTO compras_a_proveedor VALUES (1114926, false, '2009-01-10', NULL, 55, '2008-06-24', 55.11, 524.88, 0.00, '35234', 0.00, 579.99);
INSERT INTO compras_a_proveedor VALUES (1114928, false, '2009-01-10', NULL, 55, '2008-06-02', 46.46, 442.52, 0.00, '35120', 0.00, 488.98);
INSERT INTO compras_a_proveedor VALUES (1114930, false, '2009-01-10', NULL, 55, '2008-06-12', 49.02, 466.95, 0.00, '34970', 0.00, 515.97);
INSERT INTO compras_a_proveedor VALUES (1114932, false, '2009-01-10', NULL, 80, '2008-06-20', 50.23, 239.20, 0.00, '2468', 0.00, 289.43);
INSERT INTO compras_a_proveedor VALUES (1114934, false, '2009-01-10', NULL, 80, '2008-06-04', 100.80, 480.00, 0.00, '2409', 0.00, 580.80);
INSERT INTO compras_a_proveedor VALUES (1114937, false, '2009-01-10', NULL, 80, '2008-05-29', 342.30, 1630.00, 0.00, '2372', 0.00, 1972.30);
INSERT INTO compras_a_proveedor VALUES (1114939, false, '2009-01-10', NULL, 80, '2008-05-30', 81.45, 387.88, 0.00, '2379', 0.00, 469.33);
INSERT INTO compras_a_proveedor VALUES (1114941, false, '2009-01-10', NULL, 4, '2008-06-04', 0.01, 0.06, 0.00, '443593', 0.00, 0.07);
INSERT INTO compras_a_proveedor VALUES (1114943, false, '2009-01-10', NULL, 4, '2008-05-15', 43.83, 208.70, 0.00, '441199', 5.22, 257.75);
INSERT INTO compras_a_proveedor VALUES (1114945, false, '2009-01-10', NULL, 4, '2008-06-04', 38.22, 182.00, 0.00, '444008', 4.55, 224.77);
INSERT INTO compras_a_proveedor VALUES (1114947, false, '2009-01-10', NULL, 4, '2008-06-20', 1955.52, 9312.00, 0.00, '2643', 232.80, 11500.32);
INSERT INTO compras_a_proveedor VALUES (1114949, false, '2009-01-10', NULL, 111, '2008-06-25', 139.09, 662.32, 0.00, '172107', 16.56, 817.97);
INSERT INTO compras_a_proveedor VALUES (1114951, false, '2009-01-10', NULL, 111, '2008-06-03', 183.46, 873.60, 0.00, '170632', 21.84, 1078.90);
INSERT INTO compras_a_proveedor VALUES (1114960, false, '2009-01-12', NULL, 80, '2009-01-08', 78.06, 371.71, 0.00, '3379', 0.00, 449.77);
INSERT INTO compras_a_proveedor VALUES (1114970, false, '2009-01-12', NULL, 95, '2009-01-10', 3.15, 15.00, 0.00, '121420', 0.00, 18.15);
INSERT INTO compras_a_proveedor VALUES (1114972, false, '2009-01-12', NULL, 49, '2009-01-16', 176.69, 747.92, 0.00, '67443', 25.24, 949.85);
INSERT INTO compras_a_proveedor VALUES (1114977, false, '2009-01-12', NULL, 617, '2008-06-06', 1.71, 9.29, 0.00, '30456', 0.00, 11.00);
INSERT INTO compras_a_proveedor VALUES (1114979, false, '2009-01-12', NULL, 617, '2008-06-03', 1.50, 7.00, 0.00, '117560', 0.00, 8.50);
INSERT INTO compras_a_proveedor VALUES (1115021, false, '2009-01-12', NULL, 15, '2008-06-04', 20.79, 99.02, 0.00, '172731', 0.00, 119.81);
INSERT INTO compras_a_proveedor VALUES (1115023, false, '2009-01-12', NULL, 15, '2008-06-09', 20.02, 95.36, 0.00, '172801', 0.00, 115.38);
INSERT INTO compras_a_proveedor VALUES (1115025, false, '2009-01-12', NULL, 15, '2008-06-09', 4.41, 21.00, 0.00, '172843', 0.00, 25.41);
INSERT INTO compras_a_proveedor VALUES (1115027, false, '2009-01-12', NULL, 15, '2008-06-26', 16.49, 78.54, 0.00, '173473', 0.00, 95.03);
INSERT INTO compras_a_proveedor VALUES (1115029, false, '2009-01-12', NULL, 15, '2008-06-27', 16.74, 79.71, 0.00, '173558', 0.00, 96.45);
INSERT INTO compras_a_proveedor VALUES (1115031, false, '2009-01-12', NULL, 95, '2008-06-21', 3.28, 15.60, 0.00, '111719', 0.00, 18.88);
INSERT INTO compras_a_proveedor VALUES (1115033, false, '2009-01-12', NULL, 15, '2008-06-21', 4.52, 21.50, 0.00, '173291', 0.00, 26.02);
INSERT INTO compras_a_proveedor VALUES (1115035, false, '2009-01-12', NULL, 15, '2008-06-20', 4.30, 20.49, 0.00, '173225', 0.00, 24.79);
INSERT INTO compras_a_proveedor VALUES (1115037, false, '2009-01-12', NULL, 15, '2008-06-19', 23.83, 113.48, 0.00, '173157', 0.00, 137.31);
INSERT INTO compras_a_proveedor VALUES (1115039, false, '2009-01-12', NULL, 15, '2008-06-14', 2.50, 11.89, 0.00, '173004', 0.00, 14.39);
INSERT INTO compras_a_proveedor VALUES (1115041, false, '2009-01-12', NULL, 15, '2008-06-11', 12.52, 59.62, 0.00, '172910', 0.00, 72.14);
INSERT INTO compras_a_proveedor VALUES (1115043, false, '2009-01-12', NULL, 536, '2008-06-05', 0.00, 2.50, 0.00, '851106', 0.00, 2.50);
INSERT INTO compras_a_proveedor VALUES (1115045, false, '2009-01-12', NULL, 536, '2008-06-05', 0.00, 2.50, 0.00, '873121', 0.00, 2.50);
INSERT INTO compras_a_proveedor VALUES (1115047, false, '2009-01-12', NULL, 269, '2008-06-26', 6.29, 29.93, 8.80, '6408', 0.00, 45.02);
INSERT INTO compras_a_proveedor VALUES (1115049, false, '2009-01-12', NULL, 269, '2008-06-12', 5.28, 25.13, 9.61, '7516', 0.00, 40.02);
INSERT INTO compras_a_proveedor VALUES (1115051, false, '2009-01-12', NULL, 269, '2008-06-06', 4.91, 23.36, 8.76, '7210', 0.00, 37.03);
INSERT INTO compras_a_proveedor VALUES (1115053, false, '2009-01-12', NULL, 269, '2008-06-01', 19.36, 92.17, 34.54, '5649', 3.17, 149.24);
INSERT INTO compras_a_proveedor VALUES (1115055, false, '2009-01-12', NULL, 269, '2008-05-31', 3.98, 18.93, 7.10, '6847', 0.00, 30.01);
INSERT INTO compras_a_proveedor VALUES (1115057, false, '2009-01-12', NULL, 269, '2008-05-18', 13.26, 63.12, 23.65, '5884', 2.17, 102.20);
INSERT INTO compras_a_proveedor VALUES (1115059, false, '2009-01-12', NULL, 269, '2008-05-11', 17.30, 82.36, 33.40, '4602', 2.89, 135.95);
INSERT INTO compras_a_proveedor VALUES (1115061, false, '2009-01-12', NULL, 269, '2008-05-02', 11.67, 55.55, 20.23, '4748', 1.89, 89.34);
INSERT INTO compras_a_proveedor VALUES (1115063, false, '2009-01-12', NULL, 269, '2008-04-20', 22.39, 106.62, 38.84, '3981', 3.64, 171.49);
INSERT INTO compras_a_proveedor VALUES (1115065, false, '2009-01-12', NULL, 269, '2008-04-13', 9.87, 47.01, 17.12, '3616', 1.60, 75.60);
INSERT INTO compras_a_proveedor VALUES (1115067, false, '2009-01-12', NULL, 269, '2008-06-19', 9.49, 45.21, 13.29, '7680', 1.46, 69.45);
INSERT INTO compras_a_proveedor VALUES (1115069, false, '2009-01-12', NULL, -1307607040, '2008-06-17', 16.11, 76.74, 21.15, '10754', 0.00, 114.00);
INSERT INTO compras_a_proveedor VALUES (1115071, false, '2009-01-12', NULL, 135, '2008-06-22', 11.89, 80.26, 0.00, '173589', 0.00, 92.15);
INSERT INTO compras_a_proveedor VALUES (1115073, false, '2009-01-12', NULL, 269, '2008-06-08', 10.41, 49.58, 13.98, '5862', 1.59, 75.56);
INSERT INTO compras_a_proveedor VALUES (1115075, false, '2009-01-12', NULL, 269, '2008-06-04', 11.61, 55.30, 16.07, '7139', 1.78, 84.76);
INSERT INTO compras_a_proveedor VALUES (1115078, false, '2009-01-12', NULL, 24, '2008-06-13', 0.00, 15.78, 0.00, '181667', 0.00, 15.78);
INSERT INTO compras_a_proveedor VALUES (1115080, false, '2009-01-12', NULL, -1307607039, '2008-06-23', 137.11, 652.89, 0.00, '2837', 0.00, 790.00);
INSERT INTO compras_a_proveedor VALUES (1115082, false, '2009-01-12', NULL, 1044, '2008-06-04', 30.20, 113.58, 0.00, '11225', 0.00, 143.78);
INSERT INTO compras_a_proveedor VALUES (1115084, false, '2009-01-12', NULL, 52, '2008-06-18', 0.00, 56.00, 0.00, '1006', 0.00, 56.00);
INSERT INTO compras_a_proveedor VALUES (1115110, false, '2009-01-13', NULL, 4, '2009-01-13', 97.86, 466.00, 0.00, '473102', 16.31, 580.17);
INSERT INTO compras_a_proveedor VALUES (1115111, false, '2009-01-13', NULL, 287, '2009-01-13', 0.00, 500.00, 0.00, '370', 0.00, 500.00);
INSERT INTO compras_a_proveedor VALUES (1115113, false, '2009-01-13', NULL, 269, '2009-01-07', 10.31, 49.08, 15.61, '27075', 0.00, 75.00);
INSERT INTO compras_a_proveedor VALUES (1115115, false, '2009-01-13', NULL, 80, '2009-01-09', 12.44, 59.24, 0.00, '3382', 0.00, 71.68);
INSERT INTO compras_a_proveedor VALUES (1115116, false, '2009-01-13', NULL, 55, '2009-01-13', 42.76, 407.23, 0.00, '37042', 0.00, 449.99);
INSERT INTO compras_a_proveedor VALUES (1115118, false, '2009-01-13', NULL, 15, '2009-01-13', 11.08, 52.73, 0.00, '182367', 0.00, 63.81);
INSERT INTO compras_a_proveedor VALUES (1115119, false, '2009-01-13', NULL, 1, '2009-01-12', 201.60, 960.00, 0.00, '13572', 0.00, 1161.60);
INSERT INTO compras_a_proveedor VALUES (1115120, false, '2009-01-13', NULL, 639, '2009-01-13', 7.46, 35.54, 0.00, '12945', 0.00, 43.00);
INSERT INTO compras_a_proveedor VALUES (1115123, false, '2009-01-13', NULL, -1308164087, '2009-01-05', 106.47, 507.00, 0.00, '6264', 0.00, 613.47);
INSERT INTO compras_a_proveedor VALUES (1115127, false, '2009-01-13', NULL, 12, '2008-06-27', 16.31, 77.66, 0.00, '35119', 0.00, 93.97);
INSERT INTO compras_a_proveedor VALUES (1115129, false, '2009-01-13', NULL, 1174, '2008-06-14', 28.64, 136.36, 0.00, '7842', 0.00, 165.00);
INSERT INTO compras_a_proveedor VALUES (1115141, false, '2009-01-13', NULL, -1307574272, '2008-06-11', 0.00, 500.00, 0.00, '55', 0.00, 500.00);
INSERT INTO compras_a_proveedor VALUES (1115143, false, '2009-01-13', NULL, -1307574271, '2008-06-19', 142.80, 680.00, 0.00, '5566', 0.00, 822.80);
INSERT INTO compras_a_proveedor VALUES (1115145, false, '2009-01-13', NULL, 564, '2008-06-30', 12.43, 59.21, 0.00, '3872', 0.00, 71.64);
INSERT INTO compras_a_proveedor VALUES (1115147, false, '2009-01-13', NULL, -1307574270, '2008-05-30', 55.82, 265.83, 0.00, '1659', 0.00, 321.65);
INSERT INTO compras_a_proveedor VALUES (1115149, false, '2009-01-13', NULL, 121, '2008-06-20', 105.00, 500.00, 0.00, '68710', 0.00, 605.00);
INSERT INTO compras_a_proveedor VALUES (1115151, false, '2009-01-13', NULL, -1307738104, '2008-06-03', 4.72, 22.50, 0.00, '5123', 0.00, 27.22);
INSERT INTO compras_a_proveedor VALUES (1115153, false, '2009-01-13', NULL, 713, '2008-05-07', 0.00, 340.00, 0.00, '1390', 0.00, 340.00);
INSERT INTO compras_a_proveedor VALUES (1115155, false, '2009-01-13', NULL, -1307574269, '2008-06-24', 12.84, 61.16, 0.00, '54511', 0.00, 74.00);
INSERT INTO compras_a_proveedor VALUES (1115157, false, '2009-01-13', NULL, -1307574269, '2008-06-24', 3.47, 16.53, 0.00, '54514', 0.00, 20.00);
INSERT INTO compras_a_proveedor VALUES (1115159, false, '2009-01-13', NULL, -1307574271, '2008-06-03', 142.80, 680.00, 0.00, '5523', 0.00, 822.80);
INSERT INTO compras_a_proveedor VALUES (1115161, false, '2009-01-13', NULL, 42, '2008-06-05', 0.00, 692.00, 0.00, '47', 0.00, 692.00);
INSERT INTO compras_a_proveedor VALUES (1115163, false, '2009-01-13', NULL, 578, '2008-06-06', 13.23, 63.00, 9.00, '1057', 0.00, 85.23);
INSERT INTO compras_a_proveedor VALUES (1115165, false, '2009-01-13', NULL, 578, '2008-06-09', 12.60, 60.00, 18.00, '1060', 0.00, 90.60);
INSERT INTO compras_a_proveedor VALUES (1115167, false, '2009-01-13', NULL, 578, '2008-05-30', 37.14, 176.87, 31.50, '1043', 0.00, 245.51);
INSERT INTO compras_a_proveedor VALUES (1115169, false, '2009-01-13', NULL, 578, '2008-05-28', 19.90, 94.76, 27.00, '1042', 0.00, 141.66);
INSERT INTO compras_a_proveedor VALUES (1115182, false, '2009-01-14', NULL, 12, '2008-06-14', 5.60, 26.66, 0.00, '35050', 0.00, 32.26);
INSERT INTO compras_a_proveedor VALUES (1115184, false, '2009-01-14', NULL, 12, '20089-05-31', 4.73, 22.53, 0.00, '35021', 0.00, 27.26);
INSERT INTO compras_a_proveedor VALUES (1115186, false, '2009-01-14', NULL, 12, '2008-05-31', 4.73, 22.53, 0.00, '35021', 0.00, 27.26);
INSERT INTO compras_a_proveedor VALUES (1115187, false, '2009-01-14', NULL, 639, '2008-06-09', 3.73, 17.77, 0.00, '12119', 0.00, 21.50);
INSERT INTO compras_a_proveedor VALUES (1115189, false, '2009-01-14', NULL, 24, '2008-06-05', 0.00, 780.00, 0.00, '181230', 0.00, 780.00);
INSERT INTO compras_a_proveedor VALUES (1115201, false, '2009-01-14', NULL, 219, '2008-05-30', 105.36, 501.72, 0.00, '2102', 0.00, 607.08);
INSERT INTO compras_a_proveedor VALUES (1115203, false, '2009-01-14', NULL, 219, '2008-05-30', 114.86, 546.93, 0.00, '2099', 0.00, 661.79);
INSERT INTO compras_a_proveedor VALUES (1115205, false, '2009-01-14', NULL, -1307541504, '2008-06-06', 18.22, 86.77, 0.00, '130', 0.00, 104.99);
INSERT INTO compras_a_proveedor VALUES (1115207, false, '2009-01-14', NULL, 49, '2008-12-17', 192.04, 880.71, 0.00, '02025558', 6.99, 1079.74);
INSERT INTO compras_a_proveedor VALUES (1115209, false, '2009-01-14', NULL, 12, '2008-06-07', 15.65, 74.51, 0.00, '35037', 0.00, 90.16);
INSERT INTO compras_a_proveedor VALUES (1115231, false, '2009-01-14', NULL, 291, '2008-06-01', 9.45, 45.00, 0.00, '28531', 0.00, 54.45);
INSERT INTO compras_a_proveedor VALUES (1115233, false, '2009-01-14', NULL, 49, '2008-06-17', 15.13, 72.08, 0.00, '307645', 0.00, 87.21);
INSERT INTO compras_a_proveedor VALUES (1115235, false, '2009-01-14', NULL, -1308164093, '2008-06-13', 0.00, 183.16, 0.00, '80613', 0.00, 183.16);
INSERT INTO compras_a_proveedor VALUES (1115237, false, '2009-01-14', NULL, -1308164093, '2008-05-13', 0.00, 156.65, 0.00, '80513', 0.00, 156.65);
INSERT INTO compras_a_proveedor VALUES (1115239, false, '2009-01-14', NULL, 52, '2009-01-12', 0.00, 129.00, 0.00, '1161', 0.00, 129.00);
INSERT INTO compras_a_proveedor VALUES (1115241, false, '2009-01-14', NULL, 98, '2009-01-14', 0.00, 45.00, 0.00, '312', 0.00, 45.00);
INSERT INTO compras_a_proveedor VALUES (1115243, false, '2009-01-14', NULL, 49, '2008-05-28', 151.49, 586.01, 0.00, '169594', 14.07, 751.57);
INSERT INTO compras_a_proveedor VALUES (1115245, false, '2009-01-14', NULL, -1307738105, '2008-06-19', 4.34, 20.66, 0.00, '28380', 0.00, 25.00);
INSERT INTO compras_a_proveedor VALUES (1115247, false, '2009-01-14', NULL, -1307541503, '2008-06-05', 0.00, 4.40, 0.00, '1858', 0.00, 4.40);
INSERT INTO compras_a_proveedor VALUES (1115249, false, '2009-01-14', NULL, -1307705344, '2008-06-10', 48.30, 230.00, 0.00, '3799', 0.00, 278.30);
INSERT INTO compras_a_proveedor VALUES (1115251, false, '2009-01-14', NULL, -1307738105, '2008-05-30', 7.69, 36.61, 0.00, '28274', 0.00, 44.30);
INSERT INTO compras_a_proveedor VALUES (1115253, false, '2009-01-14', NULL, -1307705344, '2008-06-03', 29.40, 140.00, 0.00, '3786', 0.00, 169.40);
INSERT INTO compras_a_proveedor VALUES (1115255, false, '2009-01-14', NULL, 287, '2008-05-30', 0.00, 500.00, 0.00, '226', 0.00, 500.00);
INSERT INTO compras_a_proveedor VALUES (1115263, false, '2009-01-15', NULL, -1308098560, '2009-01-15', 0.00, 127.50, 0.00, '135', 0.00, 127.50);
INSERT INTO compras_a_proveedor VALUES (1115311, false, '2009-01-16', NULL, 12, '2008-03-04', 4.35, 20.70, 0.00, '34425', 0.00, 25.05);
INSERT INTO compras_a_proveedor VALUES (1113984, true, '2008-12-26', NULL, 12, '2008-12-26', 4.35, 20.70, 0.00, '34425', 0.00, 25.05);
INSERT INTO compras_a_proveedor VALUES (1115332, false, '2009-01-17', NULL, 52, '2009-01-15', 0.00, 72.00, 0.00, '1164', 0.00, 72.00);
INSERT INTO compras_a_proveedor VALUES (1115333, false, '2009-01-17', NULL, -1307738109, '2009-01-02', 0.00, 150.00, 0.00, '13047', 0.00, 150.00);
INSERT INTO compras_a_proveedor VALUES (1115335, false, '2009-01-17', NULL, 4, '2009-01-06', 43.23, 205.87, 0.00, '474132', 7.21, 256.31);
INSERT INTO compras_a_proveedor VALUES (1115336, false, '2009-01-17', NULL, 776, '2009-01-17', 2.78, 13.22, 0.00, '15693', 0.00, 16.00);
INSERT INTO compras_a_proveedor VALUES (1115340, false, '2009-01-19', NULL, 269, '2009-01-17', 13.53, 64.45, 20.65, '12162', 0.00, 98.63);
INSERT INTO compras_a_proveedor VALUES (1115342, false, '2009-01-19', NULL, 269, '2009-01-18', 7.30, 34.75, 17.98, '28282', 0.00, 60.03);
INSERT INTO compras_a_proveedor VALUES (1115344, false, '2009-01-19', NULL, 269, '2009-01-11', 19.77, 94.14, 39.13, '11813', 0.00, 153.04);
INSERT INTO compras_a_proveedor VALUES (1115346, false, '2009-01-19', NULL, 269, '2009-01-18', 20.91, 99.57, 51.51, '28278', 0.00, 171.99);
INSERT INTO compras_a_proveedor VALUES (1115348, false, '2009-01-19', NULL, 269, '2009-01-19', 16.79, 79.94, 41.28, '25588', 0.00, 138.01);
INSERT INTO compras_a_proveedor VALUES (1115370, false, '2009-01-19', NULL, 269, '2009-01-19', 8.51, 40.54, 20.94, '25589', 0.00, 69.99);
INSERT INTO compras_a_proveedor VALUES (1115372, false, '2009-01-19', NULL, 269, '2009-01-04', 17.64, 84.02, 43.39, '11437', 0.00, 145.05);
INSERT INTO compras_a_proveedor VALUES (1115375, false, '2009-01-19', NULL, 1440, '2009-01-19', 0.00, 240.00, 0.00, '630', 0.00, 240.00);
INSERT INTO compras_a_proveedor VALUES (1115377, false, '2009-01-20', NULL, 114, '2009-01-15', 364.77, 1737.00, 0.00, '8712', 0.00, 2101.77);
INSERT INTO compras_a_proveedor VALUES (1115378, false, '2009-01-20', NULL, 15, '2009-01-20', 23.13, 110.18, 0.00, '182578', 0.00, 133.31);
INSERT INTO compras_a_proveedor VALUES (1115379, false, '2009-01-20', NULL, 111, '2009-01-16', 13.82, 65.82, 0.00, '183516', 2.30, 81.94);
INSERT INTO compras_a_proveedor VALUES (1115400, false, '2009-01-20', NULL, 49, '2009-01-11', 4.42, 16.40, 0.00, '338836', 0.00, 20.82);
INSERT INTO compras_a_proveedor VALUES (1115401, false, '2009-01-20', NULL, 928, '2009-01-13', 9.64, 45.90, 0.00, '33416', 0.00, 55.54);
INSERT INTO compras_a_proveedor VALUES (1115402, false, '2009-01-20', NULL, 1, '2009-01-19', 42.21, 201.00, 0.00, '13645', 0.00, 243.21);
INSERT INTO compras_a_proveedor VALUES (1115420, false, '2009-01-21', NULL, -1307508736, '2009-01-20', 0.00, 45.50, 0.00, '5288', 0.00, 45.50);
INSERT INTO compras_a_proveedor VALUES (1115421, false, '2009-01-21', NULL, -1307901949, '2009-01-20', 3.47, 16.52, 0.00, '19154', 0.00, 19.99);
INSERT INTO compras_a_proveedor VALUES (1115424, false, '2009-01-21', NULL, 111, '2009-01-19', 36.11, 171.96, 0.00, '183583', 6.02, 214.09);
INSERT INTO compras_a_proveedor VALUES (1115425, false, '2009-01-21', NULL, 61, '2009-01-19', 133.62, 636.30, 0.00, '75498', 22.27, 792.19);
INSERT INTO compras_a_proveedor VALUES (1115426, false, '2009-01-21', NULL, 46, '2009-01-20', 64.81, 308.64, 0.00, '45379', 0.00, 373.45);
INSERT INTO compras_a_proveedor VALUES (1115427, false, '2009-01-21', NULL, 15, '2009-01-21', 11.69, 55.69, 0.00, '182641', 0.00, 67.38);
INSERT INTO compras_a_proveedor VALUES (1115428, false, '2009-01-21', NULL, 277, '2009-01-21', 270.90, 1290.00, 0.00, '3565', 0.00, 1560.90);
INSERT INTO compras_a_proveedor VALUES (1115452, false, '2009-01-21', NULL, 55, '2009-01-21', 42.76, 407.23, 0.00, '37213', 0.00, 449.99);
INSERT INTO compras_a_proveedor VALUES (1115460, false, '2009-01-22', NULL, 111, '2009-01-20', 62.24, 296.40, 0.00, '183677', 10.37, 369.01);
INSERT INTO compras_a_proveedor VALUES (1115461, false, '2009-01-22', NULL, -1307803648, '2009-01-22', 9.16, 43.60, 0.00, '66073', 0.00, 52.76);
INSERT INTO compras_a_proveedor VALUES (1115463, false, '2009-01-22', NULL, 15, '2009-01-22', 2.75, 13.08, 0.00, '182703', 0.00, 15.83);
INSERT INTO compras_a_proveedor VALUES (1115464, false, '2009-01-22', NULL, -1308164094, '2009-01-21', 39.69, 189.00, 0.00, '16321', 0.00, 228.69);
INSERT INTO compras_a_proveedor VALUES (1115468, false, '2009-01-22', NULL, 80, '2009-01-21', 120.33, 573.00, 0.00, '3420', 0.00, 693.33);
INSERT INTO compras_a_proveedor VALUES (1115469, false, '2009-01-22', NULL, 95, '2009-01-22', 3.28, 15.60, 0.00, '121797', 0.00, 18.88);
INSERT INTO compras_a_proveedor VALUES (1115500, false, '2009-01-22', NULL, -1308164094, '2009-01-21', 128.42, 611.50, 0.00, 'COTIZACION 00000009', 0.00, 739.92);
INSERT INTO compras_a_proveedor VALUES (1115501, false, '2009-01-23', NULL, 15, '2009-01-23', 103.54, 493.03, 0.00, '182785', 0.00, 596.57);
INSERT INTO compras_a_proveedor VALUES (1115502, false, '2009-01-23', NULL, 28, '2009-01-21', 167.58, 798.00, 0.00, '9884', 27.95, 993.53);
INSERT INTO compras_a_proveedor VALUES (1115503, false, '2009-01-23', NULL, 385, '2009-01-19', 1799.53, 8569.20, 0.00, '9458', 0.00, 10368.73);
INSERT INTO compras_a_proveedor VALUES (1115504, false, '2009-01-23', NULL, 28, '2009-01-21', 111.22, 529.60, 0.00, '9868', 18.54, 659.36);
INSERT INTO compras_a_proveedor VALUES (1115505, false, '2009-01-23', NULL, 28, '2009-01-21', 540.59, 2574.24, 0.00, '9859', 90.09, 3204.92);
INSERT INTO compras_a_proveedor VALUES (1115506, false, '2009-01-23', NULL, 28, '2009-01-21', 154.35, 735.00, 0.00, '9881', 25.74, 915.09);
INSERT INTO compras_a_proveedor VALUES (1115507, true, '2009-01-23', NULL, 28, '2009-01-19', 0.00, 290.00, 0.00, '9459', 0.00, 290.00);
INSERT INTO compras_a_proveedor VALUES (1115560, false, '2009-01-24', NULL, -1308131315, '2009-01-16', 20.32, 96.74, 40.21, '75535', 0.00, 157.27);
INSERT INTO compras_a_proveedor VALUES (1115562, false, '2009-01-24', NULL, -1307475968, '2009-01-16', 16.30, 77.63, 30.08, '60393', 0.00, 124.01);
INSERT INTO compras_a_proveedor VALUES (1115564, false, '2009-01-24', NULL, 269, '2009-01-21', 24.55, 116.89, 48.58, '28590', 0.00, 190.02);
INSERT INTO compras_a_proveedor VALUES (1115567, false, '2009-01-24', NULL, -1307475967, '2009-01-18', 25.34, 120.68, 46.95, '6297', 0.00, 192.97);
INSERT INTO compras_a_proveedor VALUES (1115568, false, '2009-01-24', NULL, -1307475966, '2009-01-20', 0.00, 1165.00, 0.00, '2841', 0.00, 1165.00);
INSERT INTO compras_a_proveedor VALUES (1115620, false, '2009-01-26', NULL, 4, '2009-01-26', 841.80, 4008.60, 0.00, '48511', 140.30, 4990.70);
INSERT INTO compras_a_proveedor VALUES (1115640, false, '2009-01-26', NULL, 256, '2009-01-26', 0.00, 15.55, 0.00, '5-1-249167', 0.54, 16.09);
INSERT INTO compras_a_proveedor VALUES (1115650, false, '2009-01-27', NULL, 196, '2009-01-22', 330.67, 1574.60, 0.00, '5195', 0.00, 1905.27);
INSERT INTO compras_a_proveedor VALUES (1115651, false, '2009-01-27', NULL, 15, '2009-01-27', 4.44, 21.13, 0.00, '182843', 0.00, 25.57);
INSERT INTO compras_a_proveedor VALUES (1115652, false, '2009-01-28', NULL, -1307836415, '2009-01-27', 17.24, 82.11, 0.00, '8145', 0.00, 99.35);
INSERT INTO compras_a_proveedor VALUES (1115654, false, '2009-01-28', NULL, 955, '2009-01-13', 9.37, 44.63, 0.00, '628', 0.00, 54.00);
INSERT INTO compras_a_proveedor VALUES (1115657, false, '2009-01-28', NULL, -1308164093, '2009-01-13', 0.00, 178.30, 0.00, '90113', 0.00, 178.30);
INSERT INTO compras_a_proveedor VALUES (1115658, true, '2009-01-28', NULL, -1308164086, '2009-01-28', 20.81, 109.51, 0.00, '19298031/4', 0.00, 130.32);
INSERT INTO compras_a_proveedor VALUES (1115659, false, '2009-01-28', NULL, -1308131315, '2009-01-28', 11.67, 55.55, 17.80, '77729', 0.00, 85.02);
INSERT INTO compras_a_proveedor VALUES (1115712, false, '2009-01-29', NULL, 20, '2009-01-22', 43.11, 243.40, 0.00, '337.474/2', 3.99, 290.50);
INSERT INTO compras_a_proveedor VALUES (1115763, false, '2009-01-30', NULL, 111, '2009-01-30', 0.00, 645.00, 0.00, '670  nota de debito', 0.00, 645.00);
INSERT INTO compras_a_proveedor VALUES (1115764, false, '2009-01-30', NULL, -1307705342, '2009-01-26', 0.00, 300.00, 0.00, '26367', 0.00, 300.00);
INSERT INTO compras_a_proveedor VALUES (1115765, false, '2009-01-30', NULL, 15, '2009-01-29', 4.55, 21.66, 0.00, '182950', 0.00, 26.21);
INSERT INTO compras_a_proveedor VALUES (1115766, false, '2009-01-30', NULL, 114, '2009-01-27', 14.99, 71.40, 0.00, '8746', 0.00, 86.39);
INSERT INTO compras_a_proveedor VALUES (1115768, false, '2009-01-30', NULL, 111, '2009-01-27', 33.14, 157.80, 0.00, '184018', 5.52, 196.46);
INSERT INTO compras_a_proveedor VALUES (1115769, false, '2009-01-30', NULL, 385, '2009-01-28', 1150.80, 5480.00, 0.00, '9557', 0.00, 6630.80);
INSERT INTO compras_a_proveedor VALUES (1115770, false, '2009-01-30', NULL, 15, '2009-01-30', 35.85, 170.76, 0.00, '182998', 0.00, 206.61);
INSERT INTO compras_a_proveedor VALUES (1115771, false, '2009-01-30', NULL, 55, '2009-01-29', 30.64, 291.85, 0.00, '37230', 0.00, 322.49);
INSERT INTO compras_a_proveedor VALUES (1115772, false, '2009-01-30', NULL, 1, '2009-01-29', 343.35, 1635.00, 0.00, '13764', 0.00, 1978.35);
INSERT INTO compras_a_proveedor VALUES (1115780, false, '2009-01-31', NULL, 80, '2009-01-30', 4.62, 22.00, 0.00, '3451', 0.00, 26.62);
INSERT INTO compras_a_proveedor VALUES (1115781, false, '2009-01-31', NULL, 80, '2009-01-26', 73.42, 349.60, 0.00, '3438', 0.00, 423.02);
INSERT INTO compras_a_proveedor VALUES (1115860, false, '2009-02-04', NULL, 98, '2009-02-03', 0.00, 135.00, 0.00, '320', 0.00, 135.00);
INSERT INTO compras_a_proveedor VALUES (1115862, false, '2009-02-04', NULL, 1048, '2009-02-04', 11.28, 53.75, 0.00, '8446', 0.00, 65.03);
INSERT INTO compras_a_proveedor VALUES (1115820, true, '2009-02-03', NULL, -1308131313, '2009-01-19', 15.75, 150.00, 0.00, '98201', 0.00, 165.75);
INSERT INTO compras_a_proveedor VALUES (1115864, false, '2009-02-04', NULL, -1308131313, '2009-02-03', 15.75, 150.00, 0.00, '98201', 0.00, 165.75);
INSERT INTO compras_a_proveedor VALUES (1115867, false, '2009-02-04', NULL, 928, '2009-02-04', 30.83, 146.82, 0.00, '33648', 0.00, 177.65);
INSERT INTO compras_a_proveedor VALUES (1115910, false, '2009-02-05', NULL, 287, '2009-02-05', 0.00, 500.00, 0.00, '393', 0.00, 500.00);
INSERT INTO compras_a_proveedor VALUES (1115911, false, '2009-02-05', NULL, -1308098559, '2009-02-02', 0.00, 150.00, 0.00, '2279', 0.00, 150.00);
INSERT INTO compras_a_proveedor VALUES (1115912, false, '2009-02-05', NULL, 55, '2009-02-05', 48.45, 461.52, 0.00, '37249', 0.00, 509.97);
INSERT INTO compras_a_proveedor VALUES (1115913, false, '2009-02-05', NULL, 111, '2009-02-03', 31.97, 152.26, 0.00, '184308', 5.33, 189.56);
INSERT INTO compras_a_proveedor VALUES (1115914, false, '2009-02-05', NULL, 15, '2009-02-05', 2.49, 11.83, 0.00, '183175', 0.00, 14.32);
INSERT INTO compras_a_proveedor VALUES (1115980, false, '2009-02-07', NULL, -1307672572, '2009-02-06', 66.36, 316.00, 0.00, '673', 0.00, 382.36);
INSERT INTO compras_a_proveedor VALUES (1115982, false, '2009-02-07', NULL, 291, '2009-02-01', 11.98, 57.02, 0.00, '32677', 0.00, 69.00);
INSERT INTO compras_a_proveedor VALUES (1115983, false, '2009-02-07', NULL, 15, '2009-02-06', 2.67, 12.71, 0.00, '183214', 0.00, 15.38);
INSERT INTO compras_a_proveedor VALUES (1115984, false, '2009-02-07', NULL, 269, '2009-02-06', 25.84, 123.05, 51.14, '30187', 0.00, 200.03);
INSERT INTO compras_a_proveedor VALUES (1115985, false, '2009-02-07', NULL, 269, '2009-02-07', 25.84, 123.05, 51.14, '29338', 0.00, 200.03);
INSERT INTO compras_a_proveedor VALUES (1115981, true, '2009-02-07', NULL, 219, '2009-01-29', 275.32, 1311.03, 0.00, '168', 0.00, 1586.35);
INSERT INTO compras_a_proveedor VALUES (1115986, false, '2009-02-07', NULL, 219, '2009-02-07', 275.32, 1311.03, 0.00, '168447', 0.00, 1586.35);
INSERT INTO compras_a_proveedor VALUES (1116070, false, '2009-02-10', NULL, -1307443200, '2009-02-10', 0.00, 15.00, 0.00, '16365', 0.00, 15.00);
INSERT INTO compras_a_proveedor VALUES (1116071, false, '2009-02-11', NULL, -1308131315, '2009-02-10', 13.31, 63.39, 20.31, '80482', 0.00, 97.01);
INSERT INTO compras_a_proveedor VALUES (1116072, false, '2009-02-11', NULL, 4, '2009-02-11', 33.64, 160.20, 0.00, '476520', 5.61, 199.45);
INSERT INTO compras_a_proveedor VALUES (1116073, false, '2009-02-11', NULL, -1307443199, '2009-02-11', 0.00, 265.00, 0.00, '3455', 0.00, 265.00);
INSERT INTO compras_a_proveedor VALUES (1116074, false, '2009-02-11', NULL, 15, '2009-02-11', 11.34, 54.02, 0.00, '183354', 0.00, 65.36);
INSERT INTO compras_a_proveedor VALUES (1116076, false, '2009-02-11', NULL, 639, '2009-02-11', 7.46, 35.54, 0.00, '13016', 0.00, 43.00);
INSERT INTO compras_a_proveedor VALUES (1116077, false, '2009-02-11', NULL, 283, '2009-02-11', 0.00, 50.00, 0.00, '632', 0.00, 50.00);
INSERT INTO compras_a_proveedor VALUES (1116140, false, '2009-02-12', NULL, 657, '2009-02-12', 49.12, 249.45, 0.00, '3402597/2', 0.00, 298.57);
INSERT INTO compras_a_proveedor VALUES (1116141, false, '2009-02-12', NULL, 24, '2009-02-12', 0.00, 2460.00, 0.00, '191561', 0.00, 2460.00);
INSERT INTO compras_a_proveedor VALUES (1116145, false, '2009-02-13', NULL, 4, '2009-02-12', 1047.44, 4987.80, 0.00, '2929', 174.57, 6209.81);
INSERT INTO compras_a_proveedor VALUES (1116146, false, '2009-02-14', NULL, 61, '2009-02-11', 121.28, 577.50, 0.00, '75942', 20.21, 718.99);
INSERT INTO compras_a_proveedor VALUES (1116147, false, '2009-02-14', NULL, 15, '2009-02-13', 4.84, 23.04, 0.00, '183452', 0.00, 27.88);
INSERT INTO compras_a_proveedor VALUES (1116148, false, '2009-02-14', NULL, 49, '2009-02-12', 366.37, 1313.60, 0.00, '2290434', 45.07, 1725.04);
INSERT INTO compras_a_proveedor VALUES (1116149, false, '2009-02-14', NULL, 121, '2009-02-14', 277.20, 1320.00, 0.00, '77441', 0.00, 1597.20);
INSERT INTO compras_a_proveedor VALUES (1116075, true, '2009-02-11', NULL, 46, '2009-02-10', 1050.74, 5003.52, 0.00, '45718', 0.00, 6054.26);
INSERT INTO compras_a_proveedor VALUES (1116227, false, '2009-02-16', NULL, 46, '2009-02-10', 1050.74, 5003.52, 0.00, '45718', 0.00, 6054.26);


--
-- Data for Name: dps; Type: TABLE DATA; Schema: public; Owner: postgres
--



--
-- Data for Name: hibernate_sequences; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO hibernate_sequences VALUES ('cheques', 222222);
INSERT INTO hibernate_sequences VALUES ('compras_a_proveedor', 222222);
INSERT INTO hibernate_sequences VALUES ('pagos_a_proveedor', 222222);
INSERT INTO hibernate_sequences VALUES ('proveedores', 222245);


--
-- Data for Name: matafuegos; Type: TABLE DATA; Schema: public; Owner: postgres
--



--
-- Data for Name: pagos_a_proveedor; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO pagos_a_proveedor VALUES (130, false, '2008-10-11', NULL, 95, '2008-07-16', 30.49, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1373, false, '2008-10-11', NULL, 269, '2008-09-22', 102.25, '7760', NULL);
INSERT INTO pagos_a_proveedor VALUES (39, false, '2008-10-11', NULL, 36, '2008-07-11', 85.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (314, false, '2008-10-11', NULL, 114, '2008-07-08', 346.00, NULL, 312);
INSERT INTO pagos_a_proveedor VALUES (1115, false, '2008-10-11', NULL, 95, '2008-09-11', 18.88, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (169, false, '2008-10-11', NULL, 55, '2008-07-01', 259.80, NULL, 168);
INSERT INTO pagos_a_proveedor VALUES (313, false, '2008-10-11', NULL, 114, '2008-07-08', 816.00, NULL, 311);
INSERT INTO pagos_a_proveedor VALUES (282, false, '2008-10-11', NULL, 277, '2008-07-02', 123.26, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (306, false, '2008-10-11', NULL, 303, '2008-07-17', 81.12, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1342, false, '2008-10-11', NULL, 1233, '2008-09-22', 343.66, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (241, false, '2008-10-11', NULL, 114, '2008-07-23', 263.27, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (921, false, '2008-10-11', NULL, 385, '2008-09-02', 170.60, NULL, 909);
INSERT INTO pagos_a_proveedor VALUES (920, false, '2008-10-11', NULL, 385, '2008-09-02', 144.00, NULL, 892);
INSERT INTO pagos_a_proveedor VALUES (74, false, '2008-10-11', NULL, 61, '2008-07-11', 289.70, '2002', NULL);
INSERT INTO pagos_a_proveedor VALUES (65, false, '2008-10-11', NULL, 61, '2008-07-15', 677.00, '2002', 64);
INSERT INTO pagos_a_proveedor VALUES (128, false, '2008-10-11', NULL, 110, '2008-06-30', 278.30, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (160, false, '2008-10-11', NULL, 46, '2008-07-17', 3449.29, NULL, 147);
INSERT INTO pagos_a_proveedor VALUES (281, false, '2008-10-11', NULL, 277, '2008-07-24', 107.00, NULL, 280);
INSERT INTO pagos_a_proveedor VALUES (141, false, '2008-10-11', NULL, 134, '2008-07-10', 249.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (159, false, '2008-10-11', 'saldo a favor', 80, '2008-07-17', 256.05, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (919, false, '2008-10-11', NULL, 385, '2008-09-02', 692.00, NULL, 918);
INSERT INTO pagos_a_proveedor VALUES (290, false, '2008-10-11', NULL, 287, '2008-07-24', 500.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (703, false, '2008-10-11', NULL, 49, '2008-08-21', 772.33, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (710, false, '2008-10-11', NULL, 287, '2008-08-20', 500.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (8, false, '2008-10-11', NULL, 4, '2008-07-13', 7011.84, '312380', 7);
INSERT INTO pagos_a_proveedor VALUES (660, false, '2008-10-11', NULL, 657, '2008-08-20', 278.79, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (222, false, '2008-10-11', NULL, 219, '2008-07-22', 778.19, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (129, false, '2008-10-11', NULL, 98, '2008-07-16', 185.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (79, false, '2008-10-11', NULL, 9, '2008-07-15', 57.10, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (202, false, '2008-10-11', NULL, 103, '2008-07-19', 678.70, NULL, 195);
INSERT INTO pagos_a_proveedor VALUES (1107, false, '2008-10-11', NULL, 28, '2008-09-11', 1500.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1384, false, '2008-10-11', NULL, 28, '2008-09-24', 1200.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (60, false, '2008-10-11', NULL, 55, '2008-07-14', 461.98, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (144, false, '2008-10-11', NULL, 95, '2008-07-08', 18.88, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (707, false, '2008-10-11', NULL, 704, '2008-08-21', 350.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (268, false, '2008-10-11', NULL, 264, '2008-07-24', 37.60, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (203, false, '2008-10-11', NULL, 103, '2008-07-19', 318.65, NULL, 193);
INSERT INTO pagos_a_proveedor VALUES (199, false, '2008-10-11', NULL, 196, '2008-07-04', 7158.36, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (200, false, '2008-10-11', NULL, 103, '2008-07-19', 1306.00, NULL, 174);
INSERT INTO pagos_a_proveedor VALUES (201, false, '2008-10-11', NULL, 103, '2008-07-19', 467.00, NULL, 192);
INSERT INTO pagos_a_proveedor VALUES (240, false, '2008-10-11', NULL, 114, '2008-07-23', 717.80, NULL, 235);
INSERT INTO pagos_a_proveedor VALUES (165, false, '2008-10-11', NULL, 46, '2008-07-17', -53.21, 'saldo anterior', NULL);
INSERT INTO pagos_a_proveedor VALUES (1535, false, '2008-10-11', NULL, 4, '2008-10-04', 389.50, NULL, 1388);
INSERT INTO pagos_a_proveedor VALUES (267, false, '2008-10-11', NULL, 264, '2008-07-24', 398.00, NULL, 250);
INSERT INTO pagos_a_proveedor VALUES (1536, false, '2008-10-11', NULL, 4, '2008-10-04', 330.00, NULL, 1386);
INSERT INTO pagos_a_proveedor VALUES (226, false, '2008-10-11', 'TRANSFERENCIA', 121, '2008-07-22', 611.05, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (301, false, '2008-10-11', NULL, 295, '2008-07-12', 86.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (298, false, '2008-10-11', NULL, 295, '2008-07-12', 86.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (286, false, '2008-10-11', NULL, 283, '2008-07-24', 50.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (322, false, '2008-10-11', NULL, 316, '2008-07-25', 205.70, 'FCT 1363/4', 321);
INSERT INTO pagos_a_proveedor VALUES (1385, false, '2008-10-11', NULL, 61, '2008-09-24', 331.85, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (45, false, '2008-10-11', NULL, 42, '2008-07-07', 692.00, '0000', NULL);
INSERT INTO pagos_a_proveedor VALUES (716, false, '2008-10-11', NULL, 713, '2008-08-21', 90.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (23, false, '2008-10-11', NULL, 20, '2008-07-13', 262.25, '4046', NULL);
INSERT INTO pagos_a_proveedor VALUES (325, false, '2008-10-11', NULL, 316, '2008-07-25', 308.16, 'FCT 1363/4', NULL);
INSERT INTO pagos_a_proveedor VALUES (329, false, '2008-10-11', NULL, 326, '2008-07-24', 33.81, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (323, false, '2008-10-11', NULL, 316, '2008-07-25', 235.95, 'FCT 1363/4', 302);
INSERT INTO pagos_a_proveedor VALUES (324, false, '2008-10-11', NULL, 316, '2008-07-25', 231.50, 'FCT 1363/4', 261);
INSERT INTO pagos_a_proveedor VALUES (663, false, '2008-10-11', NULL, 12, '2008-08-16', 56.19, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (719, false, '2008-10-11', NULL, 578, '2008-08-22', 473.38, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (152, false, '2008-10-11', NULL, 80, '2008-07-17', 700.00, NULL, 149);
INSERT INTO pagos_a_proveedor VALUES (153, false, '2008-10-11', NULL, 80, '2008-07-17', 625.13, NULL, 78);
INSERT INTO pagos_a_proveedor VALUES (71, false, '2008-10-11', NULL, 61, '2008-07-15', 484.00, NULL, 67);
INSERT INTO pagos_a_proveedor VALUES (335, false, '2008-10-11', NULL, 332, '2008-07-25', 186.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (549, false, '2008-10-11', NULL, 546, '2008-08-11', 10.60, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (860, false, '2008-10-11', NULL, 4, '2008-08-29', 7314.27, '312714', 859);
INSERT INTO pagos_a_proveedor VALUES (419, false, '2008-10-11', NULL, 219, '2008-08-05', 569.91, NULL, 404);
INSERT INTO pagos_a_proveedor VALUES (494, false, '2008-10-11', NULL, 491, '2008-08-06', 58.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (498, false, '2008-10-11', NULL, 495, '2008-08-06', 100.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (154, false, '2008-10-11', NULL, 80, '2008-07-17', 560.95, NULL, 148);
INSERT INTO pagos_a_proveedor VALUES (1130, false, '2008-10-11', NULL, 617, '2008-09-11', 35.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (539, false, '2008-10-11', NULL, 536, '2008-08-12', 2.20, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (470, false, '2008-10-11', NULL, 20, '2008-08-04', 226.25, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1380, false, '2008-10-11', NULL, 61, '2008-09-24', 305.90, NULL, 1377);
INSERT INTO pagos_a_proveedor VALUES (1381, false, '2008-10-11', NULL, 61, '2008-09-24', 1289.00, NULL, 1376);
INSERT INTO pagos_a_proveedor VALUES (511, false, '2008-10-11', NULL, 12, '2008-08-09', 93.65, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (671, false, '2008-10-11', NULL, 668, '2008-08-13', 150.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (379, false, '2008-10-11', NULL, 211, '2008-07-29', 299.84, 'TRANFERENCIA', NULL);
INSERT INTO pagos_a_proveedor VALUES (402, false, '2008-10-11', NULL, 399, '2008-08-01', 200.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (443, false, '2008-10-11', NULL, 440, '2008-08-05', 30.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (367, false, '2008-10-11', NULL, 196, '2008-07-29', 61.10, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (365, false, '2008-10-11', NULL, 196, '2008-07-29', 897.50, NULL, 353);
INSERT INTO pagos_a_proveedor VALUES (897, false, '2008-10-11', NULL, 812, '2008-09-02', 85.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (477, false, '2008-10-11', NULL, 49, '2008-07-17', 38.13, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (414, false, '2008-10-11', NULL, 407, '2008-08-01', 55.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (408, false, '2008-10-11', NULL, 407, '2008-08-01', 500.00, NULL, 225);
INSERT INTO pagos_a_proveedor VALUES (677, false, '2008-10-11', NULL, 674, '2008-08-20', 18.20, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (155, false, '2008-10-11', NULL, 80, '2008-07-17', 235.00, NULL, 150);
INSERT INTO pagos_a_proveedor VALUES (156, false, '2008-10-11', NULL, 80, '2008-07-17', 222.12, NULL, 151);
INSERT INTO pagos_a_proveedor VALUES (375, false, '2008-10-11', NULL, 55, '2008-07-29', 20.67, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (449, false, '2008-10-11', NULL, 338, '2008-08-07', 432.76, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (577, false, '2008-10-11', NULL, 574, '2008-08-12', 95.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (346, false, '2008-10-11', NULL, 256, '2008-05-28', 10.69, '20735', NULL);
INSERT INTO pagos_a_proveedor VALUES (448, false, '2008-10-11', NULL, 283, '2008-08-07', 50.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (345, false, '2008-10-11', NULL, 256, '2008-07-26', 96.11, '62010', NULL);
INSERT INTO pagos_a_proveedor VALUES (490, false, '2008-10-11', NULL, 42, '2008-08-07', 692.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (454, false, '2008-10-11', NULL, 360, '2008-08-07', 78.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (896, false, '2008-10-11', NULL, 812, '2008-09-02', 200.11, NULL, 893);
INSERT INTO pagos_a_proveedor VALUES (439, false, '2008-10-11', NULL, 95, '2008-08-06', 18.88, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (453, false, '2008-10-11', NULL, 95, '2008-08-07', 18.88, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (366, false, '2008-10-11', NULL, 196, '2008-07-29', 445.00, NULL, 194);
INSERT INTO pagos_a_proveedor VALUES (542, false, '2008-10-11', NULL, 536, '2008-08-12', 2.20, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (481, false, '2008-10-11', '600', 478, '2008-08-07', 600.00, 'marzo-abril-mayo', NULL);
INSERT INTO pagos_a_proveedor VALUES (463, false, '2008-10-11', 'TRANSFERENCIA', 121, '2008-08-07', 1512.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (373, false, '2008-10-11', NULL, 55, '2008-07-29', 316.27, NULL, 372);
INSERT INTO pagos_a_proveedor VALUES (374, false, '2008-10-11', NULL, 55, '2008-07-29', 152.04, NULL, 371);
INSERT INTO pagos_a_proveedor VALUES (473, false, '2008-10-11', 'DEBITADO EN BANCO', 291, '2008-08-07', 108.90, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (350, false, '2008-10-11', NULL, 12, '2008-07-26', 67.34, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (351, false, '2008-10-11', NULL, 12, '2008-07-26', 49.76, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (349, false, '2008-10-11', NULL, 12, '2008-07-26', 22.63, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (567, false, '2008-10-11', NULL, 564, '2008-08-12', 71.64, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (902, false, '2008-10-11', NULL, 291, '2008-09-01', 69.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (382, false, '2008-10-11', NULL, 1, '2008-07-30', 1000.25, NULL, 376);
INSERT INTO pagos_a_proveedor VALUES (889, false, '2008-10-11', NULL, 385, '2008-09-01', 125.50, NULL, 888);
INSERT INTO pagos_a_proveedor VALUES (420, false, '2008-10-11', NULL, 219, '2008-07-31', 105.35, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (484, false, '2008-10-11', NULL, 49, '2008-07-17', 804.88, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (70, false, '2008-10-11', NULL, 61, '2008-07-15', 230.00, NULL, 66);
INSERT INTO pagos_a_proveedor VALUES (436, false, '2008-10-11', NULL, 55, '2008-08-04', 275.98, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (395, false, '2008-10-11', NULL, 4, '2008-07-30', 7385.13, '0018-00312392', 394);
INSERT INTO pagos_a_proveedor VALUES (884, false, '2008-10-11', NULL, 385, '2008-09-01', 526.35, NULL, 866);
INSERT INTO pagos_a_proveedor VALUES (887, false, '2008-10-11', NULL, 385, '2008-09-01', 300.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (612, false, '2008-10-11', NULL, 46, '2008-08-15', 1994.31, NULL, 609);
INSERT INTO pagos_a_proveedor VALUES (487, false, '2008-10-11', NULL, 49, '2008-08-04', 170.79, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1135, false, '2008-10-11', NULL, 256, '2008-09-11', 95.73, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1417, false, '2008-10-11', NULL, 20, '2008-09-09', 244.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1411, false, '2008-10-11', NULL, 955, '2008-09-24', 159.96, '570', NULL);
INSERT INTO pagos_a_proveedor VALUES (133, false, '2008-10-11', NULL, 55, '2008-07-16', 289.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (72, false, '2008-10-11', NULL, 61, '2008-07-15', 186.00, NULL, 68);
INSERT INTO pagos_a_proveedor VALUES (73, false, '2008-10-11', NULL, 61, '2008-07-15', 300.00, NULL, 69);
INSERT INTO pagos_a_proveedor VALUES (272, false, '2008-10-11', NULL, 61, '2008-07-24', 3196.07, NULL, 262);
INSERT INTO pagos_a_proveedor VALUES (608, false, '2008-10-11', NULL, 1, '2008-08-14', 1500.00, NULL, 595);
INSERT INTO pagos_a_proveedor VALUES (811, false, '2008-10-11', NULL, 808, '2008-08-29', 55.66, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (171, false, '2008-10-11', NULL, 55, '2008-07-17', 149.00, NULL, 170);
INSERT INTO pagos_a_proveedor VALUES (172, false, '2008-10-11', NULL, 55, '2008-07-17', 53.18, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (248, false, '2008-10-11', NULL, 55, '2008-07-23', 434.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1168, false, '2008-10-11', NULL, 1165, '2008-09-12', 156.20, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (634, false, '2008-10-11', NULL, 630, '2008-08-15', 13.27, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (633, false, '2008-10-11', NULL, 630, '2008-08-15', 563.90, NULL, 610);
INSERT INTO pagos_a_proveedor VALUES (638, false, '2008-10-11', NULL, 635, '2008-08-14', 300.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (642, false, '2008-10-11', NULL, 639, '2008-08-15', 55.16, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (618, false, '2008-10-11', NULL, 617, '2008-08-13', 12.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (764, false, '2008-10-11', NULL, 61, '2008-08-27', 950.00, NULL, 760);
INSERT INTO pagos_a_proveedor VALUES (629, false, '2008-10-11', NULL, 55, '2008-08-15', 133.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (769, false, '2008-10-11', NULL, 61, '2008-08-27', 527.32, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (763, false, '2008-10-11', NULL, 61, '2008-08-27', 117.30, NULL, 759);
INSERT INTO pagos_a_proveedor VALUES (765, false, '2008-10-11', NULL, 61, '2008-08-27', 130.00, NULL, 758);
INSERT INTO pagos_a_proveedor VALUES (1164, false, '2008-10-11', NULL, 287, '2008-09-12', 500.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1140, false, '2008-10-11', NULL, 98, '2008-09-11', 35.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (626, false, '2008-10-11', NULL, 55, '2008-08-15', 254.00, NULL, 526);
INSERT INTO pagos_a_proveedor VALUES (605, false, '2008-10-11', NULL, 4, '2008-08-14', 1909.53, NULL, 596);
INSERT INTO pagos_a_proveedor VALUES (1139, false, '2008-10-11', NULL, 98, '2008-09-11', 410.00, NULL, 1138);
INSERT INTO pagos_a_proveedor VALUES (691, false, '2008-10-11', NULL, 687, '2008-08-09', 32.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (384, false, '2008-10-11', NULL, 80, '2008-07-30', 396.00, NULL, 378);
INSERT INTO pagos_a_proveedor VALUES (592, false, '2008-10-11', NULL, 385, '2008-08-13', 2600.00, NULL, 527);
INSERT INTO pagos_a_proveedor VALUES (913, false, '2008-10-11', NULL, 269, '2008-08-25', 102.19, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (623, false, '2008-10-11', NULL, 256, '2008-08-04', 10.70, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (628, false, '2008-10-11', NULL, 55, '2008-08-15', 62.00, NULL, 627);
INSERT INTO pagos_a_proveedor VALUES (841, false, '2008-10-11', NULL, 55, '2008-08-25', 449.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (824, false, '2008-10-11', NULL, 536, '2008-08-29', 2.20, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (792, false, '2008-10-11', NULL, 478, '2008-08-28', 400.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (795, false, '2008-10-11', NULL, 24, '2008-08-12', 720.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1021, false, '2008-10-11', NULL, 269, '2008-08-17', 70.52, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (775, false, '2008-10-11', NULL, 295, '2008-08-27', 86.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (779, false, '2008-10-11', NULL, 776, '2008-08-28', 97.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (686, false, '2008-10-11', NULL, 95, '2008-08-20', 18.88, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (828, false, '2008-10-11', NULL, 825, '2008-08-25', 6.70, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (801, false, '2008-10-11', NULL, 780, '2008-08-28', 6.25, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (783, false, '2008-10-11', NULL, 780, '2008-08-27', 6.25, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (789, false, '2008-10-11', NULL, 780, '2008-08-28', 0.90, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (766, false, '2008-10-11', NULL, 61, '2008-08-27', 94.15, NULL, 756);
INSERT INTO pagos_a_proveedor VALUES (767, false, '2008-10-11', NULL, 61, '2008-08-27', 322.37, NULL, 757);
INSERT INTO pagos_a_proveedor VALUES (1406, false, '2008-10-11', 'CONTRA REEMBOLSO', 1403, '2008-09-25', 232.93, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1171, false, '2008-10-11', NULL, 9, '2008-09-12', 86.80, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (607, false, '2008-10-11', NULL, 4, '2008-08-14', 3139.92, NULL, 606);
INSERT INTO pagos_a_proveedor VALUES (815, false, '2008-10-11', NULL, 812, '2008-08-29', 140.34, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (818, false, '2008-10-11', NULL, 812, '2008-08-29', 65.70, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (786, false, '2008-10-11', NULL, 780, '2008-08-28', 6.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (803, false, '2008-10-11', NULL, 645, '2008-08-28', 1030.17, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (802, false, '2008-10-11', NULL, 645, '2008-08-28', 213.50, NULL, 798);
INSERT INTO pagos_a_proveedor VALUES (586, false, '2008-10-11', NULL, 385, '2008-08-13', 400.00, NULL, 517);
INSERT INTO pagos_a_proveedor VALUES (590, false, '2008-10-11', NULL, 385, '2008-08-13', 568.37, NULL, 521);
INSERT INTO pagos_a_proveedor VALUES (807, false, '2008-10-11', NULL, 804, '2008-08-28', 15.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (734, false, '2008-10-11', NULL, 114, '2008-08-22', 136.71, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (845, false, '2008-10-11', NULL, 4, '2008-08-29', 129.29, '312714', 796);
INSERT INTO pagos_a_proveedor VALUES (1547, false, '2008-10-11', 'TODOS LOS RECIBOS CON FECHA 04/10/FUERON ABONADOS EL  26/09', 4, '2008-10-04', 172.00, NULL, 1546);
INSERT INTO pagos_a_proveedor VALUES (591, false, '2008-10-11', NULL, 385, '2008-08-13', 500.00, NULL, 515);
INSERT INTO pagos_a_proveedor VALUES (768, false, '2008-10-11', NULL, 61, '2008-08-27', 295.66, NULL, 755);
INSERT INTO pagos_a_proveedor VALUES (1147, false, '2008-10-11', NULL, 61, '2008-09-12', 316.25, NULL, 1146);
INSERT INTO pagos_a_proveedor VALUES (1148, false, '2008-10-11', NULL, 61, '2008-09-12', 5.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (733, false, '2008-10-11', NULL, 114, '2008-08-22', 230.00, NULL, 729);
INSERT INTO pagos_a_proveedor VALUES (587, false, '2008-10-11', NULL, 385, '2008-08-13', 965.00, NULL, 516);
INSERT INTO pagos_a_proveedor VALUES (588, false, '2008-10-11', NULL, 385, '2008-08-13', 568.37, NULL, 519);
INSERT INTO pagos_a_proveedor VALUES (589, false, '2008-10-11', NULL, 385, '2008-08-13', 568.37, NULL, 520);
INSERT INTO pagos_a_proveedor VALUES (754, false, '2008-10-11', NULL, 385, '2008-08-26', 229.48, NULL, 749);
INSERT INTO pagos_a_proveedor VALUES (1073, false, '2008-10-11', NULL, 80, '2008-09-10', 885.12, NULL, 984);
INSERT INTO pagos_a_proveedor VALUES (998, false, '2008-10-11', NULL, 995, '2008-09-06', 4911.87, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (603, false, '2008-10-11', NULL, 4, '2008-08-14', 576.90, NULL, 594);
INSERT INTO pagos_a_proveedor VALUES (604, false, '2008-10-11', NULL, 4, '2008-08-14', 274.80, NULL, 514);
INSERT INTO pagos_a_proveedor VALUES (853, false, '2008-10-11', NULL, 4, '2008-08-29', 440.00, '312714', 844);
INSERT INTO pagos_a_proveedor VALUES (846, false, '2008-10-11', NULL, 4, '2008-08-29', 411.40, '312714', 821);
INSERT INTO pagos_a_proveedor VALUES (871, false, '2008-10-11', NULL, 12, '2008-08-30', 116.23, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (847, false, '2008-10-11', NULL, 4, '2008-08-29', 637.28, '312714', 819);
INSERT INTO pagos_a_proveedor VALUES (1194, false, '2008-10-11', NULL, 385, '2008-09-13', 165.00, NULL, 1193);
INSERT INTO pagos_a_proveedor VALUES (863, false, '2008-10-11', NULL, 12, '2008-08-30', 105.95, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (848, false, '2008-10-11', NULL, 4, '2008-08-29', 225.90, '312714', 842);
INSERT INTO pagos_a_proveedor VALUES (849, false, '2008-10-11', NULL, 4, '2008-08-29', 242.00, '312714', 843);
INSERT INTO pagos_a_proveedor VALUES (1197, false, '2008-10-11', NULL, 12, '2008-09-13', 74.84, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (750, false, '2008-10-11', NULL, 385, '2008-08-26', 455.00, NULL, 731);
INSERT INTO pagos_a_proveedor VALUES (751, false, '2008-10-11', NULL, 385, '2008-08-26', 722.56, NULL, 735);
INSERT INTO pagos_a_proveedor VALUES (752, false, '2008-10-11', NULL, 385, '2008-08-26', 165.00, NULL, 747);
INSERT INTO pagos_a_proveedor VALUES (753, false, '2008-10-11', NULL, 385, '2008-08-26', 300.00, NULL, 748);
INSERT INTO pagos_a_proveedor VALUES (917, false, '2008-10-11', NULL, 385, '2008-09-02', 1722.00, NULL, 891);
INSERT INTO pagos_a_proveedor VALUES (850, false, '2008-10-11', NULL, 4, '2008-08-29', 400.00, '312714', 797);
INSERT INTO pagos_a_proveedor VALUES (851, false, '2008-10-11', NULL, 4, '2008-08-29', 160.00, '312714', 820);
INSERT INTO pagos_a_proveedor VALUES (1033, false, '2008-10-11', NULL, 269, '2008-06-01', 98.14, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1027, false, '2008-10-11', NULL, 269, '2008-06-22', 97.11, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1076, false, '2008-10-11', NULL, 111, '2008-09-10', 148.00, NULL, 1075);
INSERT INTO pagos_a_proveedor VALUES (1047, false, '2008-10-11', NULL, 1044, '2008-09-09', 67.91, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1030, false, '2008-10-11', NULL, 269, '2008-07-06', 100.16, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (356, false, '2008-10-11', NULL, 269, '2008-07-09', 63.33, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (954, false, '2008-10-11', NULL, 277, '2008-09-04', 321.00, NULL, 951);
INSERT INTO pagos_a_proveedor VALUES (435, false, '2008-10-11', NULL, 55, '2008-08-06', 186.00, NULL, 403);
INSERT INTO pagos_a_proveedor VALUES (466, false, '2008-10-11', NULL, 15, '2008-08-07', 1200.00, NULL, 464);
INSERT INTO pagos_a_proveedor VALUES (532, false, '2008-10-11', NULL, 55, '2008-08-12', 312.00, NULL, 524);
INSERT INTO pagos_a_proveedor VALUES (1548, false, '2008-10-11', NULL, 4, '2008-09-26', 244.00, NULL, 1392);
INSERT INTO pagos_a_proveedor VALUES (1539, false, '2008-10-11', NULL, 4, '2008-10-04', 1053.53, NULL, 1310);
INSERT INTO pagos_a_proveedor VALUES (533, false, '2008-10-11', NULL, 55, '2008-08-12', 165.97, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (924, false, '2008-10-11', NULL, 55, '2008-09-03', 62.00, NULL, 890);
INSERT INTO pagos_a_proveedor VALUES (1040, false, '2008-10-11', NULL, 55, '2008-09-08', 132.00, NULL, 974);
INSERT INTO pagos_a_proveedor VALUES (1042, false, '2008-10-11', NULL, 55, '2008-09-08', 400.00, NULL, 1041);
INSERT INTO pagos_a_proveedor VALUES (1043, false, '2008-10-11', NULL, 55, '2008-09-08', 1.97, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (973, false, '2008-10-11', NULL, 283, '2008-09-05', 50.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1036, false, '2008-10-11', NULL, 564, '2008-06-27', 66.27, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (958, false, '2008-10-11', NULL, 955, '2008-09-04', 840.95, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1537, false, '2008-10-11', NULL, 4, '2008-10-04', 203.20, NULL, 1390);
INSERT INTO pagos_a_proveedor VALUES (1061, false, '2008-10-11', NULL, 121, '2008-09-09', 895.40, 'TRANFERENCIA', NULL);
INSERT INTO pagos_a_proveedor VALUES (961, false, '2008-10-11', NULL, 491, '2008-09-04', 67.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1538, false, '2008-10-11', NULL, 4, '2008-10-04', 413.00, NULL, 1389);
INSERT INTO pagos_a_proveedor VALUES (950, false, '2008-10-11', NULL, 114, '2008-09-04', 201.32, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (949, false, '2008-10-11', NULL, 114, '2008-09-04', 636.00, NULL, 948);
INSERT INTO pagos_a_proveedor VALUES (1543, false, '2008-10-11', NULL, 4, '2008-10-04', 606.00, NULL, 1542);
INSERT INTO pagos_a_proveedor VALUES (1554, false, '2008-10-11', NULL, 617, '2008-09-30', 12.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (992, false, '2008-10-11', NULL, 219, '2008-09-06', 453.75, NULL, 983);
INSERT INTO pagos_a_proveedor VALUES (991, false, '2008-10-11', NULL, 219, '2008-09-06', 338.80, NULL, 980);
INSERT INTO pagos_a_proveedor VALUES (989, false, '2008-10-11', NULL, 219, '2008-09-06', 520.50, NULL, 979);
INSERT INTO pagos_a_proveedor VALUES (1177, false, '2008-10-11', NULL, 1174, '2008-09-12', 25.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1549, false, '2008-10-11', 'CHEQUE RIO DE FENIX', 4, '2008-09-26', 6212.77, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (600, false, '2008-10-11', NULL, 4, '2008-08-14', 220.00, NULL, 525);
INSERT INTO pagos_a_proveedor VALUES (255, false, '2008-10-11', NULL, 28, '2008-07-23', 2000.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (601, false, '2008-10-11', NULL, 4, '2008-08-14', 231.00, NULL, 528);
INSERT INTO pagos_a_proveedor VALUES (602, false, '2008-10-11', NULL, 4, '2008-08-14', 1100.00, NULL, 593);
INSERT INTO pagos_a_proveedor VALUES (1060, false, '2008-10-11', NULL, 95, '2008-09-09', 18.88, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1558, false, '2008-10-11', NULL, 1555, '2008-10-06', 138.81, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (383, false, '2008-10-11', NULL, 80, '2008-07-30', 1314.50, NULL, 377);
INSERT INTO pagos_a_proveedor VALUES (1074, false, '2008-10-11', NULL, 80, '2008-09-10', 586.30, NULL, 1069);
INSERT INTO pagos_a_proveedor VALUES (1065, false, '2008-10-11', NULL, 1062, '2008-09-09', 214.05, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (251, false, '2008-10-11', NULL, 28, '2008-07-23', 147.00, NULL, 223);
INSERT INTO pagos_a_proveedor VALUES (252, false, '2008-10-11', NULL, 28, '2008-07-23', 201.20, NULL, 210);
INSERT INTO pagos_a_proveedor VALUES (368, false, '2008-10-11', NULL, 28, '2008-07-29', 2000.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1072, false, '2008-10-11', NULL, 80, '2008-09-10', 300.00, NULL, 1057);
INSERT INTO pagos_a_proveedor VALUES (1561, false, '2008-10-11', NULL, 668, '2008-10-06', 150.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1006, false, '2008-10-11', NULL, 935, '2008-09-06', 128.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (396, false, '2008-10-11', NULL, 28, '2008-08-01', 4000.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1051, false, '2008-10-11', NULL, 1048, '2008-09-02', 209.58, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1149, false, '2008-10-11', NULL, 385, '2008-09-12', 900.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1183, false, '2008-10-11', NULL, 385, '2008-09-13', 632.00, NULL, 1179);
INSERT INTO pagos_a_proveedor VALUES (1184, false, '2008-10-11', NULL, 385, '2008-09-13', 207.00, NULL, 1180);
INSERT INTO pagos_a_proveedor VALUES (1182, false, '2008-10-11', NULL, 385, '2008-09-13', 330.00, NULL, 1178);
INSERT INTO pagos_a_proveedor VALUES (1188, false, '2008-10-11', NULL, 385, '2008-09-13', 350.00, NULL, 1187);
INSERT INTO pagos_a_proveedor VALUES (1189, false, '2008-10-11', NULL, 385, '2008-09-13', 231.70, NULL, 1186);
INSERT INTO pagos_a_proveedor VALUES (1192, false, '2008-10-11', NULL, 385, '2008-09-13', 133.00, NULL, 1142);
INSERT INTO pagos_a_proveedor VALUES (1190, false, '2008-10-11', NULL, 385, '2008-09-13', 387.00, NULL, 1141);
INSERT INTO pagos_a_proveedor VALUES (1191, false, '2008-10-11', NULL, 385, '2008-09-13', 130.00, NULL, 1143);
INSERT INTO pagos_a_proveedor VALUES (1209, false, '2008-10-11', NULL, 42, '2008-09-15', 692.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1213, false, '2008-10-11', NULL, 1210, '2008-08-30', 274.80, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (157, false, '2008-10-11', NULL, 80, '2008-07-17', 148.20, NULL, 76);
INSERT INTO pagos_a_proveedor VALUES (158, false, '2008-10-11', NULL, 80, '2008-07-17', 94.00, NULL, 77);
INSERT INTO pagos_a_proveedor VALUES (1241, false, '2008-10-11', NULL, 1233, '2008-09-17', 16.72, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1236, false, '2008-10-11', NULL, 1233, '2008-09-17', 375.03, NULL, 1227);
INSERT INTO pagos_a_proveedor VALUES (1237, false, '2008-10-11', NULL, 1233, '2008-09-17', 314.00, NULL, 1232);
INSERT INTO pagos_a_proveedor VALUES (1239, false, '2008-10-11', NULL, 1233, '2008-09-17', 797.00, NULL, 1238);
INSERT INTO pagos_a_proveedor VALUES (1240, false, '2008-10-11', NULL, 1233, '2008-09-17', 55.00, NULL, 1228);
INSERT INTO pagos_a_proveedor VALUES (1226, false, '2008-10-11', NULL, 55, '2008-09-16', 66.24, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1225, false, '2008-10-11', NULL, 55, '2008-09-16', 254.00, NULL, 1222);
INSERT INTO pagos_a_proveedor VALUES (1223, false, '2008-10-11', NULL, 55, '2008-09-16', 46.00, NULL, 1220);
INSERT INTO pagos_a_proveedor VALUES (1224, false, '2008-10-11', NULL, 55, '2008-09-16', 83.73, NULL, 1221);
INSERT INTO pagos_a_proveedor VALUES (421, false, '2008-10-11', NULL, 28, '2008-08-06', 2800.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (614, false, '2008-10-11', NULL, 28, '2008-08-15', 797.00, NULL, 611);
INSERT INTO pagos_a_proveedor VALUES (467, false, '2008-10-11', NULL, 15, '2008-08-07', 134.80, NULL, 465);
INSERT INTO pagos_a_proveedor VALUES (1314, false, '2008-10-11', NULL, 114, '2008-09-19', 52.27, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1289, false, '2008-10-11', NULL, 1286, '2008-09-18', 121.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1285, false, '2008-10-11', NULL, 52, '2008-09-18', 931.30, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1003, false, '2008-10-11', NULL, 15, '2008-09-06', 1786.70, NULL, 1002);
INSERT INTO pagos_a_proveedor VALUES (1205, false, '2008-10-11', NULL, 1, '2008-09-15', 222.00, NULL, 1204);
INSERT INTO pagos_a_proveedor VALUES (1214, false, '2008-10-11', NULL, 1, '2008-09-16', 2300.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1294, false, '2008-10-11', NULL, 95, '2008-09-18', 18.88, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1079, false, '2008-10-11', NULL, 111, '2008-09-10', 400.00, NULL, 1067);
INSERT INTO pagos_a_proveedor VALUES (1080, false, '2008-10-11', NULL, 111, '2008-09-10', 867.50, NULL, 1068);
INSERT INTO pagos_a_proveedor VALUES (1081, false, '2008-10-11', NULL, 111, '2008-09-10', 500.00, NULL, 1056);
INSERT INTO pagos_a_proveedor VALUES (1082, false, '2008-10-11', NULL, 111, '2008-09-10', 3690.50, NULL, 982);
INSERT INTO pagos_a_proveedor VALUES (1083, false, '2008-10-11', NULL, 111, '2008-09-10', 49.00, NULL, 1071);
INSERT INTO pagos_a_proveedor VALUES (1077, false, '2008-10-11', NULL, 111, '2008-09-10', 261.00, NULL, 977);
INSERT INTO pagos_a_proveedor VALUES (1085, false, '2008-10-11', NULL, 111, '2008-09-10', 191.31, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1084, false, '2008-10-11', NULL, 111, '2008-09-10', 56.00, NULL, 975);
INSERT INTO pagos_a_proveedor VALUES (1078, false, '2008-10-11', NULL, 111, '2008-09-10', 391.00, NULL, 1070);
INSERT INTO pagos_a_proveedor VALUES (1298, false, '2008-10-11', NULL, 103, '2008-09-19', 129.00, NULL, 1295);
INSERT INTO pagos_a_proveedor VALUES (1303, false, '2008-10-11', NULL, 103, '2008-09-19', 321.00, NULL, 1302);
INSERT INTO pagos_a_proveedor VALUES (1248, false, '2008-10-11', NULL, 995, '2008-09-17', 2797.04, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1266, false, '2008-10-11', NULL, 928, '2008-09-18', 599.37, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1271, false, '2008-10-11', NULL, 135, '2008-09-18', 100.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (138, false, '2008-10-11', NULL, 135, '2008-07-04', 98.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (476, false, '2008-10-11', NULL, 135, '2008-07-23', 104.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1313, false, '2008-10-11', NULL, 114, '2008-09-19', 1054.40, NULL, 1307);
INSERT INTO pagos_a_proveedor VALUES (1282, false, '2008-10-11', NULL, 49, '2008-09-18', 1273.90, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1089, false, '2008-10-11', NULL, 46, '2008-09-10', 1061.10, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1304, false, '2008-10-11', NULL, 103, '2008-09-19', 888.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1299, false, '2008-10-11', NULL, 103, '2008-09-19', 129.00, NULL, 1296);
INSERT INTO pagos_a_proveedor VALUES (1300, false, '2008-10-11', NULL, 103, '2008-09-19', 69.00, NULL, 1297);
INSERT INTO pagos_a_proveedor VALUES (1318, false, '2008-10-11', NULL, 962, '2008-09-19', 98.38, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1317, false, '2008-10-11', NULL, 962, '2008-09-19', 2000.00, NULL, 1306);
INSERT INTO pagos_a_proveedor VALUES (1353, false, '2008-10-11', NULL, 1350, '2008-09-22', 169.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (35, false, '2008-10-11', NULL, 28, '2008-07-11', 584.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1363, false, '2008-10-11', NULL, 1356, '2008-09-23', 494.60, NULL, 1361);
INSERT INTO pagos_a_proveedor VALUES (1359, false, '2008-10-11', NULL, 1356, '2008-09-23', 72.60, NULL, 1249);
INSERT INTO pagos_a_proveedor VALUES (1362, false, '2008-10-11', NULL, 1356, '2008-09-23', 1249.23, NULL, 1360);
INSERT INTO pagos_a_proveedor VALUES (1328, false, '2008-10-11', NULL, 12, '2008-09-20', 63.62, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1434, false, '2008-10-11', NULL, 12, '2008-09-27', 57.96, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1338, false, '2008-10-11', NULL, 1110, '2008-09-22', 2312.00, NULL, 1309);
INSERT INTO pagos_a_proveedor VALUES (1339, false, '2008-10-11', NULL, 338, '2008-09-22', 202.09, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1340, false, '2008-10-11', NULL, 1233, '2008-09-22', 2907.00, NULL, 1319);
INSERT INTO pagos_a_proveedor VALUES (34, false, '2008-10-11', NULL, 28, '2008-07-14', 2969.38, NULL, 33);
INSERT INTO pagos_a_proveedor VALUES (207, false, '2008-10-11', NULL, 28, '2008-07-21', 98.00, NULL, 173);
INSERT INTO pagos_a_proveedor VALUES (204, false, '2008-10-11', NULL, 28, '2008-07-21', 1925.00, NULL, 177);
INSERT INTO pagos_a_proveedor VALUES (205, false, '2008-10-11', NULL, 28, '2008-07-21', 213.00, NULL, 176);
INSERT INTO pagos_a_proveedor VALUES (206, false, '2008-10-11', NULL, 28, '2008-07-21', 217.00, NULL, 175);
INSERT INTO pagos_a_proveedor VALUES (254, false, '2008-10-11', NULL, 28, '2008-07-23', 578.00, NULL, 249);
INSERT INTO pagos_a_proveedor VALUES (253, false, '2008-10-11', NULL, 28, '2008-07-23', 224.00, NULL, 224);
INSERT INTO pagos_a_proveedor VALUES (613, false, '2008-10-11', NULL, 28, '2008-08-15', 3569.50, NULL, 585);
INSERT INTO pagos_a_proveedor VALUES (1435, false, '2008-10-11', 'interdeposito', 211, '2008-08-07', 88.09, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (359, false, '2008-10-11', NULL, 269, '2008-07-27', 83.46, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1441, false, '2008-10-11', NULL, 1440, '2008-09-29', 43.40, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1442, false, '2008-10-11', NULL, 121, '2008-09-29', 1512.50, 'TRASNFERENCIA BCO', NULL);
INSERT INTO pagos_a_proveedor VALUES (1452, false, '2008-10-11', NULL, 55, '2008-09-29', 449.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (925, false, '2008-10-11', NULL, 55, '2008-09-03', 387.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (424, false, '2008-10-11', NULL, 269, '2008-08-02', 73.59, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (554, false, '2008-10-11', NULL, 269, '2008-08-07', 170.69, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (545, false, '2008-10-11', NULL, 269, '2008-08-09', 50.03, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1336, false, '2008-10-11', NULL, 196, '2008-09-22', 1927.00, NULL, 1335);
INSERT INTO pagos_a_proveedor VALUES (1024, false, '2008-10-11', NULL, 269, '2008-08-10', 73.57, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (560, false, '2008-10-11', NULL, 269, '2008-06-22', 145.09, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (653, false, '2008-10-11', NULL, 28, '2008-08-20', 108.00, NULL, 650);
INSERT INTO pagos_a_proveedor VALUES (654, false, '2008-10-11', NULL, 28, '2008-08-20', 586.50, NULL, 651);
INSERT INTO pagos_a_proveedor VALUES (655, false, '2008-10-11', NULL, 28, '2008-08-20', 583.00, NULL, 652);
INSERT INTO pagos_a_proveedor VALUES (692, false, '2008-10-11', NULL, 28, '2008-08-21', 3000.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (722, false, '2008-10-11', NULL, 28, '2008-08-22', 874.54, NULL, 721);
INSERT INTO pagos_a_proveedor VALUES (723, false, '2008-10-11', NULL, 28, '2008-08-22', 1100.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (720, false, '2008-10-11', NULL, 28, '2008-08-22', 500.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (736, false, '2008-10-11', NULL, 28, '2008-08-23', 511.00, NULL, 730);
INSERT INTO pagos_a_proveedor VALUES (737, false, '2008-10-11', NULL, 28, '2008-08-23', 430.40, NULL, 726);
INSERT INTO pagos_a_proveedor VALUES (738, false, '2008-10-11', NULL, 28, '2008-08-23', 179.00, NULL, 728);
INSERT INTO pagos_a_proveedor VALUES (744, false, '2008-10-11', NULL, 28, '2008-08-26', 968.00, NULL, 739);
INSERT INTO pagos_a_proveedor VALUES (742, false, '2008-10-11', NULL, 28, '2008-08-26', 316.25, NULL, 741);
INSERT INTO pagos_a_proveedor VALUES (743, false, '2008-10-11', NULL, 28, '2008-08-26', 544.50, NULL, 740);
INSERT INTO pagos_a_proveedor VALUES (772, false, '2008-10-11', NULL, 28, '2008-08-28', 3400.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1096, false, '2008-10-11', NULL, 28, '2008-09-10', 1700.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1428, false, '2008-10-11', NULL, 61, '2008-09-29', 857.50, NULL, 1421);
INSERT INTO pagos_a_proveedor VALUES (1427, false, '2008-10-11', NULL, 61, '2008-09-29', 870.00, NULL, 1422);
INSERT INTO pagos_a_proveedor VALUES (1367, false, '2008-10-11', NULL, 95, '2008-09-23', 18.88, '115887', NULL);
INSERT INTO pagos_a_proveedor VALUES (1431, false, '2008-10-11', NULL, 52, '2008-09-29', 17.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1151, false, '2008-10-11', NULL, 28, '2008-09-12', 4504.45, NULL, 1150);
INSERT INTO pagos_a_proveedor VALUES (1254, false, '2008-10-11', 'ENVIADO POR OCA', 28, '2008-09-17', 3505.73, NULL, 1253);
INSERT INTO pagos_a_proveedor VALUES (1255, false, '2008-10-11', 'ENVIO POR OCA', 28, '2008-09-17', 6900.00, NULL, 1250);
INSERT INTO pagos_a_proveedor VALUES (1257, false, '2008-10-11', 'DE FENIX', 28, '2008-09-17', 8380.63, NULL, 1256);
INSERT INTO pagos_a_proveedor VALUES (275, false, '2008-10-11', NULL, 269, '2008-07-05', 50.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (570, false, '2008-10-11', NULL, 269, '2008-07-06', 112.44, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (573, false, '2008-10-11', NULL, 269, '2008-07-11', 24.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (276, false, '2008-10-11', NULL, 269, '2008-07-20', 50.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (557, false, '2008-10-11', NULL, 269, '2008-07-20', 163.53, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (916, false, '2008-10-11', NULL, 269, '2008-08-30', 97.08, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1001, false, '2008-10-11', NULL, 269, '2008-09-06', 75.59, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1009, false, '2008-10-11', NULL, 269, '2008-09-08', 177.77, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1012, false, '2008-10-11', NULL, 269, '2008-09-08', 182.95, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1015, false, '2008-10-11', NULL, 269, '2008-09-08', 50.03, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1018, false, '2008-10-11', NULL, 269, '2008-09-09', 30.04, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1217, false, '2008-10-11', NULL, 269, '2008-09-16', 137.98, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1349, false, '2008-10-11', NULL, 269, '2008-09-22', 166.58, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1346, false, '2008-10-11', NULL, 269, '2008-09-22', 50.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1370, false, '2008-10-11', NULL, 269, '2008-09-23', 98.00, '24999', NULL);
INSERT INTO pagos_a_proveedor VALUES (1461, false, '2008-10-11', NULL, 812, '2008-10-01', 270.71, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1471, false, '2008-10-11', NULL, 196, '2008-10-01', 1325.00, NULL, 1466);
INSERT INTO pagos_a_proveedor VALUES (1462, false, '2008-10-11', NULL, 196, '2008-10-01', 119.80, NULL, 1458);
INSERT INTO pagos_a_proveedor VALUES (1467, false, '2008-10-11', NULL, 196, '2008-10-01', 500.00, NULL, 1463);
INSERT INTO pagos_a_proveedor VALUES (1468, false, '2008-10-11', NULL, 196, '2008-10-01', 500.00, NULL, 1464);
INSERT INTO pagos_a_proveedor VALUES (1469, false, '2008-10-11', NULL, 196, '2008-10-01', 496.80, NULL, 1465);
INSERT INTO pagos_a_proveedor VALUES (1474, false, '2008-10-11', NULL, 1044, '2008-09-30', 34.00, '12569', NULL);
INSERT INTO pagos_a_proveedor VALUES (1482, false, '2008-10-11', NULL, 24, '2008-10-02', 2730.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (27, false, '2008-10-11', NULL, 24, '2008-07-13', 720.00, '182196', NULL);
INSERT INTO pagos_a_proveedor VALUES (1488, false, '2008-10-11', NULL, 291, '2008-10-01', 69.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1491, false, '2008-10-11', NULL, 283, '2008-10-02', 50.00, '604', NULL);
INSERT INTO pagos_a_proveedor VALUES (1495, false, '2008-10-11', NULL, 1492, '2008-10-02', 36.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1455, false, '2008-10-11', NULL, 269, '2008-09-27', 50.03, '7962', NULL);
INSERT INTO pagos_a_proveedor VALUES (1426, false, '2008-10-11', NULL, 269, '2008-09-29', 370.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1512, false, '2008-10-11', NULL, 316, '2008-10-03', 240.00, NULL, 1505);
INSERT INTO pagos_a_proveedor VALUES (1516, false, '2008-10-11', NULL, 219, '2008-10-04', 576.00, NULL, 1502);
INSERT INTO pagos_a_proveedor VALUES (1513, false, '2008-10-11', NULL, 219, '2008-10-04', 108.00, NULL, 1499);
INSERT INTO pagos_a_proveedor VALUES (1514, false, '2008-10-11', NULL, 219, '2008-10-04', 31.00, NULL, 1500);
INSERT INTO pagos_a_proveedor VALUES (1515, false, '2008-10-11', NULL, 219, '2008-10-04', 48.25, NULL, 1501);
INSERT INTO pagos_a_proveedor VALUES (1337, false, '2008-10-11', 'DEPOSITO EN BANCO', 28, '2008-09-22', 1550.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1354, false, '2008-10-11', NULL, 28, '2008-09-23', 650.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1364, false, '2008-10-11', NULL, 28, '2008-09-23', 100.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1355, false, '2008-10-11', NULL, 28, '2008-09-23', 250.00, NULL, 1343);
INSERT INTO pagos_a_proveedor VALUES (1444, false, '2008-10-11', NULL, 28, '2008-09-29', 987.36, NULL, 1423);
INSERT INTO pagos_a_proveedor VALUES (1443, false, '2008-10-11', NULL, 28, '2008-09-29', 167.00, NULL, 1420);
INSERT INTO pagos_a_proveedor VALUES (1521, false, '2008-10-11', NULL, 12, '2008-10-04', 40.92, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1524, false, '2008-10-11', NULL, 287, '2008-10-04', 500.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1533, false, '2008-10-11', NULL, 4, '2008-10-04', 492.00, NULL, 1391);
INSERT INTO pagos_a_proveedor VALUES (1534, false, '2008-10-11', NULL, 4, '2008-10-04', 351.50, NULL, 1387);
INSERT INTO pagos_a_proveedor VALUES (1111120, false, '2008-10-15', NULL, -1308164096, '2008-10-15', 0.01, '123456', NULL);
INSERT INTO pagos_a_proveedor VALUES (1111121, false, '2008-10-15', NULL, -1308164096, '2008-10-15', 0.01, '54321', NULL);
INSERT INTO pagos_a_proveedor VALUES (1111124, false, '2008-10-16', NULL, 1356, '2008-10-16', 663.57, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111125, false, '2008-10-16', 'TRANSFERENCIA', 121, '2008-10-11', 1512.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111126, false, '2008-10-16', NULL, 316, '2008-10-03', 1913.80, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111127, false, '2008-10-16', NULL, 1, '2008-10-09', 1700.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111128, false, '2008-10-16', NULL, 49, '2008-10-16', 422.62, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111129, false, '2008-10-16', NULL, 269, '2008-10-16', 97.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111130, false, '2008-10-16', NULL, 20, '2008-10-16', 302.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111131, false, '2008-10-16', 'TRANSFERENCIA', 211, '2008-10-11', 656.42, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111132, false, '2008-10-16', NULL, 80, '2008-10-10', 2500.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111133, false, '2008-10-16', NULL, 28, '2008-10-09', 1500.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111136, false, '2008-10-16', NULL, 338, '2008-10-07', 45.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111138, false, '2008-10-16', NULL, 55, '2008-10-07', 449.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111140, false, '2008-10-16', NULL, -1308164095, '2008-10-07', 1154.82, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111142, false, '2008-10-16', NULL, 42, '2008-10-16', 1056.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111145, false, '2008-10-16', NULL, 1403, '2008-10-08', 629.20, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111147, false, '2008-10-16', NULL, 61, '2008-10-16', 236.33, NULL, 111115);
INSERT INTO pagos_a_proveedor VALUES (1111148, false, '2008-10-16', NULL, 61, '2008-10-16', 194.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111190, true, '2008-10-16', NULL, 812, '2008-10-16', 13.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111191, false, '2008-10-16', NULL, 812, '2008-10-16', 135.35, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111192, false, '2008-10-17', NULL, 196, '2008-10-17', 11375.27, NULL, 111121);
INSERT INTO pagos_a_proveedor VALUES (1111193, false, '2008-10-17', NULL, 196, '2008-10-17', 163.00, NULL, 111116);
INSERT INTO pagos_a_proveedor VALUES (1111194, false, '2008-10-20', NULL, 28, '2008-07-29', 700.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111195, false, '2008-10-20', NULL, 28, '2008-10-20', 1113.00, NULL, 111117);
INSERT INTO pagos_a_proveedor VALUES (1111196, false, '2008-10-20', NULL, 28, '2008-10-20', 800.00, NULL, 111122);
INSERT INTO pagos_a_proveedor VALUES (1111197, false, '2008-10-20', NULL, 28, '2008-10-20', 520.00, NULL, 111120);
INSERT INTO pagos_a_proveedor VALUES (1111198, false, '2008-10-20', NULL, 28, '2008-10-20', 241.00, NULL, 111123);
INSERT INTO pagos_a_proveedor VALUES (1111199, false, '2008-10-20', NULL, 28, '2008-10-20', 584.00, NULL, 111124);
INSERT INTO pagos_a_proveedor VALUES (1111260, false, '2008-10-20', NULL, 28, '2008-10-20', 280.00, NULL, 111125);
INSERT INTO pagos_a_proveedor VALUES (1111261, false, '2008-10-20', NULL, 28, '2008-10-20', 291.30, NULL, 111127);
INSERT INTO pagos_a_proveedor VALUES (1111263, false, '2008-10-20', NULL, 55, '2008-10-20', 97.50, NULL, 111129);
INSERT INTO pagos_a_proveedor VALUES (1111264, false, '2008-10-20', NULL, 55, '2008-10-20', 72.00, NULL, 111128);
INSERT INTO pagos_a_proveedor VALUES (1111265, false, '2008-10-20', NULL, 55, '2008-10-20', 310.47, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111267, false, '2008-10-20', NULL, 49, '2008-10-16', 1880.13, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111269, false, '2008-10-20', NULL, -1308164092, '2008-10-17', 100.01, '27185', NULL);
INSERT INTO pagos_a_proveedor VALUES (1111301, false, '2008-10-20', NULL, -1308164091, '2008-10-15', 138.00, '2114', NULL);
INSERT INTO pagos_a_proveedor VALUES (1111303, false, '2008-10-20', NULL, 269, '2008-10-15', 200.03, '18709', NULL);
INSERT INTO pagos_a_proveedor VALUES (1111305, false, '2008-10-20', NULL, -1308164089, '2008-10-18', 25.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111306, false, '2008-10-20', NULL, -1308164090, '2008-10-15', 54.10, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111308, false, '2008-10-20', NULL, -1308164088, '2008-10-20', 72.30, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111310, false, '2008-10-20', NULL, 12, '2008-10-18', 49.79, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111312, false, '2008-10-20', NULL, -1308164087, '2008-10-20', 408.97, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111314, false, '2008-10-20', NULL, 55, '2008-10-16', 44.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111316, false, '2008-10-20', NULL, -1308164086, '2008-09-30', 335.76, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111319, false, '2008-10-21', NULL, -1308164093, '2008-10-15', 365.64, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111323, false, '2008-10-21', NULL, 114, '2008-10-21', 500.00, NULL, 111133);
INSERT INTO pagos_a_proveedor VALUES (1111324, false, '2008-10-21', 'CONTRA REEMBOLSO', 114, '2008-10-21', 425.65, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111325, false, '2008-10-21', 'saldo de su cuenta', 15, '2008-10-21', 262.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111326, false, '2008-10-21', NULL, 15, '2008-10-21', 150.00, NULL, 111135);
INSERT INTO pagos_a_proveedor VALUES (1111327, false, '2008-10-21', NULL, 15, '2008-10-21', 810.70, NULL, 111118);
INSERT INTO pagos_a_proveedor VALUES (1111328, false, '2008-10-21', NULL, 15, '2008-10-21', 711.21, NULL, 111134);
INSERT INTO pagos_a_proveedor VALUES (1111362, false, '2008-10-21', NULL, 928, '2008-10-21', 254.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111364, false, '2008-10-21', 'descuento', 928, '2008-10-21', 28.54, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111366, false, '2008-10-21', 'ch/ de fenix', 4, '2008-10-21', 8576.56, NULL, 111137);
INSERT INTO pagos_a_proveedor VALUES (1111368, false, '2008-10-21', 'ch/ fenix', 4, '2008-10-21', 4425.98, NULL, 111138);
INSERT INTO pagos_a_proveedor VALUES (1111412, false, '2008-10-22', '$10.- CAMBIO DE FACTURA', 95, '2008-10-22', 30.49, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111415, false, '2008-10-23', NULL, 46, '2008-10-23', 396.00, NULL, 111139);
INSERT INTO pagos_a_proveedor VALUES (1111416, false, '2008-10-23', NULL, 46, '2008-10-23', 170.50, NULL, 111140);
INSERT INTO pagos_a_proveedor VALUES (1111417, false, '2008-10-23', NULL, 46, '2008-10-23', 167.50, NULL, 111142);
INSERT INTO pagos_a_proveedor VALUES (1111418, false, '2008-10-23', NULL, 46, '2008-10-23', 120.00, NULL, 111143);
INSERT INTO pagos_a_proveedor VALUES (1111419, false, '2008-10-23', NULL, 46, '2008-10-23', 448.50, NULL, 111144);
INSERT INTO pagos_a_proveedor VALUES (1111450, false, '2008-10-23', NULL, 80, '2008-10-23', 3500.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111457, false, '2008-10-24', NULL, 1233, '2008-10-24', 235.95, NULL, 111149);
INSERT INTO pagos_a_proveedor VALUES (1111458, false, '2008-10-24', NULL, 1233, '2008-10-24', 221.00, NULL, 111152);
INSERT INTO pagos_a_proveedor VALUES (1111459, false, '2008-10-24', NULL, 1233, '2008-10-24', 207.00, NULL, 111150);
INSERT INTO pagos_a_proveedor VALUES (1111530, false, '2008-10-24', NULL, 1233, '2008-10-24', 236.00, NULL, 111151);
INSERT INTO pagos_a_proveedor VALUES (1111531, false, '2008-10-24', NULL, 1233, '2008-10-24', 345.00, NULL, 111154);
INSERT INTO pagos_a_proveedor VALUES (1111533, false, '2008-10-24', NULL, 407, '2008-10-24', 129.00, NULL, 111147);
INSERT INTO pagos_a_proveedor VALUES (1111534, false, '2008-10-24', NULL, 407, '2008-10-24', 967.50, NULL, 111148);
INSERT INTO pagos_a_proveedor VALUES (1111535, false, '2008-10-24', 'POR EL RESTO MANDAN NOTA DE CREDITO POR EL RESTO', 407, '2008-10-24', 19.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111536, false, '2008-10-24', NULL, 1, '2008-10-23', 1750.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111537, false, '2008-10-24', NULL, 1233, '2008-10-24', 505.09, '2325', 111155);
INSERT INTO pagos_a_proveedor VALUES (1111538, false, '2008-10-24', NULL, 1233, '2008-10-24', 17.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111560, true, '2008-10-24', NULL, 114, '2008-10-24', 217.90, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111561, false, '2008-10-24', 'CONTRA REEMBOLSO', 114, '2008-10-24', 217.80, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111565, false, '2008-10-24', NULL, -1308131328, '2008-10-24', 47.19, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111568, false, '2008-10-27', NULL, 219, '2008-10-03', 121.36, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111569, false, '2008-10-27', 'TRANSFERENCIA BANCARIA', 211, '2008-10-27', 581.04, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111640, false, '2008-10-28', NULL, 1, '2008-10-28', 1600.00, NULL, 111158);
INSERT INTO pagos_a_proveedor VALUES (1111456, true, '2008-10-24', NULL, 1233, '2008-10-24', 3618.89, NULL, 111146);
INSERT INTO pagos_a_proveedor VALUES (1111641, false, '2008-10-28', NULL, 1, '2008-10-28', 761.25, NULL, 111162);
INSERT INTO pagos_a_proveedor VALUES (1111642, false, '2008-10-28', NULL, 1, '2008-10-28', 392.00, NULL, 111165);
INSERT INTO pagos_a_proveedor VALUES (1111643, false, '2008-10-28', NULL, 1, '2008-10-28', 30.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111644, false, '2008-10-28', NULL, 385, '2008-10-28', 184.13, NULL, 111163);
INSERT INTO pagos_a_proveedor VALUES (1111645, false, '2008-10-28', NULL, 385, '2008-10-28', 326.17, NULL, 111166);
INSERT INTO pagos_a_proveedor VALUES (1111646, false, '2008-10-28', NULL, 385, '2008-10-28', 65.50, NULL, 111157);
INSERT INTO pagos_a_proveedor VALUES (1111648, false, '2008-10-28', NULL, 385, '2008-10-28', 229.90, NULL, 111159);
INSERT INTO pagos_a_proveedor VALUES (1111647, true, '2008-10-28', NULL, 385, '2008-10-28', 2116.00, NULL, 111161);
INSERT INTO pagos_a_proveedor VALUES (1111649, false, '2008-10-28', NULL, 385, '2008-10-28', 2216.00, NULL, 111167);
INSERT INTO pagos_a_proveedor VALUES (1111681, false, '2008-10-28', NULL, -1308131327, '2008-10-18', 86.01, '55294', NULL);
INSERT INTO pagos_a_proveedor VALUES (1111683, false, '2008-10-28', NULL, 269, '2008-10-18', 30.99, '8675', NULL);
INSERT INTO pagos_a_proveedor VALUES (1111685, false, '2008-10-28', NULL, 269, '2008-10-24', 165.02, '19524', NULL);
INSERT INTO pagos_a_proveedor VALUES (1111687, false, '2008-10-28', NULL, -1308131326, '2008-10-19', 190.10, '119404', NULL);
INSERT INTO pagos_a_proveedor VALUES (1111689, false, '2008-10-28', NULL, -1308131325, '2008-10-28', 30.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111691, false, '2008-10-28', NULL, -1308131324, '2008-10-28', 16.00, '924', NULL);
INSERT INTO pagos_a_proveedor VALUES (1111708, false, '2008-10-28', NULL, 95, '2008-10-28', 18.88, '117781', NULL);
INSERT INTO pagos_a_proveedor VALUES (1111710, false, '2008-10-29', NULL, -1308164093, '2008-10-29', 96.18, '81006', NULL);
INSERT INTO pagos_a_proveedor VALUES (1111712, false, '2008-10-29', NULL, 49, '2008-10-28', 17.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111714, false, '2008-10-29', NULL, -1308131323, '2008-10-28', 42.43, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111716, false, '2008-10-29', NULL, 4, '2008-10-29', 1133.00, '312182', 111172);
INSERT INTO pagos_a_proveedor VALUES (1111761, false, '2008-10-29', NULL, -1308131322, '2008-10-29', 97.00, NULL, 111173);
INSERT INTO pagos_a_proveedor VALUES (1111762, false, '2008-10-29', NULL, -1308131322, '2008-10-29', 176.00, NULL, 111175);
INSERT INTO pagos_a_proveedor VALUES (1111763, false, '2008-10-29', NULL, -1308131322, '2008-10-29', 100.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111764, false, '2008-10-30', 'nota de credito', 407, '2008-10-28', 1969.35, '23598', NULL);
INSERT INTO pagos_a_proveedor VALUES (1111769, false, '2008-10-30', NULL, -1308131320, '2008-10-30', 21.94, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111774, false, '2008-10-30', 'CONTRA REEMBOLSO', -1308131318, '2008-10-30', 866.36, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111776, false, '2008-10-30', NULL, -1308131317, '2008-10-30', 24.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111777, false, '2008-10-31', NULL, 52, '2008-10-31', 599.50, NULL, 111183);
INSERT INTO pagos_a_proveedor VALUES (1111778, false, '2008-10-31', NULL, 52, '2008-10-31', 215.20, NULL, 111182);
INSERT INTO pagos_a_proveedor VALUES (1111779, false, '2008-10-31', NULL, -1308131322, '2008-10-31', 547.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111840, false, '2008-10-31', NULL, 52, '2008-10-31', 176.00, NULL, 111181);
INSERT INTO pagos_a_proveedor VALUES (1111845, false, '2008-10-31', NULL, -1308131315, '2008-10-30', 90.00, '63527', NULL);
INSERT INTO pagos_a_proveedor VALUES (1111860, false, '2008-10-31', NULL, -1308131316, '2008-10-31', 50.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111861, false, '2008-11-01', NULL, 407, '2008-11-01', 200.00, '2340', 111179);
INSERT INTO pagos_a_proveedor VALUES (1111862, false, '2008-11-01', NULL, 407, '2008-11-01', 96.20, '2340', NULL);
INSERT INTO pagos_a_proveedor VALUES (1111864, false, '2008-11-01', NULL, 61, '2008-11-01', 484.00, '2341', 111185);
INSERT INTO pagos_a_proveedor VALUES (1111865, false, '2008-11-01', NULL, 61, '2008-11-01', 156.00, '2341', NULL);
INSERT INTO pagos_a_proveedor VALUES (1111867, false, '2008-11-01', NULL, 385, '2008-11-01', 2552.77, NULL, 111180);
INSERT INTO pagos_a_proveedor VALUES (1111868, false, '2008-11-01', NULL, 385, '2008-11-01', 2595.30, NULL, 111174);
INSERT INTO pagos_a_proveedor VALUES (1111872, false, '2008-11-01', NULL, 55, '2008-11-01', 374.98, '2342', NULL);
INSERT INTO pagos_a_proveedor VALUES (1111874, false, '2008-11-01', NULL, 12, '2008-11-01', 75.93, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111877, false, '2008-11-03', NULL, -1308131314, '2008-11-03', 713.90, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111890, false, '2008-11-03', NULL, -1308131312, '2008-11-03', 217.80, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111894, false, '2008-11-04', NULL, 812, '2008-11-04', 67.68, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111899, false, '2008-11-04', NULL, -1308131319, '2008-11-04', 502.40, NULL, 111191);
INSERT INTO pagos_a_proveedor VALUES (1111930, false, '2008-11-04', NULL, -1308131319, '2008-11-04', 250.00, NULL, 111192);
INSERT INTO pagos_a_proveedor VALUES (1111931, false, '2008-11-04', NULL, -1308131319, '2008-11-04', 181.00, NULL, 111188);
INSERT INTO pagos_a_proveedor VALUES (1111932, false, '2008-11-04', NULL, -1308131319, '2008-11-04', 41.38, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111933, false, '2008-11-04', NULL, -1308131321, '2008-11-04', 886.40, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111934, false, '2008-11-04', NULL, -1308131321, '2008-11-04', 130.00, NULL, 111190);
INSERT INTO pagos_a_proveedor VALUES (1111936, false, '2008-11-04', NULL, 219, '2008-11-04', 834.90, '420. MUNDO COLOR', 111194);
INSERT INTO pagos_a_proveedor VALUES (1111991, false, '2008-11-05', NULL, 291, '2008-11-05', 69.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111993, true, '2008-11-06', NULL, 111, '2008-11-06', 264.83, '9564', 111203);
INSERT INTO pagos_a_proveedor VALUES (1111992, true, '2008-11-06', NULL, 111, '2008-11-06', 630.00, NULL, 111198);
INSERT INTO pagos_a_proveedor VALUES (1111994, false, '2008-11-06', NULL, 111, '2008-11-06', 630.00, '9564', 111198);
INSERT INTO pagos_a_proveedor VALUES (1111995, false, '2008-11-06', NULL, 111, '2008-11-06', 264.83, '9564', 111203);
INSERT INTO pagos_a_proveedor VALUES (1111996, false, '2008-11-06', NULL, 111, '2008-11-06', 510.00, '9564', 111202);
INSERT INTO pagos_a_proveedor VALUES (1111997, false, '2008-11-06', NULL, 111, '2008-11-06', 506.12, '9564', 111204);
INSERT INTO pagos_a_proveedor VALUES (1111998, false, '2008-11-06', NULL, 111, '2008-11-06', 1350.00, '9564', 111205);
INSERT INTO pagos_a_proveedor VALUES (1112062, false, '2008-11-06', NULL, -1308098560, '2008-11-06', 210.20, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112064, false, '2008-11-06', NULL, 95, '2008-11-06', 18.88, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112071, false, '2008-11-06', NULL, 928, '2008-11-06', 221.70, '39728', NULL);
INSERT INTO pagos_a_proveedor VALUES (1112072, false, '2008-11-06', 'DESCUENTO', 928, '2008-11-06', 24.64, '39728', NULL);
INSERT INTO pagos_a_proveedor VALUES (1112074, false, '2008-11-06', NULL, 20, '2008-11-06', 267.75, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1111773, true, '2008-10-30', NULL, -1308131318, '2008-10-30', 367.84, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112075, false, '2008-11-06', NULL, -1308131318, '2008-11-06', 367.84, NULL, 111178);
INSERT INTO pagos_a_proveedor VALUES (1112077, false, '2008-11-07', NULL, -1308131315, '2008-11-07', 88.86, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112079, false, '2008-11-07', NULL, 283, '2008-11-07', 50.00, '614', NULL);
INSERT INTO pagos_a_proveedor VALUES (1112093, false, '2008-11-07', 'RECIBO FENIX', 407, '2008-11-07', 93.65, '2378', NULL);
INSERT INTO pagos_a_proveedor VALUES (1112092, true, '2008-11-07', NULL, 407, '2008-11-07', 202.54, NULL, 111208);
INSERT INTO pagos_a_proveedor VALUES (1112094, false, '2008-11-07', 'RECIBO FENIX', 407, '2008-11-07', 202.54, '2378', 111208);
INSERT INTO pagos_a_proveedor VALUES (1112097, false, '2008-11-07', NULL, 114, '2008-11-07', 252.89, NULL, 111212);
INSERT INTO pagos_a_proveedor VALUES (1112098, false, '2008-11-07', NULL, 114, '2008-11-07', 303.30, NULL, 111211);
INSERT INTO pagos_a_proveedor VALUES (1112096, true, '2008-11-07', NULL, 114, '2008-11-07', 269.00, NULL, 111213);
INSERT INTO pagos_a_proveedor VALUES (1112099, false, '2008-11-07', 'CONTRA REEMBOLSO', 114, '2008-11-07', 269.00, NULL, 111213);
INSERT INTO pagos_a_proveedor VALUES (1112151, false, '2008-11-08', NULL, -1308164088, '2008-11-08', 115.26, NULL, 111217);
INSERT INTO pagos_a_proveedor VALUES (1112153, false, '2008-11-08', NULL, 61, '2008-11-08', 203.00, NULL, 111210);
INSERT INTO pagos_a_proveedor VALUES (1112154, false, '2008-11-08', NULL, 61, '2008-11-08', 193.00, NULL, 111214);
INSERT INTO pagos_a_proveedor VALUES (1112155, false, '2008-11-08', NULL, 61, '2008-11-08', 194.75, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112157, false, '2008-11-08', NULL, -1308164088, '2008-11-08', 52.81, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112158, true, '2008-11-08', NULL, -1308164088, '2008-11-08', 52.81, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112156, true, '2008-11-08', NULL, -1308164088, '2008-11-08', 52.81, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112181, false, '2008-11-08', 'PAGO CON CAMBIO DE FACTURAS', 55, '2008-11-08', 344.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112183, false, '2008-11-08', NULL, 269, '2008-11-08', 193.75, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112186, false, '2008-11-08', NULL, -1308131313, '2008-11-08', 120.00, '30709', NULL);
INSERT INTO pagos_a_proveedor VALUES (1112187, false, '2008-11-08', 'confeccat', 28, '2008-11-08', 7500.00, NULL, 111201);
INSERT INTO pagos_a_proveedor VALUES (1112240, false, '2008-11-11', NULL, 111, '2008-11-11', 390.00, '9566', 111221);
INSERT INTO pagos_a_proveedor VALUES (1112241, false, '2008-11-11', NULL, 52, '2008-11-11', 1001.00, NULL, 111220);
INSERT INTO pagos_a_proveedor VALUES (1112311, false, '2008-11-12', NULL, 114, '2008-11-12', 784.00, NULL, 111228);
INSERT INTO pagos_a_proveedor VALUES (1112312, false, '2008-11-12', NULL, 114, '2008-11-12', 124.00, NULL, 111229);
INSERT INTO pagos_a_proveedor VALUES (1112313, false, '2008-11-12', 'CONTRAREEMBOLSO', 114, '2008-11-12', 210.00, NULL, 111232);
INSERT INTO pagos_a_proveedor VALUES (1112317, false, '2008-11-12', NULL, 657, '2008-11-12', 235.00, NULL, 111233);
INSERT INTO pagos_a_proveedor VALUES (1112318, false, '2008-11-12', 'SE PAGA $10.90 MENOS X DCTO. CTDO', 657, '2008-11-12', 56.17, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112319, false, '2008-11-12', NULL, 1, '2008-11-12', 460.00, NULL, 111236);
INSERT INTO pagos_a_proveedor VALUES (1112370, false, '2008-11-12', NULL, 1, '2008-11-12', 75.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112371, true, '2008-11-12', NULL, 546, '2008-11-12', 570.25, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112372, false, '2008-11-12', NULL, 80, '2008-11-12', 1278.03, NULL, 111216);
INSERT INTO pagos_a_proveedor VALUES (1112373, false, '2008-11-12', NULL, 80, '2008-11-12', 450.00, NULL, 111235);
INSERT INTO pagos_a_proveedor VALUES (1112377, true, '2008-11-12', NULL, 256, '2008-11-12', 75.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112378, false, '2008-11-12', NULL, 256, '2008-11-12', 75.34, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112375, true, '2008-11-12', NULL, 80, '2008-11-12', 384.00, NULL, 111239);
INSERT INTO pagos_a_proveedor VALUES (1112374, true, '2008-11-12', NULL, 80, '2008-11-12', 779.00, NULL, 111238);
INSERT INTO pagos_a_proveedor VALUES (1112379, false, '2008-11-12', NULL, 80, '2008-11-12', 384.00, NULL, 111239);
INSERT INTO pagos_a_proveedor VALUES (1112400, false, '2008-11-12', NULL, 80, '2008-11-12', 779.00, NULL, 111238);
INSERT INTO pagos_a_proveedor VALUES (1112401, false, '2008-11-12', NULL, 52, '2008-11-12', 600.00, NULL, 111241);
INSERT INTO pagos_a_proveedor VALUES (1112402, false, '2008-11-12', NULL, 52, '2008-11-12', 108.30, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112404, false, '2008-11-13', NULL, -1308065792, '2008-11-13', 420.03, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112406, false, '2008-11-13', NULL, 42, '2008-11-10', 1056.00, '58', NULL);
INSERT INTO pagos_a_proveedor VALUES (1112409, false, '2008-11-13', NULL, -1308065791, '2008-11-08', 48.20, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1511, true, '2008-10-11', NULL, 277, '2008-10-03', 254.39, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112422, false, '2008-11-13', NULL, 995, '2008-11-13', 100.00, NULL, 111243);
INSERT INTO pagos_a_proveedor VALUES (1112423, false, '2008-11-13', NULL, 995, '2008-11-13', 80.29, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112424, false, '2008-11-13', NULL, -1308098559, '2008-11-13', 150.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112425, false, '2008-11-13', NULL, 277, '2008-11-13', 247.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112429, false, '2008-11-13', NULL, 4, '2008-11-13', 369.00, NULL, 111249);
INSERT INTO pagos_a_proveedor VALUES (1112500, false, '2008-11-13', NULL, 4, '2008-11-13', 190.00, NULL, 111248);
INSERT INTO pagos_a_proveedor VALUES (1112501, false, '2008-11-13', NULL, 4, '2008-11-13', 89.00, NULL, 111244);
INSERT INTO pagos_a_proveedor VALUES (1112502, false, '2008-11-13', NULL, 4, '2008-11-13', 121.00, NULL, 111246);
INSERT INTO pagos_a_proveedor VALUES (1112503, false, '2008-11-13', NULL, 4, '2008-11-13', 1248.33, NULL, 111245);
INSERT INTO pagos_a_proveedor VALUES (1112504, false, '2008-11-13', 'CHEQUE 353 FENIX', 4, '2008-11-13', 10865.69, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112505, true, '2008-11-14', NULL, 49, '2008-11-14', 1734.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112506, false, '2008-11-14', NULL, 49, '2008-11-14', 1734.45, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112507, false, '2008-11-14', NULL, 546, '2008-11-14', 570.25, '167556', NULL);
INSERT INTO pagos_a_proveedor VALUES (1112509, false, '2008-11-14', NULL, 269, '2008-11-14', 186.03, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112517, false, '2008-11-14', NULL, 407, '2008-11-14', 592.42, '2454', NULL);
INSERT INTO pagos_a_proveedor VALUES (1112519, true, '2008-11-14', NULL, -1308065790, '2008-11-14', 170.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112521, true, '2008-11-14', NULL, -1308065790, '2008-11-14', 181.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112522, false, '2008-11-14', NULL, -1308065790, '2008-11-14', 181.00, '2400', NULL);
INSERT INTO pagos_a_proveedor VALUES (1112551, false, '2008-11-15', NULL, -1308033024, '2008-11-15', 100.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112600, false, '2008-11-18', NULL, 28, '2008-11-18', 6272.74, NULL, 111259);
INSERT INTO pagos_a_proveedor VALUES (1112601, false, '2008-11-18', NULL, 28, '2008-11-18', 765.00, NULL, 111254);
INSERT INTO pagos_a_proveedor VALUES (1112602, false, '2008-11-18', NULL, 28, '2008-11-18', 780.81, NULL, 111257);
INSERT INTO pagos_a_proveedor VALUES (1112605, false, '2008-11-18', NULL, 15, '2008-11-18', 446.00, '23074', 111258);
INSERT INTO pagos_a_proveedor VALUES (1112606, false, '2008-11-18', NULL, 15, '2008-11-18', 144.00, '23074', NULL);
INSERT INTO pagos_a_proveedor VALUES (1112426, true, '2008-11-13', NULL, 287, '2008-11-13', 500.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112607, false, '2008-11-18', NULL, 287, '2008-11-18', 150.00, NULL, 111262);
INSERT INTO pagos_a_proveedor VALUES (1112608, false, '2008-11-18', NULL, 287, '2008-11-18', 350.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112670, false, '2008-11-20', NULL, 46, '2008-11-20', 242.00, NULL, 111266);
INSERT INTO pagos_a_proveedor VALUES (1112671, false, '2008-11-20', NULL, 46, '2008-11-20', 846.40, NULL, 111265);
INSERT INTO pagos_a_proveedor VALUES (1112672, false, '2008-11-20', NULL, 46, '2008-11-20', 168.00, NULL, 111261);
INSERT INTO pagos_a_proveedor VALUES (1112674, false, '2008-11-20', NULL, -1308000256, '2008-11-20', 2079.00, NULL, 111263);
INSERT INTO pagos_a_proveedor VALUES (1112675, false, '2008-11-20', NULL, -1308000256, '2008-11-20', 700.00, NULL, 111264);
INSERT INTO pagos_a_proveedor VALUES (1112676, false, '2008-11-20', NULL, -1308000256, '2008-11-20', 273.00, NULL, 111256);
INSERT INTO pagos_a_proveedor VALUES (1112677, false, '2008-11-20', NULL, -1308000256, '2008-11-20', 803.55, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112682, false, '2008-11-20', NULL, 269, '2008-11-19', 176.34, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112686, false, '2008-11-20', NULL, 55, '2008-11-20', 322.49, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112687, false, '2008-11-20', 'TRANSFERENCIA', 121, '2008-11-20', 1512.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112688, false, '2008-11-20', 'CBIO FACTURA', 15, '2008-11-18', 807.75, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112721, false, '2008-11-21', NULL, 574, '2008-11-21', 124.11, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112726, false, '2008-11-22', NULL, -1308000255, '2008-11-21', 40.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112727, false, '2008-11-22', NULL, 61, '2008-11-22', 286.67, NULL, 111271);
INSERT INTO pagos_a_proveedor VALUES (1112728, false, '2008-11-22', NULL, 61, '2008-11-22', 33.80, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112729, false, '2008-11-22', NULL, -1308033023, '2008-11-22', 752.18, NULL, 111276);
INSERT INTO pagos_a_proveedor VALUES (1112770, false, '2008-11-22', NULL, -1308033023, '2008-11-22', 77.00, 'cbio factura', NULL);
INSERT INTO pagos_a_proveedor VALUES (1112771, false, '2008-11-22', NULL, -1308033023, '2008-11-22', 17.82, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112772, false, '2008-11-22', NULL, 407, '2008-11-22', 0.49, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112773, false, '2008-11-22', NULL, 80, '2008-11-22', 800.00, NULL, 111269);
INSERT INTO pagos_a_proveedor VALUES (1112774, false, '2008-11-22', NULL, 80, '2008-11-22', 200.00, NULL, 111278);
INSERT INTO pagos_a_proveedor VALUES (1112775, false, '2008-11-22', NULL, 80, '2008-11-22', 573.00, NULL, 111273);
INSERT INTO pagos_a_proveedor VALUES (1112776, false, '2008-11-22', NULL, 80, '2008-11-22', 46.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112777, false, '2008-11-24', NULL, 28, '2008-11-24', 157.51, NULL, 111283);
INSERT INTO pagos_a_proveedor VALUES (1112778, false, '2008-11-24', NULL, 28, '2008-11-24', 443.15, NULL, 111280);
INSERT INTO pagos_a_proveedor VALUES (1112779, false, '2008-11-24', NULL, 28, '2008-11-24', 563.00, NULL, 111282);
INSERT INTO pagos_a_proveedor VALUES (1112840, false, '2008-11-24', NULL, 28, '2008-11-24', 1205.11, NULL, 111279);
INSERT INTO pagos_a_proveedor VALUES (1112841, false, '2008-11-24', NULL, 28, '2008-11-24', 159.00, NULL, 111270);
INSERT INTO pagos_a_proveedor VALUES (1112844, false, '2008-11-24', NULL, 55, '2008-11-24', 337.48, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112854, false, '2008-11-27', NULL, -1307967488, '2008-11-27', 83.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112856, false, '2008-11-27', NULL, 668, '2008-11-27', 150.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112980, false, '2008-11-27', NULL, -1307967487, '2008-11-27', 67.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1112984, false, '2008-11-28', NULL, 114, '2008-11-28', 1435.00, '2475', 111295);
INSERT INTO pagos_a_proveedor VALUES (1112985, false, '2008-11-28', NULL, 114, '2008-11-28', 350.00, '2475', 111290);
INSERT INTO pagos_a_proveedor VALUES (1112986, false, '2008-11-28', NULL, 28, '2008-11-28', 2111.83, NULL, 111297);
INSERT INTO pagos_a_proveedor VALUES (1112987, false, '2008-11-28', NULL, 28, '2008-11-28', 797.00, NULL, 111296);
INSERT INTO pagos_a_proveedor VALUES (1112988, false, '2008-11-28', NULL, 114, '2008-11-28', 103.50, '2475', NULL);
INSERT INTO pagos_a_proveedor VALUES (1113060, false, '2008-12-01', NULL, 46, '2008-12-01', 587.91, NULL, 111302);
INSERT INTO pagos_a_proveedor VALUES (1113061, false, '2008-12-01', NULL, 46, '2008-12-01', 886.00, NULL, 111301);
INSERT INTO pagos_a_proveedor VALUES (1113062, false, '2008-12-01', NULL, 46, '2008-12-01', 1214.00, NULL, 111304);
INSERT INTO pagos_a_proveedor VALUES (1113064, false, '2008-12-02', NULL, 55, '2008-12-01', 337.48, 'CBIO FACTURA', NULL);
INSERT INTO pagos_a_proveedor VALUES (1113069, false, '2008-12-02', NULL, 295, '2008-11-04', 91.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113083, false, '2008-12-02', NULL, -1307967486, '2008-11-26', 87.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113085, false, '2008-12-02', NULL, 776, '2008-11-26', 102.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113087, false, '2008-12-02', NULL, 295, '2008-11-07', 91.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113089, false, '2008-12-02', NULL, -1307934720, '2008-11-28', 10.00, '805', NULL);
INSERT INTO pagos_a_proveedor VALUES (1113092, false, '2008-12-02', NULL, -1308131312, '2008-12-01', 60.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113093, false, '2008-12-02', NULL, 291, '2008-12-01', 69.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113095, false, '2008-12-02', NULL, 269, '2008-12-01', 95.22, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113097, false, '2008-12-02', NULL, 295, '2008-11-04', 91.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113099, false, '2008-12-03', NULL, 407, '2008-12-03', 222.86, '2483', 111307);
INSERT INTO pagos_a_proveedor VALUES (1113100, false, '2008-12-03', NULL, 407, '2008-12-03', 327.00, '2483', 111305);
INSERT INTO pagos_a_proveedor VALUES (1113101, false, '2008-12-03', NULL, 407, '2008-12-03', 11.00, '2483', NULL);
INSERT INTO pagos_a_proveedor VALUES (1113106, false, '2008-12-04', NULL, 283, '2008-12-04', 50.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113108, false, '2008-12-04', NULL, 385, '2008-12-04', 395.00, NULL, 111303);
INSERT INTO pagos_a_proveedor VALUES (1113109, false, '2008-12-04', NULL, 385, '2008-12-04', 450.00, NULL, 111311);
INSERT INTO pagos_a_proveedor VALUES (1113150, true, '2008-12-04', NULL, 385, '2008-12-04', 60.00, NULL, 111300);
INSERT INTO pagos_a_proveedor VALUES (1113151, true, '2008-12-04', NULL, 385, '2008-12-04', 60.00, NULL, 111313);
INSERT INTO pagos_a_proveedor VALUES (1113152, true, '2008-12-04', NULL, 385, '2008-12-04', 60.00, NULL, 111300);
INSERT INTO pagos_a_proveedor VALUES (1113153, true, '2008-12-04', NULL, 385, '2008-12-04', 60.00, NULL, 111313);
INSERT INTO pagos_a_proveedor VALUES (1113154, false, '2008-12-04', NULL, 385, '2008-12-04', 60.00, NULL, 111300);
INSERT INTO pagos_a_proveedor VALUES (1113155, false, '2008-12-04', NULL, 385, '2008-12-04', 52.00, NULL, 111312);
INSERT INTO pagos_a_proveedor VALUES (1113156, false, '2008-12-04', NULL, 385, '2008-12-04', 31.00, NULL, 111314);
INSERT INTO pagos_a_proveedor VALUES (1113157, false, '2008-12-04', NULL, 385, '2008-12-04', 73.00, NULL, 111319);
INSERT INTO pagos_a_proveedor VALUES (1113158, false, '2008-12-04', NULL, 385, '2008-12-04', 73.00, NULL, 111318);
INSERT INTO pagos_a_proveedor VALUES (1113159, false, '2008-12-04', NULL, 385, '2008-12-04', 73.00, NULL, 111317);
INSERT INTO pagos_a_proveedor VALUES (1113200, false, '2008-12-04', NULL, 385, '2008-12-04', 250.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113202, false, '2008-12-05', NULL, 219, '2008-12-05', 85.00, '448', 111322);
INSERT INTO pagos_a_proveedor VALUES (1113203, false, '2008-12-05', NULL, 219, '2008-12-05', 251.00, '448', 111321);
INSERT INTO pagos_a_proveedor VALUES (1113204, true, '2008-12-05', NULL, 219, '2008-12-05', 172.00, '448', NULL);
INSERT INTO pagos_a_proveedor VALUES (1113205, true, '2008-12-05', NULL, 219, '2008-12-05', 172.58, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113206, false, '2008-12-05', NULL, 219, '2008-12-05', 172.58, '448', NULL);
INSERT INTO pagos_a_proveedor VALUES (1113207, false, '2008-12-05', NULL, 219, '2008-12-05', 174.00, 'cbio factura', NULL);
INSERT INTO pagos_a_proveedor VALUES (1113208, false, '2008-12-06', NULL, 20, '2008-12-06', 281.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113209, false, '2008-12-06', NULL, 103, '2008-12-06', 1089.00, NULL, 111323);
INSERT INTO pagos_a_proveedor VALUES (1113240, false, '2008-12-06', NULL, 103, '2008-12-06', 192.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113281, false, '2008-12-09', NULL, 269, '2008-12-09', 153.89, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113283, false, '2008-12-09', NULL, 269, '2008-12-04', 185.96, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113285, false, '2008-12-09', NULL, 269, '2008-12-09', 192.48, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113287, false, '2008-12-09', NULL, -1307901952, '2008-12-01', 160.03, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113289, false, '2008-12-09', NULL, -1307901951, '2008-12-03', 70.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113291, false, '2008-12-09', NULL, -1307901950, '2008-12-09', 145.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113293, false, '2008-12-09', NULL, -1307901950, '2008-12-09', 155.07, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113295, false, '2008-12-09', NULL, 574, '2008-12-09', 57.02, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113301, false, '2008-12-09', NULL, 55, '2008-12-09', 93.00, NULL, 111326);
INSERT INTO pagos_a_proveedor VALUES (1113302, false, '2008-12-09', NULL, 55, '2008-12-09', 229.49, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113304, false, '2008-12-09', NULL, 98, '2008-12-09', 135.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113307, false, '2008-12-09', NULL, 42, '2008-12-09', 1056.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113309, false, '2008-12-09', NULL, 269, '2008-09-07', 137.96, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113311, false, '2008-12-09', NULL, 269, '2008-09-21', 134.92, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113313, false, '2008-12-09', NULL, 269, '2008-10-02', 143.07, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113315, false, '2008-12-09', NULL, 269, '2008-10-05', 150.80, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113320, false, '2008-12-09', NULL, -1307901949, '2008-10-09', 410.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113322, false, '2008-12-09', NULL, -1307901948, '2008-12-07', 28.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113324, false, '2008-12-10', NULL, 4, '2008-12-10', 315.50, NULL, 111333);
INSERT INTO pagos_a_proveedor VALUES (1113325, false, '2008-12-10', NULL, 4, '2008-12-10', 770.00, NULL, 111325);
INSERT INTO pagos_a_proveedor VALUES (1113326, false, '2008-12-10', NULL, 4, '2008-12-10', 611.00, NULL, 111327);
INSERT INTO pagos_a_proveedor VALUES (1113328, false, '2008-12-10', NULL, 4, '2008-12-10', 6982.74, 'CHEQUE 354', NULL);
INSERT INTO pagos_a_proveedor VALUES (1113327, true, '2008-12-10', 'PAGO CHEQUE 354', 4, '2008-12-10', 6984.74, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113329, false, '2008-12-11', NULL, -1308164093, '2008-12-11', 166.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113344, false, '2008-12-11', NULL, 399, '2008-12-10', 204.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113347, false, '2008-12-11', NULL, -1308098559, '2008-12-01', 150.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113349, false, '2008-12-11', NULL, -1307967487, '2008-12-10', 94.18, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113431, false, '2008-12-11', NULL, 269, '2008-10-07', 50.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113433, false, '2008-12-11', NULL, 269, '2008-10-13', 50.02, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113435, false, '2008-12-11', NULL, 269, '2008-10-13', 52.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113437, false, '2008-12-11', NULL, 269, '2008-10-18', 50.06, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113439, false, '2008-12-11', NULL, 269, '2008-10-27', 50.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113441, false, '2008-12-11', NULL, 269, '2008-10-24', 147.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113443, false, '2008-12-11', NULL, 269, '2008-10-30', 50.03, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113445, false, '2008-12-11', NULL, 269, '2008-11-02', 145.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113447, false, '2008-12-11', NULL, 269, '2008-11-02', 90.03, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113449, false, '2008-12-11', NULL, 269, '2008-11-16', 161.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113451, false, '2008-12-11', NULL, 269, '2008-11-16', 144.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113453, false, '2008-12-11', NULL, 269, '2008-11-23', 122.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113455, false, '2008-12-11', NULL, 269, '2008-12-07', 145.02, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113457, false, '2008-12-11', NULL, 269, '2008-12-07', 160.02, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113459, false, '2008-12-11', NULL, 630, '2008-12-11', 422.00, NULL, 111335);
INSERT INTO pagos_a_proveedor VALUES (1113460, false, '2008-12-11', NULL, 630, '2008-12-11', 121.00, NULL, 111342);
INSERT INTO pagos_a_proveedor VALUES (1113461, false, '2008-12-11', NULL, 630, '2008-12-11', 70.47, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113463, false, '2008-12-11', NULL, 287, '2008-12-11', 500.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113531, false, '2008-12-15', NULL, -1307869184, '2008-12-12', 110.21, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113534, false, '2008-12-15', NULL, -1307869183, '2008-12-11', 135.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113533, true, '2008-12-15', NULL, -1307869183, '2008-12-11', 135.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113536, false, '2008-12-15', NULL, 269, '2008-12-10', 170.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113538, false, '2008-12-15', NULL, -1307869182, '2008-12-12', 85.05, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113540, false, '2008-12-15', NULL, 536, '2008-12-11', 2.10, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113541, false, '2008-12-15', NULL, 28, '2008-12-15', 234.00, NULL, 111339);
INSERT INTO pagos_a_proveedor VALUES (1113542, false, '2008-12-15', NULL, 28, '2008-12-15', 162.40, NULL, 111348);
INSERT INTO pagos_a_proveedor VALUES (1113543, false, '2008-12-15', NULL, 28, '2008-12-15', 242.00, NULL, 111351);
INSERT INTO pagos_a_proveedor VALUES (1113544, false, '2008-12-15', NULL, 28, '2008-12-15', 845.00, NULL, 111337);
INSERT INTO pagos_a_proveedor VALUES (1113545, false, '2008-12-15', NULL, 28, '2008-12-15', 1206.00, NULL, 111336);
INSERT INTO pagos_a_proveedor VALUES (1113546, false, '2008-12-15', NULL, 28, '2008-12-15', 347.00, NULL, 111341);
INSERT INTO pagos_a_proveedor VALUES (1113547, false, '2008-12-15', NULL, 28, '2008-12-15', 306.75, NULL, 111352);
INSERT INTO pagos_a_proveedor VALUES (1113548, false, '2008-12-15', NULL, 995, '2008-12-15', 179.00, NULL, 111350);
INSERT INTO pagos_a_proveedor VALUES (1113549, false, '2008-12-15', NULL, 995, '2008-12-15', 344.40, NULL, 111349);
INSERT INTO pagos_a_proveedor VALUES (1113550, false, '2008-12-15', NULL, 995, '2008-12-15', 64.66, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113630, false, '2008-12-15', NULL, -1307934719, '2008-12-15', 2278.74, NULL, 111356);
INSERT INTO pagos_a_proveedor VALUES (1113631, false, '2008-12-15', NULL, -1307934719, '2008-12-15', 630.00, NULL, 111360);
INSERT INTO pagos_a_proveedor VALUES (1113632, false, '2008-12-15', NULL, -1307934719, '2008-12-15', 630.00, NULL, 111361);
INSERT INTO pagos_a_proveedor VALUES (1113633, false, '2008-12-15', NULL, -1307934719, '2008-12-15', 630.00, NULL, 111362);
INSERT INTO pagos_a_proveedor VALUES (1113634, false, '2008-12-15', NULL, -1307934719, '2008-12-15', 100.00, NULL, 111340);
INSERT INTO pagos_a_proveedor VALUES (1113635, false, '2008-12-15', NULL, -1307934719, '2008-12-15', 660.12, NULL, 111338);
INSERT INTO pagos_a_proveedor VALUES (1113636, false, '2008-12-15', NULL, -1307934719, '2008-12-15', 510.00, NULL, 111359);
INSERT INTO pagos_a_proveedor VALUES (1113638, false, '2008-12-16', NULL, -1307836416, '2008-12-16', 36.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113651, false, '2008-12-16', NULL, 55, '2008-12-16', 337.48, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113652, false, '2008-12-17', NULL, -1307934719, '2008-12-17', 55.50, NULL, 111357);
INSERT INTO pagos_a_proveedor VALUES (1113653, false, '2008-12-17', NULL, -1307934719, '2008-12-17', 140.00, NULL, 111358);
INSERT INTO pagos_a_proveedor VALUES (1113655, false, '2008-12-17', NULL, 277, '2008-12-17', 130.68, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113656, false, '2008-12-18', 'TRANSFERENCIA BANCARIA', -1307869181, '2008-12-18', 353.42, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113657, false, '2008-12-19', NULL, 1, '2008-12-19', 1080.00, NULL, 111371);
INSERT INTO pagos_a_proveedor VALUES (1113658, false, '2008-12-19', NULL, 1, '2008-12-19', 714.44, NULL, 111368);
INSERT INTO pagos_a_proveedor VALUES (1113659, false, '2008-12-19', NULL, 1, '2008-12-19', 400.00, NULL, 111370);
INSERT INTO pagos_a_proveedor VALUES (1113720, false, '2008-12-19', NULL, 1, '2008-12-19', 312.00, NULL, 111366);
INSERT INTO pagos_a_proveedor VALUES (1113721, false, '2008-12-19', NULL, 1, '2008-12-19', 168.00, NULL, 111367);
INSERT INTO pagos_a_proveedor VALUES (1113722, false, '2008-12-19', 'DEPOSITO BANCARIO', 385, '2008-12-19', 2000.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113724, false, '2008-12-19', NULL, 269, '2008-12-06', 70.05, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113727, false, '2008-12-19', NULL, -1307836415, '2008-12-18', 83.21, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113731, false, '2008-12-19', NULL, 269, '2008-12-18', 95.02, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113734, false, '2008-12-20', NULL, 28, '2008-12-20', 2500.00, NULL, 111376);
INSERT INTO pagos_a_proveedor VALUES (1113770, false, '2008-12-22', NULL, -1307869180, '2008-12-22', 275.60, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113739, true, '2008-12-22', NULL, -1307869180, '2008-12-22', 275.60, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113772, true, '2008-12-22', NULL, 1233, '2008-12-22', 5539.96, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113773, false, '2008-12-22', NULL, 1233, '2008-10-24', 3618.89, NULL, 111378);
INSERT INTO pagos_a_proveedor VALUES (1113775, false, '2008-12-23', NULL, -1307836414, '2008-12-23', 100.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113777, false, '2008-12-23', NULL, -1307836413, '2008-12-22', 192.03, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113779, false, '2008-12-23', NULL, 269, '2008-12-18', 197.21, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113791, false, '2008-12-23', NULL, 55, '2008-12-23', 322.49, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113795, false, '2008-12-23', NULL, 1, '2008-03-03', 577.64, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113797, false, '2008-12-23', NULL, 1, '2008-03-19', 633.13, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113799, false, '2008-12-23', NULL, 1, '2008-03-27', 1390.29, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113801, false, '2008-12-23', NULL, 211, '2008-03-04', 243.94, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113803, false, '2008-12-23', NULL, 211, '2008-03-28', 212.98, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113805, false, '2008-12-23', NULL, 28, '2008-04-02', 1944.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113807, false, '2008-12-23', NULL, 28, '2008-03-19', 4260.46, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113811, false, '2008-12-23', NULL, -1308164094, '2008-03-03', 231.83, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113814, false, '2008-12-23', NULL, -1308164094, '2008-03-03', 257.49, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113816, false, '2008-12-23', NULL, 46, '2008-03-17', 877.53, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113818, false, '2008-12-23', NULL, 114, '2008-03-12', 811.67, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113820, false, '2008-12-23', NULL, 995, '2008-03-04', 1860.49, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113822, false, '2008-12-23', NULL, 995, '2008-03-13', 649.16, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113824, false, '2008-12-23', NULL, 114, '2008-03-26', 157.30, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113826, false, '2008-12-23', NULL, 385, '2008-03-06', 679.54, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113828, false, '2008-12-23', NULL, 385, '2008-03-07', 867.33, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113830, false, '2008-12-23', NULL, 61, '2008-03-10', 1503.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113832, false, '2008-12-23', NULL, 61, '2008-03-13', 586.32, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113834, false, '2008-12-23', NULL, 55, '2008-03-08', 415.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113836, false, '2008-12-23', NULL, 55, '2008-03-25', 415.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113838, false, '2008-12-23', NULL, 4, '2008-03-07', 9554.08, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113840, false, '2008-12-23', NULL, 4, '2008-03-04', 127.26, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113842, false, '2008-12-23', NULL, 4, '2008-03-04', 171.18, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113844, false, '2008-12-23', NULL, 4, '2008-03-26', 9882.10, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113846, false, '2008-12-23', NULL, 4, '2008-03-27', 7555.36, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113848, false, '2008-12-23', NULL, 111, '2008-03-07', 131.92, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113850, false, '2008-12-23', NULL, 111, '2008-03-13', 1437.05, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113852, false, '2008-12-23', NULL, 111, '2008-03-13', 131.92, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113854, false, '2008-12-23', NULL, 111, '2008-03-28', 325.55, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113856, false, '2008-12-23', NULL, 407, '2008-03-04', 375.10, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113858, false, '2008-12-23', NULL, 269, '2008-03-16', 151.26, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113860, false, '2008-12-23', NULL, 269, '2008-03-30', 74.61, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113862, false, '2008-12-23', NULL, 269, '2008-03-02', 143.05, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113864, false, '2008-12-23', NULL, 269, '2008-03-18', 50.13, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113866, false, '2008-12-23', NULL, 269, '2008-03-12', 50.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113868, false, '2008-12-23', NULL, -1308131315, '2008-03-13', 50.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113870, false, '2008-12-23', NULL, 269, '2008-03-07', 50.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113872, false, '2008-12-23', NULL, 269, '2008-03-14', 40.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113874, false, '2008-12-23', NULL, 269, '2008-03-16', 122.62, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113876, false, '2008-12-23', NULL, -1308131315, '2008-03-27', 69.67, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113878, false, '2008-12-23', NULL, 15, '2008-03-04', 42.45, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113880, false, '2008-12-23', NULL, 15, '2008-03-06', 28.30, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113882, false, '2008-12-23', NULL, 15, '2008-03-08', 16.04, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113884, false, '2008-12-23', NULL, 15, '2008-03-11', 63.52, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113886, false, '2008-12-23', NULL, 15, '2008-03-13', 55.17, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113891, false, '2008-12-24', NULL, 15, '2008-03-15', 116.26, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113893, false, '2008-12-24', NULL, 15, '2008-03-19', 106.12, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113895, false, '2008-12-24', NULL, 15, '2008-03-18', 85.75, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113897, false, '2008-12-24', NULL, 15, '2008-03-20', 28.95, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113901, false, '2008-12-24', NULL, 15, '2008-03-27', 96.70, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113899, true, '2008-12-24', NULL, 15, '2008-03-27', 96.70, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113903, false, '2008-12-24', NULL, 15, '2008-03-28', 77.92, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113905, false, '2008-12-24', NULL, -1307803648, '2008-03-04', 25.77, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113907, false, '2008-12-24', NULL, 95, '2008-03-06', 14.52, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113909, true, '2008-12-24', NULL, 61, '2008-12-24', 127.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113920, false, '2008-12-24', NULL, 61, '2008-12-24', 127.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113922, false, '2008-12-24', NULL, 61, '2008-12-24', 500.00, NULL, 111391);
INSERT INTO pagos_a_proveedor VALUES (1113927, false, '2008-12-24', NULL, -1307803646, '2008-03-28', 50.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113929, false, '2008-12-24', NULL, -1307803645, '2008-03-09', 180.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113971, false, '2008-12-26', NULL, -1307770880, '2008-03-13', 299.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113973, false, '2008-12-26', NULL, 536, '2008-03-04', 2.20, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113975, false, '2008-12-26', NULL, 536, '2008-03-04', 2.20, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113977, false, '2008-12-26', NULL, 630, '2008-03-20', 686.07, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113979, false, '2008-12-26', NULL, 1048, '2008-03-28', 25.80, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113981, false, '2008-12-26', NULL, -1308164091, '2008-03-19', 46.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113983, true, '2008-12-26', NULL, 928, '2008-03-20', 62.80, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113985, false, '2008-12-26', NULL, 12, '2008-03-04', 25.05, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113987, false, '2008-12-26', NULL, 12, '2008-03-15', 44.83, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113989, false, '2008-12-26', NULL, 12, '2008-03-26', 45.46, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113991, false, '2008-12-26', NULL, 12, '2008-03-29', 128.02, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113993, false, '2008-12-26', NULL, 24, '2008-03-07', 960.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113994, false, '2008-12-26', NULL, -1307934719, '2008-12-26', 160.00, NULL, 111375);
INSERT INTO pagos_a_proveedor VALUES (1113995, false, '2008-12-26', NULL, -1307934719, '2008-12-26', 637.80, NULL, 111394);
INSERT INTO pagos_a_proveedor VALUES (1113996, false, '2008-12-26', NULL, -1307934719, '2008-12-26', 417.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114031, false, '2008-12-26', NULL, 49, '2008-03-17', 856.92, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114033, false, '2008-12-26', NULL, -1308164093, '2008-03-07', 218.79, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114035, false, '2008-12-26', NULL, 291, '2008-03-01', 54.45, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114037, false, '2008-12-26', NULL, 287, '2008-02-29', 500.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114039, false, '2008-12-26', NULL, -1308098559, '2008-03-03', 150.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114041, false, '2008-12-26', NULL, -1307738112, '2008-03-06', 40.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114043, false, '2008-12-26', NULL, 52, '2008-02-29', 780.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114045, false, '2008-12-26', NULL, 639, '2008-03-10', 18.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114047, false, '2008-12-26', NULL, -1307738110, '2008-03-25', 500.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114049, false, '2008-12-26', NULL, 1233, '2008-02-11', 5539.96, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114051, false, '2008-12-26', NULL, 4, '2008-03-04', 171.18, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114053, false, '2008-12-26', NULL, 80, '2008-03-05', 1322.53, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114055, false, '2008-12-26', NULL, 121, '2008-03-19', 605.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114057, false, '2008-12-26', NULL, 4, '2008-03-26', 9882.10, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114059, false, '2008-12-26', NULL, 219, '2008-03-28', 635.86, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114061, false, '2008-12-26', NULL, 269, '2008-03-30', 50.02, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114063, false, '2008-12-26', NULL, 928, '2008-03-31', 51.93, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114065, false, '2008-12-26', NULL, -1308131321, '2008-03-31', 264.39, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114066, false, '2008-12-26', 'factura que deben ellos', 15, '2008-12-26', 132.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114067, false, '2008-12-26', NULL, 15, '2008-12-26', 2147.10, NULL, 111401);
INSERT INTO pagos_a_proveedor VALUES (1114069, false, '2008-12-26', NULL, 52, '2008-12-26', 200.00, NULL, 111402);
INSERT INTO pagos_a_proveedor VALUES (1113809, true, '2008-12-23', NULL, 28, '2008-03-25', 3341.94, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114080, false, '2008-12-26', NULL, 52, '2008-12-26', 250.00, NULL, 111407);
INSERT INTO pagos_a_proveedor VALUES (1114081, false, '2008-12-26', NULL, 52, '2008-12-26', 7.95, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114083, false, '2008-12-27', NULL, -1307738109, '2008-12-27', 150.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114086, false, '2008-12-27', NULL, 385, '2008-04-01', 588.06, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114088, false, '2008-12-27', NULL, -1307934719, '2008-04-01', 2493.44, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114130, false, '2008-12-27', NULL, 15, '2008-04-01', 128.07, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114133, false, '2008-12-27', NULL, 28, '2008-12-27', 4616.26, NULL, 111400);
INSERT INTO pagos_a_proveedor VALUES (1114134, false, '2008-12-27', NULL, 28, '2008-12-27', 123.50, NULL, 111412);
INSERT INTO pagos_a_proveedor VALUES (1114135, false, '2008-12-27', NULL, 28, '2008-12-27', 170.00, NULL, 111410);
INSERT INTO pagos_a_proveedor VALUES (1114132, true, '2008-12-27', NULL, 20, '2008-03-17', 59.08, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114137, false, '2008-12-27', NULL, -1308164086, '2008-04-01', 59.08, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114140, false, '2008-12-27', NULL, 291, '2008-04-01', 54.45, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114142, false, '2008-12-27', NULL, -1308033024, '2008-04-01', 75.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114144, false, '2008-12-27', NULL, 80, '2008-04-03', 672.76, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114146, false, '2008-12-27', NULL, 4, '2008-04-03', 119.44, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114148, false, '2008-12-27', NULL, 15, '2008-04-03', 36.87, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114150, false, '2008-12-27', NULL, -1307738108, '2008-04-03', 40.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114152, false, '2008-12-27', NULL, 283, '2008-04-03', 50.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114154, false, '2008-12-27', NULL, 49, '2008-04-03', 35.64, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114156, false, '2008-12-27', NULL, 61, '2008-04-04', 823.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114158, false, '2008-12-27', NULL, 28, '2008-04-04', 4526.77, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114160, false, '2008-12-27', NULL, 114, '2008-04-04', 586.61, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114162, false, '2008-12-27', NULL, 385, '2008-04-04', 1200.32, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114164, false, '2008-12-27', NULL, 15, '2008-04-04', 73.35, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114166, false, '2008-12-27', NULL, 98, '2008-04-04', 180.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114168, false, '2008-12-27', NULL, -1308164093, '2008-04-04', 159.77, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114170, false, '2008-12-27', NULL, 20, '2008-04-04', 277.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114172, false, '2008-12-27', NULL, 12, '2008-04-05', 47.44, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114174, false, '2008-12-27', NULL, 28, '2008-04-07', 419.29, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114176, false, '2008-12-27', NULL, 95, '2008-04-07', 15.25, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114178, false, '2008-12-27', NULL, 15, '2008-04-08', 90.58, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114180, false, '2008-12-27', NULL, 55, '2008-04-07', 462.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114182, false, '2008-12-27', NULL, -1307738112, '2008-04-07', 40.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114184, false, '2008-12-27', NULL, 24, '2008-04-07', 480.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114186, false, '2008-12-27', NULL, 385, '2008-04-08', 604.03, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114188, false, '2008-12-27', NULL, 42, '2008-04-08', 692.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114190, false, '2008-12-27', NULL, -1307738107, '2008-04-09', 165.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1113921, true, '2008-12-24', NULL, 61, '2008-12-24', 250.00, NULL, 111374);
INSERT INTO pagos_a_proveedor VALUES (1114192, true, '2008-12-29', NULL, 61, '2008-12-29', 78.00, NULL, 111409);
INSERT INTO pagos_a_proveedor VALUES (1114191, true, '2008-12-29', NULL, 61, '2008-12-29', 82.00, NULL, 111411);
INSERT INTO pagos_a_proveedor VALUES (1114193, true, '2008-12-29', NULL, 61, '2008-12-29', 89.98, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114196, false, '2008-12-29', NULL, 536, '2008-12-06', 2.20, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114198, false, '2008-12-29', NULL, -1307738106, '2008-12-25', 100.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114200, false, '2008-12-29', NULL, -1307738105, '2008-12-29', 17.70, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114204, false, '2008-12-29', NULL, 211, '2008-04-09', 606.45, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114206, false, '2008-12-29', NULL, 1110, '2008-04-09', 384.54, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114208, false, '2008-12-29', NULL, 776, '2008-04-09', 12.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114210, false, '2008-12-29', NULL, 15, '2008-04-09', 158.87, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114212, false, '2008-12-29', NULL, 995, '2008-04-10', 873.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114214, false, '2008-12-29', NULL, 995, '2008-04-10', 547.88, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114216, false, '2008-12-29', NULL, 1, '2008-04-10', 255.91, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114218, false, '2008-12-29', NULL, 713, '2008-12-29', 100.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114230, false, '2008-12-29', NULL, -1307738104, '2008-12-29', 490.53, NULL, 111422);
INSERT INTO pagos_a_proveedor VALUES (1114231, false, '2008-12-29', NULL, -1307738104, '2008-12-29', 289.92, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114281, false, '2008-12-30', NULL, -1308098559, '2008-04-10', 150.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114283, false, '2008-12-30', NULL, -1307738105, '2008-04-10', 26.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114285, false, '2008-12-30', NULL, 114, '2008-04-11', 1057.90, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114287, false, '2008-12-30', NULL, -1308164095, '2008-04-11', 988.27, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114289, false, '2008-12-30', NULL, 574, '2008-04-11', 83.06, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114291, false, '2008-12-30', NULL, 269, '2008-04-11', 47.71, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114293, false, '2008-12-30', NULL, 15, '2008-04-10', 23.27, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114295, false, '2008-12-30', NULL, 15, '2008-04-11', 34.07, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114297, false, '2008-12-30', NULL, 15, '2008-04-12', 123.03, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114299, false, '2008-12-30', NULL, 617, '2008-04-12', 10.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114301, false, '2008-12-30', NULL, 12, '2008-04-12', 67.37, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114303, true, '2008-12-30', NULL, 80, '2008-04-14', 310.57, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114304, false, '2008-12-30', NULL, 80, '2008-04-14', 310.97, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114306, false, '2008-12-30', NULL, 1, '2008-04-14', 223.85, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114308, false, '2008-12-30', NULL, 46, '2008-04-14', 340.20, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114313, false, '2008-12-30', NULL, 28, '2008-04-14', 2539.79, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114315, false, '2008-12-30', NULL, 928, '2008-04-14', 33.96, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114317, false, '2008-12-30', NULL, 111, '2008-04-15', 1424.71, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114319, false, '2008-12-30', NULL, 15, '2008-04-15', 22.43, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114321, false, '2008-12-30', NULL, 55, '2008-04-16', 434.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114323, false, '2008-12-30', NULL, -1307705344, '2008-04-16', 278.40, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114325, false, '2008-12-30', NULL, 15, '2008-04-16', 58.46, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114327, false, '2008-12-30', NULL, 15, '2008-04-17', 35.65, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114329, false, '2008-12-30', NULL, 211, '2008-04-17', 749.60, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114331, false, '2008-12-30', NULL, -1307705343, '2008-04-17', 70.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114333, false, '2008-12-30', NULL, 15, '2008-04-17', 14.52, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114335, false, '2008-12-30', NULL, 15, '2008-04-19', 86.14, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114337, false, '2008-12-30', NULL, 12, '2008-04-19', 41.67, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114339, false, '2008-12-30', NULL, 264, '2008-04-18', 139.15, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114340, false, '2008-12-30', NULL, 46, '2008-12-30', 78.00, NULL, 111409);
INSERT INTO pagos_a_proveedor VALUES (1114341, false, '2008-12-30', NULL, 46, '2008-12-30', 600.00, NULL, 111393);
INSERT INTO pagos_a_proveedor VALUES (1114342, false, '2008-12-30', NULL, 80, '2008-12-30', 2703.50, NULL, 111396);
INSERT INTO pagos_a_proveedor VALUES (1114343, false, '2008-12-30', NULL, 80, '2008-12-30', 268.00, NULL, 111426);
INSERT INTO pagos_a_proveedor VALUES (1114344, false, '2008-12-30', NULL, 80, '2008-12-30', 116.50, NULL, 111425);
INSERT INTO pagos_a_proveedor VALUES (1114345, false, '2008-12-30', NULL, 80, '2008-12-30', 82.00, NULL, 111411);
INSERT INTO pagos_a_proveedor VALUES (1114346, false, '2008-12-30', NULL, 103, '2008-12-30', 1138.00, NULL, 111427);
INSERT INTO pagos_a_proveedor VALUES (1114350, false, '2008-12-30', NULL, 1, '2008-04-23', 1818.02, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114352, false, '2008-12-30', NULL, 1, '2008-04-24', 36.66, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114354, false, '2008-12-30', NULL, 385, '2008-04-24', 4077.22, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114356, false, '2008-12-30', NULL, 385, '2008-04-24', 11.37, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114358, false, '2008-12-30', NULL, 15, '2008-04-24', 62.59, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114360, false, '2008-12-30', NULL, -1307705342, '2008-04-24', 100.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114362, false, '2008-12-30', NULL, 49, '2008-04-18', 646.34, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114365, false, '2008-12-30', NULL, 24, '2008-04-25', 945.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114367, false, '2008-12-30', NULL, -1307738110, '2008-04-25', 24.44, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114369, false, '2008-12-30', NULL, 269, '2008-04-25', 83.76, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114371, false, '2008-12-30', NULL, 995, '2008-04-25', 2072.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114373, false, '2008-12-30', NULL, -1307934719, '2008-04-25', 3593.24, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114375, false, '2008-12-30', NULL, 385, '2008-04-25', 3004.67, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114377, false, '2008-12-30', NULL, 28, '2008-03-25', 3341.94, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114379, false, '2008-12-30', NULL, 111, '2008-04-25', 763.38, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114381, false, '2008-12-30', NULL, 61, '2008-04-25', 1697.38, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114383, false, '2008-12-30', NULL, 15, '2008-04-26', 294.43, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114391, true, '2008-12-31', NULL, 15, '2008-04-26', 294.43, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114393, false, '2008-12-31', NULL, 12, '2008-04-26', 58.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114395, false, '2008-12-31', NULL, 269, '2008-04-27', 61.30, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114397, false, '2008-12-31', NULL, 61, '2008-03-27', 645.60, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114399, false, '2008-12-31', NULL, 55, '2008-04-28', 434.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114401, false, '2008-12-31', NULL, 287, '2008-03-28', 500.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114406, false, '2008-12-31', NULL, 385, '2008-04-29', 462.22, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114408, false, '2008-12-31', NULL, 15, '2008-04-29', 154.27, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114450, false, '2008-12-31', NULL, -1308131320, '2008-04-29', 16.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114452, false, '2008-12-31', NULL, 28, '2008-04-29', 3546.92, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114454, false, '2008-12-31', NULL, 28, '2008-04-29', 444.29, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114456, false, '2008-12-31', NULL, 219, '2008-04-29', 1527.27, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114458, false, '2008-12-31', NULL, 812, '2008-04-29', 48.44, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114460, false, '2008-12-31', NULL, 15, '2008-04-30', 198.48, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114462, false, '2008-12-31', NULL, 49, '2008-04-30', 67.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114464, false, '2008-12-31', NULL, 1174, '2008-04-30', 127.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114466, false, '2008-12-31', NULL, 546, '2008-04-25', 511.35, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114468, false, '2008-12-31', NULL, 4, '2008-04-23', 9982.14, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114491, false, '2009-01-02', NULL, 55, '2009-01-02', 134.32, NULL, 111448);
INSERT INTO pagos_a_proveedor VALUES (1114492, false, '2009-01-02', NULL, 55, '2009-01-02', 145.00, NULL, 111447);
INSERT INTO pagos_a_proveedor VALUES (1114493, false, '2009-01-02', NULL, 55, '2009-01-02', 58.16, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114496, false, '2009-01-03', NULL, -1308131312, '2008-12-31', 84.70, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114497, false, '2009-01-03', NULL, 61, '2009-01-03', 2786.11, NULL, 111441);
INSERT INTO pagos_a_proveedor VALUES (1114498, false, '2009-01-03', NULL, 61, '2009-01-03', 999.10, NULL, 111424);
INSERT INTO pagos_a_proveedor VALUES (1114499, false, '2009-01-03', NULL, 61, '2009-01-03', 200.00, NULL, 111444);
INSERT INTO pagos_a_proveedor VALUES (1114520, false, '2009-01-03', NULL, 61, '2009-01-03', 260.00, NULL, 111451);
INSERT INTO pagos_a_proveedor VALUES (1114521, false, '2009-01-03', NULL, 61, '2009-01-03', 16.75, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114523, false, '2009-01-05', NULL, 617, '2009-01-02', 15.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114525, false, '2009-01-05', NULL, 269, '2009-01-05', 137.06, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114527, false, '2009-01-05', NULL, 269, '2009-01-05', 188.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114529, false, '2009-01-05', NULL, 20, '2008-05-22', 243.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114531, false, '2009-01-05', NULL, -1308164086, '2008-05-26', 104.41, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114533, false, '2009-01-05', NULL, 15, '2008-05-30', 24.94, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114535, false, '2009-01-05', NULL, 269, '2008-05-29', 50.04, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114537, false, '2009-01-05', NULL, 15, '2008-05-29', 35.31, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114539, false, '2009-01-05', NULL, 15, '2008-05-28', 16.07, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114541, false, '2009-01-05', NULL, -1307672575, '2008-05-28', 773.98, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114543, false, '2009-01-05', NULL, 211, '2008-05-27', 521.74, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114545, false, '2009-01-05', NULL, 385, '2008-05-27', 145.20, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114547, false, '2009-01-05', NULL, -1307803648, '2008-05-27', 18.03, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114549, false, '2009-01-05', NULL, -1308164094, '2008-05-26', 72.46, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114551, false, '2009-01-05', NULL, 407, '2008-05-26', 286.04, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114553, false, '2009-01-05', NULL, 269, '2008-05-24', 31.02, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114555, false, '2009-01-05', NULL, 12, '2008-05-24', 62.48, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114557, false, '2009-01-05', NULL, 15, '2008-05-24', 15.80, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114559, false, '2009-01-05', NULL, 15, '2008-05-23', 13.41, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114561, false, '2009-01-05', NULL, 55, '2008-05-23', 461.98, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114563, false, '2009-01-05', NULL, 211, '2008-05-22', 491.26, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114565, false, '2009-01-05', NULL, 4, '2008-05-22', 4703.87, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114567, false, '2009-01-05', NULL, 15, '2008-05-22', 147.18, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114569, false, '2009-01-05', NULL, 617, '2008-05-22', 33.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114571, false, '2009-01-05', NULL, -1307672574, '2008-05-22', 15.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114573, false, '2009-01-05', NULL, 111, '2008-05-21', 367.24, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114575, false, '2009-01-05', NULL, 15, '2008-05-21', 47.59, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114194, true, '2008-12-29', NULL, 61, '2008-12-29', 250.00, NULL, 111374);
INSERT INTO pagos_a_proveedor VALUES (1114577, false, '2009-01-06', NULL, 20, '2009-01-05', 307.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114579, false, '2009-01-06', NULL, -1307672573, '2009-01-06', 198.06, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114583, false, '2009-01-06', NULL, -1308164093, '2009-01-05', 57.07, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114585, false, '2009-01-06', NULL, 291, '2009-01-01', 69.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114587, false, '2009-01-06', NULL, 121, '2008-05-21', 605.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114589, false, '2009-01-06', NULL, -1308164088, '2008-05-21', 59.83, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114610, false, '2009-01-06', NULL, 111, '2009-01-06', 196.00, NULL, 111443);
INSERT INTO pagos_a_proveedor VALUES (1114611, false, '2009-01-06', NULL, 111, '2009-01-06', 484.00, NULL, 111450);
INSERT INTO pagos_a_proveedor VALUES (1114613, false, '2009-01-06', NULL, -1308098559, '2009-01-06', 150.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114615, false, '2009-01-06', NULL, 1, '2008-05-21', 6377.18, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114617, false, '2009-01-06', NULL, 1110, '2008-05-20', 1424.78, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114619, false, '2009-01-06', NULL, 269, '2008-05-20', 50.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114621, false, '2009-01-06', NULL, 15, '2008-05-20', 407.15, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114623, false, '2009-01-06', NULL, 114, '2008-05-19', 392.04, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114625, false, '2009-01-06', NULL, 111, '2008-05-19', 666.25, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114627, false, '2009-01-06', NULL, 269, '2008-05-18', 134.86, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114628, false, '2009-01-07', NULL, 111, '2009-01-07', 1125.00, NULL, 111459);
INSERT INTO pagos_a_proveedor VALUES (1114629, false, '2009-01-07', NULL, 111, '2009-01-06', 68.60, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114631, false, '2009-01-07', NULL, 15, '2008-05-17', 29.96, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114633, false, '2009-01-07', NULL, 114, '2008-05-15', 977.68, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114635, false, '2009-01-07', NULL, 121, '2008-05-16', 907.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114636, false, '2009-01-07', NULL, 121, '2008-04-24', 605.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114638, false, '2009-01-07', NULL, 385, '2008-05-16', 150.04, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114640, false, '2009-01-07', NULL, 49, '2008-05-19', 723.21, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114641, false, '2009-01-07', NULL, 49, '2009-01-03', 14.25, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114643, false, '2009-01-07', NULL, 15, '2008-05-16', 192.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114645, false, '2009-01-07', NULL, -1307672572, '2008-05-15', 823.28, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114647, false, '2009-01-07', NULL, 111, '2008-05-15', 537.08, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114649, false, '2009-01-07', NULL, 15, '2008-05-15', 29.44, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114651, false, '2009-01-07', NULL, 1, '2008-05-14', 257.73, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114653, false, '2009-01-07', NULL, 55, '2008-05-14', 488.98, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114655, false, '2009-01-07', NULL, 578, '2008-05-14', 132.61, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114657, false, '2009-01-07', NULL, 28, '2008-05-14', 282.20, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114659, false, '2009-01-07', NULL, 15, '2008-05-14', 45.75, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114661, false, '2009-01-07', NULL, 407, '2008-05-13', 435.16, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114663, false, '2009-01-07', NULL, 95, '2008-05-13', 18.88, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114665, false, '2009-01-07', NULL, 574, '2008-05-13', 60.02, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114667, false, '2009-01-07', NULL, 111, '2008-05-12', 1306.30, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114669, false, '2009-01-07', NULL, 28, '2008-05-12', 4779.16, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114681, false, '2009-01-07', NULL, 15, '2008-05-12', 193.43, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114683, false, '2009-01-07', NULL, 28, '2008-05-12', 13328.75, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114685, false, '2009-01-07', NULL, 28, '2008-05-12', 2274.88, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114687, false, '2009-01-08', NULL, 12, '2008-05-12', 39.33, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114689, false, '2009-01-08', NULL, 12, '2008-05-12', 39.33, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114711, false, '2009-01-08', NULL, 111, '2008-05-12', 94.85, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114713, false, '2009-01-08', NULL, -1308164095, '2008-05-09', 1157.10, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114715, false, '2009-01-08', NULL, 15, '2008-05-09', 36.34, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114717, false, '2009-01-08', NULL, 80, '2008-05-09', 1524.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114719, false, '2009-01-08', NULL, 269, '2008-05-07', 49.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114721, false, '2009-01-08', NULL, -1307738104, '2008-05-09', 258.94, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114723, false, '2009-01-08', NULL, 578, '2008-05-09', 22.65, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114725, false, '2009-01-08', NULL, 4, '2008-05-08', 6766.08, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114727, false, '2009-01-08', NULL, 111, '2008-05-08', 1997.43, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114729, false, '2009-01-08', NULL, 15, '2008-05-08', 101.42, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114731, false, '2009-01-08', NULL, 578, '2008-05-08', 50.48, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114733, false, '2009-01-08', NULL, 28, '2008-05-07', 2895.47, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114735, false, '2009-01-08', NULL, 61, '2008-05-07', 604.66, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114736, false, '2009-01-08', NULL, 121, '2009-01-08', 1512.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114738, false, '2009-01-08', NULL, 121, '2008-05-07', 3388.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114740, false, '2009-01-08', NULL, 15, '2008-05-07', 40.05, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114742, false, '2009-01-08', NULL, 1, '2008-05-06', 472.80, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114744, false, '2009-01-08', NULL, 15, '2008-05-06', 13.37, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114746, false, '2009-01-08', NULL, 95, '2008-05-06', 30.49, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114748, false, '2009-01-08', NULL, 28, '2008-05-06', 1963.43, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114750, false, '2009-01-08', NULL, 657, '2008-05-06', 277.05, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114751, false, '2009-01-08', NULL, 1, '2009-01-08', 629.20, NULL, 111460);
INSERT INTO pagos_a_proveedor VALUES (1114752, false, '2009-01-08', NULL, 1, '2009-01-08', 373.00, NULL, 111470);
INSERT INTO pagos_a_proveedor VALUES (1114753, false, '2009-01-08', NULL, 1, '2009-01-08', 457.28, NULL, 111469);
INSERT INTO pagos_a_proveedor VALUES (1114756, false, '2009-01-09', NULL, 407, '2009-01-09', 263.54, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114759, false, '2009-01-09', NULL, 269, '2009-01-07', 190.02, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114761, false, '2009-01-09', NULL, 4, '2009-01-09', 11410.05, NULL, 111478);
INSERT INTO pagos_a_proveedor VALUES (1114763, false, '2009-01-09', NULL, -1307672571, '2009-01-05', 33.69, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114766, false, '2009-01-09', NULL, 283, '2009-01-08', 50.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114791, false, '2009-01-09', NULL, 42, '2009-01-05', 1056.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114793, false, '2009-01-09', NULL, 46, '2008-05-05', 354.72, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114795, false, '2009-01-09', NULL, -1307738105, '2008-05-05', 36.90, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114797, false, '2009-01-09', NULL, 114, '2008-05-05', 586.61, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114821, false, '2009-01-10', NULL, 80, '2008-05-05', 1912.71, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114823, false, '2009-01-10', NULL, 4, '2008-05-05', 99.11, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114825, false, '2009-01-10', NULL, 55, '2008-05-05', 434.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114827, false, '2009-01-10', NULL, 269, '2008-05-05', 38.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114829, false, '2009-01-10', NULL, 269, '2008-05-04', 76.65, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114831, false, '2009-01-10', NULL, 269, '2008-05-04', 30.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114833, false, '2009-01-10', NULL, 269, '2008-05-03', 30.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114835, false, '2009-01-10', NULL, 15, '2008-05-03', 79.28, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114837, false, '2009-01-10', NULL, 12, '2008-05-03', 28.80, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114839, false, '2009-01-10', NULL, 12, '2008-05-03', 49.34, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114841, false, '2009-01-10', NULL, 15, '2008-05-02', 36.55, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114843, false, '2009-01-10', NULL, 46, '2008-05-02', 1033.26, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114845, false, '2009-01-10', NULL, 713, '2008-05-02', 230.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114847, false, '2009-01-10', NULL, 4, '2008-04-30', 184.26, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114849, false, '2009-01-10', NULL, 269, '2008-04-27', 30.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114851, false, '2009-01-10', NULL, 20, '2008-05-02', 212.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114853, false, '2009-01-10', NULL, 291, '2008-05-01', 54.45, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114855, false, '2009-01-10', NULL, 536, '2009-01-01', 2.20, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114857, false, '2009-01-10', NULL, 536, '2008-05-13', 2.20, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114859, false, '2009-01-10', NULL, 42, '2008-05-05', 692.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114861, false, '2009-01-10', NULL, -1307639808, '2008-05-19', 96.12, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114863, false, '2009-01-10', NULL, -1308164093, '2008-05-07', 142.89, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114865, false, '2009-01-10', NULL, 52, '2008-05-20', 54.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114867, false, '2009-01-10', NULL, -1307738107, '2008-05-14', 165.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114869, false, '2009-01-10', NULL, 52, '2008-04-23', 111.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114871, false, '2009-01-10', NULL, 52, '2008-05-08', 283.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114873, false, '2009-01-10', NULL, 98, '2008-05-07', 85.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114875, false, '2009-01-10', NULL, 657, '2008-05-14', 260.88, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114881, false, '2009-01-10', NULL, 287, '2008-04-30', 500.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114883, false, '2009-01-10', NULL, -1308098559, '2008-05-02', 150.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114885, false, '2009-01-10', NULL, 283, '2008-05-02', 50.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114887, false, '2009-01-10', NULL, -1307738112, '2008-05-05', 50.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114889, false, '2009-01-10', NULL, 1, '2008-06-20', 1361.25, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114891, false, '2009-01-10', NULL, 1, '2008-06-20', 1361.25, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114893, false, '2009-01-10', NULL, 1, '2008-06-25', 226.27, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114895, false, '2009-01-10', NULL, 1, '2008-06-19', 641.30, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114897, false, '2009-01-10', NULL, 1, '2008-06-03', 2493.81, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114899, false, '2009-01-10', NULL, 1, '2008-06-02', 406.86, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114901, false, '2009-01-10', NULL, 211, '2008-06-24', 149.07, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114903, false, '2009-01-10', NULL, 28, '2008-06-18', 444.29, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114905, false, '2009-01-10', NULL, 28, '2008-06-10', 509.07, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114907, false, '2009-01-10', NULL, 28, '2008-06-03', 2221.46, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114909, false, '2009-01-10', NULL, 28, '2008-06-05', 1004.81, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114911, false, '2009-01-10', NULL, 46, '2008-06-02', 1836.11, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114913, false, '2009-01-10', NULL, 114, '2008-06-25', 1245.82, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114915, false, '2009-01-10', NULL, 114, '2008-06-03', 394.46, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114917, false, '2009-01-10', NULL, 385, '2008-05-06', 1974.72, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114919, false, '2009-01-10', NULL, 61, '2008-06-18', 401.77, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114921, false, '2009-01-10', NULL, 61, '2008-06-02', 1377.77, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114923, false, '2009-01-10', NULL, 103, '2008-06-13', 3556.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114925, false, '2009-01-10', NULL, 962, '2008-06-13', 987.36, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114927, false, '2009-01-10', NULL, 55, '2008-06-24', 579.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114929, false, '2009-01-10', NULL, 55, '2008-06-02', 488.98, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114931, false, '2009-01-10', NULL, 55, '2008-06-12', 515.97, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114933, false, '2009-01-10', NULL, 80, '2008-06-20', 289.43, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114936, false, '2009-01-10', NULL, 80, '2008-06-04', 580.80, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114935, true, '2009-01-10', NULL, 80, '2009-01-10', 580.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114938, false, '2009-01-10', NULL, 80, '2008-05-29', 1972.30, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114940, false, '2009-01-10', NULL, 80, '2008-05-30', 469.33, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114942, false, '2009-01-10', NULL, 4, '2008-06-04', 0.07, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114944, false, '2009-01-10', NULL, 4, '2008-05-15', 257.75, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114946, false, '2009-01-10', NULL, 4, '2008-06-04', 224.77, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114948, false, '2009-01-10', NULL, 4, '2008-06-20', 11500.32, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114950, false, '2009-01-10', NULL, 111, '2008-06-25', 817.97, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114952, false, '2009-01-10', NULL, 111, '2008-06-03', 1078.90, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114971, false, '2009-01-12', NULL, 95, '2009-01-10', 18.15, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114973, false, '2009-01-12', NULL, 385, '2009-01-12', 2147.00, NULL, 111499);
INSERT INTO pagos_a_proveedor VALUES (1114974, false, '2009-01-12', NULL, 385, '2009-01-12', 2147.00, NULL, 111500);
INSERT INTO pagos_a_proveedor VALUES (1114976, false, '2009-01-12', NULL, 385, '2009-01-12', 158.00, NULL, 111498);
INSERT INTO pagos_a_proveedor VALUES (1114978, false, '2009-01-12', NULL, 617, '2008-06-06', 11.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115020, false, '2009-01-12', NULL, 617, '2008-06-03', 8.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115022, false, '2009-01-12', NULL, 15, '2008-06-04', 119.81, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115024, false, '2009-01-12', NULL, 15, '2008-06-09', 115.38, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115026, false, '2009-01-12', NULL, 15, '2008-06-09', 25.41, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115028, false, '2009-01-12', NULL, 15, '2008-06-26', 95.03, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115030, false, '2009-01-12', NULL, 15, '2008-06-27', 96.45, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115032, false, '2009-01-12', NULL, 95, '2008-06-21', 18.88, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115034, false, '2009-01-12', NULL, 15, '2008-06-21', 26.02, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115036, false, '2009-01-12', NULL, 15, '2008-06-20', 24.79, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115038, false, '2009-01-12', NULL, 15, '2008-06-19', 137.31, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115040, false, '2009-01-12', NULL, 15, '2008-06-14', 14.39, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115042, false, '2009-01-12', NULL, 15, '2008-06-11', 72.14, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115044, false, '2009-01-12', NULL, 536, '2008-06-05', 2.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115046, false, '2009-01-12', NULL, 536, '2008-06-05', 2.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115048, false, '2009-01-12', NULL, 269, '2008-06-26', 45.02, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115050, false, '2009-01-12', NULL, 269, '2008-06-12', 40.02, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115052, false, '2009-01-12', NULL, 269, '2008-06-06', 37.03, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115054, false, '2009-01-12', NULL, 269, '2008-06-01', 149.24, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115056, false, '2009-01-12', NULL, 269, '2008-05-31', 30.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115058, false, '2009-01-12', NULL, 269, '2008-05-18', 102.20, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115060, false, '2009-01-12', NULL, 269, '2008-05-11', 135.95, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115062, false, '2009-01-12', NULL, 269, '2008-05-02', 89.34, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115064, false, '2009-01-12', NULL, 269, '2008-04-20', 171.49, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115066, false, '2009-01-12', NULL, 269, '2008-04-13', 75.60, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115068, false, '2009-01-12', NULL, 269, '2008-06-19', 69.45, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115070, false, '2009-01-12', NULL, -1307607040, '2008-06-17', 114.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115072, false, '2009-01-12', NULL, 135, '2008-06-22', 92.15, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115074, false, '2009-01-12', NULL, 269, '2008-06-08', 75.56, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115076, true, '2009-01-12', NULL, 269, '2009-01-04', 84.76, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115077, false, '2009-01-12', NULL, 269, '2008-06-04', 84.76, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115079, false, '2009-01-12', NULL, 24, '2008-06-13', 15.78, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115081, false, '2009-01-12', NULL, -1307607039, '2008-06-23', 790.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115083, false, '2009-01-12', NULL, 1044, '2008-06-04', 143.78, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115112, false, '2009-01-13', NULL, 287, '2009-01-13', 500.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115114, false, '2009-01-13', NULL, 269, '2009-01-07', 75.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115117, false, '2009-01-13', NULL, 55, '2009-01-13', 449.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115121, false, '2009-01-13', NULL, 639, '2009-01-13', 43.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115122, true, '2009-01-13', NULL, -1308164087, '2009-01-13', 204.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115124, false, '2009-01-13', NULL, -1308164087, '2009-01-02', 204.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115125, false, '2009-01-13', NULL, -1308164087, '2009-01-05', 613.47, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115126, false, '2009-01-13', NULL, 52, '2008-06-18', 56.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115128, false, '2009-01-13', NULL, 12, '2008-06-27', 93.97, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115140, false, '2009-01-13', NULL, 1174, '2008-06-14', 165.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115142, false, '2009-01-13', NULL, -1307574272, '2008-06-11', 500.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115144, false, '2009-01-13', NULL, -1307574271, '2008-06-19', 822.80, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115146, false, '2009-01-13', NULL, 564, '2008-06-30', 71.64, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115148, false, '2009-01-13', NULL, -1307574270, '2008-05-30', 321.65, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115150, false, '2009-01-13', NULL, 121, '2008-06-20', 605.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115152, false, '2009-01-13', NULL, -1307738104, '2008-06-03', 27.22, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115154, false, '2009-01-13', NULL, 713, '2008-05-27', 340.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115156, false, '2009-01-13', NULL, -1307574269, '2008-06-24', 74.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115158, false, '2009-01-13', NULL, -1307574269, '2008-06-24', 20.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115160, false, '2009-01-13', NULL, -1307574271, '2008-06-03', 822.80, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115162, false, '2009-01-13', NULL, 42, '2008-06-05', 692.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115164, false, '2009-01-13', NULL, 578, '2008-06-06', 85.23, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115166, false, '2009-01-13', NULL, 578, '2008-06-09', 90.60, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115168, false, '2009-01-13', NULL, 578, '2008-05-30', 245.51, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115170, false, '2009-01-13', NULL, 578, '2008-06-28', 141.66, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115180, false, '2009-01-14', NULL, 28, '2009-01-14', 2947.50, NULL, 111509);
INSERT INTO pagos_a_proveedor VALUES (1115181, false, '2009-01-14', NULL, 928, '2009-01-14', 75.00, '41125', NULL);
INSERT INTO pagos_a_proveedor VALUES (1115183, false, '2009-01-14', NULL, 12, '2008-06-14', 32.26, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115188, false, '2009-01-14', NULL, 639, '2008-06-09', 21.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115200, false, '2009-01-14', NULL, 24, '2008-06-05', 780.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115202, false, '2009-01-14', NULL, 219, '2008-05-30', 607.08, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115204, false, '2009-01-14', NULL, 219, '2008-05-30', 661.79, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115206, false, '2009-01-14', NULL, -1307541504, '2008-06-06', 104.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115208, false, '2009-01-14', NULL, 49, '2008-12-17', 1079.74, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115230, false, '2009-01-14', NULL, 12, '2008-06-07', 90.16, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115232, false, '2009-01-14', NULL, 291, '2008-06-01', 54.45, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115234, false, '2009-01-14', NULL, 49, '2008-06-17', 87.21, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115236, false, '2009-01-14', NULL, -1308164093, '2008-06-27', 183.16, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115238, false, '2009-01-14', NULL, -1308164093, '2008-06-27', 156.65, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115240, false, '2009-01-14', NULL, 52, '2009-01-14', 129.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115242, false, '2009-01-14', NULL, 98, '2009-01-14', 45.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115244, false, '2009-01-14', NULL, 49, '2008-06-18', 751.57, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115246, false, '2009-01-14', NULL, -1307738105, '2008-06-19', 25.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115248, false, '2009-01-14', NULL, -1307541503, '2008-06-05', 4.40, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115250, false, '2009-01-14', NULL, -1307705344, '2008-06-10', 278.30, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115252, false, '2009-01-14', NULL, -1307738105, '2008-05-30', 44.30, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115254, false, '2009-01-14', NULL, -1307705344, '2008-06-03', 169.40, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115256, true, '2009-01-14', NULL, 287, '2009-01-30', 500.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115257, false, '2009-01-14', NULL, 287, '2008-05-30', 500.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115260, false, '2009-01-15', NULL, 28, '2009-01-15', 126.00, NULL, 111522);
INSERT INTO pagos_a_proveedor VALUES (1115261, false, '2009-01-15', NULL, 28, '2009-01-15', 325.00, NULL, 111521);
INSERT INTO pagos_a_proveedor VALUES (1115262, false, '2009-01-15', NULL, 28, '2009-01-15', 39.00, NULL, 111513);
INSERT INTO pagos_a_proveedor VALUES (1115264, false, '2009-01-15', NULL, -1308098560, '2009-01-15', 127.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115310, false, '2009-01-16', NULL, 49, '2009-01-16', 945.84, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115185, true, '2009-01-14', NULL, 12, '2008-05-31', 27.26, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115312, false, '2009-01-16', NULL, 12, '2008-05-31', 27.26, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115313, false, '2009-01-16', NULL, 80, '2009-01-16', 306.50, NULL, 111530);
INSERT INTO pagos_a_proveedor VALUES (1115314, false, '2009-01-16', NULL, 80, '2009-01-16', 235.00, NULL, 111527);
INSERT INTO pagos_a_proveedor VALUES (1115315, true, '2009-01-16', NULL, 80, '2009-01-16', 38.67, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115316, false, '2009-01-16', NULL, 80, '2009-01-16', 39.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115317, false, '2009-01-16', NULL, -1307934719, '2009-01-16', 300.00, NULL, 111519);
INSERT INTO pagos_a_proveedor VALUES (1115318, false, '2009-01-16', NULL, -1307934719, '2009-01-16', 40.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115319, false, '2009-01-16', NULL, 1, '2009-01-16', 387.91, NULL, 111510);
INSERT INTO pagos_a_proveedor VALUES (1115330, false, '2009-01-16', NULL, 1, '2009-01-16', 2996.03, NULL, 111532);
INSERT INTO pagos_a_proveedor VALUES (1115331, false, '2009-01-16', NULL, 1, '2009-01-16', 2.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115334, false, '2009-01-17', NULL, -1307738109, '2009-01-16', 150.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115337, false, '2009-01-17', NULL, 776, '2009-01-16', 16.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115341, false, '2009-01-19', NULL, 269, '2009-01-17', 98.63, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115343, false, '2009-01-19', NULL, 269, '2009-01-18', 60.03, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115345, false, '2009-01-19', NULL, 269, '2009-01-11', 153.04, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115347, false, '2009-01-19', NULL, 269, '2009-01-18', 171.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115349, false, '2009-01-19', NULL, 269, '2009-01-19', 138.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115371, false, '2009-01-19', NULL, 269, '2009-01-19', 69.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115373, false, '2009-01-19', NULL, 269, '2009-01-04', 145.05, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115374, false, '2009-01-19', NULL, 1110, '2009-01-19', 269.17, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115376, false, '2009-01-19', NULL, 1440, '2009-01-19', 196.60, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115403, false, '2009-01-20', NULL, 812, '2009-01-19', 133.17, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115404, false, '2009-01-20', NULL, 49, '2009-01-20', 20.82, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115405, false, '2009-01-20', NULL, 12, '2009-01-20', 27.26, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115408, false, '2009-01-20', NULL, 15, '2009-01-20', 437.91, NULL, 111538);
INSERT INTO pagos_a_proveedor VALUES (1115409, false, '2009-01-20', NULL, 15, '2009-01-20', 89.25, NULL, 111541);
INSERT INTO pagos_a_proveedor VALUES (1115422, false, '2009-01-21', NULL, -1307901949, '2009-01-20', 19.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115423, false, '2009-01-21', NULL, -1307508736, '2009-01-20', 45.50, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114576, true, '2009-01-06', NULL, 61, '2008-12-24', 250.00, NULL, 111374);
INSERT INTO pagos_a_proveedor VALUES (1115407, true, '2009-01-20', NULL, 114, '2009-01-20', 405.00, NULL, 111528);
INSERT INTO pagos_a_proveedor VALUES (1115406, true, '2009-01-20', NULL, 114, '2009-01-20', 3318.90, NULL, 111536);
INSERT INTO pagos_a_proveedor VALUES (1115429, false, '2009-01-21', NULL, 277, '2009-01-21', 189.00, NULL, 111543);
INSERT INTO pagos_a_proveedor VALUES (1115450, false, '2009-01-21', NULL, 277, '2009-01-21', 136.50, NULL, 111544);
INSERT INTO pagos_a_proveedor VALUES (1115451, false, '2009-01-21', NULL, 277, '2009-01-21', 300.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115453, false, '2009-01-21', NULL, 55, '2009-01-21', 449.99, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115467, true, '2009-01-22', NULL, 114, '2009-01-22', 80.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115466, true, '2009-01-22', NULL, 114, '2009-01-22', 2785.42, NULL, 111535);
INSERT INTO pagos_a_proveedor VALUES (1115465, true, '2009-01-22', NULL, 114, '2009-01-22', 797.00, NULL, 111547);
INSERT INTO pagos_a_proveedor VALUES (1115462, true, '2009-01-22', NULL, -1307803648, '2009-01-22', 52.76, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1114975, true, '2009-01-12', NULL, 385, '2009-01-12', 290.00, NULL, 111481);
INSERT INTO pagos_a_proveedor VALUES (1115508, false, '2009-01-23', NULL, 114, '2009-01-23', 2785.42, NULL, 111535);
INSERT INTO pagos_a_proveedor VALUES (1115509, false, '2009-01-23', NULL, 114, '2009-01-23', 797.00, NULL, 111547);
INSERT INTO pagos_a_proveedor VALUES (1115510, false, '2009-01-23', NULL, 114, '2009-01-23', 80.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115561, false, '2009-01-24', NULL, -1308131315, '2009-01-16', 157.27, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115563, false, '2009-01-24', NULL, -1307475968, '2009-01-16', 124.01, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115565, false, '2009-01-24', NULL, 269, '2009-01-21', 190.02, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115566, false, '2009-01-24', NULL, -1307475967, '2009-01-18', 192.97, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115569, false, '2009-01-24', NULL, -1307475966, '2009-01-24', 1165.00, NULL, 111559);
INSERT INTO pagos_a_proveedor VALUES (1115600, false, '2009-01-24', NULL, -1307803648, '2009-01-22', 52.76, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115601, false, '2009-01-24', NULL, 95, '2009-01-22', 18.88, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115621, false, '2009-01-26', '313474 VIENE FACTURA', 4, '2009-01-26', 6391.76, '48511', 111563);
INSERT INTO pagos_a_proveedor VALUES (1115653, false, '2009-01-28', NULL, -1307836415, '2009-01-27', 99.35, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115655, false, '2009-01-28', NULL, 955, '2009-01-13', 54.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115656, false, '2009-01-28', NULL, 28, '2009-01-28', 1400.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115670, false, '2009-01-28', NULL, -1308131315, '2009-01-28', 85.02, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115671, false, '2009-01-28', NULL, -1308164093, '2009-01-28', 178.30, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115672, false, '2009-01-28', NULL, 385, '2009-01-28', 5000.00, NULL, 111568);
INSERT INTO pagos_a_proveedor VALUES (1115673, false, '2009-01-28', NULL, 385, '2009-01-28', 1618.79, NULL, 111569);
INSERT INTO pagos_a_proveedor VALUES (1115674, false, '2009-01-28', NULL, 385, '2009-01-28', 1618.79, NULL, 111570);
INSERT INTO pagos_a_proveedor VALUES (1115675, false, '2009-01-28', NULL, 219, '2009-01-28', 232.54, NULL, 111553);
INSERT INTO pagos_a_proveedor VALUES (1115676, false, '2009-01-28', NULL, 219, '2009-01-28', 186.00, NULL, 111554);
INSERT INTO pagos_a_proveedor VALUES (1115677, false, '2009-01-28', NULL, 219, '2009-01-28', 168.00, NULL, 111566);
INSERT INTO pagos_a_proveedor VALUES (1115678, true, '2009-01-28', NULL, 219, '2009-01-28', 820.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115679, true, '2009-01-28', NULL, 219, '2009-01-28', 770.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115710, false, '2009-01-28', NULL, 219, '2009-01-28', 53.50, 'cambio de factura', NULL);
INSERT INTO pagos_a_proveedor VALUES (1115711, false, '2009-01-28', NULL, 219, '2009-01-28', 766.81, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115760, false, '2009-01-29', NULL, 28, '2009-01-29', 540.00, NULL, 111575);
INSERT INTO pagos_a_proveedor VALUES (1115761, false, '2009-01-29', NULL, 28, '2009-01-29', 5808.00, NULL, 111574);
INSERT INTO pagos_a_proveedor VALUES (1115762, false, '2009-01-29', NULL, 28, '2009-01-29', 171.68, NULL, 111573);
INSERT INTO pagos_a_proveedor VALUES (1115767, false, '2009-01-30', NULL, 114, '2009-01-30', 86.39, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115782, false, '2009-01-31', NULL, 55, '2009-01-29', 322.49, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115863, true, '2009-02-04', NULL, 1048, '2009-02-04', 65.03, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115821, true, '2009-02-03', NULL, -1308131313, '2009-02-03', 165.75, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115861, true, '2009-02-04', NULL, 98, '2009-02-03', 135.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1115866, true, '2009-02-04', NULL, 61, '2009-02-04', 654.79, NULL, 111580);
INSERT INTO pagos_a_proveedor VALUES (1115865, true, '2009-02-04', NULL, 61, '2009-02-04', 400.00, NULL, 111585);
INSERT INTO pagos_a_proveedor VALUES (1115921, true, '2009-02-06', NULL, 61, '2009-02-04', 400.00, NULL, 111585);
INSERT INTO pagos_a_proveedor VALUES (1115920, true, '2009-02-06', NULL, 61, '2009-02-04', 654.79, NULL, 111580);
INSERT INTO pagos_a_proveedor VALUES (1115987, true, '2009-02-07', NULL, 385, '2009-02-07', 1219.15, NULL, 111600);
INSERT INTO pagos_a_proveedor VALUES (1115988, true, '2009-02-07', NULL, 385, '2009-02-07', 1165.05, NULL, 111597);
INSERT INTO pagos_a_proveedor VALUES (1115989, true, '2009-02-07', NULL, 385, '2009-02-07', 406.50, NULL, 111602);
INSERT INTO pagos_a_proveedor VALUES (1116030, true, '2009-02-07', NULL, 385, '2009-02-07', 1165.05, NULL, 111597);
INSERT INTO pagos_a_proveedor VALUES (1116031, true, '2009-02-07', NULL, 385, '2009-02-07', 1219.15, NULL, 111600);
INSERT INTO pagos_a_proveedor VALUES (1116032, true, '2009-02-07', NULL, 385, '2009-02-07', 406.50, NULL, 111602);
INSERT INTO pagos_a_proveedor VALUES (1116130, true, '2009-02-11', NULL, 80, '2009-02-11', 9.71, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1116079, true, '2009-02-11', NULL, 80, '2009-02-11', 532.00, NULL, 111605);
INSERT INTO pagos_a_proveedor VALUES (1116078, true, '2009-02-11', NULL, 80, '2009-02-11', 600.93, NULL, 111612);
INSERT INTO pagos_a_proveedor VALUES (1116132, true, '2009-02-11', NULL, 103, '2009-02-11', 80.11, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1116131, true, '2009-02-11', NULL, 103, '2009-02-11', 203.00, NULL, 111595);
INSERT INTO pagos_a_proveedor VALUES (1116144, true, '2009-02-12', NULL, 1, '2009-02-12', 360.00, NULL, 111596);
INSERT INTO pagos_a_proveedor VALUES (1116143, true, '2009-02-12', NULL, 1, '2009-02-12', 89.00, NULL, 111609);
INSERT INTO pagos_a_proveedor VALUES (1116142, true, '2009-02-12', NULL, 1, '2009-02-12', 450.00, NULL, 111589);
INSERT INTO pagos_a_proveedor VALUES (1116223, true, '2009-02-16', NULL, -1308164094, '2009-02-16', 110.00, NULL, NULL);
INSERT INTO pagos_a_proveedor VALUES (1116221, true, '2009-02-16', NULL, -1308164094, '2009-02-16', 242.00, NULL, 111619);
INSERT INTO pagos_a_proveedor VALUES (1116220, true, '2009-02-16', NULL, -1308164094, '2009-02-16', 579.19, NULL, 111610);
INSERT INTO pagos_a_proveedor VALUES (1116222, true, '2009-02-16', NULL, -1308164094, '2009-02-16', 36.50, NULL, 111601);
INSERT INTO pagos_a_proveedor VALUES (1116224, true, '2009-02-16', NULL, 46, '2009-02-16', 138.00, NULL, 111621);
INSERT INTO pagos_a_proveedor VALUES (1116225, true, '2009-02-16', NULL, 46, '2009-02-16', 2166.00, NULL, 111618);
INSERT INTO pagos_a_proveedor VALUES (1116226, true, '2009-02-16', NULL, 46, '2009-02-16', 1534.48, NULL, 111606);
INSERT INTO pagos_a_proveedor VALUES (1116229, true, '2009-02-17', NULL, 28, '2009-02-17', 267.00, NULL, 111620);
INSERT INTO pagos_a_proveedor VALUES (1116228, true, '2009-02-17', NULL, 28, '2009-02-17', 1151.11, NULL, 111617);
INSERT INTO pagos_a_proveedor VALUES (1116262, true, '2009-02-17', NULL, 28, '2009-02-17', 339.00, NULL, 111625);
INSERT INTO pagos_a_proveedor VALUES (1116260, true, '2009-02-17', NULL, 28, '2009-02-17', 520.00, NULL, 111624);
INSERT INTO pagos_a_proveedor VALUES (1116261, true, '2009-02-17', NULL, 28, '2009-02-17', 136.50, NULL, 111623);
INSERT INTO pagos_a_proveedor VALUES (1116265, true, '2009-02-17', NULL, 28, '2009-02-17', 579.19, NULL, 111610);
INSERT INTO pagos_a_proveedor VALUES (1116264, true, '2009-02-17', NULL, 28, '2009-02-17', 242.00, NULL, 111619);
INSERT INTO pagos_a_proveedor VALUES (1116263, true, '2009-02-17', NULL, 28, '2009-02-17', 36.50, NULL, 111601);


--
-- Data for Name: proveedores; Type: TABLE DATA; Schema: public; Owner: postgres
--

INSERT INTO proveedores VALUES (110, '30504814625', 'F B D', 'BUZZI Y DUCA', 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (825, '30623295946', 'BONAFIDE', NULL, 'OTROS');
INSERT INTO proveedores VALUES (808, '33708929269', 'OXIGENO TRES ARROYOS S.R.L.', NULL, 'OTROS');
INSERT INTO proveedores VALUES (20, '30545690922', 'CELTA', NULL, 'SERVICIOS');
INSERT INTO proveedores VALUES (52, '23115990624', 'stickers', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (574, '3354288439', 'GENOVESI HNOS.', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (114, '30708875054', 'DIMA VIAL', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (407, '33708266049', 'SEGUGOMA S.R.L', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (36, '27221582565', 'PIZZOLANTE Patricia Carla', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (134, '30526874249', 'FRAVEGA', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (303, '20118435932', 'EDUARDO COZZI', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (61, '30500600183', 'FRAVIDA -FRANCISCO VICENTE DAMIANO S.A.', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (1, '30708816171', 'ACYMAT S.A.', 'BCO GALICIA 1863/0 090/1', 'MERCADERIA');
INSERT INTO proveedores VALUES (674, '27184422226', 'LIBRERIA BORGES', NULL, 'PAPALERIA');
INSERT INTO proveedores VALUES (12, '23053576249', 'FICHMAN', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (46, '30707784292', 'DE PASCALE S.A', 'C.C. BCO CREDICOOP SUC 005/10189/0', 'MERCADERIA');
INSERT INTO proveedores VALUES (1110, '20053227644', 'ALCIBIADES LAZZARO', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (935, '30708823917', 'LEBENE S.R.L.', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (295, '30664194666', 'JETMAR', NULL, 'TRANSPORTE');
INSERT INTO proveedores VALUES (546, '30536259194', 'OCA', NULL, 'PAPALERIA');
INSERT INTO proveedores VALUES (9, '30567923629', 'CARABELA', NULL, 'PAPALERIA');
INSERT INTO proveedores VALUES (928, '30500665048', 'ALVARADO S.A.', 'CONSTRUCCION', 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (316, '20160982579', 'BIANCHI SERVICE', 'MEDICION Y CONTROL', 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (478, '33708639929', 'CAPEC', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (326, '30567927446', 'CENTRO BULONERO', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (812, '30590645857', 'MADERAS MARTIN', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (80, '30709180300', 'LTM DISTRIBUCIONES', 'BCO GALICIA 5541/3 082/5', 'MERCADERIA');
INSERT INTO proveedores VALUES (196, '30707204326', 'ACCLAIM S.R.L', 'BCO CREDICOOP-SUC 059/CTA8321/4', 'MERCADERIA');
INSERT INTO proveedores VALUES (111, '30636316217', 'ROGUANT S.R.L.', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (332, '20182799948', 'SABADINI VIDRIOS', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (95, '30667446496', 'EXPRESO T.A.S.', NULL, 'TRANSPORTE');
INSERT INTO proveedores VALUES (440, '20110439076', 'TRANSPORTE PISCICELLI', NULL, 'TRANSPORTE');
INSERT INTO proveedores VALUES (776, '30577338872', 'PLUSMAR', NULL, 'TRANSPORTE');
INSERT INTO proveedores VALUES (657, '30500032886', 'LA PERSEVERANCIA SEGUROS', 'SEGURO SAVEIRO', 'SEGUROS');
INSERT INTO proveedores VALUES (491, '20053738800', 'CATEDRA', 'FABRICA DE SELLOS', 'PAPALERIA');
INSERT INTO proveedores VALUES (1233, '30600698725', 'MELISAM S.A.', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (495, '30546120313', 'ALPI', NULL, 'PUBLICIDAD');
INSERT INTO proveedores VALUES (1286, '20053871055', 'ALFREDO PODLESKER', NULL, 'OTROS');
INSERT INTO proveedores VALUES (211, '30504355442', 'CARAN S.A.', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (630, '30594598462', 'ROLLS S.R.L.', 'PRODUCTOS QUIMICOS LIMPIEZA', 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (1044, '20053740597', 'ELECTRO 3', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (704, '20049884371', 'LA CASA DE LA BOMBA DE AGUA', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (360, '20221386230', 'FLORERIA LA PLAZA', NULL, 'OTROS');
INSERT INTO proveedores VALUES (24, '0', 'OPDS', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (287, '30650457818', 'CLUB ARGENTINO JUNIOR- BASQUET', NULL, 'PUBLICIDAD');
INSERT INTO proveedores VALUES (256, '30663221317', 'HSBC', 'TARABORELLI', 'SEGUROS');
INSERT INTO proveedores VALUES (635, '20168017856', 'EL PAISANO', 'COMISIONISTA', 'OTROS');
INSERT INTO proveedores VALUES (277, '33708607059', 'GRUPO PROTECTIVO S.R.L.', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (291, '30667525906', 'ETERNET S. R. L.', NULL, 'SERVICIOS');
INSERT INTO proveedores VALUES (995, '20085148177', 'DISTRIBUIDORA PASO A PASO', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (264, '20108252147', 'GRAFIKA TS AS.de Luis Reynal', NULL, 'PAPALERIA');
INSERT INTO proveedores VALUES (687, '30708367067', 'TECNO COMPUTACION', NULL, 'PAPALERIA');
INSERT INTO proveedores VALUES (639, '27059016313', 'MASTER COMPUTACION', NULL, 'PAPALERIA');
INSERT INTO proveedores VALUES (668, '30667526139', 'AGENCIA DE DESARROLLO PRODUCTIVO', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (536, '30708530198', 'RUTAS AL SUR', 'PEAJE', 'OTROS');
INSERT INTO proveedores VALUES (955, '30708675136', 'GRAFICA SAN JORGE', NULL, 'PAPALERIA');
INSERT INTO proveedores VALUES (713, '20113401398', 'CAP - CARLOS PELLITERO', 'TALLER MECANICO', 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (780, '000', 'PLAZA L.129-L.132', NULL, 'TRANSPORTE');
INSERT INTO proveedores VALUES (578, '20181090112', 'ANIBAL S.R. MARTINEZ', 'ESCRIBANO', 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (645, '30631810582', 'LOS PROFESIONALES DEL MONTAJE', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (564, '30685200143', 'APPLUS ITEUVE ARGENTINA S.A.', 'V.T.V.', 'OTROS');
INSERT INTO proveedores VALUES (804, '20133751654', 'TRANSPORTE MARTIN', NULL, 'TRANSPORTE');
INSERT INTO proveedores VALUES (962, '30710493304', 'INDUTEX ARGENTINA S.A.', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (4, '30578780678', 'PRAXAIR ARGENTINA S.R.L.', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (283, '0', 'RADIO COOPERATIVA F.M. 102.5', NULL, 'PUBLICIDAD');
INSERT INTO proveedores VALUES (98, '20305316157', 'INFOTALLER', 'FACUNDO', 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (1048, '30707745424', 'SANI TRES S.A.', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (1062, '30702203801', 'CM COMUNICACIONES S.R.L.', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (338, '30622120697', 'ALVAREZ NEUMATICOS', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (219, '27173415945', 'MUNDO COLOR', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (121, '33658043779', 'BUREAU VERITAS', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (385, '30708300752', 'FADESA - CAUTIO S.R.L.', 'BCO CREDICOOP SUC.050-9113/7', 'MERCADERIA');
INSERT INTO proveedores VALUES (1174, '30667442369', 'BAZAR EL MUNDIAL', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (55, '30707160124', 'LINOLAN', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (1210, '30542511571', 'LA CASA DEL PANTALON', NULL, 'OTROS');
INSERT INTO proveedores VALUES (15, '30658166405', 'T. GOIZUETA', NULL, 'TRANSPORTE');
INSERT INTO proveedores VALUES (135, '30647675677', 'CUMECHE S.R.L.', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (1350, '30709691496', 'LIBERTAD HOTEL', NULL, 'OTROS');
INSERT INTO proveedores VALUES (1356, '20171735026', 'ABERTURAS WEST', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (1403, '30708255838', 'COMPAGNIE DE LA SANTE', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (1440, '20322584254', 'MIO FIGLIO', 'CLIENTE TAMBIEN', 'OTROS');
INSERT INTO proveedores VALUES (1447, '30708931051', 'JORGE SUAREZ S.A.', 'Y CLIENTE', 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (269, '30678774495', 'OPESSA ACA LAVALLE', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (1555, '20055249157', 'ALTUNA ELECTRICIDAD', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1308164096, '11111111', 'Manuel Corrales', 'De Prueba', 'MERCADERIA');
INSERT INTO proveedores VALUES (-1308164095, '30707999558', 'BAC-DALL Argentina S.A', 'CONTRA REEMBOLSO', 'MERCADERIA');
INSERT INTO proveedores VALUES (-1308164092, '30640640959', 'SERVICENTRO LOS ARROYOS', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (42, '20187763402', 'CORRALES MARTINEZ  VICENTE', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1308164094, '20933458076', 'CHIARELLO GENARO', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (1492, '30667470680', 'SEDERIA  ELICHIRY', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1308164093, '3063945397', 'TELEFONICA', NULL, 'SERVICIOS');
INSERT INTO proveedores VALUES (28, '30597919154', 'CONFECAT S.A.', 'BCO GALICIA 4328-7/045-3', 'MERCADERIA');
INSERT INTO proveedores VALUES (49, '30678814357', 'MOVISTAR', NULL, 'SERVICIOS');
INSERT INTO proveedores VALUES (399, '0', 'GRUPO  DIRECTORIO SRL', NULL, 'PUBLICIDAD');
INSERT INTO proveedores VALUES (103, '30709598283', 'SEGUTEK S.R.L.', 'BCO RIO cc.123/25056/6', 'MERCADERIA');
INSERT INTO proveedores VALUES (617, '30546481553', 'RIO PARANA S.A.', NULL, 'TRANSPORTE');
INSERT INTO proveedores VALUES (-1308164091, '23266702019', 'MADERERA EMANUEL', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1308164090, '20933217575', 'DON CRISTOBAL', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (1165, '20041316706', 'JOSE PEQUEÑO', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1308164089, '33569101579', 'DE LA PENNA JOSE E HIJOS', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (-1308164088, '30710590776', 'OLEODINAMICA T.R.H.', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1308164087, '30708283548', 'GRUPO DIRECTORIO S.R.L.', 'CUOTA 3 DE 5', 'PUBLICIDAD');
INSERT INTO proveedores VALUES (-1308164086, '30657864281', 'CAMUZZI GAS PAMPEANA', NULL, 'SERVICIOS');
INSERT INTO proveedores VALUES (-1308131328, '33707984649', 'CISMA LABORATORIOS S.A.', NULL, 'OTROS');
INSERT INTO proveedores VALUES (-1308131327, '2005380574', 'CARLOS H. PASKVAN', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (-1308131326, '20109136167', 'RAUL ALONSO', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (-1308131325, '0', 'CLUB AMISTAD', NULL, 'PUBLICIDAD');
INSERT INTO proveedores VALUES (-1308131324, '20101010024', 'CERRAJERIA ALERTA', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1308131323, '20125911529', 'LIBRERIA LETRAS', NULL, 'PAPALERIA');
INSERT INTO proveedores VALUES (-1308131321, '30638590588', 'POWDERSIL S.A.', 'SIFONES DRAGO', 'MERCADERIA');
INSERT INTO proveedores VALUES (-1308131320, '30546252848', 'EL RAPIDO S.A.', NULL, 'TRANSPORTE');
INSERT INTO proveedores VALUES (-1308131319, '30709077682', '3MDQ ARGENTINA S.R.L..', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (-1308131318, '20183989953', 'HERRAMIENTAS DE TORNERIA F.G.', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1308131317, '30688097823', 'EXPRESO FEDERAL', NULL, 'TRANSPORTE');
INSERT INTO proveedores VALUES (-1308131316, '30642146501', 'PETROGAS TANDIL SA', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (-1308131315, '30678774495', 'OPESSA RUTA Nº3', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (-1308131314, '20125910603', 'METALURGICA MOLINA', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1308131313, '30500105328', 'LA VOZ DEL PUEBLO', NULL, 'OTROS');
INSERT INTO proveedores VALUES (-1308131312, '20110436697', 'TORNERIA ALVAREZ', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1308131311, '20136511890', 'GERMAN CIANCAGLINI', NULL, 'OTROS');
INSERT INTO proveedores VALUES (-1308131322, '20173416629', 'DI CROCE RICARDO', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1308098560, '20228902447', 'JUAN SANTO JAVIER', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (-1308098559, '27117576499', 'FM VISION 106.3', NULL, 'PUBLICIDAD');
INSERT INTO proveedores VALUES (-1308065792, '27126094804', 'ELIMAR', NULL, 'PAPALERIA');
INSERT INTO proveedores VALUES (-1308065791, '27164742216', 'CELANTTELAS', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1308065790, '30595070194', 'INCAHUEN SRL', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (-1308065789, '20234670965', 'POLY PACK', NULL, 'PAPALERIA');
INSERT INTO proveedores VALUES (-1308033024, '30582541147', 'ESTACION DE SERVICIO DI TOMMASO', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (-1308033023, '20053812555', 'MH MALACATES', 'JUAN MATILLA', 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1308000256, '1', 'IVA-INGRESOS BRUTOS', 'CONTADORA', 'OTROS');
INSERT INTO proveedores VALUES (-1308000255, '20053684107', 'TALLER DI MARCO', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1307967488, '20053846778', 'RENS ENRIQUE JOSE', 'CLAROMECO', 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (-1307967487, '23053824269', 'PAPELERA SAN JUAN', NULL, 'PAPALERIA');
INSERT INTO proveedores VALUES (-1307967486, '30643922157', 'VIA BARILOCHE', NULL, 'TRANSPORTE');
INSERT INTO proveedores VALUES (-1307934720, '0', 'CRIS-TOUR', NULL, 'TRANSPORTE');
INSERT INTO proveedores VALUES (-1307934719, '30551431300', 'BORIS HNOS. S.A.', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (-1307901952, '30678774495', 'ESTACION DE SERVICIO YPF VILLA CARLOS PAZ', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (-1307901951, '20937792787', 'YPF EMBALSE', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (-1307901950, '30615341130', 'PETROSURCO S.A.', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (-1307901949, '33569101579', 'JOSE DE LA PENNA E HIJOS', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1307901948, '20164740561', 'ACCESORIOS PEDRO', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1307869184, '30535230842', 'PETROTANDIL', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (-1307869183, '30678774495', 'OPESSA LAS FLORES', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (-1307869182, '30583460930', 'POURTAU COMBUSTIBLES S.A.', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (-1307869181, '33709939799', 'CER AMERICA LATINA S.A.', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (-1307869180, '30500063242', 'INSTITUTO ASEGURADOR MERCANTIL', NULL, 'SEGUROS');
INSERT INTO proveedores VALUES (-1307836416, '20161091791', 'ALSINA LIBRERIA', NULL, 'PAPALERIA');
INSERT INTO proveedores VALUES (-1307836415, '27126220532', 'ENVASES G.R.', NULL, 'PAPALERIA');
INSERT INTO proveedores VALUES (-1307836414, '20129063514', 'PRODUCCIONES LD', NULL, 'PUBLICIDAD');
INSERT INTO proveedores VALUES (-1307836413, '20234670965', 'POLY PACK', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1307803648, '3070763163', 'TRUCKS EXPRESS S.R.L.', NULL, 'TRANSPORTE');
INSERT INTO proveedores VALUES (-1307803647, '0', 'ARBA', NULL, 'SERVICIOS');
INSERT INTO proveedores VALUES (-1307803646, '20137694868', 'MG POSTAL', NULL, 'TRANSPORTE');
INSERT INTO proveedores VALUES (-1307803645, '27188130114', 'CAMARO HOTEL', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1307770880, '20121554632', 'MONTESINOS HOGAR', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1307738112, '20242666454', 'DAMIAN HINDING', NULL, 'PUBLICIDAD');
INSERT INTO proveedores VALUES (-1307738111, '20164876730', 'GALAMAR', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1307738110, '30667074467', 'ARCIDIACONO S.A.', NULL, 'OTROS');
INSERT INTO proveedores VALUES (-1307738109, '20053871322', 'PAMPA''S PRODUCCIONES', NULL, 'PUBLICIDAD');
INSERT INTO proveedores VALUES (-1307738108, '20180541366', 'COUSO CERRAJERÍA', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1307738107, '20237795599', 'SOLUCIONES INFORMATICAS', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1307738106, '20166266328', 'ESTACION DE SERV. SAN RUBEN', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (-1307738105, '30567923629', 'LIBRERIA CARABELA', NULL, 'PAPALERIA');
INSERT INTO proveedores VALUES (-1307738104, '20053784810', 'REPUESTODO', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1307705344, '20133755765', 'IMPRESOS AMERICA', NULL, 'PAPALERIA');
INSERT INTO proveedores VALUES (-1307705343, '20226009222', 'YPF DE LA GARMA', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (-1307705342, '30516976868', 'LU24', NULL, 'PUBLICIDAD');
INSERT INTO proveedores VALUES (-1307672576, '30708694181', 'AGRO GILARDONI', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (-1307672575, '30707041990', 'INDUSTRIAS MAS SRL', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1307672574, '20116624967', 'ROBERTO ANIBAL COTTA', NULL, 'TRANSPORTE');
INSERT INTO proveedores VALUES (-1307672573, '30526111393', 'COOP AGRARIA', NULL, 'OTROS');
INSERT INTO proveedores VALUES (-1307672572, '20200702124', 'DISTRIBUIDORA NAVIA', NULL, 'MERCADERIA');
INSERT INTO proveedores VALUES (-1307672571, '20185836380', 'RESUELTO', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1307639808, '30999011345', 'MUNICIPALIDAD', NULL, 'SERVICIOS');
INSERT INTO proveedores VALUES (-1307607040, '30582541147', 'DI TOMMASO EST. DE SERV', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (-1307607039, '30667499654', 'SISTEMAS TERMODINAMICOS SRL', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1307574272, '20053904085', 'MIGUEL ANGEL GONZALEZ', NULL, 'SERVICIOS');
INSERT INTO proveedores VALUES (-1307574271, '33501174799', 'BIANCO S.A.C.I.F.I.', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1307574270, '27038733112', 'TODO EMBRAGUE', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1307574269, '30707462732', 'ELGART DISTRIBUIDORA', NULL, 'MANTENIMIENTO');
INSERT INTO proveedores VALUES (-1307541504, '20305318419', 'EL MUNDO DEL CARTUCHO', NULL, 'PAPALERIA');
INSERT INTO proveedores VALUES (-1307541503, '20147704047', 'SERVICIOS INFORMÁTICOS', NULL, 'PAPALERIA');
INSERT INTO proveedores VALUES (-1307508736, '27144994901', 'LIBRERIA NAOS', NULL, 'PAPALERIA');
INSERT INTO proveedores VALUES (-1307475968, '30520152691', 'YPF ROMERO', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (-1307475967, '306787747495', 'EES SALADILLO', NULL, 'COMBUSTIBLE');
INSERT INTO proveedores VALUES (-1307475966, '30659065548', 'ENARGAS', NULL, 'SERVICIOS');
INSERT INTO proveedores VALUES (-1307443200, '23101023729', 'TRANSPORTES SAN PEDRO', NULL, 'TRANSPORTE');
INSERT INTO proveedores VALUES (-1307443199, '30667453905', 'SOCIEDAD ITALIANA DE SOCORROS MUTUOS "UNION Y BENEVOLENCIA"', NULL, 'OTROS');


--
-- Name: cheques_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY cheques
    ADD CONSTRAINT cheques_pkey PRIMARY KEY (id);


--
-- Name: clientes_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY clientes
    ADD CONSTRAINT clientes_pkey PRIMARY KEY (id);


--
-- Name: compras_a_proveedor_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY compras_a_proveedor
    ADD CONSTRAINT compras_a_proveedor_pkey PRIMARY KEY (id);


--
-- Name: dps_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY dps
    ADD CONSTRAINT dps_pkey PRIMARY KEY (id);


--
-- Name: matafuegos_nroaparato_key; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY matafuegos
    ADD CONSTRAINT matafuegos_nroaparato_key UNIQUE (nroaparato);


--
-- Name: matafuegos_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY matafuegos
    ADD CONSTRAINT matafuegos_pkey PRIMARY KEY (id);


--
-- Name: pagos_a_proveedor_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pagos_a_proveedor
    ADD CONSTRAINT pagos_a_proveedor_pkey PRIMARY KEY (id);


--
-- Name: proveedores_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY proveedores
    ADD CONSTRAINT proveedores_pkey PRIMARY KEY (id);


--
-- Name: fk185673d3856ef; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY dps
    ADD CONSTRAINT fk185673d3856ef FOREIGN KEY (matafuego_id) REFERENCES matafuegos(id);


--
-- Name: fk32689961182f13f; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY matafuegos
    ADD CONSTRAINT fk32689961182f13f FOREIGN KEY (cliente_id) REFERENCES clientes(id);


--
-- Name: fk7fe18b739e489e55ddf1f6; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY compras_a_proveedor
    ADD CONSTRAINT fk7fe18b739e489e55ddf1f6 FOREIGN KEY (proveedor_id) REFERENCES proveedores(id);


--
-- Name: fk7fe18b739e489ec9de28bb; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY pagos_a_proveedor
    ADD CONSTRAINT fk7fe18b739e489ec9de28bb FOREIGN KEY (proveedor_id) REFERENCES proveedores(id);


--
-- Name: fkc9de28bba9b6938f; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY pagos_a_proveedor
    ADD CONSTRAINT fkc9de28bba9b6938f FOREIGN KEY (cheque_fk) REFERENCES cheques(id);


--
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


--
-- PostgreSQL database dump complete
--

